# StaticArrays

*Statically sized arrays for Julia*

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://JuliaArrays.github.io/StaticArrays.jl/stable)
[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://JuliaArrays.github.io/StaticArrays.jl/dev)
[![Build Status](https://github.com/JuliaArrays/StaticArrays.jl/workflows/CI/badge.svg)](https://github.com/JuliaArrays/StaticArrays.jl/actions?query=workflow%3ACI)
[![codecov.io](https://codecov.io/github/JuliaArrays/StaticArrays.jl/branch/master/graph/badge.svg)](http://codecov.io/github/JuliaArrays/StaticArrays.jl/branch/master)
[![Aqua QA](https://raw.githubusercontent.com/JuliaTesting/Aqua.jl/master/badge.svg)](https://github.com/JuliaTesting/Aqua.jl)
[![deps](https://juliahub.com/docs/StaticArrays/deps.svg)](https://juliahub.com/ui/Packages/StaticArrays/yY9vm?t=2)
[![version](https://juliahub.com/docs/StaticArrays/version.svg)](https://juliahub.com/ui/Packages/StaticArrays/yY9vm)


**StaticArrays** provides a framework for implementing statically sized arrays
in Julia, using the abstract type `StaticArray{Size,T,N} <: AbstractArray{T,N}`.
Subtypes of `StaticArray` will provide fast implementations of common array and
linear algebra operations. Note that here "statically sized" means that the
size can be determined from the *type*, and "static" does **not** necessarily
imply `immutable`.

The package also provides some concrete static array types: `SVector`, `SMatrix`
and `SArray`, which may be used as-is (or else embedded in your own type).
Mutable versions `MVector`, `MMatrix` and `MArray` are also exported, as well
as `SizedArray` for annotating standard `Array`s with static size information.
Further, the abstract `FieldVector` can be used to make fast `StaticVector`s
out of any uniform Julia "struct".
Full documentation can be found [here](https://JuliaArrays.github.io/StaticArrays.jl/stable/).

Most of the primary array types exported by StaticArrays.jl are defined in the small interface
package [StaticArraysCore.jl](https://github.com/JuliaArrays/StaticArraysCore.jl). This includes
e.g., the definitions of the abstract type `StaticArray` and the concrete types `SArray`,
`MArray`, and `SizedArray` (as well as their dimension-specific aliases).
This enables downstream packages to implement new methods for these types without depending
on (and hence loading) the entirety of StaticArrays.jl, and thereby to avoid incurring the full
load-time of StaticArrays.jl (which is on the order of 0.6 s for StaticArrays.jl v1.4 on Julia
v1.7).

## Speed

The speed of *small* `SVector`s, `SMatrix`s and `SArray`s is often > 10 × faster
than `Base.Array`. For example, here's a
[microbenchmark](perf/README_benchmarks.jl) showing some common operations.

```
============================================
    Benchmarks for 3×3 Float64 matrices
============================================
Matrix multiplication               -> 5.9x speedup
Matrix multiplication (mutating)    -> 1.8x speedup
Matrix addition                     -> 33.1x speedup
Matrix addition (mutating)          -> 2.5x speedup
Matrix determinant                  -> 112.9x speedup
Matrix inverse                      -> 67.8x speedup
Matrix symmetric eigendecomposition -> 25.0x speedup
Matrix Cholesky decomposition       -> 8.8x speedup
Matrix LU decomposition             -> 6.1x speedup
Matrix QR decomposition             -> 65.0x speedup
```

These numbers were generated on an Intel i7-7700HQ using Julia-1.2. As with all
synthetic benchmarks, the speedups you see here should only be taken as very
roughly indicative of the speedup you may see in real code. When in doubt,
benchmark your real application!

Note that in the current implementation, working with large `StaticArray`s puts a
lot of stress on the compiler, and becomes slower than `Base.Array` as the size
increases.  A very rough rule of thumb is that you should consider using a
normal `Array` for arrays larger than 100 elements.


## Quick start

Add *StaticArrays* from the [Pkg REPL](https://docs.julialang.org/en/latest/stdlib/Pkg/#Getting-Started-1), i.e., `pkg> add StaticArrays`. Then:
```julia
using LinearAlgebra
using StaticArrays

# Use the convenience constructor type `SA` to create vectors and matrices
SA[1, 2, 3]      isa SVector{3,Int}
SA_F64[1, 2, 3]  isa SVector{3,Float64}
SA_F32[1, 2, 3]  isa SVector{3,Float32}
SA[1 2; 3 4]     isa SMatrix{2,2,Int}
SA_F64[1 2; 3 4] isa SMatrix{2,2,Float64}

# Create an SVector using various forms, using constructors, functions or macros
v1 = SVector(1, 2, 3)
v1.data === (1, 2, 3) # SVector uses a tuple for internal storage
v2 = SVector{3,Float64}(1, 2, 3) # length 3, eltype Float64
v3 = @SVector [1, 2, 3]
v4 = @SVector [i^2 for i = 1:10] # arbitrary comprehensions (range is evaluated at global scope)
v5 = zeros(SVector{3}) # defaults to Float64
v6 = @SVector zeros(3)
v7 = SVector{3}([1, 2, 3]) # Array conversions must specify size

# Can get size() from instance or type
size(v1) == (3,)
size(typeof(v1)) == (3,)

# Similar constructor syntax for matrices
m1 = SMatrix{2,2}(1, 2, 3, 4) # flat, column-major storage, equal to m2:
m2 = @SMatrix [ 1  3 ;
                2  4 ]
m3 = SMatrix{3,3}(1I)
m4 = @SMatrix randn(4,4)
m5 = SMatrix{2,2}([1 3 ; 2 4]) # Array conversions must specify size

# Higher-dimensional support
a = @SArray randn(2, 2, 2, 2, 2, 2)

# Supports all the common operations of AbstractArray
v7 = v1 + v2
v8 = sin.(v3)
v3 == m3 * v3 # recall that m3 = SMatrix{3,3}(1I)
# map, reduce, broadcast, map!, broadcast!, etc...

# Indexing can also be done using static arrays of integers
v1[1] === 1
v1[SVector(3,2,1)] === @SVector [3, 2, 1]
v1[:] === v1
typeof(v1[[1,2,3]]) <: Vector # Can't determine size from the type of [1,2,3]

# Is (partially) hooked into BLAS, LAPACK, etc:
rand(MMatrix{20,20}) * rand(MMatrix{20,20}) # large matrices can use BLAS
eigen(m3) # eigen(), etc uses specialized algorithms up to 3×3, or else LAPACK

# Static arrays stay statically sized, even when used by Base functions, etc:
typeof(eigen(m3).vectors) == SMatrix{3,3,Float64,9}
typeof(eigen(m3).values) == SVector{3,Float64}

# similar() returns a mutable container, while similar_type() returns a constructor:
typeof(similar(m3)) == MArray{Tuple{3,3},Int64,2,9} # (final parameter is length = 9)
similar_type(m3) == SArray{Tuple{3,3},Int64,2,9}

# The Size trait is a compile-time constant representing the size
Size(m3) === Size(3,3)

# A standard Array can be wrapped into a SizedArray
m4 = SizedMatrix{3,3}(rand(3,3))
inv(m4) # Take advantage of specialized fast methods

# reshape() uses Size() or types to specify size:
reshape([1,2,3,4], Size(2,2)) == @SMatrix [ 1  3 ;
                                            2  4 ]
typeof(reshape([1,2,3,4], Size(2,2))) === SizedArray{Tuple{2, 2},Int64,2,1}

```

## Approach

The package provides a range of different useful built-in `StaticArray` types,
which include mutable and immutable arrays based upon tuples, arrays based upon
structs, and wrappers of `Array`. There is a relatively simple interface for
creating your own, custom `StaticArray` types, too.

This package also provides methods for a wide range of `AbstractArray` functions,
specialized for (potentially immutable) `StaticArray`s. Many of Julia's
built-in method definitions inherently assume mutability, and further
performance optimizations may be made when the size of the array is known to the
compiler. One example of this is by loop unrolling, which has a substantial
effect on small arrays and tends to automatically trigger LLVM's SIMD
optimizations. Another way performance is boosted is by providing specialized
methods for `det`, `inv`, `eigen` and `cholesky` where the algorithm depends on the
precise dimensions of the input. In combination with intelligent fallbacks to
the methods in Base, we seek to provide a comprehensive support for statically
sized arrays, large or small, that hopefully "just works".

const StaticULT{TA} = Union{UpperTriangular{TA,<:StaticMatrix},LowerTriangular{TA,<:StaticMatrix},UnitUpperTriangular{TA,<:StaticMatrix},UnitLowerTriangular{TA,<:StaticMatrix}}

@inline Base.:*(A::Adjoint{<:Any,<:StaticVector}, B::StaticULT{<:Any}) =
    adjoint(adjoint(B) * adjoint(A))
@inline Base.:*(A::Transpose{<:Any,<:StaticVector}, B::StaticULT{<:Any}) =
    transpose(transpose(B) * transpose(A))
@inline Base.:*(A::StaticULT{<:Any}, B::Adjoint{<:Any,<:StaticVector}) =
    adjoint(adjoint(B) * adjoint(A))
@inline Base.:*(A::StaticULT{<:Any}, B::Transpose{<:Any,<:StaticVector}) =
    transpose(transpose(B) * transpose(A))

@inline Base.:\(A::StaticULT, B::StaticVecOrMatLike) = _A_ldiv_B(Size(A), Size(B), A, B)
@inline Base.:/(A::StaticVecOrMatLike, B::StaticULT) = transpose(transpose(B) \ transpose(A))

@generated function _A_ldiv_B(::Size{sa}, ::Size{sb}, A::StaticULT{TA}, B::StaticVecOrMatLike{TB}) where {sa,sb,TA,TB}
    m = sb[1]
    n = length(sb) > 1 ? sb[2] : 1
    if m != sa[1]
        throw(DimensionMismatch("right hand side B needs first dimension of size $(sa[1]), has size $m"))
    end

    X = [Symbol("X_$(i)_$(j)") for i = 1:m, j = 1:n]

    isunitdiag = A <: Union{UnitUpperTriangular, UnitLowerTriangular}
    isupper = A <: Union{UnitUpperTriangular, UpperTriangular}

    j_range = isupper ? (m:-1:1) : (1:m)

    init = gen_by_access(B, :B) do access_b
        init_exprs = [:($(X[i,j]) = $(uplo_access(sb, :b, i, j, access_b))) for i = 1:m, j = 1:n]
        code = Expr(:block, init_exprs...)
        for k = 1:n
            for j = j_range
                if !isunitdiag && k == 1
                    push!(code.args, :(A.data[$(LinearIndices(sa)[j, j])] == zero(A.data[$(LinearIndices(sa)[j, j])]) && throw(LinearAlgebra.SingularException($j))))
                end
                if isunitdiag
                    push!(code.args, :($(X[j,k]) = oneunit(TA) \ $(X[j,k])))
                else
                    push!(code.args, :($(X[j,k]) = A.data[$(LinearIndices(sa)[j, j])] \ $(X[j,k])))
                end
                i_range = isupper ? (j-1:-1:1) : (j+1:m)
                for i = i_range
                    push!(code.args, :($(X[i,k]) -= A.data[$(LinearIndices(sa)[i, j])]*$(X[j,k])))
                end
            end
        end
        return code
    end

    return quote
        @_inline_meta
        b = mul_parent(B)
        Tb = TB
        @inbounds $init
        TAB = typeof((zero(TA)*zero(TB) + zero(TA)*zero(TB))/one(TA))
        @inbounds return similar_type(B, TAB)(tuple($(X...)))
    end
end

function _first_zero_on_diagonal(A::StaticULT)
    _first_zero_on_diagonal(A.data)
end

"""
    Args

A help wrapper to distinguish `SA(x...)` and `SA((x...,))`
"""
struct Args{T<:Tuple}
    args::T
end
Length(x::Args) = Length(length(x.args))
const BadArgs = Args{<:Tuple{Tuple{<:Tuple}}}

# Some help functions.
@pure has_ndims(::Type{<:StaticArray{<:Tuple,<:Any,N}}) where {N} = @isdefined N
has_ndims(::Type{<:StaticArray}) = false
if VERSION < v"1.7"
    Base.ndims(::Type{<:StaticArray{<:Tuple,<:Any,N}}) where {N} = N
end
@pure has_eltype(::Type{<:StaticArray{<:Tuple,T}}) where {T} = @isdefined T
has_eltype(::Type{<:StaticArray}) = false
@pure has_size(::Type{<:StaticArray{S}}) where {S<:Tuple} = @isdefined S
has_size(::Type{<:StaticArray}) = false
# workaround for https://github.com/JuliaArrays/StaticArrays.jl/issues/1047
has_size(::Type{SVector}) = false
has_size(::Type{MVector}) = false
has_size(::Type{SMatrix}) = false
has_size(::Type{MMatrix}) = false
has_size(::Type{SMatrix{N}}) where {N} = false
has_size(::Type{MMatrix{N}}) where {N} = false

@pure has_size1(::Type{<:StaticMatrix{M}}) where {M} = @isdefined M
has_size1(::Type{<:StaticMatrix}) = false
_size1(::Type{<:StaticMatrix{M}}) where {M} = M
@generated function _sqrt(::Length{L}) where {L}
    N = isqrt(L)
    N^2 == L && return :($N)
    throw(DimensionMismatch("Input's length must be perfect square"))
end

"""
    SA′ = construct_type(::Type{SA}, x) where {SA<:StaticArray}

Pick a proper constructor `SA′` based on `x` if `SA(x)`/`SA(x...)` has no specific definition.
The default returned `SA′` is `SA` itself for user defined `StaticArray`s. This differs from 
`similar_type()` in that `SA′` should always be a subtype of `SA`.

!!! note
    To distinguish `SA(x...)` and `SA(x::Tuple)`, the former calls 
    `construct_type(SA, StaticArrays.Args(x))` instead of `construct_type(SA, x)`.

!!! note
    Please make sure `SA'(x)` has a specific definition if the default behavior is overloaded. 
    Otherwise construction might fall into infinite recursion.

---
The adaption rules for official `StaticArray`s could be summarized as:

# `SA <: FieldArray`: `eltype` adaptable

`FieldArray`s are always static-sized. We only derive `SA′`'s `eltype` using type promotion if needed.

# `SA <: Union{SArray, MArray, SHermitianCompact, SizedArray}`: `size`/`eltype` adaptable

- `SA(x::Tuple)`

  If `SA` is fully static-sized, then we first try to fill `SA` with `x`'s elements.
  If failed and `length(SA) == 1`, then we try to fill `SA` with `x` itself.

  If `SA` is not fully static-sized, then we always try to fill `SA` with `x`'s elements,
  and the constructor's `Size` is derived based on:
  1. If `SA <: StaticVector`, then we use `length(x)` as the output `Length`
  2. If `SA <: StaticMatrix{M}`, then we use `(M, N)` (`N = length(x) ÷ M`) as the output `Size`
  3. If `SA <: StaticMatrix{M,M} where M`, then we use `(N, N)` (`N = sqrt(length(x)`) as the output `Size`.

- `SA(x...)`

  Similar to `Tuple`, but we never fill `SA` with `x` itself.

- `SA(x::StaticArray)`

  We treat `x` as `Tuple` whenever possible. If failed, then try to inherit `x`'s `Size`.

- `SA(x::AbstractArray)`

  `x` is used to provide eltype. Thus `SA` must be static sized.

"""
function construct_type(::Type{SA}, x) where {SA<:StaticArray}
    x isa BadArgs || return SA
    _no_precise_size(SA, x.args[1][1])
end

# These StaticArrays support `size`/`eltype` adaption during construction.
const SizeEltypeAdaptable = Union{SArray, MArray, SHermitianCompact, SizedArray}
function construct_type(::Type{SA}, x) where {SA<:SizeEltypeAdaptable}
    SA′ = adapt_eltype(adapt_size(SA, x), x)
    check_parameters(SA′)
    (!need_rewrap(SA′, x) && x isa Tuple && SA === SA′) || return SA′
    error("Constructor for $SA is missing. Please file a bug.")
end

adapt_size_impl1(::Type{SA}, ::Any, y::Int) where {SA<:StaticArray} = y
adapt_size_impl1(::Type{SA}, x, ::Any) where {SA<:StaticArray} = _no_precise_size(SA, x)

adapt_size_impl0(::Type{SA}, x, ::Length{y}) where {SA<:StaticArray, y} = adapt_size_impl1(SA, x, y)

function adapt_size(::Type{SA}, x) where {SA<:StaticArray}
    if has_size(SA) && length_match_size(SA, x)
        SZ = Tuple{size(SA)...}
    else
        len = x isa Tuple ? length(x) : adapt_size_impl0(SA, x, Length(x))
        len isa Int || _no_precise_size(SA, x)
        if SA <: StaticVector
            SZ = Tuple{len}
        elseif SA <: StaticMatrix && has_size1(SA)
            N = _size1(SA)
            M = len ÷ N
            M * N == len || throw(DimensionMismatch("Incorrect matrix sizes. $len does not divide $N elements"))
            SZ = Tuple{N, M}
        elseif SA <: StaticMatrix{N,N} where {N}
            N = _sqrt(Length(len))
            SZ = Tuple{N, N}
        elseif x isa StaticArray
            SZ = Tuple{size(x)...}
        else
            _no_precise_size(SA, x)
        end
    end
    SA′ = typeintersect(SA, StaticArrayNoEltype{SZ,tuple_length(SZ)})
    SA′ === Union{} && _no_precise_size(SA, x)
    return SA′
end

function length_match_size(::Type{SA}, x) where {SA<:StaticArray}
    if has_ndims(SA)
        SZ, N = size(SA), ndims(SA)
        length(SZ) == N || throw(ArgumentError("Size $(Tuple{SZ...}) mismatches dimension $N."))
    end
    _length_match_size(length(SA), x) || _no_precise_size(SA, x)
end
_length_match_size(l::Int, x::Union{Tuple,StaticArray}) = l == 1 || l == length(x)
_length_match_size(l::Int, x::Args) = l == length(x.args)
_length_match_size(::Int, _) = true

function adapt_eltype(::Type{SA}, x) where {SA<:StaticArray}
    has_eltype(SA) && return SA
    T = if need_rewrap(SA, x)
        typeof(x)
    elseif x isa Tuple
        promote_tuple_eltype(x)
    elseif x isa Args
        promote_tuple_eltype(x.args)
    else
        eltype(x)
    end
    return typeintersect(SA, AbstractArray{T})
end

need_rewrap(::Type{<:StaticArray}, x) = false
function need_rewrap(::Type{SA}, x::Union{Tuple,StaticArray}) where {SA <: StaticArray}
    has_size(SA) && length(SA) == 1 && length(x) != 1
end

check_parameters(::Type{<:SizeEltypeAdaptable}) = nothing
check_parameters(::Type{SArray{S,T,N,L}}) where {S<:Tuple,T,N,L} = check_array_parameters(S,T,Val{N},Val{L})
check_parameters(::Type{MArray{S,T,N,L}}) where {S<:Tuple,T,N,L} = check_array_parameters(S,T,Val{N},Val{L})
check_parameters(::Type{SHermitianCompact{N,T,L}}) where {N,T,L} = _check_hermitian_parameters(Val(N), Val(L))

_no_precise_size(SA, x::Args) = _no_precise_size(SA, x.args)
_no_precise_size(SA, x::Tuple) = throw(DimensionMismatch("No precise constructor for $SA found. Length of input was $(length(x))."))
_no_precise_size(SA, x::StaticArray) = throw(DimensionMismatch("No precise constructor for $SA found. Size of input was $(size(x))."))
_no_precise_size(SA, x) = throw(DimensionMismatch("No precise constructor for $SA found. Input is not static sized."))

@inline (::Type{SA})(x...) where {SA <: StaticArray} = construct_type(SA, Args(x))(x)
@inline function (::Type{SA})(x::Tuple) where {SA <: SizeEltypeAdaptable}
    SA′ = construct_type(SA, x)
    need_rewrap(SA′, x) ? SA′((x,)) : SA′(x)
end
@inline function (::Type{SA})(sa::StaticArray) where {SA <: StaticArray}
    SA′ = construct_type(SA, sa)
    need_rewrap(SA′, sa) ? SA′((sa,)) : SA′(Tuple(sa))
end
@propagate_inbounds (T::Type{<:StaticArray})(a::AbstractArray) = convert(T, a)

# this covers most conversions and "statically-sized reshapes"
@inline function convert(::Type{SA}, sa::StaticArray{S}) where {SA<:StaticArray,S<:Tuple}
    SA′ = construct_type(SA, sa)
    # `SA′((sa,))` is not valid. As we want `SA′(sa...)`
    need_rewrap(SA′, sa) && _no_precise_size(SA, sa)
    return SA′(Tuple(sa))
end
@inline convert(::Type{SA}, sa::SA) where {SA<:StaticArray} = sa
@inline convert(::Type{SA}, x::Tuple) where {SA<:StaticArray} = SA(x) # convert -> constructor. Hopefully no loops...

# support conversion to AbstractArray
AbstractArray{T}(sa::StaticArray{S,T}) where {S,T} = sa
AbstractArray{T,N}(sa::StaticArray{S,T,N}) where {S,T,N} = sa
AbstractArray{T}(sa::StaticArray{S,U}) where {S,T,U} = similar_type(typeof(sa),T,Size(sa))(sa)
AbstractArray{T,N}(sa::StaticArray{S,U,N}) where {S,T,U,N} = similar_type(typeof(sa),T,Size(sa))(sa)

# Constructing a Tuple from a StaticArray
@inline Base.Tuple(a::StaticArray) = unroll_tuple(a, Length(a))

@noinline function dimension_mismatch_fail(::Type{SA}, a::AbstractArray) where {SA <: StaticArray}
    throw(DimensionMismatch("expected input array of length $(length(SA)), got length $(length(a))"))
end

@propagate_inbounds function convert(::Type{SA}, a::AbstractArray) where {SA <: StaticArray}
    @boundscheck if length(a) != length(SA)
        dimension_mismatch_fail(SA, a)
    end
    SA′ = construct_type(SA, a)
    return SA′(unroll_tuple(a, Length(SA′)))
end

length_val(a::T) where {T <: StaticArrayLike} = length_val(Size(T))
length_val(a::Type{T}) where {T<:StaticArrayLike} = length_val(Size(T))

unroll_tuple(a::AbstractArray, ::Length{0}) = ()
unroll_tuple(a::AbstractArray, ::Length{1}) = @inbounds (a[],)
@generated function unroll_tuple(a::AbstractArray, ::Length{L}) where {L}
    exprs = (:(a[$j+Δj]) for j = 0:L-1)
    quote
        @_inline_meta
        Δj = firstindex(a)
        @inbounds return $(Expr(:tuple, exprs...))
    end
end

# `float` and `real` of StaticArray types, analogously to application to scalars (issue 935)
float(::Type{SA}) where SA<:StaticArray{_S,T,_N} where {_S,T,_N} = similar_type(SA, float(T))
real(::Type{SA}) where SA<:StaticArray{_S,T,_N} where {_S,T,_N} = similar_type(SA, real(T))

@inline zeros(::Type{SA}) where {SA <: StaticArray{<:Tuple}} = zeros(typeintersect(SA, AbstractArray{Float64}))
@inline zeros(::Type{SA}) where {SA <: StaticArray{<:Tuple, T}} where T = _zeros(Size(SA), SA)
@generated function _zeros(::Size{s}, ::Type{SA}) where {s, SA <: StaticArray}
    T = eltype(SA)
    v = [:(zero($T)) for i = 1:prod(s)]
    if SA <: SArray
        SA = SArray{Tuple{s...}, T, length(s), prod(s)}
    elseif SA <: MArray
        SA = MArray{Tuple{s...}, T, length(s), prod(s)}
    elseif SA <: SizedArray
        SA = SizedArray{Tuple{s...}, T, length(s)}
    end
    return quote
        @_inline_meta
        $SA(tuple($(v...)))
    end
end

@inline ones(::Type{SA}) where {SA <: StaticArray{<:Tuple}} = ones(typeintersect(SA, AbstractArray{Float64}))
@inline ones(::Type{SA}) where {SA <: StaticArray{<:Tuple, T}} where T = _ones(Size(SA), SA)
@generated function _ones(::Size{s}, ::Type{SA}) where {s, SA <: StaticArray}
    T = eltype(SA)
    v = [:(one($T)) for i = 1:prod(s)]
    if SA <: SArray
        SA = SArray{Tuple{s...}, T, length(s), prod(s)}
    elseif SA <: MArray
        SA = MArray{Tuple{s...}, T, length(s), prod(s)}
    elseif SA <: SizedArray
        SA = SizedArray{Tuple{s...}, T, length(s)}
    end
    return quote
        @_inline_meta
        $SA(tuple($(v...)))
    end
end

@inline fill(val, ::SA) where {SA <: StaticArray{<:Tuple}} = _fill(val, Size(SA), SA)
@inline fill(val::U, ::Type{SA}) where {SA <: StaticArray} where U = fill(val, Base.typeintersect(SA, AbstractArray{U}))
@inline fill(val, ::Type{SA}) where {SA <: StaticArray{<:Tuple, T}} where T = _fill(val, Size(SA), SA)
@generated function _fill(val, ::Size{s}, ::Type{SA}) where {s, SA <: StaticArray}
    T = eltype(SA)
    v = [:val for i = 1:prod(s)]
    if SA <: SArray
        SA = SArray{Tuple{s...}, T, length(s), prod(s)}
    elseif SA <: MArray
        SA = MArray{Tuple{s...}, T, length(s), prod(s)}
    elseif SA <: SizedArray
        SA = SizedArray{Tuple{s...}, T, length(s)}
    end
    return quote
        @_inline_meta
        $SA(tuple($(v...)))
    end
end

# Also consider randcycle, randperm? Also faster rand!(staticarray, collection)

using Random: SamplerType
@inline rand(rng::AbstractRNG, ::Type{SA}, dims::Dims) where {SA <: StaticArray} = rand!(rng, Array{SA}(undef, dims), SA)
@inline rand(rng::AbstractRNG, ::SamplerType{SA}) where {SA <: StaticArray} = _rand(rng, Size(SA), SA)

@generated function _rand(rng::AbstractRNG, ::Size{s}, ::Type{SA}) where {s, SA <: StaticArray}
    T = eltype(SA)
    if T == Any
        T = Float64
    end
    v = [:(rand(rng, $T)) for i = 1:prod(s)]
    if SA <: SArray
        SA = SArray{Tuple{s...}, T, length(s), prod(s)}
    elseif SA <: MArray
        SA = MArray{Tuple{s...}, T, length(s), prod(s)}
    elseif SA <: SizedArray
        SA = SizedArray{Tuple{s...}, T, length(s)}
    end
    return quote
        @_inline_meta
        $SA(tuple($(v...)))
    end
end

@inline rand(rng::AbstractRNG, range::AbstractArray, ::Type{SA}) where {SA <: StaticArray} = _rand(rng, range, Size(SA), SA)
@inline rand(range::AbstractArray, ::Type{SA}) where {SA <: StaticArray} = _rand(Random.GLOBAL_RNG, range, Size(SA), SA)
@generated function _rand(rng::AbstractRNG, X, ::Size{s}, ::Type{SA}) where {s, SA <: StaticArray}
    v = [:(rand(rng, X)) for i = 1:prod(s)]
    return quote
        @_inline_meta
        $SA(tuple($(v...)))
    end
end

#@inline rand(rng::MersenneTwister, range::AbstractArray, ::Type{SA}) where {SA <: StaticArray} = _rand(rng, range, Size(SA), SA)

@inline randn(rng::AbstractRNG, ::Type{SA}) where {SA <: StaticArray} = _randn(rng, Size(SA), SA)
@generated function _randn(rng::AbstractRNG, ::Size{s}, ::Type{SA}) where {s, SA <: StaticArray}
    T = eltype(SA)
    if T == Any
        T = Float64
    end
    v = [:(randn(rng, $T)) for i = 1:prod(s)]
    if SA <: SArray
        SA = SArray{Tuple{s...}, T, length(s), prod(s)}
    elseif SA <: MArray
        SA = MArray{Tuple{s...}, T, length(s), prod(s)}
    elseif SA <: SizedArray
        SA = SizedArray{Tuple{s...}, T, length(s)}
    end
    return quote
        @_inline_meta
        $SA(tuple($(v...)))
    end
end

@inline randexp(rng::AbstractRNG, ::Type{SA}) where {SA <: StaticArray} = _randexp(rng, Size(SA), SA)
@generated function _randexp(rng::AbstractRNG, ::Size{s}, ::Type{SA}) where {s, SA <: StaticArray}
    T = eltype(SA)
    if T == Any
        T = Float64
    end
    v = [:(randexp(rng, $T)) for i = 1:prod(s)]
    if SA <: SArray
        SA = SArray{Tuple{s...}, T, length(s), prod(s)}
    elseif SA <: MArray
        SA = MArray{Tuple{s...}, T, length(s), prod(s)}
    elseif SA <: SizedArray
        SA = SizedArray{Tuple{s...}, T, length(s)}
    end
    return quote
        @_inline_meta
        $SA(tuple($(v...)))
    end
end

# Mutable versions

# Why don't these two exist in Base?
# @generated function Base.zeros!{SA <: StaticArray}(a::SA)
# @generated function Base.ones!{SA <: StaticArray}(a::SA)

@inline fill!(a::SA, val) where {SA <: StaticArray} = _fill!(Size(SA), a, val)
@generated function _fill!(::Size{s}, a::SA, val) where {s, SA <: StaticArray}
    exprs = [:(a[$i] = valT) for i = 1:prod(s)]
    return quote
        @_inline_meta
        valT = convert(eltype(SA), val)
        @inbounds $(Expr(:block, exprs...))
        return a
    end
end

@inline rand!(rng::AbstractRNG, a::SA) where {SA <: StaticArray} = _rand!(rng, Size(SA), a)
@generated function _rand!(rng::AbstractRNG, ::Size{s}, a::SA) where {s, SA <: StaticArray}
    exprs = [:(a[$i] = rand(rng, eltype(SA))) for i = 1:prod(s)]
    return quote
        @_inline_meta
        @inbounds $(Expr(:block, exprs...))
        return a
    end
end

@inline rand!(rng::MersenneTwister, a::SA) where {SA <: StaticArray{<:Tuple, Float64}} = _rand!(rng, Size(SA), a)

@inline randn!(rng::AbstractRNG, a::SA) where {SA <: StaticArray} = _randn!(rng, Size(SA), a)
@generated function _randn!(rng::AbstractRNG, ::Size{s}, a::SA) where {s, SA <: StaticArray}
    exprs = [:(a[$i] = randn(rng, eltype(SA))) for i = 1:prod(s)]
    return quote
        @_inline_meta
        @inbounds $(Expr(:block, exprs...))
        return a
    end
end

@inline randexp!(rng::AbstractRNG, a::SA) where {SA <: StaticArray} = _randexp!(rng, Size(SA), a)
@generated function _randexp!(rng::AbstractRNG, ::Size{s}, a::SA) where {s, SA <: StaticArray}
    exprs = [:(a[$i] = randexp(rng, eltype(SA))) for i = 1:prod(s)]
    return quote
        @_inline_meta
        @inbounds $(Expr(:block, exprs...))
        return a
    end
end

"""
    arithmetic_closure(T)

Return the type which values of type `T` will promote to under a combination of the arithmetic operations `+`, `-`, `*` and `/`.

```jldoctest
julia> import StaticArrays.arithmetic_closure

julia> arithmetic_closure(Bool)
Float64

julia> arithmetic_closure(Int32)
Float64

julia> arithmetic_closure(BigFloat)
BigFloat

julia> arithmetic_closure(BigInt)
BigFloat
```
"""
arithmetic_closure(::Type{T}) where T = typeof((one(T)*zero(T) + zero(T))/one(T))

@testset "SUnitRange" begin
    @test length(StaticArrays.SUnitRange(1,3)) === 3
    @test length(StaticArrays.SUnitRange(1,-10)) === 0

    @test_throws BoundsError StaticArrays.SUnitRange(2,4)[0]
    @test StaticArrays.SUnitRange(2,4)[1] === 2
    @test StaticArrays.SUnitRange(2,4)[2] === 3
    @test StaticArrays.SUnitRange(2,4)[3] === 4
    @test_throws BoundsError StaticArrays.SUnitRange(2,4)[4]

    @test_throws Exception StaticArrays.SUnitRange{1, -1}()
    @test_throws TypeError StaticArrays.SUnitRange{1, 1.5}()

    let su = StaticArrays.SUnitRange(1, 2),
        str = "SUnitRange(1,2)",
        str2 = "($(str), $(str))"
        @test repr(su) == str
        @test repr("text/plain", su) == str
        @test repr((su, su)) == str2
        @test repr("text/plain", (su, su)) == str2
    end
end

lyap(a::StaticMatrix,  c::StaticMatrix) = _lyap(Size(a), Size(c), a, c)

_lyap(::Size{(1,1)}, ::Size{(1,1)}, a::StaticMatrix,  c::StaticMatrix) = -c/(2a[1,1])

@inline function _lyap(::Size{(2,2)}, ::Size{(2,2)}, a::StaticMatrix,  c::StaticMatrix)
    d = det(a)
    t = tr(a)
     -(d*c  + (a - t*I)*c*(a-t*I)')/(2*d*t) # http://www.nber.org/papers/w8956.pdf
end

@inline _lyap(::Size, ::Size{SC}, a::StaticMatrix, c::StaticMatrix) where {SC} =
    SizedArray{Tuple{SC...}}(lyap(Array(a),Array(c)))

@testset "Scalar" begin
    @test Scalar(2) .* [1, 2, 3] == [2, 4, 6]
    @test Scalar([1 2; 3 4]) .+ [[1 1; 1 1], [2 2; 2 2]] == [[2 3; 4 5], [3 4; 5 6]]
    @test (Scalar(1) + Scalar(1.0))::Scalar{Float64} ≈ Scalar(2.0)
    @test_throws ErrorException Scalar(2)[2]
    @test Scalar(2)[] == 2
    @testinf Tuple(Scalar(2)) === (2,)
    @testinf Tuple(convert(Scalar{Float64}, [2.0])) === (2.0,)
    a = Array{Float64, 0}(undef)
    a[] = 2
    @test Scalar(a)[] == 2
    s = Scalar(a)
    @test convert(typeof(s), s) === s
    @test Scalar(SVector(1,2,3))[] === SVector(1,2,3)
    @test Scalar(MArray{Tuple{}}(1)) === Scalar(1)
end

@testset "issue #809" begin
    @test_throws DimensionMismatch Scalar(1, 2)
end

#####################
## MVector methods ##
#####################
"""
    @MVector [a, b, c, d]
    @MVector [i for i in 1:2]
    @MVector ones(2)

A convenience macro to construct `MVector`.
See [`@SArray`](@ref) for detailed features.
"""
macro MVector(ex)
    static_vector_gen(MVector, ex, __module__)
end

# Named field access for the first four elements, using the conventional field
# names from low-dimensional geometry (x,y,z) and computer graphics (w).
let dimension_names = QuoteNode.([:x, :y, :z, :w])
    body = :(getfield(v, name))
    for (i,dim_name) in enumerate(dimension_names)
        @eval @inline function Base.propertynames(v::Union{SVector{$i},MVector{$i}}, private::Bool = false)
            named_dims = ($(first(dimension_names, i)...),)
            private ? (named_dims..., :data) : named_dims
        end

        body = :(name === $(dimension_names[i]) ? getfield(v, :data)[$i] : $body)
        @eval @inline function Base.getproperty(v::Union{SVector{$i},MVector{$i}},
                                                name::Symbol)
            $body
        end
    end

    body = :(setfield!(v, name, e))
    for (i,dim_name) in enumerate(dimension_names)
        body = :(name === $dim_name ? @inbounds(v[$i] = e) : $body)
        @eval @inline function Base.setproperty!(v::MVector{$i}, name::Symbol, e)
            $body
        end
    end
end

# for longer S/MVectors and other S/MArrays, the only property is data, and it's private
Base.propertynames(::Union{SArray,MArray}, private::Bool = false) = private ? (:data,) : ()

@inline function eigvals(a::LinearAlgebra.RealHermSymComplexHerm{T,SA},; permute::Bool=true, scale::Bool=true) where {T <: Real, SA <: StaticArray}
    _eigvals(Size(SA), a, permute, scale)
end

@inline function eigvals(a::StaticArray; permute::Bool=true, scale::Bool=true)
    if ishermitian(a)
        _eigvals(Size(a), Hermitian(a), permute, scale)
    elseif Size(a) == Size{(1,1)}()
        _eigvals(Size(a), a, permute, scale)
    else
        error("Only hermitian matrices are diagonalizable by *StaticArrays*. Non-Hermitian matrices should be converted to `Array` first.")
    end
end

function eigvals(A::StaticMatrixLike, B::StaticMatrixLike; kwargs...)
    SA = Size(A)
    if SA != Size(B)
        throw(DimensionMismatch("Generalized eigenvalues can only be calculated for matrices of equal sizes: dimensions are $SA and $(Size(B))"))
    end
    checksquare(A)
    return _eigvals(SA, A, B; kwargs...)
end

@inline function _eigvals(s::Size, A::StaticMatrixLike, B::StaticMatrixLike; kwargs...)
    return SVector{s[1]}(eigvals(Array(A), Array(B); kwargs...))
end

@inline _eigvals(::Size{(1,1)}, a, permute, scale) = @inbounds return SVector(Tuple(a))
@inline _eigvals(::Size{(1, 1)}, a::LinearAlgebra.RealHermSymComplexHerm{T}, permute, scale) where {T <: Real} = @inbounds return SVector(real(parent(a).data[1]))

@inline function _eigvals(::Size{(2,2)}, A::LinearAlgebra.RealHermSymComplexHerm{T}, permute, scale) where {T <: Real}
    a = A.data

    if A.uplo == 'U'
        @inbounds t_half = real(a[1] + a[4])/2
        @inbounds d = real(a[1]*a[4] - a[3]'*a[3]) # Should be real

        tmp2 = t_half*t_half - d
        tmp2 < 0 ? tmp = zero(tmp2) : tmp = sqrt(tmp2) # Numerically stable for identity matrices, etc.
        return SVector(t_half - tmp, t_half + tmp)
    else
        @inbounds t_half = real(a[1] + a[4])/2
        @inbounds d = real(a[1]*a[4] - a[2]'*a[2]) # Should be real

        tmp2 = t_half*t_half - d
        tmp2 < 0 ? tmp = zero(tmp2) : tmp = sqrt(tmp2) # Numerically stable for identity matrices, etc.
        return SVector(t_half - tmp, t_half + tmp)
    end
end

@inline function _eigvals(::Size{(3,3)}, A::LinearAlgebra.RealHermSymComplexHerm{T}, permute, scale) where {T <: Real}
    S = if typeof(A) <: Hermitian{Complex{T}}
        complex(arithmetic_closure(T))
    else
        arithmetic_closure(T)
    end
    Sreal = real(S)

    @inbounds a11 = convert(Sreal, real(A.data[1]))
    @inbounds a22 = convert(Sreal, real(A.data[5]))
    @inbounds a33 = convert(Sreal, real(A.data[9]))
    if A.uplo == 'U'
        @inbounds a12 = convert(S, A.data[4])
        @inbounds a13 = convert(S, A.data[7])
        @inbounds a23 = convert(S, A.data[8])
    else
        @inbounds a12 = conj(convert(S, A.data[2]))
        @inbounds a13 = conj(convert(S, A.data[3]))
        @inbounds a23 = conj(convert(S, A.data[6]))
    end

    p1 = abs2(a12) + abs2(a13) + abs2(a23)
    if (p1 == 0)
        # Matrix is diagonal
        if a11 < a22
            if a22 < a33
                return SVector(a11, a22, a33)
            elseif a33 < a11
                return SVector(a33, a11, a22)
            else
                return SVector(a11, a33, a22)
            end
        else #a22 < a11
            if a11 < a33
                return SVector(a22, a11, a33)
            elseif a33 < a22
                return SVector(a33, a22, a11)
            else
                return SVector(a22, a33, a11)
            end
        end
    end

    q = (a11 + a22 + a33) / 3
    p2 = abs2(a11 - q) + abs2(a22 - q) + abs2(a33 - q) + 2 * p1
    p = sqrt(p2 / 6)
    invp = inv(p)
    b11 = (a11 - q) * invp
    b22 = (a22 - q) * invp
    b33 = (a33 - q) * invp
    b12 = a12 * invp
    b13 = a13 * invp
    b23 = a23 * invp
    B = SMatrix{3,3,S}((b11, conj(b12), conj(b13), b12, b22, conj(b23), b13, b23, b33))
    r = real(det(B)) / 2

    # In exact arithmetic for a symmetric matrix  -1 <= r <= 1
    # but computation error can leave it slightly outside this range.
    if (r <= -1)
        phi = Sreal(pi) / 3
    elseif (r >= 1)
        phi = zero(Sreal)
    else
        phi = acos(r) / 3
    end

    eig3 = q + 2 * p * cos(phi)
    eig1 = q + 2 * p * cos(phi + (2*Sreal(pi)/3))
    eig2 = 3 * q - eig1 - eig3     # since tr(A) = eig1 + eig2 + eig3

    return SVector(eig1, eig2, eig3)
end

@inline function _eigvals(s::Size, A::LinearAlgebra.RealHermSymComplexHerm{T}, permute, scale) where {T <: Real}
    vals = eigvals(Hermitian(Array(parent(A))))
    return SVector{s[1], T}(vals)
end

# Utility to rewrap `Eigen` of normal `Array` into an Eigen containing `SArray`.
@inline function _make_static(s::Size, E::Eigen{T,V}) where {T,V}
    Eigen(similar_type(SVector, V, Size(s[1]))(E.values),
          similar_type(SMatrix, T, s)(E.vectors))
end

@inline function _eig(s::Size, A::T, permute, scale) where {T <: StaticMatrix}
    if ishermitian(A)
        return _eig(s, Hermitian(A), permute, scale)
    else
        # For the non-hermitian branch fall back to LinearAlgebra eigen().
        # Eigenvalues could be real or complex so a Union of concrete types is
        # inferred. Having _make_static a separate function allows inference to
        # preserve the union of concrete types:
        #   Union{E{A,B},E{C,D}} -> Union{E{SA,SB},E{SC,SD}}
        _make_static(s, eigen(Array(A); permute = permute, scale = scale))
    end
end

@inline function _eig(s::Size, A::LinearAlgebra.RealHermSymComplexHerm{T}, permute, scale) where {T <: Real}
    E = eigen(Hermitian(Array(parent(A))))
    return Eigen(SVector{s[1], T}(E.values), SMatrix{s[1], s[2], eltype(A)}(E.vectors))
end


@inline function _eig(::Size{(1,1)}, A::LinearAlgebra.RealHermSymComplexHerm{T}, permute, scale) where {T <: Real}
    @inbounds return Eigen(SVector{1,T}((real(A[1]),)), SMatrix{1,1,eltype(A)}(I))
end

@inline function _eig(::Size{(2,2)}, A::LinearAlgebra.RealHermSymComplexHerm{T}, permute, scale) where {T <: Real}
    a = A.data
    TA = eltype(A)
    @inbounds a21 = A.uplo == 'U' ? a[3]' : a[2]
    @inbounds if !iszero(a21) # A is not diagonal
        t_half = real(a[1] + a[4]) / 2
        diag_avg_diff = (a[1] - a[4])/2
        tmp = norm(SVector(diag_avg_diff, a21))
        vals = SVector(t_half - tmp, t_half + tmp)
        v11 = -tmp + diag_avg_diff
        n1 = sqrt(v11' * v11 + a21 * a21')
        v11 = v11 / n1
        v12 = a21 / n1

        v21 = tmp + diag_avg_diff
        n2 = sqrt(v21' * v21 + a21 * a21')
        v21 = v21 / n2
        v22 = a21 / n2

        vecs = @SMatrix [ v11  v21 ;
                            v12  v22 ]

        return Eigen(vals, vecs)
    end

    # A must be diagonal if we reached this point; treatment of uplo 'L' and 'U' is then identical
    A11 = real(a[1])
    A22 = real(a[4])
    if A11 < A22
        vals = SVector(A11, A22)
        vecs = @SMatrix [convert(TA, 1) convert(TA, 0);
                         convert(TA, 0) convert(TA, 1)]
    else # A22 <= A11
        vals = SVector(A22, A11)
        vecs = @SMatrix [convert(TA, 0) convert(TA, 1);
                         convert(TA, 1) convert(TA, 0)]
    end
    return Eigen(vals,vecs)
end

# Port of https://www.geometrictools.com/GTEngine/Include/Mathematics/GteSymmetricEigensolver3x3.h
# released by David Eberly, Geometric Tools, Redmond WA 98052
# under the Boost Software License, Version 1.0 (included at the end of this file)
# The original documentation states
# (see https://www.geometrictools.com/Documentation/RobustEigenSymmetric3x3.pdf )
# [This] is an implementation of Algorithm 8.2.3 (Symmetric QR Algorithm) described in
# Matrix Computations,2nd edition, by G. H. Golub and C. F. Van Loan, The Johns Hopkins
# University Press, Baltimore MD, Fourth Printing 1993. Algorithm 8.2.1 (Householder
# Tridiagonalization) is used to reduce matrix A to tridiagonal D′. Algorithm 8.2.2
# (Implicit Symmetric QR Step with Wilkinson Shift) is used for the iterative reduction
# from tridiagonal to diagonal. Numerically, we have errors E=RTAR−D. Algorithm 8.2.3
# mentions that one expects |E| is approximately μ|A|, where |M| denotes the Frobenius norm
# of M and where μ is the unit roundoff for the floating-point arithmetic: 2−23 for float,
# which is FLTEPSILON = 1.192092896e-7f, and 2−52 for double, which is
# DBLEPSILON = 2.2204460492503131e-16.
# TODO ensure right-handedness of the eigenvalue matrix
# TODO extend the method to complex hermitian
@inline function _eig(::Size{(3,3)}, A::LinearAlgebra.HermOrSym{T}, permute, scale) where {T <: Real}
    function converged(aggressive, bdiag0, bdiag1, bsuper)
        if aggressive
            bsuper == 0
        else
            diag_sum = abs(bdiag0) + abs(bdiag1)
            diag_sum + bsuper == diag_sum
        end
    end

    function get_cos_sin(u::T,v::T) where {T}
        max_abs = max(abs(u), abs(v))
        if max_abs > 0
            u,v = (u,v) ./ max_abs
            len = sqrt(u^2 + v^2)
            cs, sn = (u,v) ./ len
            if cs > 0
                cs = -cs
                sn = -sn
            end
            T(cs), T(sn)
        else
            T(-1), T(0)
        end
    end

    function _sortperm3(v)
        local perm = SVector(1,2,3)
        # unrolled bubble-sort
        (v[perm[1]] > v[perm[2]]) && (perm = SVector(perm[2], perm[1], perm[3]))
        (v[perm[2]] > v[perm[3]]) && (perm = SVector(perm[1], perm[3], perm[2]))
        (v[perm[1]] > v[perm[2]]) && (perm = SVector(perm[2], perm[1], perm[3]))
        perm
    end

    # Givens reflections
    update0(Q, c, s) = Q * @SMatrix [c 0 -s; s 0 c; 0 1 0]
    update1(Q, c, s) = Q * @SMatrix [0 1 0; c 0 s; -s 0 c]
    # Householder reflections
    update2(Q, c, s) = Q * @SMatrix [c s 0; s -c 0; 0 0 1]
    update3(Q, c, s) = Q * @SMatrix [1 0 0; 0 c s; 0 s -c]

    is_rotation = false

    # If `aggressive` is `true`, the iterations occur until a superdiagonal
    # entry is exactly zero, otherwise they occur until it is effectively zero
    # compared to the magnitude of its diagonal neighbors. Generally the non-
    # aggressive convergence is acceptable.
    #
    # Even with `aggressive = true` this method is faster than the one it
    # replaces and in order to keep the old interface, aggressive is set to true
    aggressive = true

    # the input is symmetric, so we only consider the unique elements:
    a00, a01, a02, a11, a12, a22 = A[1,1], A[1,2], A[1,3], A[2,2], A[2,3], A[3,3]

    # Compute the Householder reflection H and B = H * A * H where b02 = 0

    c,s = get_cos_sin(a12, -a02)

    Q = @SMatrix [c s 0; s -c 0; 0 0 1]

    term0 = c * a00 + s * a01
    term1 = c * a01 + s * a11
    b00 = c * term0 + s * term1
    b01 = s * term0 - c * term1
    term0 = s * a00 - c * a01
    term1 = s * a01 - c * a11
    b11 = s * term0 - c * term1
    b12 = s * a02 - c * a12
    b22 = a22

    # Givens reflections, B' = G^T * B * G, preserve tridiagonal matrices
    #
    # `emin` is clamped because it can overflow for extended-range numbers.  This limit
    # compiles away for standard fixed-precision types, and does not change `max_iteration`
    # for them.  It corrects the behavior for `BigFloat`; see
    # https://github.com/JuliaArrays/StaticArrays.jl/issues/1349
    emin = max(exponent(floatmin(T)), -100_000)
    max_iteration = 2 * (1 + precision(T) - emin)

    if abs(b12) <= abs(b01)
        saveB00, saveB01, saveB11 = b00, b01, b11
        for iteration in 1:max_iteration
            # compute the Givens reflection
            c2, s2 = get_cos_sin((b00 - b11) / 2, b01)
            s = sqrt((1 - c2) / 2)
            c = s2 / 2s

            # update Q by the Givens reflection
            Q = update0(Q, c, s)
            is_rotation = !is_rotation

            # update B ← Q^T * B * Q, ensuring that b02 is zero and |b12| has
            # strictly decreased
            saveB00, saveB01, saveB11 = b00, b01, b11
            term0 = c * saveB00 + s * saveB01
            term1 = c * saveB01 + s * saveB11
            b00 = c * term0 + s * term1
            b11 = b22
            term0 = c * saveB01 - s * saveB00
            term1 = c * saveB11 - s * saveB01
            b22 = c * term1 - s * term0
            b01 = s * b12
            b12 = c * b12

            if converged(aggressive, b00, b11, b01)
                # compute the Householder reflection
                c2, s2 = get_cos_sin((b00 - b11) / 2, b01)
                s = sqrt((1 - c2) / 2)
                c = s2 / 2s

                # update Q by the Householder reflection
                Q = update2(Q, c, s)
                is_rotation = !is_rotation

                # update D = Q^T * B * Q
                saveB00, saveB01, saveB11 = b00, b01, b11
                term0 = c * saveB00 + s * saveB01
                term1 = c * saveB01 + s * saveB11
                b00 = c * term0 + s * term1
                term0 = s * saveB00 - c * saveB01
                term1 = s * saveB01 - c * saveB11
                b11 = s * term0 - c * term1
                break
            end
        end
    else
        saveB11, saveB12, saveB22 = b11, b12, b22
        for iteration in 1:max_iteration
            # compute the Givens reflection
            c2, s2 = get_cos_sin((b22 - b11) / 2, b12)
            s = sqrt((1 - c2) / 2)
            c = s2 / 2s

            # update Q by the Givens reflection
            Q = update1(Q, c, s)
            is_rotation = !is_rotation

            # update B ← Q^T * B * Q ensuring that b02 is zero and |b12| has
            # strictly decreased.
            saveB11, saveB12, saveB22 = b11, b12, b22

            term0 = c * saveB22 + s * saveB12
            term1 = c * saveB12 + s * saveB11
            b22 = c * term0 + s * term1
            b11 = b00
            term0 = c * saveB12 - s * saveB22
            term1 = c * saveB11 - s * saveB12
            b00 = c * term1 - s * term0
            b12 = s * b01
            b01 = c * b01

            if converged(aggressive, b11, b22, b12)
                # compute the Householder reflection
                c2, s2 = get_cos_sin((b11 - b22) / 2, b12)
                s = sqrt((1 - c2) / 2)
                c = s2 / 2s

                # update Q by the Householder reflection
                Q = update3(Q, c, s)
                is_rotation = !is_rotation

                # update D = Q^T * B * Q
                saveB11, saveB12, saveB22 = b11, b12, b22
                term0 = c * saveB11 + s * saveB12
                term1 = c * saveB12 + s * saveB22
                b11 = c * term0 + s * term1
                term0 = s * saveB11 - c * saveB12
                term1 = s * saveB12 - c * saveB22
                b22 = s * term0 - c * term1
                break
            end
        end
    end

    evals = @SVector [b00, b11, b22]
    perm = _sortperm3(evals)
    Eigen(evals[perm], Q[:,perm])
end


@inline function eigen(A::StaticMatrix; permute::Bool=true, scale::Bool=true)
    _eig(Size(A), A, permute, scale)
end

# to avoid method ambiguity with LinearAlgebra
@inline eigen(A::Hermitian{<:Real,<:StaticMatrix}; kwargs...)    = _eigen(A; kwargs...)
@inline eigen(A::Hermitian{<:Complex,<:StaticMatrix}; kwargs...) = _eigen(A; kwargs...)
@inline eigen(A::Symmetric{<:Real,<:StaticMatrix}; kwargs...)    = _eigen(A; kwargs...)
@inline eigen(A::Symmetric{<:Complex,<:StaticMatrix}; kwargs...) = _eigen(A; kwargs...)

@inline function _eigen(A::LinearAlgebra.HermOrSym; permute::Bool=true, scale::Bool=true)
    B = convert(AbstractArray{float(eltype(A))}, A)
    _eig(Size(A), B, permute, scale)
end

# NOTE: The following Boost Software License applies to parts of the method:
#     _eig{T<:Real}(::Size{(3,3)}, A::LinearAlgebra.RealHermSymComplexHerm{T}, permute, scale)

#=
Boost Software License - Version 1.0 - August 17th, 2003



Permission is hereby granted, free of charge, to any person or organization
obtaining a copy of the software and accompanying documentation covered by
this license (the "Software") to use, reproduce, display, distribute,
execute, and transmit the Software, and to prepare derivative works of the
Software, and to permit third-parties to whom the Software is furnished to
do so, all subject to the following:

The copyright notices in the Software and this entire statement, including
the above license grant, this restriction and the following disclaimer,
must be included in all copies of the Software, in whole or in part, and
all derivative works of the Software, unless such copies or derivative
works are solely in the form of machine-executable object code generated by
a source language processor.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
DEALINGS IN THE SOFTWARE.
=#

module BenchmarkMatMul

using StaticArrays
using BenchmarkTools
using LinearAlgebra
using Printf

suite = BenchmarkGroup()

mul_wrappers = [
    (m -> m, "ident  "),
    (m -> Symmetric(m, :U), "sym-u  "),
    (m -> Hermitian(m, :U), "herm-u "),
    (m -> UpperTriangular(m), "up-tri "),
    (m -> LowerTriangular(m), "lo-tri "),
    (m -> UnitUpperTriangular(m), "uup-tri"),
    (m -> UnitLowerTriangular(m), "ulo-tri"),
    (m -> Adjoint(m), "adjoint"),
    (m -> Transpose(m), "transpo"),
    (m -> Diagonal(m), "diag   ")]

mul_wrappers_reduced = [
    (m -> m, "ident  "),
    (m -> Symmetric(m, :U), "sym-u  "),
    (m -> UpperTriangular(m), "up-tri "),
    (m -> Transpose(m), "transpo"),
    (m -> Diagonal(m), "diag   ")]

for N in [2, 4, 8, 10, 12]

    matvecstr = @sprintf("mat-vec  %2d", N)
    matmatstr = @sprintf("mat-mat  %2d", N)
    matvec_mut_str = @sprintf("mat-vec! %2d", N)
    matmat_mut_str = @sprintf("mat-mat! %2d", N)

    suite[matvecstr] = BenchmarkGroup()
    suite[matmatstr] = BenchmarkGroup()
    suite[matvec_mut_str] = BenchmarkGroup()
    suite[matmat_mut_str] = BenchmarkGroup()


    A = randn(SMatrix{N,N,Float64})
    B = randn(SMatrix{N,N,Float64})
    bv = randn(SVector{N,Float64})
    for (wrapper_a, wrapper_name) in mul_wrappers_reduced
        thrown = false
        try
            wrapper_a(A) * bv
        catch e
            thrown = true
        end
        if !thrown
            suite[matvecstr][wrapper_name] = @benchmarkable $(Ref(wrapper_a(A)))[] * $(Ref(bv))[]
        end
    end

    for (wrapper_a, wrapper_a_name) in mul_wrappers, (wrapper_b, wrapper_b_name) in mul_wrappers
        thrown = false
        try
            wrapper_a(A) * wrapper_b(B)
        catch e
            thrown = true
        end
        if !thrown
            suite[matmatstr][wrapper_a_name * " * " * wrapper_b_name] = @benchmarkable $(Ref(wrapper_a(A)))[] * $(Ref(wrapper_b(B)))[]
        end
    end

    C = randn(MMatrix{N,N,Float64})
    cv = randn(MVector{N,Float64})

    for (wrapper_a, wrapper_name) in mul_wrappers
        thrown = false
        try
            mul!(cv, wrapper_a(A), bv)
        catch e
            thrown = true
        end
        if !thrown
            suite[matvec_mut_str][wrapper_name] = @benchmarkable mul!($cv, $(Ref(wrapper_a(A)))[], $(Ref(bv))[])
        end
    end

    for (wrapper_a, wrapper_a_name) in mul_wrappers, (wrapper_b, wrapper_b_name) in mul_wrappers
        thrown = false
        try
            mul!(C, wrapper_a(A), wrapper_b(B))
        catch e
            thrown = true
        end
        if !thrown
            suite[matmat_mut_str][wrapper_a_name * " * " * wrapper_b_name] = @benchmarkable mul!($C, $(Ref(wrapper_a(A)))[], $(Ref(wrapper_b(B)))[])
        end
    end
end

function run_and_save(fname, make_params = true)
    if make_params
        tune!(suite)
        BenchmarkTools.save("params.json", params(suite))
    else
        loadparams!(suite, BenchmarkTools.load("params.json")[1], :evals, :samples)
    end
    results = run(suite, verbose = true)
    BenchmarkTools.save(fname, results)
end

function judge_results(m1, m2)
    results = Any[]
    for key1 in keys(m1)
        if !haskey(m2, key1)
            continue
        end
        for key2 in keys(m1[key1])
            if !haskey(m2[key1], key2) 
                continue
            end
            push!(results, (key1, key2, judge(median(m1[key1][key2]), median(m2[key1][key2]))))
        end
    end
    return results
end

function full_benchmark(mul_wrappers, size_iter = 1:4, T = Float64)
    suite_full = BenchmarkGroup()
    for N in size_iter
        for M in size_iter
            a = randn(SMatrix{N,M,T})
            wrappers_a = N == M ? mul_wrappers : [mul_wrappers[1]]
            sa = Size(a)
            for K in size_iter
                b = randn(SMatrix{M,K,T})
                wrappers_b = M == K ? mul_wrappers : [mul_wrappers[1]]
                sb = Size(b)
                for (w_a, w_a_name) in wrappers_a
                    for (w_b, w_b_name) in wrappers_b
                        cur_str = @sprintf("mat-mat %s %s generic  (%2d, %2d) x (%2d, %2d)", w_a_name, w_b_name, N, M, M, K)
                        suite_full[cur_str] = @benchmarkable StaticArrays.mul_generic($sa, $sb, $(Ref(w_a(a)))[], $(Ref(w_b(b)))[])
                        cur_str = @sprintf("mat-mat %s %s default  (%2d, %2d) x (%2d, %2d)", w_a_name, w_b_name, N, M, M, K)
                        suite_full[cur_str] = @benchmarkable StaticArrays._mul($sa, $sb, $(Ref(w_a(a)))[], $(Ref(w_b(b)))[])
                        cur_str = @sprintf("mat-mat %s %s unrolled (%2d, %2d) x (%2d, %2d)", w_a_name, w_b_name, N, M, M, K)
                        suite_full[cur_str] = @benchmarkable StaticArrays.mul_unrolled($sa, $sb, $(Ref(w_a(a)))[], $(Ref(w_b(b)))[])
                        if w_a_name != "diag   " && w_b_name != "diag   "
                            cur_str = @sprintf("mat-mat %s %s chunks   (%2d, %2d) x (%2d, %2d)", w_a_name, w_b_name, N, M, M, K)
                            suite_full[cur_str] = @benchmarkable StaticArrays.mul_unrolled_chunks($sa, $sb, $(Ref(w_a(a)))[], $(Ref(w_b(b)))[])
                        end
                        if w_a_name == "ident  " && w_b_name == "ident  "
                            cur_str = @sprintf("mat-mat %s %s loop     (%2d, %2d) x (%2d, %2d)", w_a_name, w_b_name, N, M, M, K)
                            suite_full[cur_str] = @benchmarkable StaticArrays.mul_loop($sa, $sb, $(Ref(w_a(a)))[], $(Ref(w_b(b)))[])
                        end
                    end
                end
            end
        end
    end
    results = run(suite_full, verbose = true)
    results_median = map(collect(results)) do res
        return (res[1], median(res[2]).time)
    end
    return results_median
end

function judge_this(new_time, old_time, tol, w_a_name, w_b_name, N, M, K, which)
    if new_time*tol < old_time
        msg = @sprintf("better for %s %s (%2d, %2d) x (%2d, %2d): %s", w_a_name, w_b_name, N, M, M, K, which)
        println(msg)
        println(">> ", new_time, " | ", old_time)
    end
end

function pick_best(results, mul_wrappers, size_iter; tol = 1.2)
    for N in size_iter
        for M in size_iter
            wrappers_a = N == M ? mul_wrappers : [mul_wrappers[1]]
            for K in size_iter
                wrappers_b = M == K ? mul_wrappers : [mul_wrappers[1]]
                for (w_a, w_a_name) in wrappers_a
                    for (w_b, w_b_name) in wrappers_b
                        cur_default = @sprintf("mat-mat %s %s default  (%2d, %2d) x (%2d, %2d)", w_a_name, w_b_name, N, M, M, K)
                        default_time = results[cur_default]

                        cur_generic = @sprintf("mat-mat %s %s generic  (%2d, %2d) x (%2d, %2d)", w_a_name, w_b_name, N, M, M, K)
                        generic_time = results[cur_generic]
                        judge_this(generic_time, default_time, tol, w_a_name, w_b_name, N, M, K, "generic")

                        cur_unrolled = @sprintf("mat-mat %s %s unrolled (%2d, %2d) x (%2d, %2d)", w_a_name, w_b_name, N, M, M, K)
                        unrolled_time = results[cur_unrolled]
                        judge_this(unrolled_time, default_time, tol, w_a_name, w_b_name, N, M, K, "unrolled")
                        
                        if w_a_name != "diag   " && w_b_name != "diag   "
                            cur_chunks = @sprintf("mat-mat %s %s chunks   (%2d, %2d) x (%2d, %2d)", w_a_name, w_b_name, N, M, M, K)
                            chunk_time = results[cur_chunks]
                            judge_this(chunk_time, default_time, tol, w_a_name, w_b_name, N, M, K, "chunks")
                        end
                        if w_a_name == "ident  " && w_b_name == "ident  "
                            cur_loop = @sprintf("mat-mat %s %s loop     (%2d, %2d) x (%2d, %2d)", w_a_name, w_b_name, N, M, M, K)
                            loop_time = results[cur_loop]
                            judge_this(loop_time, default_time, tol, w_a_name, w_b_name, N, M, K, "loop")
                        end
                    end
                end
            end
        end
    end
end

function run_1()
    return full_benchmark(mul_wrappers_reduced, [2, 3, 4, 5, 8, 9, 12])
end

end #module
BenchmarkMatMul.suite

@testset "Custom types" begin
    # Issue 123
    @eval (struct MyType{N, T} <: StaticVector{N, T}
        data::NTuple{N, T}
    end)
    @test (MyType(3, 4) isa MyType{2, Int})

    # Issue 110
    @eval (struct Polly{N,T}
        data::SVector{N,T}
    end)
    @test (Polly{2,Float64}((1.0, 0.0)) isa Polly)
end

@generated function (::Type{MMatrix{S1,S2,T}})(::UndefInitializer) where {S1,S2,T}
    return quote
        $(Expr(:meta, :inline))
        MMatrix{S1, S2, T, $(S1*S2)}(undef)
    end
end

# Some more advanced constructor-like functions
@inline one(::Type{MMatrix{N}}) where {N} = one(MMatrix{N,N})


#####################
## MMatrix methods ##
#####################

"""
    @MMatrix [a b c d]
    @MMatrix [[a, b];[c, d]]
    @MMatrix [i+j for i in 1:2, j in 1:2]
    @MMatrix ones(2, 2)

A convenience macro to construct `MMatrix`.
See [`@SArray`](@ref) for detailed features.
"""
macro MMatrix(ex)
    static_matrix_gen(MMatrix, ex, __module__)
end

# Moore-Penrose pseudoinverse

@inline function pinv(A::StaticMatrix{m,n,T} where m where n; atol::Real = 0.0, rtol::Real = (eps(real(float(one(T))))*min(size(A)...))*iszero(atol)) where T
    # This function is a StaticMatrix version of `LinearAlgebra.pinv`.
    S = typeof(zero(T)/sqrt(one(T) + one(T)))
    A_S = convert(similar_type(A,S),A)
    return _pinv(A_S, atol, rtol)
end

@inline pinv(A::LinearAlgebra.HermOrSym{T,<:StaticMatrix}; kwargs...) where T = pinv(convert(similar_type(A), A); kwargs...)

@inline function _pinv(A::StaticMatrix{m,n,T}, atol::Real, rtol::Real) where T where m where n
    if m == 0 || n == 0
        return similar_type(A, Size(n,m))()
    end
    if isdiag(A)
        maxabsA = maximum(abs.(diag(A)))
        tol = max(rtol*maxabsA, atol)
        return _pinv_diag(A, tol)
    end
    ssvd = svd(A, full = false)
    tol = max(rtol*maximum(ssvd.S), atol)
    sinv = _pinv_vector(ssvd.S, tol)
    return ssvd.Vt'*SDiagonal(sinv)*ssvd.U'
end

@inline function pinv(D::Diagonal{T,<:StaticVector}) where T
    V = D.diag
    S = typeof(zero(T)/sqrt(one(T) + one(T)))
    V_S = convert(similar_type(V,S),V)
    return Diagonal(_pinv_vector(V_S))
end

@generated function _pinv_diag(A::StaticMatrix{m,n,T}, tol) where m where n where T
    minlen = min(m,n)
    exprs = [:(zero($T)) for i in 1:n, j in 1:m]
    for i in 1:minlen
        exprs[i,i] = :(ifelse(abs(A[$i,$i]) > tol, inv(A[$i,$i]), zero($T)))
    end
    return quote
        Base.@_inline_meta
        @inbounds return similar_type(A, Size($n, $m))(tuple($(exprs...)))
    end
end

@generated function _pinv_vector(v::StaticVector{n,T}, tol) where n where T
    exprs = [
        :(ifelse(v[$i] > tol, inv(v[$i]), zero(T)))
        for i in 1:n
    ]
    return quote
        Base.@_inline_meta
        @inbounds return similar_type(v, Size($n))(tuple($(exprs...)))
    end
end

@generated function _pinv_vector(v::StaticVector{n,T}) where n where T
    exprs = [
        :(pinv(v[$i]))
        for i in 1:n
    ]
    return quote
        Base.@_inline_meta
        @inbounds return similar_type(v, Size($n))(tuple($(exprs...)))
    end
end

# Originally contributed by D. Getz (https://github.com/getzdan), M. Schauer
# at https://github.com/mschauer/Bridge.jl under MIT License

import Base: ==, -, +, *, /, \, abs, real, imag, conj

const SDiagonal = Diagonal{T,SVector{N,T}} where {N,T}
SDiagonal(x...) = Diagonal(SVector(x...))

# this is to deal with convert.jl
#@inline (::Type{SDiagonal{N,T}})(a::AbstractVector) where {N,T} = Diagonal(SVector{N,T}(a))
@inline SDiagonal{N,T}(a::Tuple) where {N,T} = Diagonal(SVector{N,T}(a))
@inline SDiagonal{N}(a::Tuple) where {N} = Diagonal(SVector{N}(a))

SDiagonal(a::SVector) = Diagonal(a)
SDiagonal(a::StaticMatrix{N,N,T}) where {N,T} = Diagonal(diag(a))

size(::Type{SDiagonal{N}}) where {N} = (N,N)
size(::Type{SDiagonal{N,T}}) where {N,T} = (N,N)
size(::Type{SDiagonal{N}}, d::Int) where {N} = d > 2 ? 1 : N
size(::Type{SDiagonal{N,T}}, d::Int) where {N,T} = d > 2 ? 1 : N

# define specific methods to avoid allocating mutable arrays
\(D::SDiagonal, b::AbstractVector) = D.diag .\ b
\(D::SDiagonal, b::StaticVector) = D.diag .\ b # catch ambiguity

\(D::SDiagonal, B::StaticMatrix) = D.diag .\ B
/(B::StaticMatrix, D::SDiagonal) = B ./ transpose(D.diag)
\(Da::SDiagonal, Db::SDiagonal) = SDiagonal(Db.diag ./ Da.diag)
/(Da::SDiagonal, Db::SDiagonal) = SDiagonal(Da.diag ./ Db.diag )

\(D::Diagonal, B::StaticMatrix) = ldiv!(D, Matrix(B))

# override to avoid copying
diag(D::SDiagonal) = D.diag

# SDiagonal(I::UniformScaling) methods
SDiagonal{N}(I::UniformScaling) where {N} = SDiagonal{N}(ntuple(x->I.λ, Val(N)))
SDiagonal{N,T}(I::UniformScaling) where {N,T} = SDiagonal{N,T}(ntuple(x->I.λ, Val(N)))

one(::Type{SDiagonal{N,T}}) where {N,T} = SDiagonal(ones(SVector{N,T}))
one(::SDiagonal{N,T}) where {N,T} = SDiagonal(ones(SVector{N,T}))

Base.zero(::SDiagonal{N,T}) where {N,T} = SDiagonal(zeros(SVector{N,T}))
Base.zero(::Type{SDiagonal{N,T}}) where {N,T} = SDiagonal(zeros(SVector{N,T}))

function LinearAlgebra.cholesky(D::SDiagonal)
    any(x -> x < 0, D.diag) && throw(LinearAlgebra.PosDefException(1))
    C = sqrt.(D.diag)
    return Cholesky(SDiagonal(C), 'U', 0)
end

@generated function check_singular(D::SDiagonal{N}) where {N}
    quote
    Base.Cartesian.@nexprs $N i->(@inbounds iszero(D.diag[i]) && throw(LinearAlgebra.SingularException(i)))
    end
end
function inv(D::SDiagonal)
    check_singular(D)
    SDiagonal(inv.(D.diag))
end

import LinearAlgebra: BlasFloat, matprod, mul!


# Manage dispatch of * and mul!
# TODO Adjoint? (Inner product?)

# *(A::StaticMatMulLike, B::AbstractVector) causes an ambiguity with SparseArrays
@inline *(A::StaticMatrix, B::AbstractVector) = _mul(Size(A), A, B)
@inline *(A::StaticMatMulLike, B::StaticVector) = _mul(Size(A), Size(B), A, B)
@inline *(A::StaticMatrix, B::StaticVector) = _mul(Size(A), Size(B), A, B)
@inline *(A::StaticMatMulLike, B::StaticMatMulLike) = _mul(Size(A), Size(B), A, B)
@inline *(A::StaticVector, B::StaticMatMulLike) = *(reshape(A, Size(Size(A)[1], 1)), B)
@inline *(A::StaticVector, B::Transpose{<:Any, <:StaticVector}) = _mul(Size(A), Size(B), A, B)
@inline *(A::StaticVector, B::Adjoint{<:Any, <:StaticVector}) = _mul(Size(A), Size(B), A, B)
@inline *(A::StaticArray{Tuple{N,1},<:Any,2}, B::Adjoint{<:Any,<:StaticVector}) where {N} = vec(A) * B
@inline *(A::StaticArray{Tuple{N,1},<:Any,2}, B::Transpose{<:Any,<:StaticVector}) where {N} = vec(A) * B

"""
    mul_result_structure(a::Type, b::Type)

Get a structure wrapper that should be applied to the result of multiplication of matrices
of given types (`a*b`).
"""
function mul_result_structure(a, b)
    return identity
end
function mul_result_structure(::UpperTriangular{<:Any, <:StaticMatrix}, ::UpperTriangular{<:Any, <:StaticMatrix})
    return UpperTriangular
end
function mul_result_structure(::LowerTriangular{<:Any, <:StaticMatrix}, ::LowerTriangular{<:Any, <:StaticMatrix})
    return LowerTriangular
end
function mul_result_structure(::UpperTriangular{<:Any, <:StaticMatrix}, ::SDiagonal)
    return UpperTriangular
end
function mul_result_structure(::LowerTriangular{<:Any, <:StaticMatrix}, ::SDiagonal)
    return LowerTriangular
end
function mul_result_structure(::SDiagonal, ::UpperTriangular{<:Any, <:StaticMatrix})
    return UpperTriangular
end
function mul_result_structure(::SDiagonal, ::LowerTriangular{<:Any, <:StaticMatrix})
    return LowerTriangular
end
function mul_result_structure(::UnitUpperTriangular{<:Any, <:StaticMatrix}, ::SDiagonal)
    return UpperTriangular
end
function mul_result_structure(::UnitLowerTriangular{<:Any, <:StaticMatrix}, ::SDiagonal)
    return LowerTriangular
end
function mul_result_structure(::SDiagonal, ::UnitUpperTriangular{<:Any, <:StaticMatrix})
    return UpperTriangular
end
function mul_result_structure(::SDiagonal, ::UnitLowerTriangular{<:Any, <:StaticMatrix})
    return LowerTriangular
end
function mul_result_structure(::SDiagonal, ::SDiagonal)
    return Diagonal
end

# Implementations

function mul_smat_vec_exprs(sa, access_a)
    return [combine_products([:($(uplo_access(sa, :a, k, j, access_a))*b[$j]) for j = 1:sa[2]]) for k = 1:sa[1]]
end

@generated function _mul(::Size{sa}, wrapped_a::StaticMatMulLike{<:Any, <:Any, Ta}, b::AbstractVector{Tb}) where {sa, Ta, Tb}
    if sa[2] != 0
        retexpr = gen_by_access(wrapped_a) do access_a
            exprs = mul_smat_vec_exprs(sa, access_a)
            return :(@inbounds return similar_type(b, T, Size(sa[1]))(tuple($(exprs...))))
        end
    else
        exprs = [:(zero(T)) for k = 1:sa[1]]
        retexpr = :(@inbounds return similar_type(b, T, Size(sa[1]))(tuple($(exprs...))))
    end

    return quote
        @_inline_meta
        if length(b) != sa[2]
            throw(DimensionMismatch("Tried to multiply arrays of size $sa and $(size(b))"))
        end
        T = promote_op(matprod,Ta,Tb)
        a = mul_parent(wrapped_a)
        $retexpr
    end
end

@generated function _mul(::Size{sa}, ::Size{sb}, wrapped_a::StaticMatMulLike{<:Any, <:Any, Ta}, b::StaticVector{<:Any, Tb}) where {sa, sb, Ta, Tb}
    if sb[1] != sa[2]
        throw(DimensionMismatch("Tried to multiply arrays of size $sa and $sb"))
    end

    if sa[2] != 0
        retexpr = gen_by_access(wrapped_a) do access_a
            exprs = mul_smat_vec_exprs(sa, access_a)
            return :(@inbounds return similar_type(b, T, Size(sa[1]))(tuple($(exprs...))))
        end
    else
        exprs = [:(zero(T)) for k = 1:sa[1]]
        retexpr = :(@inbounds return similar_type(b, T, Size(sa[1]))(tuple($(exprs...))))
    end

    return quote
        @_inline_meta
        T = promote_op(matprod,Ta,Tb)
        a = mul_parent(wrapped_a)
        $retexpr
    end
end

# outer product
@generated function _mul(::Size{sa}, ::Size{sb}, a::StaticVector{<: Any, Ta},
        b::Union{Transpose{Tb, <:StaticVector}, Adjoint{Tb, <:StaticVector}}) where {sa, sb, Ta, Tb}
    newsize = (sa[1], sb[2])
    exprs = [:(a[$i]*b[$j]) for i = 1:sa[1], j = 1:sb[2]]

    return quote
        @_inline_meta
        T = promote_op(*, Ta, Tb)
        @inbounds return similar_type(b, T, Size($newsize))(tuple($(exprs...)))
    end
end

_unstatic_array(::Type{TSA}) where {S, T, N, TSA<:StaticArray{S,T,N}} = AbstractArray{T,N}
for TWR in [Adjoint, Transpose, Symmetric, Hermitian, LowerTriangular, UpperTriangular, UnitUpperTriangular, UnitLowerTriangular, Diagonal]
    @eval _unstatic_array(::Type{$TWR{T,TSA}}) where {S, T, N, TSA<:StaticArray{S,T,N}} = $TWR{T,<:AbstractArray{T,N}}
end

@generated function _mul(Sa::Size{sa}, Sb::Size{sb}, a::StaticMatMulLike{<:Any, <:Any, Ta}, b::StaticMatMulLike{<:Any, <:Any, Tb}) where {sa, sb, Ta, Tb}
    # Heuristic choice for amount of codegen
    a_tri_mul = a <: LinearAlgebra.AbstractTriangular ? 4 : 1
    b_tri_mul = b <: LinearAlgebra.AbstractTriangular ? 4 : 1
    ab_tri_mul = (a == 4 && b == 4) ? 2 : 1
    if a <: StaticMatrix && b <: StaticMatrix
        # Julia unrolls these loops pretty well
        return quote
            @_inline_meta
            return mul_loop(Sa, Sb, a, b)
        end
    elseif sa[1]*sa[2]*sb[2] <= 4*8*8*8*a_tri_mul*b_tri_mul*ab_tri_mul || a <: Diagonal || b <: Diagonal
        return quote
            @_inline_meta
            return mul_unrolled(Sa, Sb, a, b)
        end
    elseif (sa[1] <= 14 && sa[2] <= 14 && sb[2] <= 14) || !(a <: StaticMatrix) || !(b <: StaticMatrix)
        return quote
            @_inline_meta
            return mul_unrolled_chunks(Sa, Sb, a, b)
        end
    else
        # we don't have any special code for handling this case so let's fall back to
        # the generic implementation of matrix multiplication
        return quote
            @_inline_meta
            return mul_generic(Sa, Sb, a, b)
        end
    end
end

@generated function mul_unrolled(::Size{sa}, ::Size{sb}, wrapped_a::StaticMatMulLike{<:Any, <:Any, Ta}, wrapped_b::StaticMatMulLike{<:Any, <:Any, Tb}) where {sa, sb, Ta, Tb}
    if sb[1] != sa[2]
        throw(DimensionMismatch("Tried to multiply arrays of size $sa and $sb"))
    end

    S = Size(sa[1], sb[2])

    if sa[2] != 0
        retexpr = gen_by_access(wrapped_a, wrapped_b) do access_a, access_b
            exprs = [combine_products([:($(uplo_access(sa, :a, k1, j, access_a))*$(uplo_access(sb, :b, j, k2, access_b))) for j = 1:sa[2]]
                ) for k1 = 1:sa[1], k2 = 1:sb[2]]
            return :((mul_result_structure(wrapped_a, wrapped_b))(similar_type(a, T, $S)(tuple($(exprs...)))))
        end
    else
        exprs = [:(zero(T)) for k1 = 1:sa[1], k2 = 1:sb[2]]
        retexpr = :(return (mul_result_structure(wrapped_a, wrapped_b))(similar_type(a, T, $S)(tuple($(exprs...)))))
    end

    return quote
        @_inline_meta
        T = promote_op(matprod,Ta,Tb)
        a = mul_parent(wrapped_a)
        b = mul_parent(wrapped_b)
        @inbounds $retexpr
    end
end

@generated function mul_loop(::Size{sa}, ::Size{sb}, a::StaticMatrix{<:Any, <:Any, Ta}, b::StaticMatrix{<:Any, <:Any, Tb}) where {sa, sb, Ta, Tb}
    if sb[1] != sa[2]
        throw(DimensionMismatch("Tried to multiply arrays of size $sa and $sb"))
    end

    S = Size(sa[1], sb[2])

    # optimal for AVX2 with `Float64
    # AVX512 would want something more like 16x14 or 24x9 with `Float64`
    M_r, N_r = 8, 6
    n = 0
    M, K = sa
    N = sb[2]
    q = Expr(:block)
    atemps = [Symbol(:a_, k1) for k1 = 1:M]
    tmps = [Symbol("tmp_$(k1)_$(k2)") for k1 = 1:M, k2 = 1:N]
    while n < N
        nu = min(N, n + N_r)
        nrange = n+1:nu
        m = 0
        while m < M
            mu = min(M, m + M_r)
            mrange = m+1:mu

            atemps_init = [:($(atemps[k1]) = a[$k1]) for k1 = mrange]
            exprs_init = [:($(tmps[k1,k2])  = $(atemps[k1]) * b[$(1 + (k2-1) * sb[1])]) for k1 = mrange, k2 = nrange]
            atemps_loop_init = [:($(atemps[k1]) = a[$(k1-sa[1]) + $(sa[1])*j]) for k1 = mrange]
            exprs_loop = [:($(tmps[k1,k2]) = muladd($(atemps[k1]), b[j + $((k2-1) * sb[1])], $(tmps[k1,k2]))) for k1 = mrange, k2 = nrange]
            qblock = quote
                @inbounds $(Expr(:block, atemps_init...))
                @inbounds $(Expr(:block, exprs_init...))
                for j = 2:$(sa[2])
                    @inbounds $(Expr(:block, atemps_loop_init...))
                    @inbounds $(Expr(:block, exprs_loop...))
                end
            end
            push!(q.args, qblock)
            m = mu
        end
        n = nu
    end
    return quote
        @_inline_meta
        T = promote_op(matprod,Ta,Tb)
        $q
        @inbounds return similar_type(a, T, $S)(tuple($(tmps...)))
    end
end

@generated function mul_generic(::Size{sa}, ::Size{sb}, wrapped_a::StaticMatMulLike{<:Any, <:Any, Ta}, wrapped_b::StaticMatMulLike{<:Any, <:Any, Tb}) where {sa, sb, Ta, Tb}
    if sb[1] != sa[2]
        throw(DimensionMismatch("Tried to multiply arrays of size $sa and $sb"))
    end

    S = Size(sa[1], sb[2])

    return quote
        @_inline_meta
        T = promote_op(matprod, Ta, Tb)
        a = mul_parent(wrapped_a)
        b = mul_parent(wrapped_b)
        return (mul_result_structure(wrapped_a, wrapped_b))(similar_type(a, T, $S)(invoke(*, Tuple{$_unstatic_array(a),$_unstatic_array(b)}, a, b)))
    end
end

# Concatenate a series of matrix-vector multiplications
# Each function is N^2 not N^3 - aids in compile time.
@generated function mul_unrolled_chunks(::Size{sa}, ::Size{sb}, wrapped_a::StaticMatMulLike{<:Any, <:Any, Ta}, wrapped_b::StaticMatMulLike{<:Any, <:Any, Tb}) where {sa, sb, Ta, Tb}
    if sb[1] != sa[2]
        throw(DimensionMismatch("Tried to multiply arrays of size $sa and $sb"))
    end

    S = Size(sa[1], sb[2])

    # Do a custom b[:, k2] to return a SVector (an isbitstype type) rather than (possibly) a mutable type. Avoids allocation == faster
    tmp_type_in = :(SVector{$(sb[1]), T})
    tmp_type_out = :(SVector{$(sa[1]), T})

    retexpr = gen_by_access(wrapped_a, wrapped_b) do access_a, access_b
        vect_exprs = [:($(Symbol("tmp_$k2")) = partly_unrolled_multiply($(Size{sa}()), $(Size{(sb[1],)}()),
            a, $(Expr(:call, tmp_type_in, [uplo_access(sb, :b, i, k2, access_b) for i = 1:sb[1]]...)), $(Val(access_a)))::$tmp_type_out) for k2 = 1:sb[2]]

        exprs = [:($(Symbol("tmp_$k2"))[$k1]) for k1 = 1:sa[1], k2 = 1:sb[2]]

        return quote
            @inbounds $(Expr(:block, vect_exprs...))
            $(Expr(:block,
                :(@inbounds return (mul_result_structure(wrapped_a, wrapped_b))(similar_type(a, T, $S)(tuple($(exprs...)))))
            ))
        end
    end
    return quote
        @_inline_meta
        T = promote_op(matprod, Ta, Tb)
        a = mul_parent(wrapped_a)
        b = mul_parent(wrapped_b)
        $retexpr
    end
end

# a special version for plain matrices
@generated function mul_unrolled_chunks(::Size{sa}, ::Size{sb}, a::StaticMatrix{<:Any, <:Any, Ta}, b::StaticMatrix{<:Any, <:Any, Tb}) where {sa, sb, Ta, Tb}
    if sb[1] != sa[2]
        throw(DimensionMismatch("Tried to multiply arrays of size $sa and $sb"))
    end

    S = Size(sa[1], sb[2])

    # optimal for AVX2 with `Float64
    # AVX512 would want something more like 16x14 or 24x9 with `Float64`
    M_r, N_r = 8, 6
    n = 0
    M, K = sa
    N = sb[2]
    q = Expr(:block)
    atemps = [Symbol(:a_, k1) for k1 = 1:M]
    tmps = [Symbol("tmp_$(k1)_$(k2)") for k1 = 1:M, k2 = 1:N]
    while n < N
        nu = min(N, n + N_r)
        nrange = n+1:nu
        m = 0
        while m < M
            mu = min(M, m + M_r)
            mrange = m+1:mu

            atemps_init = [:($(atemps[k1]) = a[$k1]) for k1 = mrange]
            exprs_init = [:($(tmps[k1,k2])  = $(atemps[k1]) * b[$(1 + (k2-1) * sb[1])]) for k1 = mrange, k2 = nrange]
            push!(q.args, :(@inbounds $(Expr(:block, atemps_init...))))
            push!(q.args, :(@inbounds $(Expr(:block, exprs_init...))))

            for j in 2:K
                atemps_loop_init = [:($(atemps[k1]) = a[$(LinearIndices(sa)[k1,j])]) for k1 = mrange]
                exprs_loop = [:($(tmps[k1,k2]) = muladd($(atemps[k1]), b[$(LinearIndices(sb)[j,k2])], $(tmps[k1,k2]))) for k1 = mrange, k2 = nrange]
                push!(q.args, :(@inbounds $(Expr(:block, atemps_loop_init...))))
                push!(q.args, :(@inbounds $(Expr(:block, exprs_loop...))))
            end
            m = mu
        end
        n = nu
    end
    return quote
        @_inline_meta
        T = promote_op(matprod,Ta,Tb)
        $q
        @inbounds return similar_type(a, T, $S)(tuple($(tmps...)))
    end
end

#

# `Start` and `End` should be `Int`
struct SUnitRange{Start, L} <: StaticVector{L, Int}
    function SUnitRange{Start, L}() where {Start, L}
        check_sunitrange_params(L)
        new{Start, L}()
    end
end

function check_sunitrange_params(L::Int)
    if L < 0
        error("Static unit range length is negative")
    end
end

function check_sunitrange_params(L)
    throw(TypeError(:SUnitRange, "type parameters must be `Int`", Tuple{Int,}, Tuple{typeof(L),}))
end

SUnitRange(a::Int, b::Int) = SUnitRange{a, max(0, b - a + 1)}()

@propagate_inbounds function getindex(x::SUnitRange{Start, L}, i::Int) where {Start, L}
    @boundscheck if i < 1 || i > L
        throw(BoundsError(x, i))
    end
    return Start + i - 1
end

function show(io::IO, ::SUnitRange{Start, L}) where {Start, L}
    print(io, "SUnitRange($Start,$(Start + L - 1))")
end

# Shorten show for REPL use.
show(io::IO, ::MIME"text/plain", su::SUnitRange) = show(io, su)

using StaticArrays, Test
struct ScalarTest end
Base.:(+)(x::Number, y::ScalarTest) = x
Broadcast.broadcastable(x::ScalarTest) = Ref(x)

@testset "Scalar Broadcast" begin
    for t in (SVector{2}, MVector{2}, SMatrix{2, 2}, MMatrix{2, 2})
        x = rand(t)
        @test x == @inferred(x .+ ScalarTest())
        @test x .+ 1 == @inferred(x .+ Ref(1))
    end

    @test Scalar(3) == @inferred(Scalar(1) .+ 2)
end

@testset "Broadcast sizes" begin
    @test @inferred(StaticArrays.broadcast_sizes(1, 1, 1)) === (Size(), Size(), Size())
    for t in (SVector{2}, MVector{2}, SMatrix{2, 2}, MMatrix{2, 2})
        @test @inferred(StaticArrays.broadcast_sizes(ones(t), ones(t), ones(t))) === (Size(t), Size(t), Size(t))
        @test @inferred(StaticArrays.broadcast_sizes(ones(t), 1, ones(t))) === (Size(t), Size(), Size(t))
        @test @inferred(StaticArrays.broadcast_sizes(1, ones(t), ones(t))) === (Size(), Size(t), Size(t))
        @test @inferred(StaticArrays.broadcast_sizes(ones(t), ones(t), 1)) === (Size(t), Size(t), Size())
        @test @inferred(StaticArrays.broadcast_sizes(1, ones(t), 1)) === (Size(), Size(t), Size())
        @test @inferred(StaticArrays.broadcast_sizes(ones(t), 1, 1)) === (Size(t), Size(), Size())
        @test @inferred(StaticArrays.broadcast_sizes(1, 1, ones(t))) === (Size(), Size(), Size(t))
    end
    # test case issue #191
    @test @inferred(broadcast((a, b, c) -> 0, SVector(1, 1), 0, 0)) == SVector(0, 0)

    # test case issue #841
    @test @inferred(StaticArrays.broadcast_size((1, 2.0))) === Size(2)
end

@testset "Broadcast" begin
    @testset "AbstractArray-of-StaticArray with scalar math" begin
        v = SVector{2,Float64}[SVector{2,Float64}(1,1)]
        @test @inferred(v .* 1.0)::typeof(v) == v
        v2 = SVector{2,Int}[SVector{2,Int}(1,1)]
        @test @inferred(v2 .* 1.0)::typeof(v) == v
    end

    @testset "0-dimensional Array broadcast" begin
        x = Array{Int, 0}(undef)
        x .= Scalar(4)
        @test x[] == 4
    end

    @testset "2x2 StaticMatrix with StaticVector" begin
        m = @SMatrix [1 2; 3 4]
        v = SVector(1, 4)
        vrep = @SMatrix [1 1; 4 4]
        for m in (m, Transpose(m), Adjoint(m), Diagonal(m), Symmetric(m, :U), Symmetric(m, :L), Hermitian(m, :U), Hermitian(m, :L), UpperTriangular(m), LowerTriangular(m), UnitUpperTriangular(m), UnitLowerTriangular(m)) 
            @test @inferred(broadcast(+, m, v)) === map(+, m, vrep)::SMatrix
            @test @inferred(m .+ v) === map(+, m, vrep)::SMatrix
            @test @inferred(v .+ m) === map(+, vrep, m)::SMatrix
            @test @inferred(m .* v) === map(*, m, vrep)::SMatrix
            @test @inferred(v .* m) === map(*, vrep, m)::SMatrix
            @test @inferred(m ./ v) === map(/, m, vrep)::SMatrix
            @test @inferred(v ./ m) === map(/, vrep, m)::SMatrix
            @test @inferred(m .- v) === map(-, m, vrep)::SMatrix
            @test @inferred(v .- m) === map(-, vrep, m)::SMatrix
            @test @inferred(m .^ v) === map(^, m, vrep)::SMatrix
            @test @inferred(v .^ m) === map(^, vrep, m)::SMatrix
            # Issue #546
            @test @inferred(m ./ (v .* v')) === map(/, m, v .* v')::SMatrix
            testinf(m, v) = m ./ (v .* v')
            @test @inferred(testinf(m, v)) === map(/, m, v .* v')::SMatrix
        end
    end

    @testset "2x2 StaticMatrix with 1x2 StaticMatrix" begin
        # Issues #197, #242: broadcast between SArray and row-like SMatrix
        m1 = @SMatrix [1 2; 3 4]
        m2 = @SMatrix [1 4]
        m2rep = @SMatrix [1 4; 1 4]
        m1s = (m1, Transpose(m1), Adjoint(m1), Diagonal(m1), Symmetric(m1, :U), Symmetric(m1, :L), Hermitian(m1, :U), Hermitian(m1, :L), UpperTriangular(m1), LowerTriangular(m1), UnitUpperTriangular(m1), UnitLowerTriangular(m1))
        for m1 in m1s
            @test @inferred(broadcast(+, m1, m2)) === map(+, m1, m2rep)::SMatrix
            @test @inferred(m1 .+ m2) === map(+, m1, m2rep)::SMatrix
            @test @inferred(m2 .+ m1) === map(+, m2rep, m1)::SMatrix
            @test @inferred(m1 .* m2) === map(*, m1, m2rep)::SMatrix
            @test @inferred(m2 .* m1) === map(*, m2rep, m1)::SMatrix
            @test @inferred(m1 ./ m2) === map(/, m1, m2rep)::SMatrix
            @test @inferred(m2 ./ m1) === map(/, m2rep, m1)::SMatrix
            @test @inferred(m1 .- m2) === map(-, m1, m2rep)::SMatrix
            @test @inferred(m2 .- m1) === map(-, m2rep, m1)::SMatrix
            @test @inferred(m1 .^ m2) === map(^, m1, m2rep)::SMatrix
        end
    end

    @testset "1x2 StaticMatrix with StaticVector" begin
        # Issues #197, #242: broadcast between SVector and row-like SMatrix
        m = @SMatrix [1 2]
        v = SVector(1, 4)
        @test @inferred(broadcast(+, m, v)) === @SMatrix [2 3; 5 6]
        @test @inferred(m .+ v) === @SMatrix [2 3; 5 6]
        @test @inferred(v .+ m) === @SMatrix [2 3; 5 6]
        @test @inferred(m .* v) === @SMatrix [1 2; 4 8]
        @test @inferred(v .* m) === @SMatrix [1 2; 4 8]
        @test @inferred(m ./ v) === @SMatrix [1 2; 1/4 1/2]
        @test @inferred(v ./ m) === @SMatrix [1 1/2; 4 2]
        @test @inferred(m .- v) === @SMatrix [0 1; -3 -2]
        @test @inferred(v .- m) === @SMatrix [0 -1; 3 2]
        @test @inferred(m .^ v) === @SMatrix [1 2; 1 16]
        @test @inferred(v .^ m) === @SMatrix [1 1; 4 16]
    end

    @testset "StaticVector with StaticVector" begin
        v1 = SVector(1, 2)
        v2 = SVector(1, 4)
        @test @inferred(broadcast(+, v1, v2)) === SVector(2, 6)
        @test @inferred(v1 .+ v2) === SVector(2, 6)
        @test @inferred(v2 .+ v1) === SVector(2, 6)
        @test @inferred(v1 .* v2) === SVector(1, 8)
        @test @inferred(v2 .* v1) === SVector(1, 8)
        @test @inferred(v1 ./ v2) === SVector(1, 1/2)
        @test @inferred(v2 ./ v1) === SVector(1, 2/1)
        @test @inferred(v1 .- v2) === SVector(0, -2)
        @test @inferred(v2 .- v1) === SVector(0, 2)
        @test @inferred(v1 .^ v2) === SVector(1, 16)
        @test @inferred(v2 .^ v1) === SVector(1, 16)
        # Issue #200: broadcast with Adjoint
        @test @inferred(v1 .+ v2') === @SMatrix [2 5; 3 6]
        @test @inferred(v1 .+ transpose(v2)) === @SMatrix [2 5; 3 6]
        # Issue 382: infinite recursion in broadcasting axes with Adjoint
        @test @inferred(SVector(1,1)' .+ [1, 1]) == [2 2; 2 2]
        @test @inferred(transpose(SVector(1,1)) .+ [1, 1]) == [2 2; 2 2]
        
        # Issue 704: broadcast with adjoint wrapped static arrays
        @test @inferred(v1' .+ v2') === SA[2 6]
    end

    @testset "StaticVector with Scalar" begin
        v = SVector(1, 2)
        @test @inferred(broadcast(+, v, 2)) === SVector(3, 4)
        @test @inferred(v .+ 2) === SVector(3, 4)
        @test @inferred(2 .+ v) === SVector(3, 4)
        @test @inferred(v .* 2) === SVector(2, 4)
        @test @inferred(2 .* v) === SVector(2, 4)
        @test @inferred(v ./ 2) === SVector(1/2, 1)
        @test @inferred(2 ./ v) === SVector(2, 1/1)
        @test @inferred(v .- 2) === SVector(-1, 0)
        @test @inferred(2 .- v) === SVector(1, 0)
        @test @inferred(v .^ 2) === SVector(1, 4)
        @test @inferred(2 .^ v) === SVector(2, 4)
    end

    @testset "Empty arrays" begin
        @test @inferred(1.0 .+ zeros(SMatrix{2,0})) === zeros(SMatrix{2,0})
        @test @inferred(1.0 .+ zeros(SMatrix{0,2})) === zeros(SMatrix{0,2})
        @test @inferred(1.0 .+ zeros(SArray{Tuple{2,3,0}})) === zeros(SArray{Tuple{2,3,0}})
        @test @inferred(zeros(SVector{0}) .+ zeros(SMatrix{0,2})) === zeros(SMatrix{0,2})
        m = zeros(MMatrix{0,2})
        @test @inferred(broadcast!(+, m, m, zeros(SVector{0}))) == zeros(SMatrix{0,2})
        # Issue #199: broadcast with empty SArray
        @test @inferred(SVector(1) .+ SVector{0,Int}()) === SVector{0,Int}()
        @test @inferred(SVector{0,Int}() .+ SVector(1.0)) === SVector{0,Float64}()
        # Issue #528
        @test @inferred(isapprox(SMatrix{3,0,Float64}(), SMatrix{3,0,Float64}()))
        @test @inferred(broadcast(length, SVector{0,String}())) === SVector{0,Int}()
        @test @inferred(broadcast(join, SVector{0,String}(), SVector{0,String}(), SVector{0,String}())) === SVector{0,String}()
    end

    @testset "Mutating broadcast!" begin
        # No setindex! error
        A = one(SMatrix{2, 2}); @test_throws ErrorException broadcast!(+, A, A, SVector(1, 4))
        A = one(MMatrix{2, 2}); @test @inferred(broadcast!(+, A, A, SVector(1, 4))) == @MMatrix [2 1; 4 5]
        A = one(MMatrix{2, 2}); @test @inferred(broadcast!(+, A, A, @SMatrix([1  4]))) == @MMatrix [2 4; 1 5]
        A = @MMatrix([1 0]); @test_throws DimensionMismatch broadcast!(+, A, A, SVector(1, 4))
        A = @MMatrix([1 0]); @test @inferred(broadcast!(+, A, A, @SMatrix([1 4]))) == @MMatrix [2 4]
        A = @MMatrix([1 0]); @test @inferred(broadcast!(+, A, A, 2)) == @MMatrix [3 2]
    end

    @testset "broadcast! with mixtures of SArray and Array" begin
        a = zeros(MVector{2}); @test @inferred(broadcast!(+, a, [1,2])) == [1,2]
        a = zeros(MMatrix{2,3}); @test @inferred(broadcast!(+, a, [1,2])) == [1 1 1; 2 2 2]
    end

    @testset "eltype after broadcast" begin
        # test cases issue #198
        let a = SVector{4, Number}(2, 2.0, 4//2, 2+0im)
            @test eltype(a .+ 2) == Number
            @test eltype(a .- 2) == Number
            @test eltype(a * 2) == Number
            @test eltype(a / 2) == Number
        end
        let a = SVector{3, Real}(2, 2.0, 4//2)
            @test eltype(a .+ 2) == Real
            @test eltype(a .- 2) == Real
            @test eltype(a * 2) == Real
            @test eltype(a / 2) == Real
        end
        let a = SVector{3, Real}(2, 2.0, 4//2)
            @test eltype(a .+ 2.0) == Float64
            @test eltype(a .- 2.0) == Float64
            @test eltype(a * 2.0) == Float64
            @test eltype(a / 2.0) == Float64
        end
        let a = broadcast(Float32, SVector(3, 4, 5))
            @test eltype(a) == Float32
        end
    end

    @testset "broadcast general scalars" begin
        # Issue #239 - broadcast with non-numeric element types
        @eval @enum Axis aX aY aZ
        @testinf (SVector(aX,aY,aZ) .== Ref(aX)) == SVector(true,false,false)
        mv = MVector(aX,aY,aZ)
        @testinf broadcast!(identity, mv, Ref(aX)) == MVector(aX,aX,aX)
        @test mv == SVector(aX,aX,aX)
    end

    @testset "broadcast! with Array destination" begin
        # Issue #385
        a = zeros(3, 3)
        b = @SMatrix [1 2 3; 4 5 6; 7 8 9]
        a .= b
        @test a == b

        c = SVector(1, 2, 3)
        a .= c
        @test a == [1 1 1; 2 2 2; 3 3 3]

        d = SVector(1, 2, 3, 4)
        @test_throws DimensionMismatch a .= d
    end

    @testset "issue #493" begin
        X = rand(SVector{3,SVector{2,Float64}})
        foo493(X) = normalize.(X)
        @test foo493(X) isa Core.Compiler.return_type(foo493, Tuple{typeof(X)})
    end

    @testset "broadcasting with tuples" begin
        # issue 485
        @test @inferred(SA[1,2,3] .+ (1,))               === SA{Int}[2, 3, 4]
        @test @inferred(SA[1,2,3] .+ (10, 20, 30))       === SA{Int}[11, 22, 33]
        @test @inferred((1,2)     .+ (SA[10 20; 30 40])) === SA{Int}[11 21; 32 42]
        @test @inferred((SA[10 20; 30 40]) .+ (1,2))     === SA{Int}[11 21; 32 42]

        add_bc!(m, v) = m .+= v  # Helper function; @inferred gets confused by .+= syntax
        @test @inferred(add_bc!(MVector((1,2,3)), (10, 20, 30)))   ::MVector{3,Int}   == SA[11, 22, 33]
        @test @inferred(add_bc!(MMatrix(SA[10 20; 30 40]), (1,2))) ::MMatrix{2,2,Int} == SA[11 21; 32 42]

        # Tuples of SA
        @test (@inferred SA[1,2,3] .* (SA[1,0],)) === SVector{3,SVector{2,Int}}(((1,0), (2,0), (3,0)))
    end

    @testset "SDiagonal" begin
        for DS in Any[Diagonal(SVector{2}(1:2)), Diagonal(MVector{2}(1:2)), Diagonal(SizedArray{Tuple{2}}(1:2))],
                S in Any[SVector{2}(1:2), MVector{2}(1:2), SizedArray{Tuple{2}}(1:2)]
            @test DS .* S isa StaticArray
            @test DS .* S == collect(DS) .* collect(S)
            @test DS .* collect(S) == collect(DS) .* collect(S)
            @test DS .* S' isa StaticArray
            @test DS .* S' == collect(DS) .* collect(S)
            @test DS .* collect(S') == collect(DS) .* collect(S)
            @test S .* DS .* S' isa StaticArray
            @test S .* DS .* S' == collect(S) .* collect(DS) .* collect(S)
            DS2 = Diagonal(S)
            @test DS .* DS2 isa StaticArray
            @test DS .* DS2 == collect(DS) .* collect(DS2)
            @test DS .* collect(DS2) == collect(DS) .* collect(DS2)

            # inplace broadcasting for mutable diagonal types
            DS2 = Diagonal(MVector{2}(diag(DS)))
            DS2 .*= S
            @test DS2 == DS .* S
            DS2 .= DS
            @test DS2 == DS
            DS2 .+= DS
            @test DS2 == DS .+ DS
            DS2 .= DS
            DS2 .*= DS
            @test DS2 == DS .* DS
        end
    end

    @testset "broadcast! with reshaping" begin
        m = @MMatrix [1 2; 3 4]
        m[1:2] .= 10
        @test m == SA[10 2; 10 4]

        ms = SizedMatrix{2,2}([1 2; 3 4])
        ms[1:2] .= 10
        @test ms == SA[10 2; 10 4]
    end

end

# A help struct to test style-based broadcast dispatch with unknown array wrapper.
# `WrapArray(A)` behaves like `A` during broadcast. But its not a `StaticArray`.
struct WrapArray{T,N,P<:AbstractArray{T,N}} <: AbstractArray{T,N}
    data::P
end
Base.@propagate_inbounds Base.getindex(A::WrapArray, i::Integer...) = A.data[i...]
Base.@propagate_inbounds Base.setindex!(A::WrapArray, v::Any, i::Integer...) = setindex!(A.data, v, i...)
Base.size(A::WrapArray) = size(A.data)
Base.axes(A::WrapArray) = axes(A.data)
Broadcast.BroadcastStyle(::Type{WrapArray{T,N,P}}) where {T,N,P} = Broadcast.BroadcastStyle(P)
StaticArrays.isstatic(A::WrapArray) = StaticArrays.isstatic(A.data)
StaticArrays.Size(::Type{WrapArray{T,N,P}}) where {T,N,P} = StaticArrays.Size(P)
function StaticArrays.similar_type(::Type{WrapArray{T,N,P}}, ::Type{t}, s::Size{S}) where {T,N,P,t,S}
    return StaticArrays.similar_type(P, t, s)
end

@testset "Broadcast with unknown wrapper" begin
    data = (1, 2)
    for T in (SVector{2}, MVector{2})
        destT = T <: SArray ? SArray : MArray
        a = T(data)
        for b in (WrapArray(a), WrapArray(a'))
            @test @inferred(b .+ a) isa destT
            @test @inferred(b .+ b) isa destT
            @test @inferred(b .+ (1, 2)) isa destT
            @test @inferred(b .+ a') isa destT
            @test @inferred(a' .+ b) isa destT
            # @test @inferred(b' .+ a') isa StaticMatrix # Adjoint doesn't propagate style
            @test b .+ b.data == b .+ b == b.data .+ b.data
        end
    end
end

@testset "instantiate with axes updated" begin
    f(a; ax = nothing) = Broadcast.Broadcasted{StaticArrays.StaticArrayStyle{ndims(a)}}(+,(a,),ax)
    a = @SArray zeros(2,2,2)
    ax = Base.OneTo(2), Base.OneTo(2), Base.OneTo(2)
    @test @inferred(Broadcast.instantiate(f(a; ax))).axes isa NTuple{3,SOneTo}
    ax = (ax..., Base.OneTo(2))
    @test @inferred(Broadcast.instantiate(f(a; ax))).axes isa NTuple{4,Base.OneTo}
    ax = setindex(ax, Base.OneTo(1), 4)
    @test @inferred(Broadcast.instantiate(f(a; ax))).axes isa NTuple{4,Base.OneTo}
    a = @SArray zeros(2,1,2)
    ax = Base.OneTo(2), Base.OneTo(2), Base.OneTo(2)
    @test @inferred(Broadcast.instantiate(f(a; ax))).axes isa Tuple{SOneTo,Base.OneTo,SOneTo}
    @test_throws DimensionMismatch Broadcast.instantiate(f(a; ax = ax[1:2]))

    a = @SArray zeros(2,2,1)
    ax = Base.OneTo(2), Base.OneTo(2), Base.OneTo(2)
    @test @inferred(Broadcast.instantiate(f(a; ax))).axes isa Tuple{SOneTo,SOneTo,Base.OneTo}
    @test @inferred(Broadcast.instantiate(f(a; ax = ax[1:2]))).axes isa NTuple{2,SOneTo}
end

@testset "`broadcast`'s stability" begin
    issue1078(t) = t ./ (1 .- t .^ 2)
    a = @SVector rand(3)
    @test @inferred(issue1078(a)) == issue1078(Vector(a))
    issue560(ũ, u₀, u₁, ρ) = ũ ./ (1e-6 .+ max.(abs.(u₀), abs.(u₁)) .* ρ)
    issue797(a, b, c, d) = @. a + 5 * b + 3 * c - d
    manual(a, b, c, d) = @. 0.1a^2 + 0.2b^3 * 0.4c^1 + 0.5d
    manual2(a, b, c, d) = @. Float32(a) * Float32(b) + Float32(c) * Float32(d)
    args = rand(3), rand(3), rand(3), rand(3)
    @test @inferred(issue560(map(SVector{3}, args)...)) == issue560(args...)
    @test @inferred(issue797(map(SVector{3}, args)...)) == issue797(args...)
    @test @inferred(manual(map(SVector{3}, args)...)) == manual(args...)
    @test @inferred(manual2(map(SVector{3}, args)...)) == manual2(args...)
    issue609(s, c::Integer) = (s .- s.^2) ./ c
    @test @inferred(issue609(SA[1.], 2)) == issue609([1.], 2)
end

@testset "broadcasting out-of-bounds getindex" begin
    @test_throws BoundsError getindex.(SA[1, 2], 0)
    a = @MArray [1, 2]
    @test_throws BoundsError a .= getindex.(SA[1, 2], 0)
end

"""
    x ≊ y

Inexact equality comparison. Like `≈` this calls `isapprox`, but with a
tighter tolerance of `rtol=10*eps()`.  Input with "\\approxeq".
"""
≊(x,y) = isapprox(x, y, rtol=10*eps())

"""
    @testinf a op b

Test that the type of the first argument `a` is inferred, and that `a op b` is
true.  For example, the following are equivalent:

    @testinf SVector(1,2) + SVector(1,2) == SVector(2,4)
    @test @inferred(SVector(1,2) + SVector(1,2)) == SVector(2,4)
"""
macro testinf(ex)
    @assert ex.head == :call
    infarg = ex.args[2]
    if !(infarg isa Expr) || infarg.head != :call
        # Workaround for an oddity in @inferred
        infarg = :(identity($infarg))
    end
    ex.args[2] = :(@inferred($infarg))
    esc(:(@test $ex))
end

function test_expand_error(ex)
    @test_throws LoadError macroexpand(@__MODULE__, ex)
end

mutable struct ErrorCounterTestSet <: Test.AbstractTestSet
    passcount::Int
    errorcount::Int
    failcount::Int
end
ErrorCounterTestSet(args...; kws...) = ErrorCounterTestSet(0,0,0)
Test.finish(ts::ErrorCounterTestSet) = ts
Test.record(ts::ErrorCounterTestSet, ::Test.Pass)  = (ts.passcount += 1)
Test.record(ts::ErrorCounterTestSet, ::Test.Error) = (ts.errorcount += 1)
Test.record(ts::ErrorCounterTestSet, ::Test.Fail)  = (ts.failcount += 1)

"""
    @test_inlined f(x,y, ...)

Check that the (optimized) llvm code generated for the expression
`f(x,y,...)` contains no `call` instructions.

Note that LLVM IR can contain `call` instructions to intrinsics which don't
make it into the native code, so this can be overly eager in declaring a
a lack of complete inlining.
"""
macro test_inlined(ex, should_inline=true)
    ex_orig = ex
    ex = macroexpand(@__MODULE__, :(@code_llvm $ex))
    expr = quote
        @static if hasfield(Base.CodegenParams, :safepoint_on_entry)
            code_str = let params = Base.CodegenParams(safepoint_on_entry=false),
                f = $(esc(ex.args[2])),
                t = $(esc(ex.args[3]))
                d = InteractiveUtils._dump_function(f, t, false, false, true, false, :att, true, :none, false, params)
                sprint(print, d)
            end
        else
            code_str = sprint() do io
                code_llvm(io, $(map(esc, ex.args[2:end])...))
            end
        end
        # Crude detection of call instructions remaining within what should be
        # fully inlined code.
        #
        # TODO: Figure out some better pattern matching; LLVM IR can contain
        # calls to intrinsics, so this will sometimes/often fail even when the
        # native code has no call instructions.
        $(should_inline ?
          :(@test !occursin("call", code_str)) :
          :(@test occursin("call", code_str))
        )
    end
    @assert expr.args[4].head == :macrocall
    expr.args[4].args[2] = __source__
    expr
end

should_be_inlined(x) = x*x
@noinline _should_not_be_inlined(x) = x*x
should_not_be_inlined(x) = _should_not_be_inlined(x)

"""
    @test_was_once_broken good_version ex

Expands to `@test ex` if `VERSION ≥ good_version` and to `@test_broken ex` if 
`VERSION ≥ good_version`. Useful for tests that are broken on earlier versions of Julia
that are fixed on later versions.
"""
macro test_was_once_broken(good_version, ex)
    esc(quote
        if VERSION < $good_version
            @test_broken $ex
        else
            @test $ex
        end
    end)
end

@testset "test utils" begin
    @testset "@testinf" begin
        @testinf [1,2] == [1,2]
        x = [1,2]
        @testinf x == [1,2]
        @testinf (@SVector [1,2]) == (@SVector [1,2])
    end

    @testset "@test_inlined" begin
        @test_inlined should_be_inlined(1)
        @test_inlined should_not_be_inlined(1) false
        ts = @testset ErrorCounterTestSet "" begin
            @test_inlined should_be_inlined(1) false
            @test_inlined should_not_be_inlined(1)
        end
        @test ts.errorcount == 0 && ts.failcount == 2 && ts.passcount == 0
    end
end

"""
    Scalar{T}(x::T)

Construct a statically-sized 0-dimensional array that contains a single element,
`x`. This type is particularly useful for influencing broadcasting operations.
"""
const Scalar{T} = SArray{Tuple{},T,0,1}

@inline Scalar(a::AbstractArray) = Scalar{typeof(a)}((a,))
@inline Scalar(a::StaticArray) = Scalar{typeof(a)}((a,)) # disambiguation

@inline Scalar(a::AbstractScalar) = Scalar{eltype(a)}((a[],)) # Do we want this to convert or wrap?
@inline Scalar(a::StaticScalar) = Scalar{eltype(a)}((a[],)) # disambiguation

@propagate_inbounds function getindex(v::Scalar, i::Int)
    @boundscheck if i != 1
        error("Attempt to index Scalar at index $i")
    end
    v.data[1]
end

# A lot more compact than the default array show
Base.show(io::IO, ::MIME"text/plain", x::Scalar{T}) where {T} = print(io, "Scalar{$T}(", x.data, ")")

module BenchQR

using BenchmarkTools
using LinearAlgebra
using StaticArrays

const suite = BenchmarkGroup()

for K = [2, 3, 4, 8, 10, 12]
    a = rand(SMatrix{K,K,Float64,K*K})
    m = Matrix(a)
    s = suite["S=$K"] = BenchmarkGroup()
    s["SMatrix"] = @benchmarkable qr($a)
    s["Matrix"] = @benchmarkable qr($m)
end

end  # module
BenchQR.suite

# Default error messages to help users with new types and to avoid subsequent stack overflows
getindex(a::StaticArray, i::Int) = error("getindex(::$(typeof(a)), ::Int) is not defined.")
setindex!(a::StaticArray, value, i::Int) = error("setindex!(::$(typeof(a)), value, ::Int) is not defined.\n Hint: Use `MArray` or `SizedArray` to create a mutable static array")

#######################################
## Multidimensional scalar indexing  ##
#######################################

# Note: all indexing behavior defaults to dense, linear indexing

@propagate_inbounds function getindex(a::StaticArray, inds::Int...)
    @boundscheck checkbounds(a, inds...)
    _getindex_scalar(Size(a), a, inds...)
end

@generated function _getindex_scalar(::Size{S}, a::StaticArray, inds::Int...) where S
    if length(inds) == 0
        return quote
            @_propagate_inbounds_meta
            a[1]
        end
    end

    stride = 1
    ind_expr = :()
    for i ∈ 1:length(inds)
        if i == 1
            ind_expr = :(inds[1])
        else
            ind_expr = :($ind_expr + $stride * (inds[$i] - 1))
        end
        stride *= Size(S)[i]
    end
    return quote
        @_propagate_inbounds_meta
        a[$ind_expr]
    end
end

@propagate_inbounds function setindex!(a::StaticArray, value, inds::Int...)
    @boundscheck checkbounds(a, inds...)
    _setindex!_scalar(Size(a), a, value, inds...)
    return a
end

@generated function _setindex!_scalar(::Size{S}, a::StaticArray, value, inds::Int...) where S
    if length(inds) == 0
        return quote
            @_propagate_inbounds_meta
            a[1] = value
        end
    end

    stride = 1
    ind_expr = :()
    for i ∈ 1:length(inds)
        if i == 1
            ind_expr = :(inds[1])
        else
            ind_expr = :($ind_expr + $stride * (inds[$i] - 1))
        end
        stride *= Size(S)[i]
    end
    return quote
        @_propagate_inbounds_meta
        a[$ind_expr] = value
    end
end

#########################
## Indexing utilities  ##
#########################

@generated unpack_size(::Type{Size{S}}) where {S} = map(Size, S)

@inline index_size(::Size, ::Int) = Size()
@inline index_size(::Size, a::StaticArray) = Size(a)
@inline index_size(s::Size, ::Colon) = s
@inline index_size(s::Size, a::SOneTo{n}) where n = Size(n,)

@inline index_sizes(::S, inds...) where {S<:Size} = map(index_size, unpack_size(S), inds)

@inline index_sizes() = ()
@inline index_sizes(::Int, inds...) = (Size(), index_sizes(inds...)...)
@inline index_sizes(a::StaticArray, inds...) = (Size(a), index_sizes(inds...)...)

out_index_size(ind_sizes::Type{<:Size}...) = Size(_out_index_size((), ind_sizes...))
@inline _out_index_size(t::Tuple) = t
@inline _out_index_size(t::Tuple, ::Type{Size{S}}, ind_sizes...) where {S} = _out_index_size((t..., S...), ind_sizes...)

linear_index_size(ind_sizes::Type{<:Size}...) = _linear_index_size((), ind_sizes...)
@inline _linear_index_size(t::Tuple) = t
@inline _linear_index_size(t::Tuple, ::Type{Size{S}}, ind_sizes...) where {S} = _linear_index_size((t..., prod(S)), ind_sizes...)

_ind(i::Int, ::Int, ::Type{Int}) = :(inds[$i])
_ind(i::Int, j::Int, ::Type{<:StaticArray}) = :(inds[$i][$j])
_ind(i::Int, j::Int, ::Type{Colon}) = j
_ind(i::Int, j::Int, ::Type{<:SOneTo}) = j

################################
## Non-scalar linear indexing ##
################################

@inline function getindex(a::StaticArray, ::Colon)
    _getindex(a::StaticArray, Length(a), :)
end

@generated function _getindex(a::StaticArray, ::Length{L}, ::Colon) where {L}
    exprs = [:(a[$i]) for i = 1:L]
    return quote
        @_inline_meta
        @inbounds return similar_type(a, Size(L))(tuple($(exprs...)))
    end
end

@propagate_inbounds function getindex(a::StaticArray, inds::StaticArray{<:Tuple, Int})
    _getindex(a, Size(inds), inds)
end

@generated function _getindex(a::StaticArray, s::Size{S}, inds::StaticArray{<:Tuple, Int}) where {S}
    exprs = [:(a[inds[$i]]) for i = 1:prod(S)]
    return quote
        @_propagate_inbounds_meta
        similar_type(a, s)(tuple($(exprs...)))
    end
end

@inline function setindex!(a::StaticArray, v, ::Colon)
    _setindex!(a::StaticArray, v, Length(a), :)
    return a
end

@generated function _setindex!(a::StaticArray, v, ::Length{L}, ::Colon) where {L}
    exprs = [:(a[$i] = v) for i = 1:L]
    return quote
        @_inline_meta
        @inbounds $(Expr(:block, exprs...))
        return a
    end
end

@generated function _setindex!(a::StaticArray, v::AbstractArray, ::Length{L}, ::Colon) where {L}
    exprs = [:(a[$i] = v[$i]) for i = 1:L]
    return quote
        @_propagate_inbounds_meta
        @boundscheck if length(v) != L
            throw(DimensionMismatch("tried to assign $(length(v))-element array to length-$L destination"))
        end
        @inbounds $(Expr(:block, exprs...))
        return a
    end
end

@generated function _setindex!(a::StaticArray, v::StaticArray, ::Length{L}, ::Colon) where {L}
    exprs = [:(a[$i] = v[$i]) for i = 1:L]
    return quote
        @_propagate_inbounds_meta
        @boundscheck if Length(typeof(v)) != L
            throw(DimensionMismatch("tried to assign $(length(v))-element array to length-$L destination"))
        end
        $(Expr(:block, exprs...))
        return a
    end
end

@propagate_inbounds function setindex!(a::StaticArray, v, inds::StaticArray{<:Tuple, Int})
    _setindex!(a, v, Size(inds), inds)
    return a
end

@generated function _setindex!(a::StaticArray, v, s::Size{S}, inds::StaticArray{<:Tuple, Int}) where {S}
    exprs = [:(a[inds[$i]] = v) for i = 1:prod(S)]
    return quote
        @_propagate_inbounds_meta
        similar_type(a, s)(tuple($(exprs...)))
        return a
    end
end

@generated function _setindex!(a::StaticArray, v::AbstractArray, s::Size{S}, inds::StaticArray{<:Tuple, Int}) where {S}
    exprs = [:(a[inds[$i]] = v[$i]) for i = 1:prod(S)]
    return quote
        @_propagate_inbounds_meta
        @boundscheck if length(v) != $(prod(S))
            throw(DimensionMismatch("tried to assign $(length(v))-element array to length-$(length(inds)) destination"))
        end
        $(Expr(:block, exprs...))
        return a
    end
end

@generated function _setindex!(a::StaticArray, v::StaticArray, s::Size{S}, inds::StaticArray{<:Tuple, Int}) where {S}
    exprs = [:(a[inds[$i]] = v[$i]) for i = 1:prod(S)]
    return quote
        @_propagate_inbounds_meta
        @boundscheck if Length(typeof(v)) != Length(s)
            throw(DimensionMismatch("tried to assign $(length(v))-element array to length-$(length(inds)) destination"))
        end
        $(Expr(:block, exprs...))
        return a
    end
end

###########################################
## Multidimensional non-scalar indexing  ##
###########################################

# To intercept `A[i1, ...]` where all `i` indexes have static sizes,
# create a wrapper used to mark non-scalar indexing operations.
# We insert this at a point in the dispatch hierarchy where we can intercept any
# `typeof(A)` (specifically, including dynamic arrays) without triggering ambiguities.

struct StaticIndexing{I}
    ind::I
end
unwrap(i::StaticIndexing) = i.ind

function Base.to_indices(A, I::Tuple{Vararg{Union{Integer, CartesianIndex, StaticArray{<:Tuple,Int}}}})
    inds = to_indices(A, axes(A), I)
    return map(StaticIndexing, inds)
end

# Overloading getindex, size, iterate, lastindex and to_index is necessary to support
# external operations that want to use to_indices on a StaticArray (see issue #878)

function getindex(ind::StaticIndexing, i::Int)
    return ind.ind[i]
end

function Base.size(ind::StaticIndexing)
    return size(ind.ind)
end

function Base.length(ind::StaticIndexing)
    return length(ind.ind)
end

function Base.iterate(ind::StaticIndexing)
    return iterate(ind.ind)
end
function Base.iterate(ind::StaticIndexing, state)
    return iterate(ind.ind, state)
end

function Base.firstindex(ind::StaticIndexing)
    return firstindex(ind.ind)
end

function Base.lastindex(ind::StaticIndexing)
    return lastindex(ind.ind)
end

function Base.to_index(ind::StaticIndexing)
    return Base.to_index(ind.ind)
end

# getindex

@propagate_inbounds function getindex(a::StaticArray, inds::Union{Int, StaticArray{<:Tuple, Int}, SOneTo, Colon}...)
    _getindex(a, index_sizes(Size(a), inds...), inds)
end

function Base._getindex(::IndexStyle, A::AbstractArray, i1::StaticIndexing, I::StaticIndexing...)
    inds = (unwrap(i1), map(unwrap, I)...)
    return StaticArrays._getindex(A, index_sizes(inds...), inds)
end


@generated function _getindex(a::AbstractArray, ind_sizes::Tuple{Vararg{Size}}, inds)
    newsize = out_index_size(ind_sizes.parameters...)
    linearsizes = linear_index_size(ind_sizes.parameters...)
    exprs = Array{Expr}(undef, linearsizes)

    # Iterate over input indices
    ind_types = inds.parameters
    current_ind = ones(Int,length(linearsizes))
    more = !isempty(exprs)
    while more
        exprs_tmp = [_ind(i, current_ind[i], ind_types[i]) for i = 1:length(linearsizes)]
        exprs[current_ind...] = :(getindex(a, $(exprs_tmp...)))

        # increment current_ind
        current_ind[1] += 1
        for i ∈ 1:length(linearsizes)
            if current_ind[i] > linearsizes[i]
                if i == length(linearsizes)
                    more = false
                    break
                else
                    current_ind[i] = 1
                    current_ind[i+1] += 1
                end
            else
                break
            end
        end
    end

    quote
        @_propagate_inbounds_meta
        similar_type(a, $newsize)(tuple($(exprs...)))
    end
end

# setindex!

@propagate_inbounds function setindex!(a::StaticArray, value, inds::Union{Int, StaticArray{<:Tuple, Int}, Colon}...)
    _setindex!(a, value, index_sizes(Size(a), inds...), inds)
end

function Base._setindex!(::IndexStyle, a::AbstractArray, value, i1::StaticIndexing, I::StaticIndexing...)
    inds = (unwrap(i1), map(unwrap, I)...)
    return StaticArrays._setindex!(a, value, index_sizes(inds...), inds)
end

# setindex! from a scalar
@generated function _setindex!(a::AbstractArray, value, ind_sizes::Tuple{Vararg{Size}}, inds)
    linearsizes = linear_index_size(ind_sizes.parameters...)
    exprs = Array{Expr}(undef, linearsizes)

    # Iterate over input indices
    ind_types = inds.parameters
    current_ind = ones(Int,length(ind_types))
    more = !isempty(exprs)
    while more
        exprs_tmp = [_ind(i, current_ind[i], ind_types[i]) for i = 1:length(ind_types)]
        exprs[current_ind...] = :(setindex!(a, value, $(exprs_tmp...)))

        # increment current_ind
        current_ind[1] += 1
        for i ∈ 1:length(linearsizes)
            if current_ind[i] > linearsizes[i]
                if i == length(linearsizes)
                    more = false
                    break
                else
                    current_ind[i] = 1
                    current_ind[i+1] += 1
                end
            else
                break
            end
        end
    end

    quote
        @_propagate_inbounds_meta
        $(exprs...)
        return a
    end
end

# setindex! from an array
@generated function _setindex!(a::AbstractArray, v::AbstractArray, ind_sizes::Tuple{Vararg{Size}}, inds)
    linearsizes = linear_index_size(ind_sizes.parameters...)
    exprs = Array{Expr}(undef, linearsizes)

    # Iterate over input indices
    ind_types = inds.parameters
    current_ind = ones(Int,length(ind_types))
    more = true
    j = 1
    while more
        exprs_tmp = [_ind(i, current_ind[i], ind_types[i]) for i = 1:length(ind_types)]
        exprs[current_ind...] = :(setindex!(a, v[$j], $(exprs_tmp...)))

        # increment current_ind
        current_ind[1] += 1
        for i ∈ 1:length(linearsizes)
            if current_ind[i] > linearsizes[i]
                if i == length(linearsizes)
                    more = false
                    break
                else
                    current_ind[i] = 1
                    current_ind[i+1] += 1
                end
            else
                break
            end
        end
        j += 1
    end

    quote
        @_propagate_inbounds_meta
        if length(v) != $(prod(linearsizes))
            newsize = $linearsizes
            throw(DimensionMismatch("tried to assign $(length(v))-element array to $newsize destination"))
        end
        $(exprs...)
        return a
    end
end

# checkindex

Base.checkindex(B::Type{Bool}, inds::AbstractUnitRange, i::StaticIndexing{T}) where T = Base.checkindex(B, inds, unwrap(i))

# unsafe_view

# unsafe_view need only deal with vargs of `StaticIndexing`, as wrapped by to_indices.
# i1 is explicitly specified to avoid ambiguities with Base
Base.unsafe_view(A::AbstractArray, i1::StaticIndexing, indices::StaticIndexing...) = Base.unsafe_view(A, unwrap(i1), map(unwrap, indices)...)

# Views of views need a new method for Base.SubArray because storing indices
# wrapped in StaticIndexing in field indices of SubArray causes all sorts of problems.
# Additionally, in some cases the SubArray constructor may be called directly
# instead of unsafe_view so we need this method too (Base._maybe_reindex
# is a good example)
# the tuple indices has to have at least one element to prevent infinite
# recursion when viewing a zero-dimensional array (see issue #705)
Base.SubArray(A::AbstractArray, indices::Tuple{StaticIndexing, Vararg{StaticIndexing}}) = Base.SubArray(A, map(unwrap, indices))

module StaticArraysStatisticsExt

import Statistics: mean, median

using Base.Order: Forward, ord
using Statistics: median!, middle

using StaticArrays
using StaticArrays: BitonicSort, _InitialValue, _reduce, _mapreduce, _bitonic_sort_limit, _sort

_mean_denom(a, ::Colon) = length(a)
_mean_denom(a, dims::Int) = size(a, dims)
_mean_denom(a, ::Val{D}) where {D} = size(a, D)

@inline mean(a::StaticArray; dims::D=:) where {D} = _reduce(+, a, dims) / _mean_denom(a, dims)
@inline mean(f::Function, a::StaticArray; dims::D=:) where {D} = _mapreduce(f, +, dims, _InitialValue(), Size(a), a) / _mean_denom(a, dims)

@inline function median(a::StaticArray; dims::D = :) where {D}
    if dims == Colon()
        median(vec(a))
    else
        # FIXME: Implement `mapslices` correctly on `StaticArray` to remove
        # this fallback.
        median(Array(a); dims)
    end
end

@inline function median(a::StaticVector)
    (isimmutable(a) && length(a) <= _bitonic_sort_limit) ||
        return median!(Base.copymutable(a))

    # following Statistics.median
    isempty(a) &&
        throw(ArgumentError("median of empty vector is undefined, $(repr(a))"))
    eltype(a) >: Missing && any(ismissing, a) &&
        return missing
    nanix = findfirst(x -> x isa Number && isnan(x), a)
    isnothing(nanix) ||
        return a[nanix]

    order = ord(isless, identity, nothing, Forward)
    sa = _sort(Tuple(a), BitonicSort, order)

    n = length(a)
    # sa is 1-indexed
    return isodd(n) ?
        middle(sa[n ÷ 2 + 1]) :
        middle(sa[n ÷ 2], sa[n ÷ 2 + 1])
end

end # module

# Singular Value Decomposition

# We need our own SVD factorization struct, as LinearAlgebra.SVD assumes
# Base.Vector for `S`, and that the `U` and `Vt` have the same
struct SVD{T,TU,TS,TVt} <: Factorization{T}
    U::TU
    S::TS
    Vt::TVt
end
SVD(U::AbstractArray{T}, S::AbstractVector, Vt::AbstractArray{T}) where {T} = SVD{T,typeof(U),typeof(S),typeof(Vt)}(U, S, Vt)

@inline function Base.getproperty(F::SVD, s::Symbol)
    if s === :V
        return getfield(F, :Vt)'
    else
        return getfield(F, s)
    end
end

# iteration for destructuring into components
Base.iterate(S::SVD) = (S.U, Val(:S))
Base.iterate(S::SVD, ::Val{:S}) = (S.S, Val(:V))
Base.iterate(S::SVD, ::Val{:V}) = (S.V, Val(:done))
Base.iterate(S::SVD, ::Val{:done}) = nothing

function svdvals(A::StaticMatrix)
    sv = svdvals(Matrix(A))
    # We should be using `T2=eltype(sv)`, but it's not inferable for complex
    # eltypes.  See https://github.com/JuliaLang/julia/pull/22443
    T = eltype(A)
    T2 = promote_type(Float32, real(typeof(one(T)/norm(one(T)))))
    similar_type(A, T2, Size(diagsize(A)))(sv)
end

# `@inline` annotation is required to propagate `full` as constant to `_svd`
@inline svd(A::StaticMatrix; full=Val(false)) = _svd(A, full)

# Allow plain Bool in addition to Val
# Required inline as of version 1.5 to ensure Bool usage like svd(A,
# full=false) is constant-propagated
@inline _svd(A, full) = _svd(A, Val(convert(Bool, full)))

function _svd(A, full::Val{false})
    f = svd(Matrix(A), full=false)
    U = similar_type(A,  eltype(f.U),  Size(Size(A)[1], diagsize(A)))(f.U)
    S = similar_type(A,  eltype(f.S),  Size(diagsize(A)))(f.S)
    Vt = similar_type(A, eltype(f.Vt), Size(diagsize(A), Size(A)[2]))(f.Vt)
    SVD(U,S,Vt)
end

function _svd(A, full::Val{true})
    f = svd(Matrix(A), full=true)
    U = similar_type(A,  eltype(f.U),  Size(Size(A)[1], Size(A)[1]))(f.U)
    S = similar_type(A,  eltype(f.S),  Size(diagsize(A)))(f.S)
    Vt = similar_type(A, eltype(f.Vt), Size(Size(A)[2], Size(A)[2]))(f.Vt)
    SVD(U,S,Vt)
end

function \(F::SVD, B::StaticVecOrMat)
    sthresh = eps(F.S[1])
    Sinv = map(s->s < sthresh ? zero(1/sthresh) : 1/s, F.S)
    return transposemult(F.Vt, diagmult(Sinv, transposemult(F.U, B)))
end

transposemult(U, B) = transposemult(Size(U), Size(B), U, B)
function transposemult(sU, sB, U, B)
    sU[1] == sB[1] && return U'*B
    return U[SOneTo(sB[1]),:]'*B
end
diagmult(d, B) = diagmult(Size(d), Size(B), d, B)
function diagmult(sd, sB, d, B)
    sd[1] == sB[1] && return Diagonal(d)*B
    ind = SOneTo(sd[1])
    return isa(B, AbstractVector) ? Diagonal(d)*B[ind] : Diagonal(d)*B[ind,:]
end

using StaticArrays, Test
import StaticArrays.arithmetic_closure

struct TestDie
    nsides::Int
end
Random.rand(rng::AbstractRNG, d::Random.SamplerTrivial{TestDie}) = rand(rng, 1:d[].nsides)
Base.eltype(::Type{TestDie}) = Int

const AbstractFloatSubtypes = [Float16, Float32, Float64, BigFloat]
const UnsignedSubtypes = [UInt8, UInt16, UInt32, UInt64, UInt128]
const SignedSubtypes = [Int8, Int16, Int32, Int64, Int128, BigInt]

@testset "Array math" begin
    @testset "zeros() and ones()" begin
        @test @inferred(zeros(SVector{3,Float64})) === @SVector [0.0, 0.0, 0.0]
        @test @inferred(zeros(SVector{3,Int})) === @SVector [0, 0, 0]
        @test @inferred(ones(SVector{3,Float64})) === @SVector [1.0, 1.0, 1.0]
        @test @inferred(ones(SVector{3,Int})) === @SVector [1, 1, 1]
        @test @inferred(zeros(SVector{0,Float64})) === @SVector Float64[]
        @test @inferred(zeros(SVector{0,Int})) === @SVector Int[]
        @test @inferred(ones(SVector{0,Float64})) === @SVector Float64[]
        @test @inferred(ones(SVector{0,Int})) === @SVector Int[]

        @test @inferred(zeros(SVector{3})) === @SVector [0.0, 0.0, 0.0]
        @test @inferred(zeros(SMatrix{2,2})) === @SMatrix [0.0 0.0; 0.0 0.0]
        @test @inferred(zeros(SArray{Tuple{1,1,1}})) === SArray{Tuple{1,1,1}}((0.0,))
        @test @inferred(zeros(MVector{3}))::MVector == @MVector [0.0, 0.0, 0.0]
        @test @inferred(zeros(MMatrix{2,2}))::MMatrix == @MMatrix [0.0 0.0; 0.0 0.0]
        @test @inferred(zeros(MArray{Tuple{1,1,1}}))::MArray == MArray{Tuple{1,1,1}}((0.0,))

        @test @inferred(ones(SVector{3})) === @SVector [1.0, 1.0, 1.0]
        @test @inferred(ones(SMatrix{2,2})) === @SMatrix [1.0 1.0; 1.0 1.0]
        @test @inferred(ones(SArray{Tuple{1,1,1}})) === SArray{Tuple{1,1,1}}((1.0,))
        @test @inferred(ones(MVector{3}))::MVector == @MVector [1.0, 1.0, 1.0]
        @test @inferred(ones(MMatrix{2,2}))::MMatrix == @MMatrix [1.0 1.0; 1.0 1.0]
        @test @inferred(ones(MArray{Tuple{1,1,1}}))::MArray == MArray{Tuple{1,1,1}}((1.0,))

        # https://github.com/JuliaArrays/StaticArrays.jl/issues/428
        bigzeros = zeros(SVector{2, BigInt})
        @test bigzeros == @SVector [big(0), big(0)]
        @test bigzeros[1] !== bigzeros[2]

        bigones = ones(SVector{2, BigInt})
        @test bigones == @SVector [big(1), big(1)]
        @test bigones[1] !== bigones[2]
    end

    @testset "ones()" begin
        for SA in (SVector, MVector, SizedVector)
            # Float64
            m = @inferred ones(SA{3, Float64})
            @test m == [1.0, 1.0, 1.0]
            @test m isa SA{3, Float64}
            # Int
            m = @inferred ones(SA{3, Int})
            @test m == [1, 1, 1]
            @test m isa SA{3, Int}
            # Unspecified
            m = @inferred ones(SA{3})
            @test m == [1.0, 1.0, 1.0]
            @test m isa SA{3}
            # Float64
            m = @inferred ones(SA{0, Float64})
            @test m == Float64[]
            @test m isa SA{0, Float64}
            # Int
            m = @inferred ones(SA{0, Int})
            @test m == Int[]
            @test m isa SA{0, Int}
            # Unspecified
            m = @inferred ones(SA{0})
            @test m == Float64[]
            @test m isa SA{0}
            # Any
            @test_throws MethodError ones(SA{3, Any})
            @test ones(SA{0, Any}) isa SA{0, Any}
        end
    end

    @testset "zero()" begin
        for SA in (SVector, MVector, SizedVector)
            # Float64
            m = @inferred zero(SA{3, Float64})
            @test m == [0.0, 0.0, 0.0]
            @test m isa SA{3, Float64}
            # Int
            m = @inferred zero(SA{3, Int})
            @test m == [0, 0, 0]
            @test m isa SA{3, Int}
            # Unspecified
            m = @inferred zero(SA{3})
            @test m == [0.0, 0.0, 0.0]
            @test m isa SA{3}
            # Float64 (zero-element)
            m = @inferred zero(SA{0, Float64})
            @test m == Float64[]
            @test m isa SA{0, Float64}
            # Int (zero-element)
            m = @inferred zero(SA{0, Int})
            @test m == Int[]
            @test m isa SA{0, Int}
            # Unspecified (zero-element)
            m = @inferred zero(SA{0})
            @test m == Float64[]
            @test m isa SA{0}
            # Any
            @test_throws MethodError zeros(SA{3, Any})
            @test zeros(SA{0, Any}) isa SA{0, Any}
        end
    end

    @testset "fill()" begin
        @test @allocated(fill(0., SMatrix{1, 16, Float64})) == 0 # #81
        @test @allocated(fill(0., SMatrix{0, 5, Float64})) == 0

        for SA in (SMatrix, MMatrix, SizedMatrix)
            for T in (Float64, Int, Any)
                # Float64 -> T
                m = @inferred(fill(3.0, SA{4, 16, T}))
                @test m isa SA{4, 16, T}
                @test all(m .== 3)
                # Float64 -> T (zero-element)
                m = @inferred(fill(3.0, SA{0, 5, T}))
                @test m isa SA{0, 5, T}
                @test all(m .== 3)
                # Int -> T
                m = @inferred(fill(3, SA{4, 16, T}))
                @test m isa SA{4, 16, T}
                @test all(m .== 3)
                # Int -> T (zero-element)
                m = @inferred(fill(3, SA{0, 5, T}))
                @test m isa SA{0, 5, T}
                @test all(m .== 3)
            end

            # Float64 -> Unspecified
            m = @inferred(fill(3.0, SA{4, 16}))
            @test m isa SA{4, 16, Float64}
            @test all(m .== 3)
            # Float64 -> Unspecified (zero-element)
            m = @inferred(fill(3.0, SA{0, 5}))
            @test m isa SA{0, 5, Float64}
            @test all(m .== 3)
            # Int -> Unspecified
            m = @inferred(fill(3, SA{4, 16}))
            @test m isa SA{4, 16, Int}
            @test all(m .== 3)
            # Int -> Unspecified (zero-element)
            m = @inferred(fill(3, SA{0, 5}))
            @test m isa SA{0, 5, Int}
            @test all(m .== 3)
        end
    end

    @testset "fill!()" begin
        m = MMatrix{4,16,Float64}(undef)
        fill!(m, 3)
        @test all(m .== 3.)
        m = MMatrix{0,5,Float64}(undef)
        fill!(m, 3)
        @test all(m .== 3.)
    end

    @testset "rand()" begin
        m = rand(1:2, SVector{3})
        check = ((m .>= 1) .& (m .<= 2))
        @test all(check)
        m = rand(1:2, SMatrix{4, 4})
        check = ((m .>= 1) .& (m .<= 2))
        @test all(check)
        m = rand(1:1, SVector{3})
        @test rand(m) == 1

        for SA in (SVector, MVector, SizedVector)
            v1 = rand(SA{3})
            @test v1 isa SA{3, Float64}
            @test all(0 .< v1 .< 1)

            v2 = rand(SA{0})
            @test v2 isa SA{0, Float64}
            @test all(0 .< v2 .< 1)

            v3 = rand(SA{3, Float32})
            @test v3 isa SA{3, Float32}
            @test all(0 .< v3 .< 1)

            v4 = rand(SA{0, Float32})
            @test v4 isa SA{0, Float32}
            @test all(0 .< v4 .< 1)
        end
        rng = MersenneTwister(123)
        @test (@SVector rand(3)) isa SVector{3,Float64}
        @test (@SMatrix rand(3, 4)) isa SMatrix{3,4,Float64}
        @test (@SArray rand(3, 4, 5)) isa SArray{Tuple{3,4,5},Float64}

        @test (@MVector rand(3)) isa MVector{3,Float64}
        @test (@MMatrix rand(3, 4)) isa MMatrix{3,4,Float64}
        @test (@MArray rand(3, 4, 5)) isa MArray{Tuple{3,4,5},Float64}

        @test (@SVector rand(TestDie(6), 3)) isa SVector{3,Int}
        @test (@SVector rand(rng, TestDie(6), 3)) isa SVector{3,Int}
        @test (@SVector rand(TestDie(6), 0)) isa SVector{0,Int}
        @test (@SVector rand(rng, TestDie(6), 0)) isa SVector{0,Int}
        @test (@MVector rand(TestDie(6), 3)) isa MVector{3,Int}
        @test (@MVector rand(rng, TestDie(6), 3)) isa MVector{3,Int}

        @test (@SMatrix rand(TestDie(6), 3, 4)) isa SMatrix{3,4,Int}
        @test (@SMatrix rand(rng, TestDie(6), 3, 4)) isa SMatrix{3,4,Int}
        @test (@SMatrix rand(TestDie(6), 0, 4)) isa SMatrix{0,4,Int}
        @test (@SMatrix rand(rng, TestDie(6), 0, 4)) isa SMatrix{0,4,Int}
        @test (@MMatrix rand(TestDie(6), 3, 4)) isa MMatrix{3,4,Int}
        @test (@MMatrix rand(rng, TestDie(6), 3, 4)) isa MMatrix{3,4,Int}

        @test (@SArray rand(TestDie(6), 3, 4, 5)) isa SArray{Tuple{3,4,5},Int}
        @test (@SArray rand(rng, TestDie(6), 3, 4, 5)) isa SArray{Tuple{3,4,5},Int}
        @test (@SArray rand(TestDie(6), 0, 4, 5)) isa SArray{Tuple{0,4,5},Int}
        @test (@SArray rand(rng, TestDie(6), 0, 4, 5)) isa SArray{Tuple{0,4,5},Int}
        @test (@MArray rand(TestDie(6), 3, 4, 5)) isa MArray{Tuple{3,4,5},Int}

        # test if rng generator is actually respected
        @test (@SVector rand(MersenneTwister(123), TestDie(6), 3)) ===
              (@SVector rand(MersenneTwister(123), TestDie(6), 3))
        @test (@SMatrix rand(MersenneTwister(123), TestDie(6), 3, 4)) ===
              (@SMatrix rand(MersenneTwister(123), TestDie(6), 3, 4))
        @test (@SArray rand(MersenneTwister(123), TestDie(6), 3, 4, 5)) ===
              (@SArray rand(MersenneTwister(123), TestDie(6), 3, 4, 5))
    end

    @testset "rand!()" begin
        m = @MMatrix [0. 0.; 0. 0.]
        rand!(m)
        check = ((m .< 1.) .& (m .> 0.))
        @test all(check)
        m = @MMatrix [0. 0.; 0. 0.]
        rand!(m, 1:2)
        check = ((m .>= 1) .& (m .<= 2))
        @test all(check)

        for SA in (MVector, SizedVector)
            v1 = rand(SA{3})
            rand!(v1)
            @test v1 isa SA{3, Float64}
            @test all(0 .< v1 .< 1)

            v2 = rand(SA{0})
            rand!(v2)
            @test v2 isa SA{0, Float64}
            @test all(0 .< v2 .< 1)

            v3 = rand(SA{3, Float32})
            rand!(v3)
            @test v3 isa SA{3, Float32}
            @test all(0 .< v3 .< 1)

            v4 = rand(SA{0, Float32})
            rand!(v4)
            @test v4 isa SA{0, Float32}
            @test all(0 .< v4 .< 1)
        end
    end

    @testset "randn()" begin
        for SA in (SVector, MVector, SizedVector)
            v1 = randn(SA{3})
            @test v1 isa SA{3, Float64}

            v2 = randn(SA{0})
            @test v2 isa SA{0, Float64}

            v3 = randn(SA{3, Float32})
            @test v3 isa SA{3, Float32}

            v4 = randn(SA{0, Float32})
            @test v4 isa SA{0, Float32}
        end
    end

    @testset "randn!()" begin
        for SA in (MVector, SizedVector)
            v1 = randn(SA{3})
            randn!(v1)
            @test v1 isa SA{3, Float64}

            v2 = randn(SA{0})
            randn!(v2)
            @test v2 isa SA{0, Float64}

            v3 = randn(SA{3, Float32})
            randn!(v3)
            @test v3 isa SA{3, Float32}

            v4 = randn(SA{0, Float32})
            randn!(v4)
            @test v4 isa SA{0, Float32}
        end
    end

    @testset "randexp()" begin
        for SA in (SVector, MVector, SizedVector)
            v1 = randexp(SA{3})
            @test v1 isa SA{3, Float64}
            @test all(0 .< v1)

            v2 = randexp(SA{0})
            @test v2 isa SA{0, Float64}
            @test all(0 .< v2)

            v3 = randexp(SA{3, Float32})
            @test v3 isa SA{3, Float32}
            @test all(0 .< v3)

            v4 = randexp(SA{0, Float32})
            @test v4 isa SA{0, Float32}
            @test all(0 .< v4)
        end
    end

    @testset "randexp!()" begin
        for SA in (MVector, SizedVector)
            v1 = randexp(SA{3})
            randexp!(v1)
            @test v1 isa SA{3, Float64}
            @test all(0 .< v1)

            v2 = randexp(SA{0})
            randexp!(v2)
            @test v2 isa SA{0, Float64}
            @test all(0 .< v2)

            v3 = randexp(SA{3, Float32})
            randexp!(v3)
            @test v3 isa SA{3, Float32}
            @test all(0 .< v3)

            v4 = randexp(SA{0, Float32})
            randexp!(v4)
            @test v4 isa SA{0, Float32}
            @test all(0 .< v4)
        end
    end

    @testset "arithmetic_closure" for T0 in [UnsignedSubtypes;
                                             SignedSubtypes;
                                             AbstractFloatSubtypes;
                                             Bool;
                                             Complex{Int};
                                             Complex{Float64};
                                             ]
        T = @inferred arithmetic_closure(T0)
        @test arithmetic_closure(T) == T

        t = one(T)
        @test (t+t) isa T
        @test (t-t) isa T
        @test (t*t) isa T
        @test (t/t) isa T
    end

    @testset "arithmetic_closure allocation" begin
        # a little icky, but `@allocated` seems to be too fragile to use in a loop with
        # types assigned in variables (see #924); so we write out a test explicitly for
        # every `isbitstype` type of interest
        @test (@allocated arithmetic_closure(UInt128))        == 0
        @test (@allocated arithmetic_closure(UInt16))         == 0
        @test (@allocated arithmetic_closure(UInt32))         == 0
        @test (@allocated arithmetic_closure(UInt64))         == 0
        @test (@allocated arithmetic_closure(UInt8))          == 0
        @test (@allocated arithmetic_closure(Int128))         == 0
        @test (@allocated arithmetic_closure(Int16))          == 0
        @test (@allocated arithmetic_closure(Int32))          == 0
        @test (@allocated arithmetic_closure(Int64))          == 0
        @test (@allocated arithmetic_closure(Int8))           == 0
        @test (@allocated arithmetic_closure(Float16))        == 0
        @test (@allocated arithmetic_closure(Float32))        == 0
        @test (@allocated arithmetic_closure(Float64))        == 0
        @test (@allocated arithmetic_closure(Bool))           == 0
        @test (@allocated arithmetic_closure(Complex{Int64})) == 0
        @test (@allocated arithmetic_closure(ComplexF64))     == 0
    end
end

using Unitful

@testset "Unitful" begin
    # issue #1124
    @test norm(SVector(1.0*u"m")) == 1.0*u"m"
    # issue $1127
    @test norm(SVector(0.0, 0.0)*u"nm") == 0.0*u"nm"

    @test norm(SVector(1.0, 2.0)*u"m", 1) == 3.0*u"m"
    @test norm(SVector(0.0, 0.0)*u"nm", 1) == 0.0*u"nm"

    @test norm([SVector(1.0u"m", 2.0u"m")]) == norm([1.0u"m", 2.0u"m"])
    @test isapprox(SVector(1.0u"m", 2.0u"m"), SVector(1.1u"m", 2.1u"m"); atol=0.2u"m")
end

using StaticArrays, Test, LinearAlgebra

tol = 1e-13

@testset "Moore–Penrose inverse (pseudoinverse)" begin
    M1 = @SMatrix [1.5 1.3; 1.2 1.9]
    N1 = pinv(M1)
    @test norm(M1*N1*M1 - M1) < tol
    @test norm(N1*M1*N1 - N1) < tol
    @test N1 isa SMatrix{2,2,Float64}
    @test N1 ≈ pinv(Matrix(M1))

    M2 = @SMatrix [1//2 0 0;3//2 5//3 8//7;9//4 -1//3 -8//7;0 0 0]
    N2 = pinv(M2)
    @test norm(M2*N2*M2 - M2) < tol
    @test norm(N2*M2*N2 - N2) < tol
    @test N2 isa SMatrix{3,4,Float64}
    @test N2 ≈ pinv(Matrix(M2))

    M3 = SDiagonal(0,1,2,3)
    N3 = pinv(M3)
    @test norm(M3*N3*M3 - M3) < tol
    @test norm(N3*M3*N3 - N3) < tol
    @test N3 isa Diagonal{Float64, <:SVector{4,Float64}}
    @test N3 ≈ pinv(Matrix(M3))

    M4 = @SMatrix randn(2,5)
    N4 = pinv(M4)
    @test norm(M4*N4*M4 - M4) < tol
    @test norm(N4*M4*N4 - N4) < tol
    @test N4 isa SMatrix{5,2,Float64}
    @test N4 ≈ pinv(Matrix(M4))

    M5 = SMatrix{0,5,Int}()
    N5 = pinv(M5)
    @test norm(M5*N5*M5 - M5) < tol
    @test norm(N5*(M5*N5) - N5) < tol
    @test N5 isa SMatrix{5,0,Float64}
    @test N5 ≈ pinv(Matrix(M5))

    M6 = @SMatrix [1/2 0 0;0 -5/3 0;0 0 0;0 0 0]
    N6 = pinv(M6)
    @test norm(M6*N6*M6 - M6) < tol
    @test norm(N6*M6*N6 - N6) < tol
    @test N6 isa SMatrix{3,4,Float64}
    @test N6 ≈ I(3)/Matrix(M6)
    @test N6 ≈ pinv(Matrix(M6))

    M7 = M6'
    N7 = pinv(M7)
    @test norm(M7*N7*M7 - M7) < tol
    @test norm(N7*M7*N7 - N7) < tol
    @test N7 isa SMatrix{4,3,Float64}
    @test N7 ≈ I(4)/Matrix(M7)
    @test N7 ≈ pinv(Matrix(M7))

    M8 = @MMatrix [0.5 1.1 0.0;0.0 -2.8 0.0;0.0 0.0 0.0;0.0 0.0 0.0]
    N8 = pinv(M8)
    @test norm(M8*N8*M8 - M8) < tol
    @test norm(N8*M8*N8 - N8) < tol
    @test N8 isa MMatrix{3,4,Float64}
    @test N8 ≈ pinv(Matrix(M8))

    M9 = M8'
    N9 = pinv(M9)
    @test norm(M9*N9*M9 - M9) < tol
    @test norm(N9*M9*N9 - N9) < tol
    @test N9 isa MMatrix{4,3,Float64}
    @test N9 ≈ pinv(Matrix(M9))

    M10 = @SMatrix randn(3,3)
    N10 = pinv(M10)
    @test N10 ≈ inv(M10)
    @test norm(M10*N10*M10 - M10) < tol
    @test norm(N10*M10*N10 - N10) < tol
    @test N10 isa StaticMatrix
    @test N10 ≈ pinv(Matrix(M10))

    for wrapper in (Symmetric, Hermitian)
        M_w = wrapper(@SMatrix [1.0 0.5; 0.5 2.0])
        N_w = pinv(M_w)
        @test N_w ≈ pinv(Matrix(M_w))
        @test N_w isa SMatrix{2,2,Float64}
    end
end

using StaticArrays, Test, LinearAlgebra

mul_wrappers = [
    m -> m,
    m -> Symmetric(m, :U),
    m -> Symmetric(m, :L),
    m -> Hermitian(m, :U),
    m -> Hermitian(m, :L),
    m -> UpperTriangular(m),
    m -> LowerTriangular(m),
    m -> UnitUpperTriangular(m),
    m -> UnitLowerTriangular(m),
    m -> Adjoint(m),
    m -> Transpose(m),
    m -> Diagonal(m)]

@testset "Matrix multiplication" begin
    @testset "Matrix-vector" begin
        m = @SMatrix [1 2; 3 4]
        v = @SVector [1, 2]
        v_bad = @SVector [1, 2, 3]
        @test m*v === @SVector [5, 11]
        for wrapper in mul_wrappers
            @test (@inferred wrapper(m)*v)::SVector{2} == wrapper(Array(m))*Array(v)
        end
        @test_throws DimensionMismatch m*v_bad
        # More complicated eltype inference
        v2 = @SVector [CartesianIndex((1,3)), CartesianIndex((3,1))]
        x = @inferred(m*v2)
        @test isa(x, SVector{2,CartesianIndex{2}})
        @test x == @SVector [CartesianIndex((7,5)), CartesianIndex((15,13))]

        # block matrices
        bm = @SMatrix [m m; m m]
        bv = @SVector [v,v]
        @test (bm*bv)::SVector{2,SVector{2,Int}} == @SVector [[10,22],[10,22]]
        for wrapper in mul_wrappers
            # there may be some problems with inferring the result type of symmetric block matrices
            # and for some reason setindex! in Julia LinearAlgebra has == 0 and == 1 tests
            if !any(x->isa(wrapper(bm), x), [UpperTriangular, LowerTriangular, UnitUpperTriangular, UnitLowerTriangular])
                @test wrapper(bm)*bv == wrapper(Array(bm))*Array(bv)
            end
        end

        # inner product
        @test @inferred(v'*v) === 5
        @test @inferred(transpose(v)*v) === 5

        # outer product
        @test @inferred(v*v') === @SMatrix [1 2; 2 4]
        @test @inferred(v*transpose(v)) === @SMatrix [1 2; 2 4]

        v3 = [1, 2]
        @test m*v3 == @MVector [5, 11]
        v3_bad = [1, 2, 3]
        @test_throws DimensionMismatch m*v3_bad

        m2 = @MMatrix [1 2; 3 4]
        v4 = @MVector [1, 2]
        @test (m2*v4)::MVector == @MVector [5, 11]

        m3 = @SArray [1 2; 3 4]
        v5 = @SArray [1, 2]
        @test m3*v5 === @SVector [5, 11]

        m4 = @MArray [1 2; 3 4]
        v6 = @MArray [1, 2]
        @test (m4*v6) == @MVector [5, 11]

        m5 = @SMatrix [1.0 2.0; 3.0 4.0]
        v7 = [1.0, 2.0]
        @test (m5*v7)::SVector ≈ @SVector [5.0, 11.0]

        m6 = @SMatrix Float32[1.0 2.0; 3.0 4.0]
        v8 = Float64[1.0, 2.0]
        @test (m6*v8)::SVector{2,Float64} ≈ @SVector [5.0, 11.0]

    end

    @testset "Vector-matrix" begin
        m = @SMatrix [1 2 3 4]
        v = @SVector [1, 2]
        @test @inferred(v*m) === @SMatrix [1 2 3 4; 2 4 6 8]

        # block matrices
        m = @SMatrix [1 2; 3 4]
        bm = @SMatrix [m m; m m]
        bv = @SVector [v,v]

        @test (bv'*bm)'::SVector{2,SVector{2,Int}} == @SVector [[14,20],[14,20]]

        # Outer product
        v2 = SVector(1, 2)
        v3 = SVector(3, 4)
        @test v2 * v3' === @SMatrix [3 4; 6 8]
        @test v2 * transpose(v3) === @SMatrix [3 4; 6 8]

        v4 = SVector(1+0im, 2+0im)
        v5 = SVector(3+0im, 4+0im)
        @test v4 * v5' === @SMatrix [3+0im 4+0im; 6+0im 8+0im]
        @test v4 * transpose(v5) === @SMatrix [3+0im 4+0im; 6+0im 8+0im]
    end

    @testset "Column vector-vector" begin
        cv_array = rand(4,1)
        rv_array = rand(4)
        a_array = cv_array * rv_array'

        cv = SMatrix{4,1}(cv_array)
        rv = SVector{4}(rv_array)
        @test (cv*adjoint(rv))::SMatrix ≈ a_array

        cv = MMatrix{4,1}(cv_array)
        rv = MVector{4}(rv_array)
        @test (cv*adjoint(rv))::MMatrix ≈ a_array

        cv = SMatrix{4,1}(cv_array)
        rv = SVector{4}(rv_array)
        @test (cv*transpose(rv))::SMatrix ≈ a_array

        cv = MMatrix{4,1}(cv_array)
        rv = MVector{4}(rv_array)
        @test (cv*transpose(rv))::MMatrix ≈ a_array

        cv_bad = @SMatrix rand(4,2)
        rv = @SVector rand(4)
        @test_throws DimensionMismatch cv_bad*transpose(rv)
        @test_throws DimensionMismatch cv_bad*adjoint(rv)
        @test_throws DimensionMismatch cv_bad*rv

        cv_bad = @MMatrix rand(4,2)
        rv = @MVector rand(4)

        @test_throws DimensionMismatch cv_bad*transpose(rv)
        @test_throws DimensionMismatch cv_bad*adjoint(rv)
        @test_throws DimensionMismatch cv_bad*rv
    end

    @testset "vector-column vector" begin
        for T1 in [Float64, ComplexF64, SMatrix{2,2,Float64,4}, SMatrix{2,2,ComplexF64,4}],
            T2 in [Float64, ComplexF64, SMatrix{2,2,Float64,4}, SMatrix{2,2,ComplexF64,4}]

            v1 = @SVector randn(T1, 4)
            v2 = @SVector randn(T2, 4)
            if T1 <: Number
                v1a = Array(v1)
            else
                v1a = Array(Array.(v1))
            end
            if T2 <: Number
                v2a = Array(v2)
            else
                v2a = Array(Array.(v2))
            end
            @test all(isapprox.(v1 * adjoint(v2), v1a * adjoint(v2a)))
            @test all(isapprox.(v1 * transpose(v2), v1a * transpose(v2a)))
        end
    end

    @testset "Matrix-matrix" begin
        m = @SMatrix [1 2; 3 4]
        n = @SMatrix [2 3; 4 5]
        nc = @SMatrix [CartesianIndex((2,2)) CartesianIndex((3,3));
                       CartesianIndex((4,4)) CartesianIndex((5,5))]
        @test @inferred(m*n)  === @SMatrix [10 13; 22 29]
        @test m*nc === @SMatrix [CartesianIndex((10,10)) CartesianIndex((13,13));
                                 CartesianIndex((22,22)) CartesianIndex((29,29))]

        @test m'*n === @SMatrix [14 18; 20 26]
        @test m*n' === @SMatrix [8 14; 18 32]
        @test m'*n' === @SMatrix [11 19; 16 28]
        @test transpose(m)*n === @SMatrix [14 18; 20 26]
        @test m*transpose(n) === @SMatrix [8 14; 18 32]
        @test transpose(m)*transpose(n) === @SMatrix [11 19; 16 28]

        # check different sizes because there are multiple implementations for matrices of different sizes
        for (mm, nn) in [
            (m, n),
            (SMatrix{10, 10}(collect(1:100)), SMatrix{10, 10}(collect(1:100))),
            (SMatrix{15, 15}(collect(1:225)), SMatrix{15, 15}(collect(1:225)))
            ]
            for wrapper_m in mul_wrappers, wrapper_n in mul_wrappers
                wm = wrapper_m(mm)
                wn = wrapper_n(nn)
                if length(mm) >= 255 && (!isa(wm, StaticArray) || !isa(wn, StaticArray))
                    continue
                end
                res_structure = StaticArrays.mul_result_structure(wm, wn)
                expected_type = if length(m) >= 100
                    Matrix{Int}
                elseif res_structure == identity || length(m) >= 100
                    typeof(mm)
                elseif res_structure == LowerTriangular
                    LowerTriangular{Int,typeof(mm)}
                elseif res_structure == UpperTriangular
                    UpperTriangular{Int,typeof(mm)}
                elseif res_structure == Diagonal
                    Diagonal{Int,<:SVector}
                else
                    error("Unknown structure: ", res_structure)
                end
                @test (@inferred wm * wn)::expected_type == wrapper_m(Array(mm)) * wrapper_n(Array(nn))
            end
        end

        m = @MMatrix [1 2; 3 4]
        n = @MMatrix [2 3; 4 5]
        @test (m*n) == @MMatrix [10 13; 22 29]

        m = @SArray [1 2; 3 4]
        n = @SArray [2 3; 4 5]
        @test m*n === @SMatrix [10 13; 22 29]

        m = @MArray [1 2; 3 4]
        n = @MArray [2 3; 4 5]
        @test (m*n) == @SMatrix [10 13; 22 29]

        # block matrices
        bm = @SMatrix [m m; m m]
        bm2 = @MMatrix [14 20; 30 44]
        @test (bm*bm)::SMatrix{2,2,MMatrix{2,2,Int,4}} == @SMatrix [bm2 bm2; bm2 bm2]

        # Alternative methods used between 8 < n <= 14 and n > 14
        m_array = rand(1:10, 10, 10)
        n_array = rand(1:10, 10, 10)
        a_array = m_array*n_array

        m = SMatrix{10,10}(m_array)
        n = SMatrix{10,10}(n_array)
        @test m*n === SMatrix{10,10}(a_array)

        m_array2 = rand(1:10, 16, 16) # see JuliaLang/julia#18794 for reason for variable name changes
        n_array2 = rand(1:10, 16, 16)
        a_array2 = m_array2*n_array2

        m2 = SMatrix{16,16}(m_array2)
        n2 = SMatrix{16,16}(n_array2)
        @test m2*n2 === SMatrix{16,16}(a_array2)

        # Non-square version
        m_array3 = rand(1:10, 9, 10)
        n_array3 = rand(1:10, 10, 11)
        a_array3 = m_array3*n_array3
        m3 = SMatrix{9,10}(m_array3)
        n3 = SMatrix{10,11}(n_array3)
        @test m3*n3 === SMatrix{9,11}(a_array3)

        # Mutating types follow different behaviour
        m_array = rand(1:10, 10, 10)
        n_array = rand(1:10, 10, 10)
        a_array = m_array*n_array

        m = MMatrix{10,10}(m_array)
        n = MMatrix{10,10}(n_array)
        @test (m*n)::MMatrix == a_array

        m_array = rand(1:10, 16, 16)
        n_array = rand(1:10, 16, 16)
        a_array = m_array*n_array

        m = MMatrix{16,16}(m_array)
        n = MMatrix{16,16}(n_array)
        @test (m*n)::MMatrix == a_array

        # Mutating BLAS types follow yet different behaviour
        m_array = randn(4, 4)
        n_array = randn(4, 4)
        a_array = m_array*n_array

        m = MMatrix{4,4}(m_array)
        n = MMatrix{4,4}(n_array)
        @test m*n::MMatrix ≈ a_array

        m_array = randn(10, 10)
        n_array = randn(10, 10)
        a_array = m_array*n_array

        m = MMatrix{10,10}(m_array)
        n = MMatrix{10,10}(n_array)
        @test m*n::MMatrix ≈ a_array

        m_array = randn(16, 16)
        n_array = randn(16, 16)
        a_array = m_array*n_array

        m = MMatrix{16,16}(m_array)
        n = MMatrix{16,16}(n_array)
        @test m*n::MMatrix ≈ a_array

        # Complex numbers
        m_array = randn(4, 4)
        n_array = im*randn(4, 4)
        a_array = m_array*n_array

        m = MMatrix{4,4}(m_array)
        n = MMatrix{4,4}(n_array)
        @test m*n::MMatrix ≈ a_array

        m_array = randn(10, 10)
        n_array = im*randn(10, 10)
        a_array = m_array*n_array

        m = MMatrix{10,10}(m_array)
        n = MMatrix{10,10}(n_array)
        @test m*n::MMatrix ≈ a_array

        m_array = randn(16, 16)
        n_array = im*randn(16, 16)
        a_array = m_array*n_array

        m = MMatrix{16,16}(m_array)
        n = MMatrix{16,16}(n_array)
        @test m*n::MMatrix ≈ a_array

        # Bad dimensions
        m_array = randn(16, 16)
        n_array = randn(17, 17)
        m = MMatrix{16,16}(m_array)
        n = MMatrix{17,17}(n_array)
        @test_throws DimensionMismatch m*n
        m_array = randn(10, 10)
        n_array = randn(11, 11)
        m = MMatrix{10,10}(m_array)
        n = MMatrix{11,11}(n_array)
        @test_throws DimensionMismatch m*n
        m_array = randn(4, 4)
        n_array = randn(3, 3)
        m = MMatrix{4,4}(m_array)
        n = MMatrix{3,3}(n_array)
        @test_throws DimensionMismatch m*n
    end

    @testset "mul!" begin
        v = @SVector [2, 4]
        v2 = [2, 4]
        m = @SMatrix [1 2; 3 4]
        n = @SMatrix [2 3; 4 5]

        outvec = MVector{2,Int}(undef)
        mul!(outvec, m, v)
        @test outvec == @MVector [10,22]
        outvec2 = Vector{Int}(undef, 2)
        mul!(outvec2, m, v2)
        @test outvec2 == [10,22]

        # Bad dimensions
        outvec_bad = MVector{3,Int}(undef)
        @test_throws DimensionMismatch mul!(outvec_bad, m, v)

        a = MMatrix{2,2,Int,4}(undef)
        mul!(a, m, n)
        @test a::MMatrix{2,2,Int,4} == @MMatrix [10 13; 22 29]

        a = MMatrix{2,2,Int,4}(undef)
        mul!(a, m', n)
        @test a::MMatrix{2,2,Int,4} == @MMatrix [14 18; 20 26]
        mul!(a, m, n')
        @test a::MMatrix{2,2,Int,4} == @MMatrix [8 14; 18 32]
        mul!(a, m', n')
        @test a::MMatrix{2,2,Int,4} == @MMatrix [11 19; 16 28]
        mul!(a, transpose(m), n)
        @test a::MMatrix{2,2,Int,4} == @MMatrix [14 18; 20 26]
        mul!(a, m, transpose(n))
        @test a::MMatrix{2,2,Int,4} == @MMatrix [8 14; 18 32]
        mul!(a, transpose(m), transpose(n))
        @test a::MMatrix{2,2,Int,4} == @MMatrix [11 19; 16 28]
        for wrapper_m in mul_wrappers, wrapper_n in mul_wrappers
            mul!(a, wrapper_m(m), wrapper_n(n))
            @test a::MMatrix{2,2,Int,4} == wrapper_m(Array(m))*wrapper_n(Array(n))
        end

        a2 = MArray{Tuple{2,2},Int,2,4}(undef)
        mul!(a2, m, n)
        @test a2::MArray{Tuple{2,2},Int,2,4} == @MArray [10 13; 22 29]

        # Alternative builtin method used for n > 8
        m_array_2 = rand(1:10, 10, 10)
        n_array_2 = rand(1:10, 10, 10)
        a_array_2 = m_array_2*n_array_2

        m_2 = MMatrix{10,10}(m_array_2)
        n_2 = MMatrix{10,10}(n_array_2)
        a_2 = MMatrix{10,10,Int}(undef)
        mul!(a_2, m_2, n_2)
        @test a_2 == a_array_2

        # BLAS used for n > 14
        m_array_3 = randn(4, 4)
        n_array_3 = randn(4, 4)
        a_array_3 = m_array_3*n_array_3

        m_3 = MMatrix{4,4}(m_array_3)
        n_3 = MMatrix{4,4}(n_array_3)
        a_3 = MMatrix{4,4,Float64}(undef)
        mul!(a_3, m_3, n_3)
        @test a_3 ≈ a_array_3

        m_array_4 = randn(10, 10)
        n_array_4 = randn(10, 10)
        a_array_4 = m_array_4*n_array_4

        m_4 = MMatrix{10,10}(m_array_4)
        n_4 = MMatrix{10,10}(n_array_4)
        a_4 = MMatrix{10,10,Float64}(undef)
        mul!(a_4, m_4, n_4)
        @test a_4 ≈ a_array_4

        m_array_5 = rand(1:10, 16, 16)
        n_array_5 = rand(1:10, 16, 16)
        a_array_5 = m_array_5*n_array_5

        m_5 = MMatrix{16,16}(m_array_5)
        n_5 = MMatrix{16,16}(n_array_5)
        a_5 = MMatrix{16,16,Int}(undef)
        mul!(a_5, m_5, n_5)
        @test a_5 ≈ a_array_5

        m_array_6 = rand(1:10, 8, 10)
        n_array_6 = rand(1:10, 10, 8)
        a_array_6 = m_array_6*n_array_6

        m_6 = MMatrix{8,10}(m_array_6)
        n_6 = MMatrix{10,8}(n_array_6)
        a_6 = MMatrix{8,8,Int}(undef)
        mul!(a_6, m_6, n_6)
        @test a_6 == a_array_6

        # Float64
        vf = @SVector [2.0, 4.0]
        vf2 = [2.0, 4.0]
        mf = @SMatrix [1.0 2.0; 3.0 4.0]

        outvecf = MVector{2,Float64}(undef)
        mul!(outvecf, mf, vf)
        @test outvecf ≈ @MVector [10.0, 22.0]
        outvec2f = Vector{Float64}(undef, 2)
        mul!(outvec2f, mf, vf2)
        @test outvec2f ≈ [10.0, 22.0]

        @test mul!(@MArray([0.0]), Diagonal([1]), @MArray([2.0])) == @MArray([2.0])
    end
end

using StaticArrays, Test, LinearAlgebra

using LinearAlgebra: checksquare

# For one() test
struct RotMat2 <: StaticMatrix{2,2,Float64}
    elements::NTuple{4,Float64}
end
Base.getindex(m::RotMat2, i::Int) = getindex(m.elements, i)
# Rotation matrices must be unitary so `similar_type` has to return an SMatrix.
StaticArrays.similar_type(::Union{RotMat2,Type{RotMat2}}) = SMatrix{2,2,Float64,4}

Base.@kwdef mutable struct KPS4{S, T, P}
    v_apparent::T =       zeros(S, 3)
end

@testset "Linear algebra" begin

    @testset "SArray as a (mathematical) vector space" begin
        c = 2
        v1 = @SVector [2,4,6,8]
        v2 = @SVector [4,3,2,1]

        @test @inferred(v1 * c) === @SVector [4,8,12,16]
        @test @inferred(v1 / c) === @SVector [1.0,2.0,3.0,4.0]
        @test @inferred(c \ v1)::SVector === @SVector [1.0,2.0,3.0,4.0]

        @test @inferred(+v1) === @SVector [+2,+4,+6,+8]
        @test @inferred(-v1) === @SVector [-2,-4,-6,-8]

        @test @inferred(v1 + v2) === @SVector [6, 7, 8, 9]
        @test @inferred(v1 - v2) === @SVector [-2, 1, 4, 7]

        # #528 eltype with empty addition
        zm = zeros(SMatrix{3, 0, Float64})
        @test @inferred(zm + zm) === zm

        # TODO Decide what to do about this stuff:
        #v3 = [2,4,6,8]
        #v4 = [4,3,2,1]

        #@test @inferred(v1 + v4) === @SVector [6, 7, 8, 9]
        #@test @inferred(v3 + v2) === @SVector [6, 7, 8, 9]
        #@test @inferred(v1 - v4) === @SVector [-2, 1, 4, 7]
        #@test @inferred(v3 - v2) === @SVector [-2, 1, 4, 7]

        # #899 matrix-of-matrix
        A = SMatrix{1,1}([1])
        B = SMatrix{1,1}([A])
        @test @inferred(1.0 * B) === SMatrix{1, 1, SMatrix{1, 1, Float64, 1}, 1}(B)
        @test @inferred(1.0 \ B) === SMatrix{1, 1, SMatrix{1, 1, Float64, 1}, 1}(B)
        @test @inferred(B * 1.0) === SMatrix{1, 1, SMatrix{1, 1, Float64, 1}, 1}(B)
        @test @inferred(B / 1.0) === SMatrix{1, 1, SMatrix{1, 1, Float64, 1}, 1}(B)
    end

    @testset "Ternary operators" begin
        for T in (Int, Float32, Float64)
            c = convert(T, 2)
            v1 = @SVector T[2, 4, 6, 8]
            v2 = @SVector T[4, 3, 2, 1]
            m1 = @SMatrix T[2 4; 6 8]
            m2 = @SMatrix T[4 3; 2 1]

            # Use that these small integers can be represented exactly
            # as floating point numbers. In general, the comparison of
            # floats should use `≈` instead of `===`.
            @test @inferred(muladd(c, v1, v2)) === @SVector T[8, 11, 14, 17]
            @test @inferred(muladd(v1, c, v2)) === @SVector T[8, 11, 14, 17]
            @test @inferred(muladd(c, m1, m2)) === @SMatrix T[8 11; 14 17]
            @test @inferred(muladd(m1, c, m2)) === @SMatrix T[8 11; 14 17]
        end
    end

    @testset "@fastmath operators" begin
        for T in (Int, Float32, Float64)
            s0 = convert(T, 2)
            v1 = @SVector T[2, 4, 6, 8]
            v2 = @SVector T[4, 3, 2, 1]
            m1 = @SMatrix T[2 4; 6 8]
            m2 = @SMatrix T[4 3; 2 1]

            # Use that these small integers can be represented exactly
            # as floating point numbers. In general, the comparison of
            # floats should use `≈` instead of `===`.
            # These should be turned into `vfmadd...` calls
            @test @fastmath(@inferred(s0 * v1 + v2)) === @SVector T[8, 11, 14, 17]
            @test @fastmath(@inferred(v1 * s0 + v2)) === @SVector T[8, 11, 14, 17]
            @test @fastmath(@inferred(s0 * m1 + m2)) === @SMatrix T[8 11; 14 17]
            @test @fastmath(@inferred(m1 * s0 + m2)) === @SMatrix T[8 11; 14 17]

            # These should be turned into `vfmsub...` calls
            @test @fastmath(@inferred(s0 * v1 - v2)) === @SVector T[0, 5, 10, 15]
            @test @fastmath(@inferred(v1 * s0 - v2)) === @SVector T[0, 5, 10, 15]
            @test @fastmath(@inferred(s0 * m1 - m2)) === @SMatrix T[0 5; 10 15]
            @test @fastmath(@inferred(m1 * s0 - m2)) === @SMatrix T[0 5; 10 15]
        end
    end

    @testset "Interaction with `UniformScaling`" begin
        @test @inferred(@SMatrix([0 1; 2 3]) + I) === @SMatrix [1 1; 2 4]
        @test @inferred(I + @SMatrix([0 1; 2 3])) === @SMatrix [1 1; 2 4]
        @test @inferred(@SMatrix([0 1; 2 3]) - I) === @SMatrix [-1 1; 2 2]
        @test @inferred(I - @SMatrix([0 1; 2 3])) === @SMatrix [1 -1; -2 -2]
        @test_throws DimensionMismatch I + @SMatrix [0 1 4; 2 3 5]

        @test @inferred(@SMatrix([0 1; 2 3]) * I) === @SMatrix [0 1; 2 3]
        @test @inferred(I * @SMatrix([0 1; 2 3])) === @SMatrix [0 1; 2 3]
        @test @inferred(@SMatrix([0 1; 2 3]) / I) === @SMatrix [0.0 1.0; 2.0 3.0]
        @test @inferred(I \ @SMatrix([0 1; 2 3])) === @SMatrix [0.0 1.0; 2.0 3.0]

        A = @SMatrix [1.0 2.0 3.0; 4.0 5.0 6.0; 7.0 8.0 9.0]
        A_dynamic = Matrix(A)

        for WR in (Symmetric, Hermitian)
            B = WR(A, :L)
            B_dynamic = WR(A_dynamic, :L)

            @test @inferred(B + I) isa WR{Float64,SMatrix{3,3,Float64,9}}
            @test @inferred(I + B) isa WR{Float64,SMatrix{3,3,Float64,9}}
            @test @inferred(B - I) isa WR{Float64,SMatrix{3,3,Float64,9}}
            @test @inferred(I - B) isa WR{Float64,SMatrix{3,3,Float64,9}}
            @test (B + I).uplo == 'L'
            @test (I - B).uplo == 'L'

            @test B + I == B_dynamic + I
            @test I + B == I + B_dynamic
            @test B - I == B_dynamic - I
            @test I - B == I - B_dynamic
        end

        B = Hermitian(complex.(A), :U)
        B_dynamic = Hermitian(complex.(A_dynamic), :U)

        # Hermitian wrapper should be dropped iff the UniformScaling is complex, in-line with Base behavior
        @test @inferred(B + I) isa Hermitian{ComplexF64,SMatrix{3,3,ComplexF64,9}}
        @test @inferred(I - B) isa Hermitian{ComplexF64,SMatrix{3,3,ComplexF64,9}}
        @test @inferred(B + (1 + 2im)I) isa SMatrix{3,3,ComplexF64,9}
        @test @inferred((1 + 2im)I - B) isa SMatrix{3,3,ComplexF64,9}
        @test B + (1 + 2im)I == B_dynamic + (1 + 2im)I
        @test (1 + 2im)I - B == (1 + 2im)I - B_dynamic

        for (WR1, WR2) in ((UpperTriangular, UpperTriangular),
            (LowerTriangular, LowerTriangular),
            (UnitUpperTriangular, UpperTriangular),
            (UnitLowerTriangular, LowerTriangular))
            B = WR1(A)
            B_dynamic = WR1(A_dynamic)

            @test @inferred(B + I) isa WR2{Float64,SMatrix{3,3,Float64,9}}
            @test @inferred(I + B) isa WR2{Float64,SMatrix{3,3,Float64,9}}
            @test @inferred(B - I) isa WR2{Float64,SMatrix{3,3,Float64,9}}
            @test @inferred(I - B) isa WR2{Float64,SMatrix{3,3,Float64,9}}

            @test B + I == B_dynamic + I
            @test I + B == I + B_dynamic
            @test B - I == B_dynamic - I
            @test I - B == I - B_dynamic
        end
    end

    @testset "Constructors from UniformScaling" begin
        I3x3 = Matrix(I, 3, 3)
        I3x2 = Matrix(I, 3, 2)
        # SArray
        ## eltype from I
        @test @inferred(SArray{Tuple{3,3}}(I))::SMatrix{3,3,Bool,9} == I3x3
        @test @inferred(SArray{Tuple{3,3}}(2.0I))::SMatrix{3,3,Float64,9} == 2I3x3
        ## eltype from constructor
        @test @inferred(SArray{Tuple{3,3},Float64}(I))::SMatrix{3,3,Float64,9} == I3x3
        @test @inferred(SArray{Tuple{3,3},Float32}(2.0I))::SMatrix{3,3,Float32,9} == 2I3x3
        ## non-square
        @test @inferred(SArray{Tuple{3,2}}(I))::SMatrix{3,2,Bool,6} == I3x2
        # SMatrix
        @test @inferred(SMatrix{3,3}(I))::SMatrix{3,3,Bool,9} == I3x3
        @test @inferred(SMatrix{3,3}(2.0I))::SMatrix{3,3,Float64,9} == 2I3x3
        # MArray
        ## eltype from I
        @test @inferred(MArray{Tuple{3,3}}(I))::MMatrix{3,3,Bool,9} == I3x3
        @test @inferred(MArray{Tuple{3,3}}(2.0I))::MMatrix{3,3,Float64,9} == 2I3x3
        ## eltype from constructor
        @test @inferred(MArray{Tuple{3,3},Float64}(I))::MMatrix{3,3,Float64,9} == I3x3
        @test @inferred(MArray{Tuple{3,3},Float32}(2.0I))::MMatrix{3,3,Float32,9} == 2I3x3
        ## non-square
        @test @inferred(MArray{Tuple{3,2}}(I))::MMatrix{3,2,Bool,6} == I3x2
        # MMatrix
        @test @inferred(MMatrix{3,3}(I))::MMatrix{3,3,Bool,9} == I3x3
        @test @inferred(MMatrix{3,3}(2.0I))::MMatrix{3,3,Float64,9} == 2I3x3
        # SDiagonal
        @test @inferred(SDiagonal{3}(I))::SDiagonal{3,Bool} == I3x3
        @test @inferred(SDiagonal{3}(2.0I))::SDiagonal{3,Float64} == 2I3x3
        @test @inferred(SDiagonal{3,Float64}(I))::SDiagonal{3,Float64} == I3x3
        @test @inferred(SDiagonal{3,Float32}(2.0I))::SDiagonal{3,Float32} == 2I3x3
    end

    @testset "diagm()" begin
        @test diagm() isa BitArray # issue #961: type piracy of zero-arg diagm
        @test @inferred(diagm(SA[1,2])) === SA[1 0; 0 2]
        @test @inferred(diagm(Val(0) => SVector(1,2))) === @SMatrix [1 0; 0 2]
        @test @inferred(diagm(Val(2) => SVector(1,2,3)))::SMatrix == diagm(2 => [1,2,3])
        @test @inferred(diagm(Val(-2) => SVector(1,2,3)))::SMatrix == diagm(-2 => [1,2,3])
        @test @inferred(diagm(Val(-2) => SVector(1,2,3), Val(1) => SVector(4,5)))::SMatrix ==
            diagm(-2 => [1,2,3], 1 => [4,5])
        # numeric promotion
        @test @inferred(diagm(Val(0) => SA[1,2,3], Val(1) => SA[4.0im,5.0im]))::SMatrix{3,3,ComplexF64} ==
            diagm(0 => [1.0,2.0,3.0], 1 => [4.0im,5.0im])
        # diagm respects input type
        @test @inferred(diagm(MArray(SA[1,2])))::MArray == SA[1 0; 0 2]
    end

    @testset "diag()" begin
        @test @inferred(diag(@SMatrix([0 1; 2 3]))) === SVector(0, 3)
        @test @inferred(diag(@SMatrix([0 1 2; 3 4 5]), Val{1})) === SVector(1, 5)
        @test @inferred(diag(@SMatrix([0 1; 2 3; 4 5]), Val{-1})) === SVector(2, 5)
    end

    @testset "one() and zero()" begin
        @test @inferred(one(SMatrix{2,2,Int})) === @SMatrix [1 0; 0 1]
        @test @inferred(one(SMatrix{2,2})) === @SMatrix [1.0 0.0; 0.0 1.0]
        @test @inferred(one(SMatrix{2})) === @SMatrix [1.0 0.0; 0.0 1.0]
        @test @inferred(one(one(SMatrix{2,2,Int}))) === @SMatrix [1 0; 0 1]
        @test @inferred(zero(SMatrix{2,2,Int})) === @SMatrix [0 0; 0 0]
        @test @inferred(zero(one(SMatrix{2,2,Int}))) === @SMatrix [0 0; 0 0]

        @test @inferred(one(MMatrix{2,2,Int}))::MMatrix == @MMatrix [1 0; 0 1]
        @test @inferred(one(MMatrix{2,2}))::MMatrix == @MMatrix [1.0 0.0; 0.0 1.0]
        @test @inferred(one(MMatrix{2}))::MMatrix == @MMatrix [1.0 0.0; 0.0 1.0]

        @test_throws DimensionMismatch one(MMatrix{2,4})

        @test one(RotMat2) isa RotMat2
        @test one(RotMat2) == SA[1 0; 0 1]
        # TODO: See comment in _one.
        @test_broken one(RotMat2) isa SMatrix{2,2,Float64}

        # zero preserves wrapper types over StaticArrays
        let S = SMatrix{2,2}(1.0, 0.5, 0.5, 2.0), v = SVector(1.0, 2.0)
            for WR in (Symmetric, Hermitian, UpperTriangular, LowerTriangular,
                       UnitUpperTriangular, UnitLowerTriangular, Transpose, Adjoint)
                @test @inferred(zero(WR(S))) === WR(zero(S))
            end
            @test @inferred(zero(Diagonal(v))) === Diagonal(zero(v))
        end
    end

    @testset "cross()" begin
        @test @inferred(cross(SVector(1,2,3), SVector(4,5,6))) === SVector(-3, 6, -3)
        @test @inferred(cross(SVector(1,2), SVector(4,5))) === -3
        @test @inferred(cross(SVector(UInt(1),UInt(2)), SVector(UInt(4),UInt(5)))) === -3
        @test @inferred(cross(SVector(UInt(1),UInt(2),UInt(3)), SVector(UInt(4),UInt(5),UInt(6)))) === SVector(-3, 6, -3)
    end

    @testset "inner products" begin
        v1 = @SVector [2,4,6,8]
        v2 = @SVector [4,3,2,1]

        @test @inferred(dot(v1, v2)) === 40
        @test @inferred(dot(v1, -v2)) === -40
        @test @inferred(dot(v1*im, v2*im)) === 40*im*conj(im)
        @test @inferred(StaticArrays.bilinear_vecdot(v1*im, v2*im)) === 40*im*im
        # inner product, whether via `dot` or written out as `x'*y`, should be recursive like Base:
        @test @inferred(dot(@SVector[[1,2],[3,4]], @SVector[[1,2],[3,4]])) === 30
        @test @inferred(@SVector[[1,2],[3,4]]' * @SVector[[1,2],[3,4]]) === 30

        m1 = reshape(v1, Size(2,2))
        m2 = reshape(v2, Size(2,2))
        @test @inferred(dot(m1, m2)) === dot(v1, v2)
    end

    @testset "transpose() and conj()" begin
        @test @inferred(conj(SVector(1+im, 2+im))) === SVector(1-im, 2-im)

        @test @inferred(transpose(@SVector([1, 2, 3]))) === Transpose(@SVector([1, 2, 3]))
        @test @inferred(adjoint(@SVector([1, 2, 3]))) === Adjoint(@SVector([1, 2, 3]))
        @test @inferred(transpose(@SMatrix([1 2; 0 3]))) === @SMatrix([1 0; 2 3])
        @test @inferred(transpose(@SMatrix([1 2 3; 4 5 6]))) === @SMatrix([1 4; 2 5; 3 6])

        @test @inferred(adjoint(@SMatrix([1 2; 0 3]))) === @SMatrix([1 0; 2 3])
        @test @inferred(adjoint(@SMatrix([1 2 3; 4 5 6]))) === @SMatrix([1 4; 2 5; 3 6])
        @test @inferred(adjoint(@SMatrix([1 2*im 3; 4 5 6]))) === @SMatrix([1 4; -2*im 5; 3 6])

        m = [1 2; 3 4] + im*[5 6; 7 8]
        @test @inferred(adjoint(@SVector [m,m])) == adjoint([m,m])
        @test @inferred(transpose(@SVector [m,m])) == transpose([m,m])
        @test @inferred(adjoint(@SMatrix [m m; m m])) == adjoint([[m] [m]; [m] [m]])
        @test @inferred(transpose(@SMatrix [m m; m m])) == transpose([[m] [m]; [m] [m]])

        # Recursive adjoint/transpose correctly handles eltype (#708)
        @test (@inferred(adjoint(SMatrix{2,2}(fill([1,2], 2,2)))))::SMatrix == SMatrix{2,2}(fill(adjoint([1,2]), 2,2))
        @test (@inferred(transpose(SMatrix{2,2}(fill([1,2], 2,2)))))::SMatrix == SMatrix{2,2}(fill(transpose([1,2]), 2,2))

        # 0×0 matrix
        for T in (SMatrix{0,0,Float64}, MMatrix{0,0,Float64}, SizedMatrix{0,0,Float64})
            m = T()
            @test adjoint(m)::T == transpose(m)::T == m
        end
        @test adjoint(SMatrix{0,0,Vector{Int}}()) isa SMatrix{0,0,Adjoint{Int,Vector{Int}}}
        @test transpose(SMatrix{0,0,Vector{Int}}()) isa SMatrix{0,0,Transpose{Int,Vector{Int}}}

        @testset "inference for nested matrices" begin
            A = reshape([reshape([complex(i,2i)*j for i in 1:2], 1, 2) for j in 1:6], 3, 2)
            for TA in (SMatrix, MMatrix), TB in (SMatrix, MMatrix)
                S = TA{3,2}(TB{1,2}.(A)) # static matrix of static matrices
                @test @inferred(transpose(S)) == transpose(A)
                @test @inferred(adjoint(S)) == adjoint(A)
            end
        end
    end

    @testset "normalization" begin
        @test norm(SVector(0.0,1e-180)) == 1e-180  # avoid underflow
        @test norm(SVector(0.0,1e155)) == 1e155  # avoid overflow
        @test all([norm(SVector(0.0,1e-180), p) == 1e-180 for p = [2,3,Inf]])  # avoid underflow
        @test all([norm(SVector(0.0,1e155), p) == 1e155 for p = [2,3,Inf]])  # avoid overflow
        @test norm(SVector(1.0,2.0,2.0)) ≈ 3.0
        @test norm(SVector(1.0,2.0,2.0),2) ≈ 3.0
        @test norm(SVector(1.0,2.0,2.0),Inf) ≈ 2.0
        @test norm(SVector(1.0,2.0,2.0),1) ≈ 5.0
        @test norm(SVector(1.0,2.0,0.0),0) ≈ 2.0

        @test norm(SVector(1.0,2.0)) ≈ norm([1.0,2.0])
        @test norm(@SMatrix [1 2; 3 4.0+im]) ≈ norm([1 2; 3 4.0+im])
        sm = @SMatrix [1 2; 3 4.0+im]
        @test norm(sm, 3.) ≈ norm([1 2; 3 4.0+im], 3.)
        @test LinearAlgebra.norm_sqr(SVector(1.0,2.0)) ≈ norm([1.0,2.0])^2

        @test normalize(SVector(1,2,3)) ≈ normalize([1,2,3])
        @test normalize(SVector(1,2,3), 1) ≈ normalize([1,2,3], 1)
        @test normalize!(MVector(1.,2.,3.)) ≈ normalize([1.,2.,3.])
        @test normalize!(MVector(1.,2.,3.), 1) ≈ normalize([1.,2.,3.], 1)

        @test normalize(SA[1 2 3; 4 5 6; 7 8 9]) ≈ normalize([1 2 3; 4 5 6; 7 8 9])
        @test normalize(SA[1 2 3; 4 5 6; 7 8 9], 1) ≈ normalize([1 2 3; 4 5 6; 7 8 9], 1)
        @test normalize!((@MMatrix [1. 2. 3.; 4. 5. 6.; 7. 8. 9.])) ≈ normalize!([1. 2. 3.; 4. 5. 6.; 7. 8. 9.])
        @test normalize!((@MMatrix [1. 2. 3.; 4. 5. 6.; 7. 8. 9.]), 1) ≈ normalize!([1. 2. 3.; 4. 5. 6.; 7. 8. 9.], 1)

        D3 = Array{Float64, 3}(undef, 2, 2, 3)
        D3[:] .= 1.0:12.0
        SA_D3 = convert(SArray{Tuple{2,2,3}, Float64, 3, 12}, D3)
        @test normalize(SA_D3) ≈ normalize(D3)

        # nested vectors
        a  = SA[SA[1, 2], SA[3, 4]]
        av = convert(Vector{Vector{Int}}, a)
        aa = SA[a,a]
        @test norm(a) ≈ norm(av)
        @test norm(aa) ≈ norm([a,a])
        @test norm(aa) ≈ norm([av,av])
        @test norm(SVector{0,Int}()) === norm(Vector{Float64}()) === 0.0

        # do not overflow for Int
        c = SA[typemax(Int)÷2, typemax(Int)÷3]
        @test norm(c) ≈ norm(Vector(c))
        @test norm(SA[c,c]) ≈ norm([Vector(c), Vector(c)])

        # 0-norm of vectors w/ zero-vectors
        @test norm(SA[0,0], 0) == norm([0,0], 0)
        @test norm(SA[[0,0],[1,1]], 0) == norm([[0,0],[1,1]], 0) == 1.0
        @test norm(SA[[0,1],[1,1]], 0) == norm([[0,1],[1,1]], 0) == 2.0

        # complex numbers
        @test norm(SA[1+im, 2+3im]) ≈ norm([1+im, 2+3im])
        @test norm(SA[22.0+0.1im, 2.0-23.0im]) ≈ norm([22.0+0.1im, 2.0-23.0im])
        a_c, av_c = a+1im*a, av+1im*av
        @test norm(a_c) ≈ norm(av_c)

        # p-norms for nested vectors
        for (x,xv) in ((a,av), (a_c, av_c))
            @test norm(x, 2) ≈ norm(xv,2)
            @test norm(x, Inf) ≈ norm(xv, Inf)
            @test norm(x, 1) ≈ norm(xv, 1)
            @test norm(x, 0) ≈ norm(xv, 0)
            @test norm(SA[Int[], [1,2]], 0) ≈ norm([Int[], [1,2]], 0)
        end

        # type-stability
        @test (@inferred norm(a[1])) == (@inferred norm(a[1], 2))
        @test (@inferred norm(a)) == (@inferred norm(a, 2))
        @test (@inferred norm(aa)) == (@inferred norm(aa, 2))
        @test (@inferred norm(float.(aa))) == (@inferred norm(float.(aa), 2))
        @test (@inferred norm(SVector{0,Int}())) == (@inferred norm(SVector{0,Int}(), 2))

        # norm of empty SVector
        @test norm(SVector{0,Int}()) isa float(Int)
        @test norm(SVector{0,Float64}()) isa Float64
        @test norm(SA[SVector{0,Int}(),SVector{0,Int}()]) isa float(Int)
        @test norm(SA[SVector{0,Int}(),SVector{0,Int}()]) == norm([Int[], Int[]])

        # norm of SVector with NaN and/or Inf elements -- issue #1135
        @test isnan(norm(SA[0.0, NaN]))
        @test isnan(norm(SA[NaN, 0.0]))
        @test norm(SA[0.0, Inf]) == Inf
        @test norm(SA[Inf, 0.0]) == Inf
        @test norm(SA[0.0, -Inf]) == Inf
        @test norm(SA[-Inf, 0.0]) == Inf
        @test norm(SA[Inf, Inf]) == Inf
        @test norm(SA[-Inf, -Inf]) == Inf
        @test norm(SA[Inf, -Inf]) == Inf
        @test norm(SA[-Inf, Inf]) == Inf
        @test isnan(norm(SA[Inf, NaN]))
        @test isnan(norm(SA[NaN, Inf]))
        @test isnan(norm(SA[-Inf, NaN]))
        @test isnan(norm(SA[NaN, -Inf]))
        @test isapprox(SA[0.0, NaN], SA[0.0, NaN], nans=true)

        # no allocation for MArray -- issue #1126

        @inline function calc_particle_forces!(s, pos1, pos2)
            segment = pos1 - pos2
            norm1 = norm(segment)
            unit_vector = segment / norm1
        
            v_app_perp = s.v_apparent - s.v_apparent ⋅ unit_vector * unit_vector
            half_drag_force = norm(v_app_perp)
            nothing
        end
        kps4 = KPS4{Float64, MVector{3, Float64}, 6+4+1}()
        
        pos1 = MVector{3, Float64}(1.0, 2.0, 3.0)
        pos2 = MVector{3, Float64}(2.0, 3.0, 4.0)
        calc_particle_forces!(kps4, pos1, pos2)
        calc_particle_forces!(kps4, pos1, pos2)
        @test (@allocated calc_particle_forces!(kps4, pos1, pos2)) == 0
    end

    @testset "trace" begin
        @test tr(@SMatrix [1.0 2.0; 3.0 4.0]) === 5.0
        @test_throws DimensionMismatch tr(@SMatrix ones(5,4))
    end

    @testset "size zero" begin
        @test dot(SVector{0, Float64}(()), SVector{0, Float64}(())) === 0.
        @test StaticArrays.bilinear_vecdot(SVector{0, Float64}(()), SVector{0, Float64}(())) === 0.
        @test norm(SVector{0, Float64}(())) === 0.
        @test norm(SVector{0, Float64}(()), 1) === 0.
        @test tr(SMatrix{0,0,Float64}(())) === 0.
    end

    @testset "kron" begin
        @test @inferred(kron(@SMatrix([1 2; 3 4]), @SMatrix([0 1 0; 1 0 1]))) ==
            SMatrix{4,6,Int}([0 1 0 0 2 0;
                              1 0 1 2 0 2;
                              0 3 0 0 4 0;
                              3 0 3 4 0 4])
        @test @inferred(kron(@SMatrix([1 2; 3 4]), @SMatrix([2.0]))) === @SMatrix [2.0 4.0; 6.0 8.0]

        # Output should be heap allocated into a SizedArray when it gets large
        # enough.
        M1 = collect(1:20)
        M2 = collect(20:-1:1)'
        @test @inferred(kron(SMatrix{20,1}(M1),SMatrix{1,20}(M2)))::SizedMatrix{20,20} == kron(M1,M2)

        test_kron = function (a, b, A, p, q, P)
            @test @inferred(kron(a,b)) ===  SVector{9}(kron(p,q))
            @test @inferred(kron(b,a)) ===  SVector{9}(kron(q,p))
            @test @inferred(kron(a',b')) ===  SMatrix{1,9}(kron(p',q'))
            @test @inferred(kron(b',a')) ===  SMatrix{9,1}(kron(q',p'))'
            @test @inferred(kron(b',a)) ===  SMatrix{3,3}(kron(q',p))
            @test @inferred(kron(b,a')) ===  SMatrix{3,3}(kron(q,p'))
            @test @inferred(kron(b,A)) ===  SMatrix{6,2}(kron(q,P))
            @test @inferred(kron(b',A)) ===  SMatrix{2,6}(kron(q',P))
            @test @inferred(kron(A,b)) ===  SMatrix{6,2}(kron(P,q))
            @test @inferred(kron(A,b')) ===  SMatrix{2,6}(kron(P,q'))

            @test @inferred(kron(transpose(a),transpose(b))) ===  SMatrix{1,9}(kron(transpose(p),transpose(q)))
            @test @inferred(kron(transpose(b),transpose(a))) ===  SMatrix{9,1}(kron(transpose(q),transpose(p)))'
            @test @inferred(kron(transpose(b),a)) ===  SMatrix{3,3}(kron(transpose(q),p))
            @test @inferred(kron(b,transpose(a))) ===  SMatrix{3,3}(kron(q,transpose(p)))
            @test @inferred(kron(transpose(b),A)) ===  SMatrix{2,6}(kron(transpose(q),P))
            @test @inferred(kron(A,transpose(b))) ===  SMatrix{2,6}(kron(P,transpose(q)))
        end

        # Tests for kron of two SVectors as well as between SVectors and SMatrices.
        a = @SVector [1, 2, 3]
        b = @SVector [4, 5, 6]
        A = @SMatrix [1 2; 3 4]

        p = [1,2,3]
        q = [4,5,6]
        P = [1 2; 3 4]

        test_kron(a, b, A, p, q, P)


        # Tests for kron of two SVectors as well as between SVectors and
        # SMatrices and verifies type promotion (e.g. Int to Float).
        a = @SVector [1, 2, 3]
        b = @SVector [4.5, 5.5, 6.5]
        A = @SMatrix [1 2; 3 4]

        p = [1,2,3]
        q = [4.5, 5.5, 6.5]
        P = [1 2; 3 4]

        test_kron(a, b, A, p, q, P)

        # Output should be heap allocated into a SizedArray when it gets large
        # enough.
        p = collect(1:10)
        q = collect(1:21)
        P = randn(10,10)
        a = SVector{10}(p)
        b = SVector{21}(q)
        A = SMatrix{10,10}(P)

        @test @inferred(kron(a,b))::SizedVector{210} == kron(p,q)
        @test @inferred(kron(b,a))::SizedVector{210} == kron(q,p)
        @test @inferred(kron(b,a'))::SizedMatrix{21,10} == kron(q,p')
        @test @inferred(kron(b',a))::SizedMatrix{10,21} == kron(q',p)
        @test @inferred(kron(a',b'))::SizedMatrix{1,210} == kron(p',q')
        @test @inferred(kron(b',a'))::SizedMatrix{1,210} == kron(q',p')
        @test @inferred(kron(b',A))::SizedMatrix{10,210} == kron(q',P)
        @test @inferred(kron(A,b'))::SizedMatrix{10,210} == kron(P,q')
        @test @inferred(kron(b,A))::SizedMatrix{210,10} == kron(q,P)
        @test @inferred(kron(A,b))::SizedMatrix{210,10} == kron(P,q)

        @test @inferred(kron(b,transpose(a)))::SizedMatrix{21,10} == kron(q,transpose(p))
        @test @inferred(kron(transpose(b),a))::SizedMatrix{10,21} == kron(transpose(q),p)
        @test @inferred(kron(transpose(a),transpose(b)))::SizedMatrix{1,210} == kron(transpose(p),transpose(q))
        @test @inferred(kron(transpose(b),transpose(a)))::SizedMatrix{1,210} == kron(transpose(q),transpose(p))
        @test @inferred(kron(transpose(b),A))::SizedMatrix{10,210} == kron(transpose(q),P)
        @test @inferred(kron(A,transpose(b)))::SizedMatrix{10,210} == kron(P,transpose(q))

    end

    @testset "checksquare" begin
        m22 = SA[1 2; 3 4]
        @test @inferred(checksquare(m22)) === 2
        @test_inlined checksquare(m22)
        m23 = SA[1 2 3; 4 5 6]
        @test_inlined checksquare(m23) false
    end

    @testset "triu/tril" begin
        for S in (SMatrix{7,5}(1:35), MMatrix{4,6}(1:24), SizedArray{Tuple{2,2}}([1 2; 3 4]))
            M = Matrix(S)
            for k in -10:10
                @test triu(S, k) == triu(M, k)
                @test tril(S, k) == tril(M, k)
            end
        end
    end
end

@inline function SizedArray{S,T,N,M}(a::AbstractArray) where {S<:Tuple,T,N,M}
    if eltype(a) == T && (M == 1 || M == ndims(a))
        a′ = M == 1 ? vec(a) : a
        return SizedArray{S,T,N,M,typeof(a′)}(a′)
    end
    return convert(SizedArray{S,T,N,M}, a)
end

@inline function SizedArray{S,T,N}(a::AbstractArray) where {S<:Tuple,T,N}
    M = ndims(a) == N ? N : 1
    return SizedArray{S,T,N,M}(a)
end

@inline (::Type{SZA})(a::AbstractArray) where {SZA<:SizedArray} = construct_type(SZA, a)(a)

# disambiguation
@inline SizedArray{S,T,N,M}(a::StaticArray) where {S<:Tuple,T,N,M} = construct_type(SizedArray{S,T,N,M}, a)(a.data)
@inline SizedArray{S,T,N}(a::StaticArray) where {S<:Tuple,T,N} = construct_type(SizedArray{S,T,N}, a)(a.data)
@inline (::Type{SZA})(a::StaticArray) where {SZA<:SizedArray} = construct_type(SZA, a)(a.data)
# TODO: Should we respect `TData`?
SizedArray{S,T,N,M,TData}(a::TData) where {S<:Tuple,T,N,M,TData<:StaticArray{<:Tuple,T,M}} = SizedArray{S,T,N,M}(a.data)

function SizedArray{S,T,N,N}(::UndefInitializer) where {S<:Tuple,T,N}
    return SizedArray{S,T,N,N,Array{T,N}}(undef)
end
function SizedArray{S,T,N,1}(::UndefInitializer) where {S<:Tuple,T,N}
    return SizedArray{S,T,N,1,Vector{T}}(undef)
end
@inline function SizedArray{S,T,N}(::UndefInitializer) where {S<:Tuple,T,N}
    return SizedArray{S,T,N,N}(undef)
end
@inline function SizedArray{S,T}(::UndefInitializer) where {S<:Tuple,T}
    return SizedArray{S,T,tuple_length(S)}(undef)
end
@generated function (::Type{SizedArray{S,T,N,M,TData}})(x::NTuple{L,Any}) where {S<:Tuple,T,N,M,TData<:AbstractArray{T,M},L}
    if L != tuple_prod(S)
        error("Dimension mismatch")
    end
    exprs = [:(a[$i] = x[$i]) for i = 1:L]
    return quote
        $(Expr(:meta, :inline))
        a = SizedArray{S,T,N,M}(undef)
        @inbounds $(Expr(:block, exprs...))
        return a
    end
end
@inline function SizedArray{S,T,N,M}(x::Tuple) where {S<:Tuple,T,N,M}
    return SizedArray{S,T,N,M,Array{T,M}}(x)
end
@inline function SizedArray{S,T,N}(x::Tuple) where {S<:Tuple,T,N}
    return SizedArray{S,T,N,N,Array{T,N}}(x)
end

# Override some problematic default behaviour
@inline convert(::Type{SA}, sa::SizedArray) where {SA<:SizedArray} = SA(sa.data)
@inline convert(::Type{SA}, sa::SA) where {SA<:SizedArray} = sa

# Back to Array (unfortunately need both convert and construct to override other methods)
@inline function Base.Array(sa::SizedArray{S}) where {S}
    return Array(reshape(sa.data, size_to_tuple(S)))
end
@inline function Base.Array{T}(sa::SizedArray{S,T}) where {T,S}
    return Array(reshape(sa.data, size_to_tuple(S)))
end
@inline function Base.Array{T,N}(sa::SizedArray{S,T,N}) where {T,S,N}
    return Array(reshape(sa.data, size_to_tuple(S)))
end

@inline function convert(::Type{Array}, sa::SizedArray{S}) where {S}
    return Array(reshape(sa.data, size_to_tuple(S)))
end
@inline function convert(::Type{Array}, sa::SizedArray{S,T,N,M,Array{T,M}}) where {S,T,N,M}
    return sa.data
end
@inline function convert(::Type{Array{T}}, sa::SizedArray{S,T}) where {T,S}
    return Array(reshape(sa.data, size_to_tuple(S)))
end
@inline function convert(::Type{Array{T}}, sa::SizedArray{S,T,N,M,Array{T,M}}) where {S,T,N,M}
    return sa.data
end
@inline function convert(
    ::Type{Array{T,N}},
    sa::SizedArray{S,T,N},
) where {T,S,N}
    return Array(reshape(sa.data, size_to_tuple(S)))
end
@inline function convert(::Type{Array{T,N}}, sa::SizedArray{S,T,N,N,Array{T,N}}) where {S,T,N}
    return sa.data
end

@propagate_inbounds getindex(a::SizedArray, i::Int) = getindex(a.data, i)
@propagate_inbounds setindex!(a::SizedArray, v, i::Int) = (setindex!(a.data, v, i); a)

Base.parent(sa::SizedArray) = sa.data

Base.cconvert(P::Type{Ptr{T}}, sa::SizedArray) where {T} = Base.cconvert(P, sa.data)
if VERSION < v"1.11-"
    Base.unsafe_convert(::Type{Ptr{T}}, sa::SizedArray) where {T} = Base.unsafe_convert(Ptr{T}, sa.data)
end
Base.elsize(::Type{SizedArray{S,T,M,N,A}}) where {S,T,M,N,A} = Base.elsize(A)

Base.dataids(sa::SizedArray) = Base.dataids(sa.data)

function promote_rule(
    ::Type{SizedArray{S,T,N,M,TDataA}},
    ::Type{SizedArray{S,U,N,M,TDataB}},
) where {S,T,U,N,M,TDataA,TDataB}
    TU = promote_type(T, U)
    return SizedArray{S, TU, N, M, promote_type(TDataA, TDataB)}
end

function promote_rule(
    ::Type{SizedArray{S,T,N,M}},
    ::Type{SizedArray{S,U,N,M}},
) where {S,T,U,N,M,}
    TU = promote_type(T, U)
    return SizedArray{S, TU, N, M}
end

function promote_rule(
    ::Type{SizedArray{S,T,N}},
    ::Type{SizedArray{S,U,N}},
) where {S,T,U,N}
    TU = promote_type(T, U)
    return SizedArray{S, TU, N}
end


### Code that makes views of statically sized arrays also statically sized (where possible)

# Note, _get_static_vector_length is used in a generated function so it's strictly internal and can't be extended
_get_static_vector_length(::Type{<:StaticVector{N}}) where {N} = N

@generated function new_out_size(::Type{Size}, inds...) where Size
    os = []
    map(Size.parameters, inds) do s, i
        if i <: Integer
            # dimension is fixed
        elseif i <: StaticVector
            push!(os, _get_static_vector_length(i))
        elseif i == Colon || i <: Base.Slice
            push!(os, s)
        elseif i <: SOneTo
            push!(os, i.parameters[1])
        else
            error("Unknown index type: $i")
        end
    end
    return Tuple{os...}
end

@generated function new_out_size(::Type{Size}, ::Colon) where Size
    prod_size = tuple_prod(Size)
    return Tuple{prod_size}
end

function Base.view(
    a::SizedArray{S},
    indices::Union{Integer, Colon, StaticVector, Base.Slice, SOneTo}...,
) where {S}
    view_of_wrapped = view(a.data, indices...)
    if _indices_have_bools(indices)
        return view_of_wrapped
    else
        new_size = new_out_size(S, indices...)
        return SizedArray{new_size}(view_of_wrapped)
    end
end

function Base.vec(a::SizedArray{S}) where {S}
    return SizedVector{tuple_prod(S)}(vec(a.data))
end

# Special case flatten of iterators of static arrays.
import Base.Iterators: flatten_iteratorsize, flatten_length
flatten_iteratorsize(::Union{Base.HasShape, Base.HasLength}, ::Type{<:StaticArray{S}}) where {S} = Base.HasLength()
function flatten_length(f, T::Type{<:StaticArray{S}}) where {S}
    length(T)*length(f.it)
end

@testset "Core definitions and constructors" begin
    @testset "Inner Constructors" begin
        # SVector
        @test SVector{1,Int}((1,)).data === (1,)
        @test SVector{1,Float64}((1,)).data === (1.0,)
        @test_throws Exception SVector{1,Int}()

        @test SMatrix{1,1,Int}((1,)).data === (1,)
        @test SMatrix{1,1,Float64}((1,)).data === (1.0,)
        @test_throws Exception SMatrix{1,Int}()

        #@test MArray{(1,),Int,1,Tuple{Int}}((1,)).data === (1,)
        #@test MArray{(1,),Float64,1,Tuple{Float64}}((1,)).data === (1.0,)

        # default constructors
        #@test try; MArray{(1,),Int,1,Tuple{Int}}(); true; catch; false; end
    end

    @testset "Type parameter errors" begin
        # (not sure what type of exception these should be?)
        @test_throws Exception SVector{1.0,Int}((1,))
        @test_throws DimensionMismatch("No precise constructor for $(SVector{2, Int}) found. Length of input was 1.") SVector{2,Int}((1,))
        @test_throws Exception SVector{1,3}((1,))

        @test_throws Exception SMatrix{1.0,1,Int,1}((1,))
        @test_throws Exception SMatrix{1,1.0,Int,1}((1,))
        @test_throws Exception SMatrix{2,1,Int,1}((1,))
        @test_throws Exception SMatrix{1,2,Int,1}((1,))
        @test_throws Exception SMatrix{1,1,3,1}((1,))
        @test_throws Exception SMatrix{1,1,Int,2}((1,))

    end
#=
    @testset "Outer constructors" begin
        @test SArray{(1,),Int,1}((1,)).data === (1,)
        @test_inferred SArray{(1,),Int,1}((1,))
        @test SArray{(1,),Int}((1,)).data === (1,)
        @test_inferred SArray{(1,),Int}((1,))
        @test SArray{(1,)}((1,)).data === (1,)
        @test_inferred SArray{(1,)}((1,))

        @test MArray{(1,),Int,1}((1,)).data === (1,)
        @test_inferred MArray{(1,),Int,1}((1,))
        @test_inferred MArray{(1,),Int,1}()
        @test MArray{(1,),Int}((1,)).data === (1,)
        @test_inferred MArray{(1,),Int}((1,))
        @test_inferred MArray{(1,),Int}()
        @test MArray{(1,)}((1,)).data === (1,)
        @test_inferred MArray{(1,)}((1,))
    end

    @testset "Constructors that convert types" begin
        @test SArray{(1,),Float64,1}((1,)).data === (1.0,)
        @test_inferred SArray{(1,),Float64,1}((1,))
        @test SArray{(1,),Float64}((1,)).data === (1.0,)
        @test_inferred SArray{(1,),Float64}((1,))

        @test MArray{(1,),Float64,1}((1,)).data === (1.0,)
        @test_inferred MArray{(1,),Float64,1}((1,))
        @test MArray{(1,),Float64}((1,)).data === (1.0,)
        @test_inferred MArray{(1,),Float64}((1,))
    end
    =#
    @testset "eltype conversion" begin
        sa_int = SArray{Tuple{1}}((1,))
        ma_int = MArray{Tuple{1}}((1,))

        sa_float = SArray{Tuple{1}}((1.0,))
        ma_float = MArray{Tuple{1}}((1.0,))

        @test @inferred(convert(SArray{Tuple{1},Float64}, sa_int)) === sa_float
        @test @inferred(convert(SArray{Tuple{1},Float64,1}, sa_int)) === sa_float
        @test @inferred(convert(SArray{Tuple{1},Float64,1,1}, sa_int)) === sa_float

        @test @inferred(convert(MArray{Tuple{1},Float64}, ma_int)) == ma_float
        @test @inferred(convert(MArray{Tuple{1},Float64,1}, ma_int)) == ma_float
        @test @inferred(convert(MArray{Tuple{1},Float64,1,1}, ma_int)) == ma_float
    end

    @testset "StaticArray conversion" begin
        sa_int = SArray{Tuple{1}}((1,))
        ma_int = MArray{Tuple{1}}((1,))

        sa_float = SArray{Tuple{1}}((1.0,))
        ma_float = MArray{Tuple{1}}((1.0,))

        # SArray -> MArray
        #@test @inferred(convert(MArray, sa_int)) == ma_int
        @test @inferred(convert(MArray{Tuple{1}}, sa_int)) == ma_int
        @test @inferred(convert(MArray{Tuple{1},Int}, sa_int)) == ma_int
        @test @inferred(convert(MArray{Tuple{1},Int,1}, sa_int)) == ma_int
        @test @inferred(convert(MArray{Tuple{1},Int,1,1}, sa_int)) == ma_int

        @test @inferred(convert(MArray{Tuple{1},Float64}, sa_int)) == ma_float
        @test @inferred(convert(MArray{Tuple{1},Float64,1}, sa_int)) == ma_float
        @test @inferred(convert(MArray{Tuple{1},Float64,1,1}, sa_int)) == ma_float

        # MArray -> SArray
        #@test @inferred(convert(SArray, ma_int)) === sa_int
        @test @inferred(convert(SArray{Tuple{1}}, ma_int)) === sa_int
        @test @inferred(convert(SArray{Tuple{1},Int}, ma_int)) === sa_int
        @test @inferred(convert(SArray{Tuple{1},Int,1}, ma_int)) === sa_int
        @test @inferred(convert(SArray{Tuple{1},Int,1,1}, ma_int)) === sa_int

        @test @inferred(convert(SArray{Tuple{1},Float64}, ma_int)) === sa_float
        @test @inferred(convert(SArray{Tuple{1},Float64,1}, ma_int)) === sa_float
        @test @inferred(convert(SArray{Tuple{1},Float64,1,1}, ma_int)) === sa_float

        # Self-conversion returns the matrix itself
        @test convert(MArray, ma_int) === ma_int
        @test convert(MArray, ma_float) === ma_float
    end

    @testset "AbstractArray conversion" begin
        sa = SArray{Tuple{2,2}, Int}((3, 4, 5, 6))
        ma = MArray{Tuple{2,2}, Int}((3, 4, 5, 6))
        a = [3 5; 4 6]

        @test @inferred(convert(SArray{Tuple{2,2}}, a)) === sa
        @test @inferred(convert(SArray{Tuple{2,2},Int}, a)) === sa
        @test @inferred(convert(SArray{Tuple{2,2},Int,2}, a)) === sa
        @test @inferred(convert(SArray{Tuple{2,2},Int,2,4}, a)) === sa

        @test @inferred(convert(MArray{Tuple{2,2}}, a)) == ma
        @test @inferred(convert(MArray{Tuple{2,2},Int}, a)) == ma
        @test @inferred(convert(MArray{Tuple{2,2},Int,2}, a)) == ma
        @test @inferred(convert(MArray{Tuple{2,2},Int,2,4}, a)) == ma

        @test @inferred(convert(Array, sa)) == a
        @test @inferred(convert(Array{Int}, sa)) == a
        @test @inferred(convert(Array{Int,2}, sa)) == a

        @test @inferred(convert(Array, ma)) == a
        @test @inferred(convert(Array{Int}, ma)) == a
        @test @inferred(convert(Array{Int,2}, ma)) == a

        try
            convert(SVector, [1,2,3])
        catch err
            @test isa(err, ErrorException)
            @test startswith(err.msg, "The size of type")
        end
        @test_throws DimensionMismatch("expected input array of length 2, got length 3") convert(SVector{2}, [1,2,3])
    end
    @test_throws Exception Length{2.5}()
    @test Length(2) == Length{2}()
    @test Tuple{2, 3, 5} != StaticArrays.Size{(2, 3, 4)}
    @test StaticArrays.Size{(2, 3, 4)} != Tuple{2, 3, 5}
    @test StaticArrays.check_length(2) == nothing
    @test StaticArrays.check_length(StaticArrays.Dynamic()) == nothing

    @testset "Size" begin
        @test Size(zero(SMatrix{2, 3})) == Size(2, 3)
        @test Size(Transpose(zero(SMatrix{2, 3}))) == Size(3, 2)
        @test Size(Adjoint(zero(SMatrix{2, 3}))) == Size(3, 2)
        @test Size(Diagonal(SVector(1, 2, 3))) == Size(3, 3)
        @test Size(Transpose(Diagonal(SVector(1, 2, 3)))) == Size(3, 3)
        @test Size(UpperTriangular(zero(SMatrix{2, 2}))) == Size(2, 2)
        @test Size(LowerTriangular(zero(SMatrix{2, 2}))) == Size(2, 2)
        @test Size(LowerTriangular(Symmetric(zero(SMatrix{2, 2})))) == Size(2,2)
    end

    @testset "dimmatch" begin
        @test StaticArrays.dimmatch(3, 3)
        @test StaticArrays.dimmatch(3, StaticArrays.Dynamic())
        @test StaticArrays.dimmatch(StaticArrays.Dynamic(), 3)
        @test StaticArrays.dimmatch(StaticArrays.Dynamic(), StaticArrays.Dynamic())

        @test !StaticArrays.dimmatch(3, 2)
    end

    @testset "sizematch" begin
        @test StaticArrays.sizematch(Size(1, 2, 3), Size(1, 2, 3))
        @test StaticArrays.sizematch(Size(1, StaticArrays.Dynamic(), 3), Size(1, 2, 3))
        @test StaticArrays.sizematch(Size(1, 2, 3), Size(1, StaticArrays.Dynamic(), 3))
        @test StaticArrays.sizematch(Size(StaticArrays.Dynamic()), Size(StaticArrays.Dynamic()))

        @test !StaticArrays.sizematch(Size(1, 2, 3), Size(1, 2, 4))
        @test !StaticArrays.sizematch(Size(2, 2, 3), Size(1, 2, 3))
        @test !StaticArrays.sizematch(Size(2, 2, StaticArrays.Dynamic()), Size(1, 2, 3))
        @test !StaticArrays.sizematch(Size(1, 2), Size(1, 2, 3))
        @test !StaticArrays.sizematch(Size(1, 2, 3), Size(1, 2))

        sa = SArray{Tuple{2,3}, Int}((3, 4, 5, 6, 7, 8))
        a = [3 5 7; 4 6 8]

        @test StaticArrays.sizematch(Size(2, 3), sa)
        @test StaticArrays.sizematch(Size(2, StaticArrays.Dynamic()), sa)
        @test StaticArrays.sizematch(Size(2, 3), a)
        @test StaticArrays.sizematch(Size(2, StaticArrays.Dynamic()), a)

        @test !StaticArrays.sizematch(Size(2, 2), sa)
        @test !StaticArrays.sizematch(Size(3, StaticArrays.Dynamic()), sa)
        @test !StaticArrays.sizematch(Size(2, 2), a)
        @test !StaticArrays.sizematch(Size(3, StaticArrays.Dynamic()), a)
    end

    @testset "SOneTo" begin
        a = Base.OneTo(3)
        b = StaticArrays.SOneTo{2}()
        @test @inferred(promote(a, b)) === (a, Base.OneTo(2))
        @test @inferred(promote(b, a)) === (Base.OneTo(2), a)

        @test StaticArrays.SOneTo{2}(1:2) === StaticArrays.SOneTo{2}()
        @test convert(StaticArrays.SOneTo{2}, 1:2) === StaticArrays.SOneTo{2}()
        @test_throws DimensionMismatch StaticArrays.SOneTo{2}(1:3)
        @test_throws DimensionMismatch StaticArrays.SOneTo{2}(1:1)

        @test @inferred(intersect(SOneTo(2), SOneTo(4))) === SOneTo(2)
        @test @inferred(union(SOneTo(2), SOneTo(4))) === SOneTo(4)
    end
end

using StaticArrays, ChainRulesCore, ChainRulesTestUtils, JLArrays, LinearAlgebra, Test

@testset "ChainRules Integration" begin
    @testset "Projection" begin
        # There is no code for this, but when argument isa StaticArray, axes(x) === axes(dx)
        # implies a check, and reshape will wrap a Vector into a static SizedVector:
        pstat = ProjectTo(SA[1, 2, 3])
        @test axes(pstat(rand(3))) === (SOneTo(3),)

        # This recurses into structured arrays:
        pst = ProjectTo(transpose(SA[1, 2, 3]))
        @test axes(pst(rand(1,3))) === (SOneTo(1), SOneTo(3))
        @test pst(rand(1,3)) isa Transpose

        # When the argument is an ordinary Array, static gradients are allowed to pass,
        # like FillArrays. Collecting to an Array would cost a copy.
        pvec3 = ProjectTo([1, 2, 3])
        @test pvec3(SA[1, 2, 3]) isa StaticArray
    end

    @testset "Constructor rrules" begin
        test_rrule(SMatrix{1, 4}, (1.0, 1.0, 1.0, 1.0))
        test_rrule(SMatrix{4, 1}, (1.0, 1.0, 1.0, 1.0))
        test_rrule(SMatrix{2, 2}, (1.0, 1.0, 1.0, 1.0))
        test_rrule(SVector{4}, (1.0, 1.0, 1.0, 1.0))
        test_rrule(SVector{4}, 1.0, 1.0, 1.0, 1.0)
        test_rrule(SVector{4}, 1.0, 1.0f0, 1.0, 1.0f0)
    end

    @testset "Type Stability" begin
        x = ones(SMatrix{2, 2})
        y = ones(SVector{4})

        @inferred ProjectTo(x)
        @inferred ProjectTo(y)
        @inferred ProjectTo(x)(y)
        @inferred ProjectTo(y)(x)

        x = ones(SMatrix{2, 2, Float32})
        y = ones(SVector{4})

        @inferred ProjectTo(x)
        @inferred ProjectTo(x)(y)
        @inferred ProjectTo(y)(x)
    end

    @testset "Array of Structs Projection" begin
        x = JLArray(rand(SVector{3, Float64}, 10))
        @inferred ProjectTo(x)
        @inferred Union{Nothing, JLVector{SVector{3, Float64}}, DenseJLVector{SVector{3, Float64}}} ProjectTo(x)(x)
        @test ProjectTo(x)(x) isa JLArray
    end
end

@testset "FieldVector" begin
    @testset "Immutable Point3D" begin
        eval(quote
            struct Point3D <: FieldVector{3, Float64}
                x::Float64
                y::Float64
                z::Float64
            end

            # No need to define similar_type for non-parametric FieldVector (#792)
        end)

        p = Point3D(1.0, 2.0, 3.0)

        @test_throws Exception p[2] = 4.0

        @test size(p) === (3,)
        @test length(p) === 3
        @test eltype(p) === Float64

        @testinf Tuple(p) === (1.0, 2.0, 3.0)

        @test (p + p) === Point3D(2.0, 4.0, 6.0)

        @test (p[1], p[2], p[3]) === (p.x, p.y, p.z)

        m = @SMatrix [2.0 0.0 0.0;
                      0.0 2.0 0.0;
                      0.0 0.0 2.0]

        @test @inferred(m*p) === Point3D(2.0, 4.0, 6.0)
        @test @inferred(SA[2.0 0.0 0.0;
                           0.0 2.0 0.0]*p) === SVector((2.0, 4.0))

        @test @inferred(similar_type(Point3D)) == Point3D
        @test @inferred(similar_type(Point3D, Float64)) == Point3D
        @test @inferred(similar_type(Point3D, Float32)) == SVector{3,Float32}
        @test @inferred(similar_type(Point3D, Size(4))) == SVector{4,Float64}
        @test @inferred(similar_type(Point3D, Float32, Size(4))) == SVector{4,Float32}

        # Issue 146
        @test [[Point3D(1.0,2.0,3.0)]; [Point3D(4.0,5.0,6.0)]]::Vector{Point3D} == [Point3D(1.0,2.0,3.0), Point3D(4.0,5.0,6.0)]

        # Issue 342
        @test_throws DimensionMismatch("No precise constructor for Point3D found. Length of input was 4.") Point3D(1,2,3,4)

        eval(quote
            struct Point2DT{T} <: FieldVector{2, T}
                x::T
                y::T
            end
        end)

        # eltype promotion
        @test Point2DT(1., 2) === Point2DT(1.0, 2.0) && Tuple(Point2DT(1.0, 2.0)) === (1.0, 2.0)
        @test Point2DT{Int}(1., 2) === Point2DT(1, 2) && Tuple(Point2DT(1, 2)) === (1, 2)
    end

    @testset "Mutable Point2D" begin
        eval(quote
            mutable struct Point2D{T} <: FieldVector{2, T}
                x::T
                y::T
            end

            StaticArrays.similar_type(::Type{<:Point2D}, ::Type{T}, s::Size{(2,)}) where {T} = Point2D{T}
        end)

        p = Point2D(0.0, 0.0)
        p[1] = 1.0
        p[2] = 2.0

        @test size(p) === (2,)
        @test length(p) === 2
        @test eltype(p) === Float64

        @testinf Tuple(p) === (1.0, 2.0)

        @test (p[1], p[2]) === (p.x, p.y)
        @test (p[1], p[2]) === (1.0, 2.0)

        m = @SMatrix [2.0 0.0;
                      0.0 2.0]

        @test @inferred(m*p)::Point2D == Point2D(2.0, 4.0)

        @test @inferred(similar_type(Point2D{Float64})) == Point2D{Float64}
        @test @inferred(similar_type(Point2D{Float64}, Float32)) == Point2D{Float32}
        @test @inferred(similar_type(Point2D{Float64}, Size(4))) == SVector{4,Float64}
        @test @inferred(similar_type(Point2D{Float64}, Float32, Size(4))) == SVector{4,Float32}

        # eltype promotion
        @test Point2D(1f0, 2) isa Point2D{Float32}
        @test Point2D{Int}(1f0, 2) isa Point2D{Int}
        p = Point2D(0, 0.0)
        @test p[1] === p[2] === 0.0
    end

    @testset "FieldVector with Tuple fields" begin
        # verify that having a field which is itself a Tuple
        # doesn't break anything

        eval(quote
            struct TupleField <: FieldVector{1, NTuple{2, Int}}
                x::NTuple{2, Int}
                function TupleField(x::NTuple{2,Int})
                    new(x)
                end
            end
        end)

        x = TupleField((1,2))
        @test length(x) == 1
        @test length(x[1]) == 2
        @test x.x == (1, 2)
    end

    @testset "FieldVector with parametric eltype and without similar_type" begin
        eval(quote
            struct FVT{T} <: FieldVector{2, T}
                x::T
                y::T
            end

            # No similar_type defined - test fallback codepath
        end)

        @test @inferred(similar_type(FVT{Float64}, Float32)) == SVector{2,Float32} # Fallback code path
        @test @inferred(similar_type(FVT{Float64}, Size(2))) == FVT{Float64}
        @test @inferred(similar_type(FVT{Float64}, Size(3))) == SVector{3,Float64}
        @test @inferred(similar_type(FVT{Float64}, Float32, Size(3))) == SVector{3,Float32}
    end

    @testset "FieldVector with constructor missing" begin
        struct Position1088{T} <: FieldVector{3, T}
            x::T
            y::T
            z::T
            Position1088(x::T, y::T, z::T) where {T} = new{T}(x, y, z)
        end
        @test_throws ErrorException("The constructor for Position1088{Float64}(::Float64, ::Float64, ::Float64) is missing!") Position1088((1.,2.,3.))
    end

    @testset "FieldVector to NamedTuple" begin
        struct FieldVectorNT{T} <: FieldVector{3,T}
            a::T
            b::T
            c::T
        end

        @test NamedTuple(FieldVectorNT(1,2,3)) isa @NamedTuple{a::Int, b::Int, c::Int}
    end
end

@testset "SArray" begin
    @testset "Inner Constructors" begin
        @test SArray{Tuple{1},Int,1,1}((1,)).data === (1,)
        @test SArray{Tuple{1},Float64,1,1}((1,)).data === (1.0,)
        @test SArray{Tuple{2,2},Float64,2,4}((1, 1.0, 1, 1)).data === (1.0, 1.0, 1.0, 1.0)

        # Bad input
        @test_throws Exception SArray{Tuple{1},Int,1,1}()
        @test_throws Exception SArray{Tuple{2},Int,1,2}((1,))
        @test_throws Exception SArray{Tuple{1},Int,1,1}(())

        # Bad parameters
        @test_throws Exception SArray{Tuple{1},Int,1,2}((1,))
        @test_throws Exception SArray{Tuple{1},Int,2,1}((1,))
        @test_throws Exception SArray{Tuple{1},1,1,1}((1,))
        @test_throws Exception SArray{Tuple{2},Int,1,1}((1,))
    end

    @testset "Outer constructors and macro" begin
        @test_throws Exception SArray(1,2,3,4) # unknown constructor

        @test SArray{Tuple{1},Int,1}((1,)).data === (1,)
        @test SArray{Tuple{1},Int}((1,)).data === (1,)
        @test SArray{Tuple{1}}((1,)).data === (1,)

        @test SArray{Tuple{2,2},Int,2}((1,2,3,4)).data === (1,2,3,4)
        @test SArray{Tuple{2,2},Int}((1,2,3,4)).data === (1,2,3,4)
        @test SArray{Tuple{2,2}}((1,2,3,4)).data === (1,2,3,4)

        @test SArray(SArray{Tuple{2}}(1,2)) === SArray{Tuple{2}}(1,2)

        @test (@inferred SArray(MMatrix{0,0,Float64}()))::SMatrix{0,0,Float64} == SMatrix{0,0,Float64}()

        @test SArray{Tuple{}}(i for i in 1:1).data === (1,)
        @test SArray{Tuple{3}}(i for i in 1:3).data === (1,2,3)
        @test SArray{Tuple{3}}(float(i) for i in 1:3).data === (1.0,2.0,3.0)
        @test SArray{Tuple{2,3}}(i+10j for i in 1:2, j in 1:3).data === (11,12,21,22,31,32)
        @test SArray{Tuple{1,2,3}}(i+10j+100k for i in 1:1, j in 1:2, k in 1:3).data === (111,121,211,221,311,321)
        @test_throws Exception SArray{Tuple{}}(i for i in 1:0)
        @test_throws Exception SArray{Tuple{}}(i for i in 1:2)
        @test_throws Exception SArray{Tuple{3}}(i for i in 1:2)
        @test_throws Exception SArray{Tuple{3}}(i for i in 1:4)
        @test_throws Exception SArray{Tuple{2,3}}(10i+j for i in 1:1, j in 1:3)
        @test_throws Exception SArray{Tuple{2,3}}(10i+j for i in 1:3, j in 1:3)

        @test StaticArrays.sacollect(SVector{6}, Iterators.product(1:2, 1:3)) ==
            SVector{6}(collect(Iterators.product(1:2, 1:3)))
        @test StaticArrays.sacollect(SVector{2}, Iterators.zip(1:2, 2:3)) ==
            SVector{2}(collect(Iterators.zip(1:2, 2:3)))
        @test StaticArrays.sacollect(SVector{3}, Iterators.take(1:10, 3)) ==
            SVector{3}(collect(Iterators.take(1:10, 3)))
        @test StaticArrays.sacollect(SMatrix{2,3}, Iterators.product(1:2, 1:3)) ==
            SMatrix{2,3}(collect(Iterators.product(1:2, 1:3)))
        @test StaticArrays.sacollect(SArray{Tuple{2,3,4}}, 1:24) ==
            SArray{Tuple{2,3,4}}(collect(1:24))

        @test ((@SArray [1])::SArray{Tuple{1}}).data === (1,)
        @test ((@SArray [1,2])::SArray{Tuple{2}}).data === (1,2)
        @test ((@SArray Float64[1,2,3])::SArray{Tuple{3}}).data === (1.0, 2.0, 3.0)
        @test ((@SArray [1 2])::SArray{Tuple{1,2}}).data === (1, 2)
        @test ((@SArray Float64[1 2])::SArray{Tuple{1,2}}).data === (1.0, 2.0)
        @test ((@SArray [1 ; 2])::SArray{Tuple{2}}).data === (1, 2)
        @test ((@SArray Float64[1 ; 2])::SArray{Tuple{2}}).data === (1.0, 2.0)
        @test ((@SArray [1 2 ; 3 4])::SArray{Tuple{2,2}}).data === (1, 3, 2, 4)
        @test ((@SArray Float64[1 2 ; 3 4])::SArray{Tuple{2,2}}).data === (1.0, 3.0, 2.0, 4.0)

        @test ((@SArray [i for i = 1:2])::SArray{Tuple{2}}).data === (1, 2)
        @test ((@SArray [i*j for i = 1:2, j = 2:3])::SArray{Tuple{2,2}}).data === (2, 4, 3, 6)
        @test ((@SArray [i*j*k for i = 1:2, j = 2:3, k = 3:4])::SArray{Tuple{2,2,2}}).data === (6, 12, 9, 18, 8, 16, 12, 24)
        @test ((@SArray [i*j*k*l for i = 1:2, j = 2:3, k = 3:4, l = 1:2])::SArray{Tuple{2,2,2,2}}).data === (6, 12, 9, 18, 8, 16, 12, 24, 12, 24, 18, 36, 16, 32, 24, 48)
        @test ((@SArray [i*j*k*l*m for i = 1:2, j = 2:3, k = 3:4, l = 1:2, m = 1:2])::SArray{Tuple{2,2,2,2,2}}).data === (6, 12, 9, 18, 8, 16, 12, 24, 12, 24, 18, 36, 16, 32, 24, 48, 2*6, 2*12, 2*9, 2*18, 2*8, 2*16, 2*12, 2*24, 2*12, 2*24, 2*18, 2*36, 2*16, 2*32, 2*24, 2*48)
        @test ((@SArray [1 for i = 1:2, j = 2:3, k = 3:4, l = 1:2, m = 1:2, n = 1:2])::SArray{Tuple{2,2,2,2,2,2}}).data === ntuple(i->1, 64)
        @test ((@SArray [1 for i = 1:2, j = 2:3, k = 3:4, l = 1:2, m = 1:2, n = 1:2, o = 1:2])::SArray{Tuple{2,2,2,2,2,2,2}}).data === ntuple(i->1, 128)
        @test ((@SArray [1 for i = 1:2, j = 2:3, k = 3:4, l = 1:2, m = 1:2, n = 1:2, o = 1:2, p = 1:2])::SArray{Tuple{2,2,2,2,2,2,2,2}}).data === ntuple(i->1, 256)
        @test ((@SArray [1 for i = 1:2, j = 2:3, k = 3:4, l = 1:2, m = 1:2, n = 1:2, o = 1:2, p = 1:2, q = 1:2])::SArray{Tuple{2,2,2,2,2,2,2,2,2}}).data === ntuple(i->1, 512)
        @test ((@SArray Float64[i for i = 1:2])::SArray{Tuple{2}}).data === (1.0, 2.0)
        @test ((@SArray Float64[i*j for i = 1:2, j = 2:3])::SArray{Tuple{2,2}}).data === (2.0, 4.0, 3.0, 6.0)
        @test ((@SArray Float64[i*j*k for i = 1:2, j = 2:3, k =3:4])::SArray{Tuple{2,2,2}}).data === (6.0, 12.0, 9.0, 18.0, 8.0, 16.0, 12.0, 24.0)
        @test ((@SArray Float64[i*j*k*l for i = 1:2, j = 2:3, k = 3:4, l = 1:2])::SArray{Tuple{2,2,2,2}}).data === (6.0, 12.0, 9.0, 18.0, 8.0, 16.0, 12.0, 24.0, 12.0, 24.0, 18.0, 36.0, 16.0, 32.0, 24.0, 48.0)
        @test ((@SArray Float64[i*j*k*l*m for i = 1:2, j = 2:3, k = 3:4, l = 1:2, m = 1:2])::SArray{Tuple{2,2,2,2,2}}).data === (6.0, 12.0, 9.0, 18.0, 8.0, 16.0, 12.0, 24.0, 12.0, 24.0, 18.0, 36.0, 16.0, 32.0, 24.0, 48.0, 2*6.0, 2*12.0, 2*9.0, 2*18.0, 2*8.0, 2*16.0, 2*12.0, 2*24.0, 2*12.0, 2*24.0, 2*18.0, 2*36.0, 2*16.0, 2*32.0, 2*24.0, 2*48.0)
        @test ((@SArray Float64[1 for i = 1:2, j = 2:3, k = 3:4, l = 1:2, m = 1:2, n = 1:2])::SArray{Tuple{2,2,2,2,2,2}}).data === ntuple(i->1.0, 64)
        @test ((@SArray Float64[1 for i = 1:2, j = 2:3, k = 3:4, l = 1:2, m = 1:2, n = 1:2, o = 1:2])::SArray{Tuple{2,2,2,2,2,2,2}}).data === ntuple(i->1.0, 128)
        @test ((@SArray Float64[1 for i = 1:2, j = 2:3, k = 3:4, l = 1:2, m = 1:2, n = 1:2, o = 1:2, p = 1:2])::SArray{Tuple{2,2,2,2,2,2,2,2}}).data === ntuple(i->1.0, 256)
        @test ((@SArray Float64[1 for i = 1:2, j = 2:3, k = 3:4, l = 1:2, m = 1:2, n = 1:2, o = 1:2, p = 1:2, q = 1:2])::SArray{Tuple{2,2,2,2,2,2,2,2,2}}).data === ntuple(i->1.0, 512)

        @testset "expand error" begin
            test_expand_error(:(@SArray [1 2; 3]))
            test_expand_error(:(@SArray Float64[1 2; 3]))
            test_expand_error(:(@SArray ones))
            test_expand_error(:(@SArray fill))
            test_expand_error(:(@SArray sin(1:5)))
            test_expand_error(:(@SArray fill()))
            test_expand_error(:(@SArray [1; 2; 3; 4]...))

            # (typed-)comprehension LoadError for `ex.args[1].head != :generator`
            test_expand_error(:(@SArray [i+j for i in 1:2 for j in 1:2]))
            test_expand_error(:(@SArray Int[i+j for i in 1:2 for j in 1:2]))
        end

        @testset "@SArray rand*" begin
            @testset "Same test as @SVector rand*" begin
                n = 4
                @test (@SArray rand(n)) isa SVector{n, Float64}
                @test (@SArray randn(n)) isa SVector{n, Float64}
                @test (@SArray randexp(n)) isa SVector{n, Float64}
                @test (@SArray rand(4)) isa SVector{4, Float64}
                @test (@SArray randn(4)) isa SVector{4, Float64}
                @test (@SArray randexp(4)) isa SVector{4, Float64}
                @test (@SArray rand(_rng(), n)) isa SVector{n, Float64}
                @test (@SArray rand(_rng(), n)) == rand(_rng(), n)
                @test (@SArray randn(_rng(), n)) isa SVector{n, Float64}
                @test (@SArray randn(_rng(), n)) == randn(_rng(), n)
                @test (@SArray randexp(_rng(), n)) isa SVector{n, Float64}
                @test (@SArray randexp(_rng(), n)) == randexp(_rng(), n)
                @test (@SArray rand(_rng(), 4)) isa SVector{4, Float64}
                @test (@SArray rand(_rng(), 4)) == rand(_rng(), 4)
                @test (@SArray randn(_rng(), 4)) isa SVector{4, Float64}
                @test (@SArray randn(_rng(), 4)) == randn(_rng(), 4)
                @test (@SArray randexp(_rng(), 4)) isa SVector{4, Float64}
                @test (@SArray randexp(_rng(), 4)) == randexp(_rng(), 4)

                for T in (Float32, Float64)
                    @test (@SArray rand(T, n)) isa SVector{n, T}
                    @test (@SArray randn(T, n)) isa SVector{n, T}
                    @test (@SArray randexp(T, n)) isa SVector{n, T}
                    @test (@SArray rand(T, 4)) isa SVector{4, T}
                    @test (@SArray randn(T, 4)) isa SVector{4, T}
                    @test (@SArray randexp(T, 4)) isa SVector{4, T}
                    @test (@SArray rand(_rng(), T, n)) isa SVector{n, T}
                    VERSION≥v"1.7" && @test (@SArray rand(_rng(), T, n)) == rand(_rng(), T, n) broken=(T===Float32)
                    @test (@SArray randn(_rng(), T, n)) isa SVector{n, T}
                    @test (@SArray randn(_rng(), T, n)) == randn(_rng(), T, n)
                    @test (@SArray randexp(_rng(), T, n)) isa SVector{n, T}
                    @test (@SArray randexp(_rng(), T, n)) == randexp(_rng(), T, n)
                    @test (@SArray rand(_rng(), T, 4)) isa SVector{4, T}
                    VERSION≥v"1.7" && @test (@SArray rand(_rng(), T, 4)) == rand(_rng(), T, 4) broken=(T===Float32)
                    @test (@SArray randn(_rng(), T, 4)) isa SVector{4, T}
                    @test (@SArray randn(_rng(), T, 4)) == randn(_rng(), T, 4)
                    @test (@SArray randexp(_rng(), T, 4)) isa SVector{4, T}
                    @test (@SArray randexp(_rng(), T, 4)) == randexp(_rng(), T, 4)
                end
            end

            @testset "Same tests as @SMatrix rand*" begin
                n = 4
                @testset "zero-length" begin
                    @test (@SArray rand(0, 0)) isa SMatrix{0, 0, Float64}
                    @test (@SArray rand(0, n)) isa SMatrix{0, n, Float64}
                    @test (@SArray rand(n, 0)) isa SMatrix{n, 0, Float64}
                    @test (@SArray rand(Float32, 0, 0)) isa SMatrix{0, 0, Float32}
                    @test (@SArray rand(Float32, 0, n)) isa SMatrix{0, n, Float32}
                    @test (@SArray rand(Float32, n, 0)) isa SMatrix{n, 0, Float32}
                    @test (@SArray rand(_rng(), Float32, 0, 0)) isa SMatrix{0, 0, Float32}
                    @test (@SArray rand(_rng(), Float32, 0, n)) isa SMatrix{0, n, Float32}
                    @test (@SArray rand(_rng(), Float32, n, 0)) isa SMatrix{n, 0, Float32}
                end

                @test (@SArray rand(n, n)) isa SMatrix{n, n, Float64}
                @test (@SArray randn(n, n)) isa SMatrix{n, n, Float64}
                @test (@SArray randexp(n, n)) isa SMatrix{n, n, Float64}
                @test (@SArray rand(4, 4)) isa SMatrix{4, 4, Float64}
                @test (@SArray randn(4, 4)) isa SMatrix{4, 4, Float64}
                @test (@SArray randexp(4, 4)) isa SMatrix{4, 4, Float64}
                @test (@SArray rand(_rng(), n, n)) isa SMatrix{n, n, Float64}
                @test (@SArray rand(_rng(), n, n)) == rand(_rng(), n, n)
                @test (@SArray randn(_rng(), n, n)) isa SMatrix{n, n, Float64}
                @test (@SArray randn(_rng(), n, n)) == randn(_rng(), n, n)
                @test (@SArray randexp(_rng(), n, n)) isa SMatrix{n, n, Float64}
                @test (@SArray randexp(_rng(), n, n)) == randexp(_rng(), n, n)
                @test (@SArray rand(_rng(), 4, 4)) isa SMatrix{4, 4, Float64}
                @test (@SArray rand(_rng(), 4, 4)) == rand(_rng(), 4, 4)
                @test (@SArray randn(_rng(), 4, 4)) isa SMatrix{4, 4, Float64}
                @test (@SArray randn(_rng(), 4, 4)) == randn(_rng(), 4, 4)
                @test (@SArray randexp(_rng(), 4, 4)) isa SMatrix{4, 4, Float64}
                @test (@SArray randexp(_rng(), 4, 4)) == randexp(_rng(), 4, 4)

                for T in (Float32, Float64)
                    @test (@SArray rand(T, n, n)) isa SMatrix{n, n, T}
                    @test (@SArray randn(T, n, n)) isa SMatrix{n, n, T}
                    @test (@SArray randexp(T, n, n)) isa SMatrix{n, n, T}
                    @test (@SArray rand(T, 4, 4)) isa SMatrix{4, 4, T}
                    @test (@SArray randn(T, 4, 4)) isa SMatrix{4, 4, T}
                    @test (@SArray randexp(T, 4, 4)) isa SMatrix{4, 4, T}
                    @test (@SArray rand(_rng(), T, n, n)) isa SMatrix{n, n, T}
                    VERSION≥v"1.7" && @test (@SArray rand(_rng(), T, n, n)) == rand(_rng(), T, n, n) broken=(T===Float32)
                    @test (@SArray randn(_rng(), T, n, n)) isa SMatrix{n, n, T}
                    @test (@SArray randn(_rng(), T, n, n)) == randn(_rng(), T, n, n)
                    @test (@SArray randexp(_rng(), T, n, n)) isa SMatrix{n, n, T}
                    @test (@SArray randexp(_rng(), T, n, n)) == randexp(_rng(), T, n, n)
                    @test (@SArray rand(_rng(), T, 4, 4)) isa SMatrix{4, 4, T}
                    VERSION≥v"1.7" && @test (@SArray rand(_rng(), T, 4, 4)) == rand(_rng(), T, 4, 4) broken=(T===Float32)
                    @test (@SArray randn(_rng(), T, 4, 4)) isa SMatrix{4, 4, T}
                    @test (@SArray randn(_rng(), T, 4, 4)) == randn(_rng(), T, 4, 4)
                    @test (@SArray randexp(_rng(), T, 4, 4)) isa SMatrix{4, 4, T}
                    @test (@SArray randexp(_rng(), T, 4, 4)) == randexp(_rng(), T, 4, 4)
                end
            end

            @test (@SArray rand(2,2,1))    isa SArray{Tuple{2,2,1}, Float64}
            @test (@SArray rand(2,2,0))    isa SArray{Tuple{2,2,0}, Float64}
            @test (@SArray randn(2,2,1))   isa SArray{Tuple{2,2,1}, Float64}
            @test (@SArray randn(2,2,0))   isa SArray{Tuple{2,2,0}, Float64}
            @test (@SArray randexp(2,2,1)) isa SArray{Tuple{2,2,1}, Float64}
            @test (@SArray randexp(2,2,0)) isa SArray{Tuple{2,2,0}, Float64}
            @test (@SArray rand(Float32,2,2,1))    isa SArray{Tuple{2,2,1}, Float32}
            @test (@SArray rand(Float32,2,2,0))    isa SArray{Tuple{2,2,0}, Float32}
            @test (@SArray randn(Float32,2,2,1))   isa SArray{Tuple{2,2,1}, Float32}
            @test (@SArray randn(Float32,2,2,0))   isa SArray{Tuple{2,2,0}, Float32}
            @test (@SArray randexp(Float32,2,2,1)) isa SArray{Tuple{2,2,1}, Float32}
            @test (@SArray randexp(Float32,2,2,0)) isa SArray{Tuple{2,2,0}, Float32}
        end

        @testset "fill, zeros, ones" begin
            @test ((@SArray fill(1))::SArray{Tuple{},Int}).data === (1,)
            @test ((@SArray zeros())::SArray{Tuple{},Float64}).data === (0.,)
            @test ((@SArray ones())::SArray{Tuple{},Float64}).data === (1.,)
            @test ((@SArray fill(3.,2,2,1))::SArray{Tuple{2,2,1}, Float64}).data === (3.0, 3.0, 3.0, 3.0)
            @test ((@SArray zeros(2,2,1))::SArray{Tuple{2,2,1}, Float64}).data === (0.0, 0.0, 0.0, 0.0)
            @test ((@SArray ones(2,2,1))::SArray{Tuple{2,2,1}, Float64}).data === (1.0, 1.0, 1.0, 1.0)
            @test ((@SArray zeros(3-1,2,1))::SArray{Tuple{2,2,1}, Float64}).data === (0.0, 0.0, 0.0, 0.0)
            @test ((@SArray ones(3-1,2,1))::SArray{Tuple{2,2,1}, Float64}).data === (1.0, 1.0, 1.0, 1.0)
            @test ((@SArray zeros(Float32,2,2,1))::SArray{Tuple{2,2,1}, Float32}).data === (0.f0, 0.f0, 0.f0, 0.f0)
            @test ((@SArray ones(Float32,2,2,1))::SArray{Tuple{2,2,1}, Float32}).data === (1.f0, 1.f0, 1.f0, 1.f0)
            @test ((@SArray zeros(Float32,3-1,2,1))::SArray{Tuple{2,2,1}, Float32}).data === (0.f0, 0.f0, 0.f0, 0.f0)
            @test ((@SArray ones(Float32,3-1,2,1))::SArray{Tuple{2,2,1}, Float32}).data === (1.f0, 1.f0, 1.f0, 1.f0)
        end

        m = [1 2; 3 4]
        @test SArray{Tuple{2,2}}(m) === @SArray [1 2; 3 4]

        # Non-square comprehensions built from SVectors - see #76
        @test @SArray([1 for x = SVector(1,2), y = SVector(1,2,3)]) == ones(2,3)

        # Nested cat
        @test ((@SArray [[1;2] [3;4]])::SMatrix{2,2}).data === (1,2,3,4)
        @test ((@SArray Float64[[1;2] [3;4]])::SMatrix{2,2}).data === (1.,2.,3.,4.)
        @test ((@SArray [[1 3];[2 4]])::SMatrix{2,2}).data === (1,2,3,4)
        @test ((@SArray Float64[[1 3];[2 4]])::SMatrix{2,2}).data === (1.,2.,3.,4.)
        test_expand_error(:(@SArray [[1;2] [3]]))
        test_expand_error(:(@SArray [[1 2]; [3]]))

        @test (@SArray [[[1,2],1]; 2; 3]) == [[[1,2],1]; 2; 3]

        if VERSION >= v"1.7.0"
            function test_ex(ex)
                a = eval(:(@SArray $ex))
                b = eval(ex)
                @test a isa SArray
                @test eltype(a) === eltype(b)
                @test a == b
            end
            test_ex(:([1 2 ; 3 4 ;;; 5 6 ; 7 8]))
            test_ex(:(Float64[1 2 ; 3 4 ;;; 5 6 ; 7 8]))
            test_ex(:([1 2 ;;; 3 4]))
            test_ex(:(Float32[1 2 ;;; 3 4]))
            test_ex(:([ 1 2
                        3 4
                        ;;;
                        5 6
                        7 8 ]))
            test_ex(:([1 ; 2 ;; 3 ; 4 ;;; 5 ; 6 ;; 7 ; 8]))
            test_ex(:([[[1 ; 2] ;; [3 ; 4]] ;;; [[5 ; 6] ;; [7 ; 8]]]))
        end
    end

    @testset "Methods" begin
        m = @SArray [11 13; 12 14]

        @test isimmutable(m) == true

        @test m[1] === 11
        @test m[2] === 12
        @test m[3] === 13
        @test m[4] === 14

        @testinf Tuple(m) === (11, 12, 13, 14)

        @test size(m) === (2, 2)
        @test size(typeof(m)) === (2, 2)
        @test size(SArray{Tuple{2,2},Int,2}) === (2, 2)
        @test size(SArray{Tuple{2,2},Int}) === (2, 2)
        @test size(SArray{Tuple{2,2}}) === (2, 2)

        @test size(m, 1) === 2
        @test size(m, 2) === 2
        @test size(typeof(m), 1) === 2
        @test size(typeof(m), 2) === 2

        @test length(m) === 4

        @test_throws Exception m[1] = 1

        @test Base.dataids(m) === ()

        @test (@inferred view(m, :, :)) === m
        @test (@inferred view(m, :, 1)) === @SArray [11, 12]
        @test (@inferred view(m, SVector{2,Int}(1,2), 1)) === @SArray [11, 12]
        @test (@inferred view(m, SMatrix{2,2,Int}(1,2,3,4))) === m
        @test (@inferred view(m, SOneTo(2), 1)) === @SArray [11, 12]
        @test (@inferred view(m, 1, 1)) === Scalar(m[1, 1])
        @test (@inferred view(m, CartesianIndex(1, 1))) === Scalar(m[1, 1])
        @test (@inferred view(m, CartesianIndex(1, 1, 1))) === Scalar(m[1, 1])
        @test (@inferred view(m, 1, 1, CartesianIndex(1))) === Scalar(m[1, 1])

        @test reverse(m) == reverse(reverse(collect(m), dims = 2), dims = 1)

        m1 = reshape(m, Val(1))

        m1 = @inferred reshape(m, Val(1))

        @test m1 isa SVector
        @test all(((x, y),) -> isequal(x,y), zip(m, m1))

        m2 = @inferred reshape(m, Val(2))
        @test m2 === m

        m3 = @inferred reshape(m, Val(3))
        @test eltype(m3) == eltype(m)
        @test ndims(m3) == 3
        @test size(m3) == (size(m)..., 1)
        @test all(((x, y),) -> isequal(x,y), zip(m, m3))
    end

    @testset "promotion" begin
        @test @inferred(promote_type(SVector{1,Float64}, SVector{1,BigFloat})) == SVector{1,BigFloat}
        @test @inferred(promote_type(SVector{2,Int}, SVector{2,Float64})) === SVector{2,Float64}
        @test @inferred(promote_type(SMatrix{2,3,Float32,6}, SMatrix{2,3,Complex{Float64},6})) === SMatrix{2,3,Complex{Float64},6}
    end
end

@testset "some special case" begin
    @test_throws Exception (SArray{Tuple{2,M,N}} where {M,N})(SArray{Tuple{3,2,1}}(1,2,3,4,5,6))

    @test_throws Exception SVector{1}(1, 2)
    @test (@inferred(SVector{1}((1, 2)))::SVector{1,NTuple{2,Int}}).data === ((1,2),)
    @test (@inferred(SVector{2}((1, 2)))::SVector{2,Int}).data === (1,2)
    @test (@inferred(SVector(1, 2))::SVector{2,Int}).data === (1,2)
    @test (@inferred(SVector((1, 2)))::SVector{2,Int}).data === (1,2)

    @test_throws Exception SMatrix{1,1}(1, 2)
    @test (@inferred(SMatrix{1,1}((1, 2)))::SMatrix{1,1,NTuple{2,Int}}).data === ((1,2),)
    @test (@inferred(SMatrix{1,2}((1, 2)))::SMatrix{1,2,Int}).data === (1,2)
    @test (@inferred(SMatrix{1}((1, 2)))::SMatrix{1,2,Int}).data === (1,2)
    @test (@inferred(SMatrix{1}(1, 2))::SMatrix{1,2,Int}).data === (1,2)
    @test (@inferred(SMatrix{2}((1, 2)))::SMatrix{2,1,Int}).data === (1,2)
    @test (@inferred(SMatrix{2}(1, 2))::SMatrix{2,1,Int}).data === (1,2)
end

using StaticArrays, Test

@testset "Matrix square root" begin
    @test sqrt(SMatrix{0,0,Int}())::SMatrix === SMatrix{0,0,Float64}()
    @test sqrt(@SMatrix [2])::SMatrix ≈ SMatrix{1,1}(sqrt(2))
    @test sqrt(@SMatrix [5 2; -2 1])::SMatrix ≈ sqrt([5 2; -2 1])
    @test sqrt(@SMatrix [4 2; -2 1])::SMatrix ≈ sqrt([4 2; -2 1])
    @test sqrt(@SMatrix [4 2; 2 1])::SMatrix ≈ sqrt([4 2; 2 1])
    @test sqrt(@SMatrix [0 0; 0 0])::SMatrix ≈ sqrt([0 0; 0 0])
    @test sqrt(@SMatrix [1 2 0; 2 1 0; 0 0 1])::SizedArray{Tuple{3,3}} ≈ sqrt([1 2 0; 2 1 0; 0 0 1])
end

@testset "FieldMatrix" begin
    @testset "Immutable Tensor3x3" begin
        eval(quote
            struct Tensor3x3 <: FieldMatrix{3, 3, Float64}
                xx::Float64
                yx::Float64
                zx::Float64
                xy::Float64
                yy::Float64
                zy::Float64
                xz::Float64
                yz::Float64
                zz::Float64
            end

            # No need to define similar_type for non-parametric FieldMatrix (#792)
        end)

        p = Tensor3x3(1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0, 9.0)

        @test_throws Exception p[2] = 4.0
        @test_throws Exception p[2, 3] = 6.0

        @test size(p) === (3,3)
        @test length(p) === 9
        @test eltype(p) === Float64

        @testinf Tuple(p) === (1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0, 9.0)

         @test @inferred(p + p) === Tensor3x3(2.0, 4.0, 6.0, 8.0, 10.0, 12.0, 14.0, 16.0, 18.0)

        @test (p[1], p[2], p[3], p[4], p[5], p[6], p[7], p[8], p[9]) === (p.xx, p.yx, p.zx, p.xy, p.yy, p.zy, p.xz, p.yz, p.zz)

        m = @SMatrix [2.0 0.0 0.0;
                      0.0 2.0 0.0;
                      0.0 0.0 2.0]

        @test @inferred(p*m) === Tensor3x3(2.0, 4.0, 6.0, 8.0, 10.0, 12.0, 14.0, 16.0, 18.0)

        @test @inferred(similar_type(Tensor3x3)) == Tensor3x3
        @test @inferred(similar_type(Tensor3x3, Float64)) == Tensor3x3
        @test @inferred(similar_type(Tensor3x3, Float32)) == SMatrix{3,3,Float32,9}
        @test @inferred(similar_type(Tensor3x3, Size(4,4))) == SMatrix{4,4,Float64,16}
        @test @inferred(similar_type(Tensor3x3, Float32, Size(4,4))) == SMatrix{4,4,Float32,16}

        # Issue 146
        @test [[Tensor3x3(1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0, 9.0)]; [Tensor3x3(2.0, 4.0, 6.0, 8.0, 10.0, 12.0, 14.0, 16.0, 18.0)]]::Vector{Tensor3x3} == [Tensor3x3(1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0, 9.0), Tensor3x3(2.0, 4.0, 6.0, 8.0, 10.0, 12.0, 14.0, 16.0, 18.0)]

        # Issue 342
        @test_throws DimensionMismatch("No precise constructor for Tensor3x3 found. Length of input was 10.") Tensor3x3(1,2,3,4,5,6,7,8,9,10)
    end

    @testset "Mutable Tensor2x2" begin
        eval(quote
            mutable struct Tensor2x2{T} <: FieldMatrix{2, 2, T}
                xx::T
                yx::T
                xy::T
                yy::T
            end

            StaticArrays.similar_type(::Type{<:Tensor2x2}, ::Type{T}, s::Size{(2,2)}) where {T} = Tensor2x2{T}
        end)

        p = Tensor2x2(0.0, 0.0, 0.0, 0.0)
        p[1,1] = 1.0
        @test setindex!(p, 1.0, 1,1) === p
        p[2,1] = 2.0

        @test size(p) === (2,2)
        @test length(p) === 4
        @test eltype(p) === Float64

        @testinf Tuple(p) === (1.0, 2.0, 0.0, 0.0)

        @test (p[1], p[2], p[3], p[4]) === (p.xx, p.yx, p.xy, p.yy)
        @test (p[1], p[2], p[3], p[4]) === (1.0, 2.0, 0.0, 0.0)

        m = @SMatrix [2.0 0.0;
                      0.0 2.0]

        @test @inferred(p*m)::Tensor2x2 == Tensor2x2(2.0, 4.0, 0.0, 0.0)

        @test @inferred(similar_type(Tensor2x2{Float64})) == Tensor2x2{Float64}
        @test @inferred(similar_type(Tensor2x2{Float64}, Float32)) == Tensor2x2{Float32}
        @test @inferred(similar_type(Tensor2x2{Float64}, Size(3,3))) == SMatrix{3,3,Float64,9}
        @test @inferred(similar_type(Tensor2x2{Float64}, Float32, Size(4,4))) == SMatrix{4,4,Float32,16}

        # eltype promotion
        @test Tuple(@inferred(Tensor2x2(1., 2, 3, 4f0))) === (1.,2.,3.,4.)
        @test Tuple(@inferred(Tensor2x2{Int}(1., 2, 3, 4f0))) === (1,2,3,4)
    end

    @testset "FieldMatrix with Tuple fields" begin
        # verify that having a field which is itself a Tuple
        # doesn't break anything

        eval(quote
            struct TupleField2 <: FieldMatrix{1, 1, NTuple{2, Int}}
                x::NTuple{2, Int}
                function TupleField2(x::NTuple{2,Int})
                    new(x)
                end
            end
        end)

        x = TupleField2((1,2))
        @test length(x) == 1
        @test length(x[1]) == 2
        @test x.x == (1, 2)
    end

    @testset "FieldMatrix to NamedTuple" begin
        struct FieldMatrixNT{T} <: FieldMatrix{2,2,T}
            a::T
            b::T
            c::T
            d::T
        end

        @test NamedTuple(FieldMatrixNT(1,2,3,4)) isa @NamedTuple{a::Int, b::Int, c::Int, d::Int}
    end
end

using Documenter
using StaticArrays
using StaticArraysCore

# Setup for doctests in docstrings
doctest_setup = :(using LinearAlgebra, StaticArrays)
DocMeta.setdocmeta!(StaticArrays,     :DocTestSetup, doctest_setup)
DocMeta.setdocmeta!(StaticArraysCore, :DocTestSetup, doctest_setup)

makedocs(;
    modules = [StaticArrays, StaticArraysCore],
    format = Documenter.HTML(
        canonical = "https://JuliaArrays.github.io/StaticArrays.jl/stable/",
        assets = ["assets/favicon.ico"],
    ),
    pages = [
        "Home" => "index.md",
        "API" => "api.md",
        "Quick Start" => "quickstart.md",
        ],
    sitename = "StaticArrays.jl",
)

deploydocs(; repo = "github.com/JuliaArrays/StaticArrays.jl")

fsa = false
all_methods = false

using StaticArrays
@static if fsa
    using FixedSizeArrays
end

if !isdefined(:N)
    N = 4
end

M_f = div(10^9, N^3)
M_g = div(2*10^8, N^2)

# Size

A = rand(Float64,N,N)
A = A*A'
As = SMatrix{N,N}(A)
Am = MMatrix{N,N}(A)
Az = SizedMatrix{N,N}(copy(A))
@static if fsa
    Af = Mat(ntuple(j -> ntuple(i->A[i,j], N), N)) # there is a bug in FixedSizeArrays Mat constructor (13 July 2016)
end


if !isdefined(:f_mut_marray) || !isdefined(:benchmark_suite) || benchmark_suite == false
    @generated f(n::Integer, A) = :(@inbounds (C = A; for i = 1:n; C = C*A; end; return C))
    @generated f_unrolled(n::Integer, A::Union{SMatrix{M,M},MMatrix{M,M}}) where {M} = :(@inbounds (C = A; for i = 1:n; C = StaticArrays.A_mul_B_unrolled(C,A); end; return C))
    @generated f_unrolled_chunks(n::Integer, A::Union{SMatrix{M,M},MMatrix{M,M}}) where {M} = :(@inbounds (C = A; for i = 1:n; C = StaticArrays.A_mul_B_unrolled_chunks(C,A); end; return C))
    @generated f_loop(n::Integer, A::Union{SMatrix{M,M},MMatrix{M,M}}) where {M} = :(@inbounds (C = A; for i = 1:n; C = StaticArrays.A_mul_B_loop(C,A); end; return C))
    @generated f_via_sarray(n::Integer, A::MMatrix{M,M}) where {M}= :(@inbounds (C = A; for i = 1:n; C = MMatrix{M,M}(SMatrix{M,M}(C)*SMatrix{M,M}(A)); end; return C))
    @generated f_mut_array(n::Integer, A) = :(@inbounds (C = copy(A); tmp = similar(A); for i = 1:n;  A_mul_B!(tmp, C, A); map!(identity, C, tmp); end; return C))
    @generated f_mut_marray(n::Integer, A) = :(@inbounds (C = similar(A); C[:] = A[:]; tmp = similar(A); for i = 1:n; StaticArrays.A_mul_B!(tmp, C, A); C.data = tmp.data; end; return C))
    @generated f_mut_unrolled(n::Integer, A) = :(@inbounds (C = similar(A); C[:] = A[:]; tmp = similar(A); for i = 1:n; StaticArrays.A_mul_B_unrolled!(tmp, C, A); C.data = tmp.data; end; return C))
    @generated f_mut_chunks(n::Integer, A) = :(@inbounds (C = similar(A); C[:] = A[:]; tmp = similar(A); for i = 1:n; StaticArrays.A_mul_B_unrolled_chunks!(tmp, C, A); C.data = tmp.data; end; return C))
    @generated f_blas_marray(n::Integer, A) = :(@inbounds (C = similar(A); C[:] = A[:]; tmp = similar(A); for i = 1:n; StaticArrays.A_mul_B_blas!(tmp, C, A); C.data = tmp.data; end; return C))

    @generated g(n::Integer, A) = :(@inbounds (C = A; for i = 1:n; C = C + A; end; return C))
    @generated g_mut(n::Integer, A) = :(@inbounds (C = copy(A); for i = 1:n; @inbounds map!(+, C, C, A); end; return C))
    @generated g_via_sarray(n::Integer, A::MMatrix{M,M}) where {M} = :(@inbounds (C = similar(A); C[:] = A[:]; for i = 1:n; C = MMatrix{M,M}(SMatrix{M,M}(C) + SMatrix{M,M}(A)); end; return C))

    @noinline _det(x) = det(x)
    @noinline _inv(x) = inv(x)
    @noinline _eig(x) = eig(x)
    @noinline _chol(x) = chol(x)

    f_det(n::Int, A) = (for i = 1:n; _det(A); end)
    f_inv(n::Int, A) = (for i = 1:n; _inv(A); end)
    f_eig(n::Int, A) = (for i = 1:n; _eig(A); end)
    f_chol(n::Int, A) = (for i = 1:n; _chol(A); end)

    # Notes: - A[:] = B[:] is allocating in Base, unlike `map!`
    #        - Also, the same goes for Base's implementation of broadcast!(f, A, B, C) (but map! is OK).
    #        - I really need to implement copy() in StaticArrays... (and maybe a special instance of setindex!(C, :))
    #        - I tried generated functions here to see if they force the compiler to specialize more.

end

# Test and compile f()

C = f(2, A)
C_mut = f_mut_array(2, A)
if N <= 4;  @assert C_mut ≈ C; end

println("=====================================")
println("    Benchmarks for $N×$N matrices")
println("=====================================")
@static if all_methods
    print("SMatrix * SMatrix compilation time (unrolled):         ")
    @time eval(quote
        Cs_unrolled = f_unrolled(2, As)
        Cs_unrolled::SMatrix
        if N <= 4; @assert Cs_unrolled ≈ C; end
    end)

    print("SMatrix * SMatrix compilation time (chunks):           ")
    @time eval(quote
        Cs_chunks = f_unrolled_chunks(2, As)
        Cs_chunks::SMatrix
        if N <= 4; @assert Cs_chunks ≈ C; end
    end)

    print("SMatrix * SMatrix compilation time (loop):           ")
    @time eval(quote
        Cs_loop = f_loop(2, As)
        Cs_loop::SMatrix
        if N <= 4; @assert Cs_loop ≈ C; end
    end)

    print("MMatrix * MMatrix compilation time (unrolled):         ")
    @time eval(quote
        Cm_unrolled = f_unrolled(2, Am)
        Cm_unrolled::MMatrix
        if N <= 4; @assert Cm_unrolled ≈ C; end
    end)

    print("MMatrix * MMatrix compilation time (chunks):           ")
    @time eval(quote
        Cm_chunks = f_unrolled_chunks(2, Am)
        Cm_chunks::MMatrix
        if N <= 4; @assert Cm_chunks ≈ C; end
    end)

    print("MMatrix * MMatrix compilation time (loop):           ")
    @time eval(quote
        Cm_loop = f_loop(2, Am)
        Cm_loop::MMatrix
        if N <= 4; @assert Cm_loop ≈ C; end
    end)

    Cm_via_sarray = f_via_sarray(2, Am)
    Cm_via_sarray::MMatrix
    if N <= 4; @assert Cm_via_sarray ≈ C; end
else
    #Cs_unrolled = f_unrolled(2, As)
    #Cs_unrolled::SMatrix
    #if N <= 4; @assert Cs_unrolled ≈ C; end

    #Cs_chunks = f_unrolled_chunks(2, As)
    #Cs_chunks::SMatrix
    #if N <= 4; @assert Cs_chunks ≈ C; end

    #Cm_unrolled = f_unrolled(2, Am)
    #Cm_unrolled::MMatrix
    #if N <= 4; @assert Cm_unrolled ≈ C; end

    #Cm_chunks = f_unrolled_chunks(2, Am)
    #Cm_chunks::MMatrix
    #if N <= 4; @assert Cm_chunks ≈ C; end
end

# Warmup and some checks
Cs = f(2, As)
Cm = f(2, Am)
Cz = f(2, Az)

Cs::SMatrix
if N <= 4; @assert Cs ≈ C; end
Cm::MMatrix
if N <= 4; @assert Cm ≈ C; end
Cz::SizedMatrix
if N <= 4; @assert Cz ≈ C; end

@static if fsa
    @static if all_methods
        print("Mat * Mat compilation time:                            ")
        @time eval(quote
            Cf = f(2, Af)
            Cf::Mat
            if N <= 4; @assert Cf == C; end
        end)
    else
        Cf = f(2, Af)
        Cf::Mat
        if N <= 4; @assert Cf == C; end
    end
end

# Mutating versions

Cm_mut = f_mut_marray(2, Am)
Cm_mut::MMatrix
if N <= 4; @assert Cm_mut ≈ C; end

Cz_mut = f_mut_array(2, Az)
Cz_mut::SizedMatrix
if N <= 4; @assert Cz_mut ≈ C; end

@static if all_methods
    println()
    print("A_mul_B!(MMatrix, MMatrix) compilation time (unrolled):")
    @time eval(quote
        Cm_mut_unrolled = f_mut_unrolled(2, Am)
        Cm_mut_unrolled::MMatrix
        if N <= 4; @assert Cm_mut_unrolled ≈ C; end
    end)

    print("A_mul_B!(MMatrix, MMatrix) compilation time (chunks):  ")
    @time eval(quote
        Cm_mut_chunks = f_mut_chunks(2, Am)
        Cm_mut_chunks::MMatrix
        if N <= 4; @assert Cm_mut_chunks ≈ C; end
    end)

    print("A_mul_B!(MMatrix, MMatrix) compilation time (BLAS):    ")
    @time eval(quote
        Cm_blas = f_blas_marray(2, Am)
        Cm_blas::MMatrix
        if N <= 4; @assert Cm_blas ≈ C; end
    end)
else
    #Cm_mut_unrolled = f_mut_marray(2, Am)
    #Cm_mut_unrolled::MMatrix
    #if N <= 4; @assert Cm_mut_unrolled ≈ C; end

    #Cm_mut_chunks = f_mut_chunks(2, Am)
    #Cm_mut_chunks::MMatrix
    #if N <= 4; @assert Cm_mut_chunks ≈ C; end

    #Cm_blas = f_blas_marray(2, Am)
    #Cm_blas::MMatrix
    #if N <= 4; @assert Cm_blas ≈ C; end
end


# Test and compile g()

C = g(2, A)
C_mut = g_mut(2, A)

if N <= 4; @assert C_mut ≈ C; end

Cs = g(2, As)
Cm = g(2, Am)
Cm_mut = g_mut(2, Am)
Cz = g(2, Az)
Cz_mut = g_mut(2, Az)

Cs::SMatrix
if N <= 4; @assert Cs == C; end
Cm::MMatrix
if N <= 4; @assert Cm == C; end
Cm_mut::MMatrix
if N <= 4; @assert Cm_mut == C; end
Cz::SizedMatrix
if N <= 4; @assert Cz == C; end
Cz_mut::SizedMatrix
if N <= 4; @assert Cz_mut == C; end

@static if all_methods
    Cm_via_sarray = g_via_sarray(2, Am)
    Cm_via_sarray::MMatrix
    if N <= 4; @assert Cm_via_sarray == C; end
end

@static if fsa
    Cf = g(2, Af)
    Cf::Mat
    if N <= 4; @assert Cf == C; end
end

if N <= 3
    # det, eig etc
    C = f_det(2, A)
    Cs = f_det(2, As)
    Cm = f_det(2, Am)
    Cz = f_det(2, Az)

    C = f_inv(2, A)
    Cs = f_inv(2, As)
    Cm = f_inv(2, Am)
    Cz = f_inv(2, Az)

    C = f_eig(2, Symmetric(A))
    Cs = f_eig(2, Symmetric(As))
    Cm = f_eig(2, Symmetric(Am))
    Cz = f_eig(2, Symmetric(Az))

    C = f_chol(2, Symmetric(A))
    Cs = f_chol(2, Symmetric(As))
    Cm = f_chol(2, Symmetric(Am))
    Cz = f_chol(2, Symmetric(Az))
end

println()

# Do the performance tests

println("Matrix multiplication")
println("---------------------")
begin
   print("Array               ->"); @time f(M_f, A)
   @static if fsa
       print("Mat                 ->"); @time f(M_f, Af)
   end
   print("SArray              ->"); @time f(M_f, As)
   print("MArray              ->"); @time f(M_f, Am)
   print("SizedArray          ->"); @time f(M_f, Az)
   @static if all_methods
       print("SArray (unrolled)   ->"); @time f_unrolled(M_f, As)
       print("SArray (chunks)     ->"); @time f_unrolled_chunks(M_f, As)
       print("SArray (loop)       ->"); @time f_loop(M_f, As)
       print("MArray (unrolled)   ->"); @time f_unrolled(M_f, Am)
       print("MArray (chunks)     ->"); @time f_unrolled_chunks(M_f, Am)
       print("MArray (loop)       ->"); @time f_loop(M_f, Am)
       print("MArray (via SArray) ->"); @time f_via_sarray(M_f, Am)
   end
end
println()

println("Matrix multiplication (mutating)")
println("--------------------------------")
begin
   print("Array               ->"); @time f_mut_array(M_f, A)
   print("MArray              ->"); @time f_mut_marray(M_f, Am)
   print("SizedArray          ->"); @time f_mut_array(M_f, Az)
   @static if all_methods
       print("MArray (unrolled)   ->"); @time f_mut_unrolled(M_f, Am)
       print("MArray (chunks)     ->"); @time f_mut_chunks(M_f, Am)
       print("MArray (BLAS gemm!) ->"); @time f_blas_marray(M_f, Am)
   end
end
println()

println("Matrix addition")
println("---------------")
begin
   print("Array               ->"); @time g(M_g, A)
   @static if fsa
       print("Mat                 ->"); @time g(M_g, Af)
   end
   print("SArray              ->"); @time g(M_g, As)
   print("MArray              ->"); @time g(M_g, Am)
   print("SizedArray          ->"); @time g(M_g, Az)
   @static if all_methods
       print("MArray (via SArray) ->"); @time g_via_sarray(M_g, Am)
   end
end
println()

println("Matrix addition (mutating)")
println("--------------------------")
begin
   print("Array      ->"); @time g_mut(M_g, A) # broadcast! seems to be broken!
   print("MArray     ->"); @time g_mut(M_g, Am)
   print("SizedArray ->"); @time g_mut(M_g, Az)
end
println()

if N <= 3
    println("Matrix determinant")
    println("------------------")
    begin
       print("Array      ->"); @time f_det(M_f, A)
       print("SArray     ->"); @time f_det(M_f, As)
       print("MArray     ->"); @time f_det(M_f, Am)
       print("SizedArray ->"); @time f_det(M_f, Az)
    end
    println()

    println("Matrix inverse")
    println("--------------")
    begin
       print("Array      ->"); @time f_inv(M_f, A)
       print("SArray     ->"); @time f_inv(M_f, As)
       print("MArray     ->"); @time f_inv(M_f, Am)
       print("SizedArray ->"); @time f_inv(M_f, Az)
    end
    println()

    println("Matrix symmetric eigenvalue")
    println("---------------------------")
    begin
       print("Array      ->"); @time f_eig(M_f, Symmetric(A))
       print("SArray     ->"); @time f_eig(M_f, Symmetric(As))
       print("MArray     ->"); @time f_eig(M_f, Symmetric(Am))
       print("SizedArray ->"); @time f_eig(M_f, Symmetric(Az))
    end
    println()

    println("Matrix Cholesky")
    println("---------------")
    begin
       print("Array      ->"); @time f_chol(M_f, Symmetric(A))
       print("SArray     ->"); @time f_chol(M_f, Symmetric(As))
       print("MArray     ->"); @time f_chol(M_f, Symmetric(Am))
       print("SizedArray ->"); @time f_chol(M_f, Symmetric(Az))
    end
    println()
end #if N <= 3

using StaticArrays, Test, LinearAlgebra
using LinearAlgebra: PosDefException

@testset "Cholesky decomposition" begin
    for elty in [Float32, Float64, ComplexF64]
        @testset "1×1" begin
            m = @SMatrix [4.0]
            (c,) = cholesky(m).U
            @test c === 2.0
        end

        @testset "2×2" for i = 1:100
            m_a = randn(elty, 2,2)
            #non hermitian
            @test_throws PosDefException cholesky(SMatrix{2,2}(m_a))
            m_a = m_a*m_a'
            m = SMatrix{2,2}(m_a)
            @test cholesky(Hermitian(m)).U ≈ cholesky(m_a).U
            @test cholesky(Hermitian(m)).L ≈ cholesky(m_a).L
        end

        @testset "3×3" for i = 1:100
            m_a = randn(elty, 3,3)
            #non hermitian
            @test_throws PosDefException cholesky(SMatrix{3,3}(m_a))
            m_a = m_a*m_a'
            m = SMatrix{3,3}(m_a)
            @test cholesky(m).U ≈ cholesky(m_a).U
            @test cholesky(m).L ≈ cholesky(m_a).L
            @test cholesky(Hermitian(m)).U ≈ cholesky(m_a).U
            @test cholesky(Hermitian(m)).L ≈ cholesky(m_a).L
        end
        @testset "4×4" for i = 1:100
            m_a = randn(elty, 4,4)
            #non hermitian
            @test_throws PosDefException cholesky(SMatrix{4,4}(m_a))
            
            m_a = m_a*m_a'
            m = SMatrix{4,4}(m_a)
            @test cholesky(m).L ≈ cholesky(m_a).L
            @test cholesky(m).U ≈ cholesky(m_a).U
            @test cholesky(Hermitian(m)).L ≈ cholesky(m_a).L
            @test cholesky(Hermitian(m)).U ≈ cholesky(m_a).U
        end

        @testset "large (25x25)" begin
            m_a = randn(elty, 25, 25)
            m_a = m_a*m_a'
            m = SMatrix{25,25}(m_a)
            @test cholesky(m).L ≈ cholesky(m_a).L
        end

        @testset "Inverse" begin
            m_a = randn(elty, 3, 3)
            m_a = m_a*m_a'
            m = SMatrix{3,3}(m_a)
            c = cholesky(m)
            @test (@inferred inv(c)) isa SMatrix{3,3,elty}
            @test inv(c) ≈ SMatrix{3,3}(inv(m_a))
            # Check special case of 2 × 2 inverse that used to trigger an
            # error
            c2 = cholesky(@SMatrix elty[π 3.1; 3.1 12.0])
            d2 = inv(c2)
            @test d2[1,2] == d2[2,1]
        end

        @testset "Division" begin
            m_a = randn(elty, 3, 3)
            m_a = m_a*m_a'
            m = SMatrix{3,3}(m_a)
            c = cholesky(m)
            c_a = cholesky(m_a)
            
            d_a = randn(elty, 3, 3)
            d = SMatrix{3,3}(d_a)

            @test (@inferred c \ d) isa SMatrix{3,3,elty}
            @test c \ d ≈ c_a \ d_a
            @test (@inferred c \ Symmetric(d)) isa SMatrix{3,3,elty}
            @test c \ Symmetric(d) ≈ c_a \ Symmetric(d_a)

            @test (@inferred d / c) isa SMatrix{3,3,elty}
            @test d / c ≈ d_a / c_a
            @test (@inferred Symmetric(d) / c) isa SMatrix{3,3,elty}
            @test Symmetric(d) / c ≈ Symmetric(d_a) / c_a

            v_a = randn(elty, 3)
            v = SVector{3}(v_a)
            @test (@inferred c \ v) isa SVector{3,elty}
            @test c \ v ≈ c_a \ v_a
        end

        @testset "Check" begin
            for i ∈ [1,3,7,25]
                x = SVector(ntuple(elty, i))
                nonpd = x * x'
                if i > 1
                    @test_throws PosDefException cholesky(nonpd)
                    @test !issuccess(cholesky(nonpd,check=false))
                    @test_throws PosDefException cholesky(Hermitian(nonpd))
                    @test !issuccess(cholesky(Hermitian(nonpd),check=false))
                else
                    @test issuccess(cholesky(Hermitian(nonpd),check=false))
                end
            end
        end
    end

    @testset "static blockmatrix" for i = 1:10
        m_a = randn(3,3)
        m_a = m_a*m_a'
        m = SMatrix{3,3}(m_a)
        @test_broken cholesky(reshape([m, 0m, 0m, m], 2, 2)) ==
            reshape([chol(m), 0m, 0m, chol(m)], 2, 2)
    end
end

# This file contains funtions that uses a direct interface to BLAS library. We use this
# approach to reduce allocations.

import LinearAlgebra: BLAS, LAPACK, libblastrampoline

# == Singular Value Decomposition ==========================================================

# Implement direct call to BLAS functions that computes the SVD values for `SMatrix` and
# `MMatrix` reducing allocations. In this case, we use `MMatrix` to call the library and
# convert the result back to the input type. Since the former does not exit this scope, we
# can reduce allocations.
#
# We are implementing here the following functions:
#
#   svdvals(A::SMatrix{M, N, Float64}) where {M, N}
#   svdvals(A::SMatrix{M, N, Float32}) where {M, N}
#   svdvals(A::MMatrix{M, N, Float64}) where {M, N}
#   svdvals(A::MMatrix{M, N, Float32}) where {M, N}
#
for (gesdd, elty) in ((:dgesdd_, :Float64), (:sgesdd_, :Float32)),
    (mtype, vtype) in ((SMatrix, SVector), (MMatrix, MVector))

    blas_func = @eval BLAS.@blasfunc($gesdd)

    @eval begin
        function svdvals(A::$mtype{M, N, $elty}) where {M, N}
            K = min(M, N)

            # Convert the input to a `MMatrix` and allocate the required arrays.
            Am    = MMatrix{M, N, $elty}(A)
            Sm    = MVector{K, $elty}(undef)

            # We compute the `lwork` (size of the work array) by obtaining the maximum value
            # from the possibilities shown in:
            #   https://docs.oracle.com/cd/E19422-01/819-3691/dgesdd.html
            lwork = max(8N, 3N + max(M, 7N), 8M, 3M + max(N, 7M))
            work  = MVector{lwork, $elty}(undef)
            iwork = MVector{8min(M, N), BLAS.BlasInt}(undef)
            info  = Ref(1)

            @ccall libblastrampoline.$blas_func(
                'N'::Ref{UInt8},
                M::Ref{BLAS.BlasInt},
                N::Ref{BLAS.BlasInt},
                Am::Ptr{$elty},
                M::Ref{BLAS.BlasInt},
                Sm::Ptr{$elty},
                C_NULL::Ptr{C_NULL},
                M::Ref{BLAS.BlasInt},
                C_NULL::Ptr{C_NULL},
                K::Ref{BLAS.BlasInt},
                work::Ptr{$elty},
                lwork::Ref{BLAS.BlasInt},
                iwork::Ptr{BLAS.BlasInt},
                info::Ptr{BLAS.BlasInt},
                1::Clong
            )::Cvoid

            # Check if the return result of the function.
            LAPACK.chklapackerror(info.x)

            # Convert the vector to static arrays and return.
            S = $vtype{K, $elty}(Sm)

            return S
        end
    end
end

# For matrices with interger numbers, we should promote them to float and call `svdvals`.
@inline svdvals(A::StaticMatrix{<: Any, <: Any, <: Integer}) = svdvals(float(A))

# Implement direct call to BLAS functions that computes the SVD for `SMatrix` and `MMatrix`
# reducing allocations. In this case, we use `MMatrix` to call the library and convert the
# result back to the input type. Since the former does not exit this scope, we can reduce
# allocations.
#
# We are implementing here the following functions:
#
#   _svd(A::SMatrix{M, N, Float64}, full::Val{false}) where {M, N}
#   _svd(A::SMatrix{M, N, Float64}, full::Val{true})  where {M, N}
#   _svd(A::SMatrix{M, N, Float32}, full::Val{false}) where {M, N}
#   _svd(A::SMatrix{M, N, Float32}, full::Val{true})  where {M, N}
#   _svd(A::MMatrix{M, N, Float64}, full::Val{false}) where {M, N}
#   _svd(A::MMatrix{M, N, Float64}, full::Val{true})  where {M, N}
#   _svd(A::MMatrix{M, N, Float32}, full::Val{false}) where {M, N}
#   _svd(A::MMatrix{M, N, Float32}, full::Val{true})  where {M, N}
#
for (gesvd, elty) in ((:dgesvd_, :Float64), (:sgesvd_, :Float32)),
    full in (false, true),
    (mtype, vtype) in ((SMatrix, SVector), (MMatrix, MVector))

    blas_func = @eval BLAS.@blasfunc($gesvd)

    @eval begin
        function _svd(A::$mtype{M, N, $elty}, full::Val{$full}) where {M, N}
            K = min(M, N)

            # Convert the input to a `MMatrix` and allocate the required arrays.
            Am    = MMatrix{M, N, $elty}(A)
            Um    = MMatrix{M, $(full ? :M : :K), $elty}(undef)
            Sm    = MVector{K, $elty}(undef)
            Vtm   = MMatrix{$(full ? :N : :K), N, $elty}(undef)
            lwork = max(3min(M, N) + max(M, N), 5min(M, N))
            work  = MVector{lwork, $elty}(undef)
            info  = Ref(1)

            @ccall libblastrampoline.$blas_func(
                $(full ? 'A' : 'S')::Ref{UInt8},
                $(full ? 'A' : 'S')::Ref{UInt8},
                M::Ref{BLAS.BlasInt},
                N::Ref{BLAS.BlasInt},
                Am::Ptr{$elty},
                M::Ref{BLAS.BlasInt},
                Sm::Ptr{$elty},
                Um::Ptr{$elty},
                M::Ref{BLAS.BlasInt},
                Vtm::Ptr{$elty},
                $(full ? :N : :K)::Ref{BLAS.BlasInt},
                work::Ptr{$elty},
                lwork::Ref{BLAS.BlasInt},
                info::Ptr{BLAS.BlasInt},
                1::Clong,
                1::Clong
            )::Cvoid

            # Check if the return result of the function.
            LAPACK.chklapackerror(info.x)

            # Convert the matrices to the correct type and return.
            U  = $mtype{M, $(full ? :M : :K), $elty}(Um)
            S  = $vtype{K, $elty}(Sm)
            Vt = $mtype{$(full ? :N : :K), N, $elty}(Vtm)

            return SVD(U, S, Vt)
        end
    end
end

# For matrices with interger numbers, we should promote them to float and call `svd`.
@inline svd(A::StaticMatrix{<: Any, <: Any, <: Integer}) = svd(float(A))

using StaticArrays, Test

import StaticArrays: drop_sdims

@testset "util" begin
    @test !(drop_sdims(SVector(1,2)) isa StaticArray)
    @test !(drop_sdims([1,2]) isa StaticArray)
    @test !(drop_sdims(SizedVector{2}([1,2])) isa StaticArray)

    @test drop_sdims(SVector(1,2)) == SVector(1,2)
    @test drop_sdims(@SMatrix [1 2; 3 4]) == [1 2; 3 4]
    # Check this works for SizedArray where it's tempting to *unwrap* rather
    # than add an extra wrapper.  Currently unwrapping doesn't work due to
    # reshaping issues.
    @test drop_sdims(SizedMatrix{2,2}([1 2; 3 4])) == [1 2; 3 4]
    @test drop_sdims(SizedMatrix{2,3}([1 4;
                                       2 5;
                                       3 6])) == [1 3 5;
                                                  2 4 6]
end

using StaticArrays, Test, LinearAlgebra

@testset "LU" begin

@testset "LU utils" begin
    F = lu(SA[1 2; 3 4])

    @test @inferred((F->F.p)(F)) === SA[2, 1]
    @test @inferred((F->F.P)(F)) === SA[0 1; 1 0]

    @test occursin(r"^StaticArrays.LU.*L factor.*U factor"s, sprint(show, MIME("text/plain"), F))
end

@testset "LU decomposition ($m×$n, pivot=$pivot, wrapper=$wrapper)" for pivot in (true, false), m in [0:4..., 15], n in [0:4..., 15], wrapper in [identity, Symmetric, Hermitian]

    a = if m == n && m > 0
        wrapper(SMatrix{m,n,Int}(1:(m*n)))
    elseif wrapper !== identity
        continue
    else
        SMatrix{m,n,Int}(1:(m*n))
    end
    l, u, p = @inferred(lu(a, Val{pivot}(); check = false))

    # expected types
    @test p isa SVector{m,Int}
    if m==n
        @test l isa LowerTriangular{<:Any,<:SMatrix{m,n}}
        @test u isa UpperTriangular{<:Any,<:SMatrix{m,n}}
    else
        @test l isa SMatrix{m,min(m,n)}
        @test u isa SMatrix{min(m,n),n}
    end

    if pivot
        # p is a permutation
        @test sort(p) == collect(1:m)
    else
        @test p == collect(1:m)
    end

    # l is unit lower triangular
    for i=1:m, j=(i+1):size(l,2)
        @test iszero(l[i,j])
    end
    for i=1:size(l,2)
        @test l[i,i] == 1
    end

    # u is upper triangular
    for i=1:size(u,1), j=1:i-1
        @test iszero(u[i,j])
    end

    # decomposition is correct
    l_u = l*u
    @test l*u ≈ a[p,:]

end

@testset "LU division ($m×$n)" for m in [1:4..., 15], n in [1:4..., 15]
    a = SMatrix{m,m,Float64}(rand(Float64,m,m))
    a_lu = lu(a)
    b_col = SMatrix{m,n,Float64}(rand(Float64,m,n))
    b_line = SMatrix{n,m,Float64}(rand(Float64,n,m))

    # test if / and \ work with lu:
    @test a\b_col ≈ a_lu\b_col
    @test b_line/a ≈ b_line/a_lu
end

@testset "LU singularity check" for m in [2, 3, 20], n in [2, 3, 20]
    # NOTE: large dimensions test fallback to LinearAlgebra.lu
    A = ones(SMatrix{m,n})
    @test_throws SingularException lu(A)
    @test !issuccess(lu(A; check = false))
end

@testset "LU method ambiguity" begin
    # Issue #920; just test that methods do not throw an ambiguity error when called
    for A in ((@SMatrix [1.0 2.0; 3.0 4.0]), (@SMatrix [1.0 2.0 3.0; 4.0 5.0 6.0]))
        @test isa(lu(A),              StaticArrays.LU)
        @test isa(lu(A, Val(true)),   StaticArrays.LU)
        @test isa(lu(A, Val(false)),  StaticArrays.LU)
        @test isa(lu(A; check=false), StaticArrays.LU)
        @test isa(lu(A; check=true),  StaticArrays.LU)
    end
end

if isdefined(LinearAlgebra, :PivotingStrategy)
    for N = (3, 15)
        A = (@SMatrix randn(N,N))
        @test lu(A, Val(false)) == lu(A, NoPivot())
        @test lu(A, Val(true)) == lu(A, RowMaximum())
    end
end

end # @testset "LU"

@inline sqrt(A::StaticMatrix) = _sqrt(Size(A),A)

@inline function _sqrt(::Size{(0,0)}, A::SA) where {SA<:StaticArray}
    similar_type(A,typeof(sqrt(zero(eltype(A)))))()
end

@inline function _sqrt(::Size{(1,1)}, A::SA) where {SA<:StaticArray}
    s = sqrt(A[1,1])
    similar_type(SA,typeof(s))(s)
end

@inline function _sqrt(::Size{(2,2)}, A::SA) where {SA<:StaticArray}
    a,b,c,d = A
    if a==b==c==d==0
        zero(A)
    else
        s = sqrt(a*d-b*c)
        t = inv(sqrt(a+d+2s))
        similar_type(SA,typeof(t))(t*(a+s), t*b, t*c, t*(d+s))
    end
end

@inline _sqrt(::Size{S}, A::StaticArray) where {S} = SizedArray{Tuple{S...}}(sqrt(Array(A)))

#####################
## SVector methods ##
#####################

# Converting a CartesianIndex to an SVector
convert(::Type{SVector}, I::CartesianIndex) = SVector(I.I)
convert(::Type{SVector{N}}, I::CartesianIndex{N}) where {N} = SVector{N}(I.I)
convert(::Type{SVector{N,T}}, I::CartesianIndex{N}) where {N,T} = SVector{N,T}(I.I)

Base.promote_rule(::Type{SVector{N,T}}, ::Type{CartesianIndex{N}}) where {N,T} = SVector{N,promote_type(T,Int)}

function check_vector_length(x::Tuple, T = :S)
    if length(x) > 1
        all(isone, Base.tail(x)) || error("Bad input for @$(T)Vector, must be vector like")
    end
    length(x) >= 1 ? x[1] : 1
end

# @SVector rand(...)
@inline _rand_with_Val(::Type{SV}, rng::AbstractRNG, ::Val{n}) where {SV, n} = rand(rng, SV{n})
@inline _rand_with_Val(::Type{SV}, T::DataType,      ::Val{n}) where {SV, n} = _rand(Random.GLOBAL_RNG, T, Size(n), SV{n, T})
@inline _rand_with_Val(::Type{SV}, sampler,          ::Val{n}) where {SV, n} = _rand(Random.GLOBAL_RNG, sampler, Size(n), SV{n, Random.gentype(sampler)})
@inline _rand_with_Val(::Type{SV}, rng::AbstractRNG, T::DataType, ::Val{n}) where {SV, n} = rand(rng, SV{n, T})
@inline _rand_with_Val(::Type{SV}, rng::AbstractRNG, sampler,     ::Val{n}) where {SV, n} = _rand(rng, sampler, Size(n), SV{n, Random.gentype(sampler)})
# @SVector randn(...)
@inline _randn_with_Val(::Type{SV}, rng::AbstractRNG, ::Val{n}) where {SV, n} = randn(rng, SV{n})
@inline _randn_with_Val(::Type{SV}, T::DataType,      ::Val{n}) where {SV, n} = _randn(Random.GLOBAL_RNG, Size(n), SV{n, T})
@inline _randn_with_Val(::Type{SV}, rng::AbstractRNG, T::DataType, ::Val{n}) where {SV, n} = randn(rng, SV{n, T})
# @SVector randexp(...)
@inline _randexp_with_Val(::Type{SV}, rng::AbstractRNG, ::Val{n}) where {SV, n} = randexp(rng, SV{n})
@inline _randexp_with_Val(::Type{SV}, T::DataType,      ::Val{n}) where {SV, n} = _randexp(Random.GLOBAL_RNG, Size(n), SV{n, T})
@inline _randexp_with_Val(::Type{SV}, rng::AbstractRNG, T::DataType, ::Val{n}) where {SV, n} = randexp(rng, SV{n, T})

function static_vector_gen(::Type{SV}, @nospecialize(ex), mod::Module) where {SV}
    if !isa(ex, Expr)
        error("Bad input for @$SV")
    end
    head = ex.head
    if head === :vect
        return :($SV{$(length(ex.args))}($tuple($(escall(ex.args)...))))
    elseif head === :ref
        return :($SV{$(length(ex.args)-1),$(esc(ex.args[1]))}($tuple($(escall(ex.args[2:end])...))))
    elseif head === :typed_vcat || head === :typed_hcat || head === :typed_ncat # typed, cat
        args = parse_cat_ast(ex)
        len = check_vector_length(size(args))
        return :($SV{$len,$(esc(ex.args[1]))}($tuple($(escall(args)...))))
    elseif head === :vcat || head === :hcat || head === :ncat # untyped, cat
        args = parse_cat_ast(ex)
        len = check_vector_length(size(args))
        return :($SV{$len}($tuple($(escall(args)...))))
    elseif head === :comprehension
        if length(ex.args) != 1
            error("Expected generator in comprehension, e.g. [f(i) for i = 1:3]")
        end
        ex = ex.args[1]
        if !isa(ex, Expr) || (ex::Expr).head != :generator
            error("Expected generator in comprehension, e.g. [f(i) for i = 1:3]")
        end
        if length(ex.args) != 2
            error("Use a one-dimensional comprehension for @$SV")
        end
        rng = Core.eval(mod, ex.args[2].args[2])
        exprs = (:(f($j)) for j in rng)
        return quote
            let
                f($(esc(ex.args[2].args[1]))) = $(esc(ex.args[1]))
                $SV{$(length(rng))}($tuple($(exprs...)))
            end
        end
    elseif head === :typed_comprehension
        if length(ex.args) != 2
            error("Expected generator in typed comprehension, e.g. Float64[f(i) for i = 1:3]")
        end
        T = esc(ex.args[1])
        ex = ex.args[2]
        if !isa(ex, Expr) || (ex::Expr).head != :generator
            error("Expected generator in typed comprehension, e.g. Float64[f(i) for i = 1:3]")
        end
        if length(ex.args) != 2
            error("Use a one-dimensional comprehension for @$SV")
        end
        rng = Core.eval(mod, ex.args[2].args[2])
        exprs = (:(f($j)) for j in rng)
        return quote
            let 
                f($(esc(ex.args[2].args[1]))) = $(esc(ex.args[1]))
                $SV{$(length(rng)),$T}($tuple($(exprs...)))
            end
        end
    elseif head === :call
        f = ex.args[1]
        fargs = ex.args[2:end]
        if f === :zeros || f === :ones
            if length(fargs) == 1
                # for calls like `zeros(dim)`
                return :($f($SV{$(esc(fargs[1]))}))
            elseif length(fargs) == 2
                # for calls like `zeros(type, dim)`
                return :($f($SV{$(esc(fargs[2])), $(esc(fargs[1]))}))
            else
                error("@$SV got bad expression: $(ex)")
            end
        elseif f === :fill
            # for calls like `fill(value, dim)`
            if length(fargs) == 2
                return :($f($(esc(fargs[1])), $SV{$(esc(fargs[2]))}))
            else
                error("@$SV expected a 1-dimensional array expression")
            end
        elseif f === :rand || f === :randn || f === :randexp
            _f_with_Val = Symbol(:_, f, :_with_Val)
            if length(fargs) == 1
                # for calls like `rand(dim)`
                # for calls like `randn(dim)`
                # for calls like `randexp(dim)`
                return :($f($SV{$(escall(fargs)...)}))
            elseif length(fargs) == 2
                # for calls like `rand(rng, dim)`
                # for calls like `rand(type, dim)`
                # for calls like `rand(sampler, dim)`
                # for calls like `randn(rng, dim)`
                # for calls like `randn(type, dim)`
                # for calls like `randexp(rng, dim)`
                # for calls like `randexp(type, dim)`
                return :($_f_with_Val($SV, $(esc(fargs[1])), Val($(esc(fargs[2])))))
            elseif length(fargs) == 3
                # for calls like `rand(rng, type, dim)`
                # for calls like `rand(rng, sampler, dim)`
                # for calls like `randn(rng, type, dim)`
                # for calls like `randexp(rng, type, dim)`
                return :($_f_with_Val($SV, $(esc(fargs[1])), $(esc(fargs[2])), Val($(esc(fargs[3])))))
            else
                error("@$SV got bad expression: $(ex)")
            end
        else
            error("@$SV only supports the zeros(), ones(), fill(), rand(), randn(), and randexp() functions.")
        end
    else
        error("Use @$SV [a,b,c], @$SV Type[a,b,c] or a comprehension like @$SV [f(i) for i = i_min:i_max]")
    end
end

"""
    @SVector [a, b, c, d]
    @SVector [i for i in 1:2]
    @SVector ones(2)

A convenience macro to construct `SVector`.
See [`@SArray`](@ref) for detailed features.
"""
macro SVector(ex)
    static_vector_gen(SVector, ex, __module__)
end

"""
    SA[ elements ]
    SA{T}[ elements ]

Create `SArray` literals using array construction syntax. The element type is
inferred by promoting `elements` to a common type or set to `T` when `T` is
provided explicitly.

# Examples:

* `SA[1.0, 2.0]` creates a length-2 `SVector` of `Float64` elements.
* `SA[1 2; 3 4]` creates a 2×2 `SMatrix` of `Int`s.
* `SA[1 2]` creates a 1×2 `SMatrix` of `Int`s.
* `SA{Float32}[1, 2]` creates a length-2 `SVector` of `Float32` elements.

A couple of helpful type aliases are also provided:

* `SA_F64[1, 2]` creates a length-2 `SVector` of `Float64` elements
* `SA_F32[1, 2]` creates a length-2 `SVector` of `Float32` elements
"""
struct SA{T} ; end

const SA_F32 = SA{Float32}
const SA_F64 = SA{Float64}

@inline similar_type(::Type{SA}, ::Size{S}) where {S} = SArray{Tuple{S...}}
@inline similar_type(::Type{SA{T}}, ::Size{S}) where {T,S} = SArray{Tuple{S...}, T}

# These definitions are duplicated to avoid matching `sa === Union{}` in the
# neater-looking alternative `sa::Type{<:SA}`.
@inline Base.getindex(sa::Type{SA}, xs...)            = similar_type(sa, Size(length(xs)))(xs)
@inline Base.getindex(sa::Type{SA{T}}, xs...) where T = similar_type(sa, Size(length(xs)))(xs)

@inline Base.typed_vcat(sa::Type{SA}, xs::Number...)            = similar_type(sa, Size(length(xs)))(xs)
@inline Base.typed_vcat(sa::Type{SA{T}}, xs::Number...) where T = similar_type(sa, Size(length(xs)))(xs)

@inline Base.typed_hcat(sa::Type{SA}, xs::Number...)            = similar_type(sa, Size(1,length(xs)))(xs)
@inline Base.typed_hcat(sa::Type{SA{T}}, xs::Number...) where T = similar_type(sa, Size(1,length(xs)))(xs)

Base.@pure function _SA_hvcat_transposed_size(rows)
    M = rows[1]
    if any(r->r != M, rows)
        # @pure may not throw... probably. See
        # https://discourse.julialang.org/t/can-pure-functions-throw-an-error/18459
        return nothing
    end
    Size(M, length(rows))
end

@inline function _SA_typed_hvcat(sa, rows, xs)
    msize = _SA_hvcat_transposed_size(rows)
    if msize === nothing
        throw(ArgumentError("SA[...] matrix rows of length $rows are inconsistent"))
    end
    # hvcat lowering is row major ordering, so we must transpose
    transpose(similar_type(sa, msize)(xs))
end

@inline Base.typed_hvcat(sa::Type{SA}, rows::Dims, xs::Number...)            = _SA_typed_hvcat(sa, rows, xs)
@inline Base.typed_hvcat(sa::Type{SA{T}}, rows::Dims, xs::Number...) where T = _SA_typed_hvcat(sa, rows, xs)

if VERSION >= v"1.7"
@generated function reorder(x::NTuple{M,Any}, ::Val{N1}, ::Val{N2}) where {M,N1,N2}
    a = Base.PermutedDimsArray(reshape(1:M, N1, N2, :), (2, 1, 3))
    args = (:(x[$i]) for i in a)
    return :(tuple($(args...)))
end
    
@inline function _SA_typed_hvncat(sa, dimsshape, row_first, xs)
    msize = Size(dimsshape)
    xs′ = row_first ? reorder(xs, Val(msize[1]), Val(msize[2])) : xs
    x = similar_type(sa, msize)(xs′)
end

@inline Base.typed_hvncat(sa::Type{SA}, dimsshape::Dims, row_first::Bool, xs::Number...) = _SA_typed_hvncat(sa, dimsshape, row_first, xs)
@inline Base.typed_hvncat(sa::Type{SA{T}}, dimsshape::Dims, row_first::Bool, xs::Number...) where T = _SA_typed_hvncat(sa, dimsshape, row_first, xs)

@inline function _SA_typed_hvncat(sa, ::Val{dim}, xs) where {dim}
    msize = Size(ntuple(_->1, Val(dim))..., length(xs))
    x = similar_type(sa, msize)(xs)
end

@inline Base.typed_hvncat(sa::Type{SA}, dim::Int, xs::Number...) = _SA_typed_hvncat(sa, Val(dim-1), xs)
@inline Base.typed_hvncat(sa::Type{SA{T}}, dim::Int, xs::Number...) where T = _SA_typed_hvncat(sa, Val(dim-1), xs)
end

using StaticArrays, Test

@testset "Iterators.flatten" begin
    for x in [SVector(1.0, 2.0), MVector(1.0, 2.0),
            @SMatrix([1.0 2.0; 3.0 4.0]), @MMatrix([1.0 2.0]),
            SizedMatrix{1,2}([1.0 2.0])
            ]
        X = [x,x,x]
        @test length(Iterators.flatten(X)) == length(X)*length(x)
        @test collect(Iterators.flatten(typeof(x)[])) == []
        @test collect(Iterators.flatten(X)) == [x..., x..., x...]
    end
    @test collect(Iterators.flatten([SVector(1,1), SVector(1)])) == [1,1,1]
    @test_throws ArgumentError length(Iterators.flatten([SVector(1,1), SVector(1)]))
end

"""
    _InitialValue

A singleton type for representing "universal" initial value (identity element).

The idea is that, given `op` for `mapfoldl`, virtually, we define an "extended"
version of it by

```julia
op′(::_InitialValue, x) = x
op′(acc, x) = op(acc, x)
```

This is just a conceptually useful model to have in mind and we don't actually
define `op′` here  (yet?).  But see `Base.BottomRF` for how it might work in
action.

(It is related to that you can always turn a semigroup without an identity into
a monoid by "adjoining" an element that acts as the identity.)
"""
struct _InitialValue end

@inline _first(a1, as...) = a1

################
## map / map! ##
################

# In 0.6 the three methods below could be replaced with
# `map(f, as::Union{<:StaticArray,AbstractArray}...)` which included at least one `StaticArray`
# this is not the case on 0.7 and we instead hope to find a StaticArray in the first two arguments.
@inline function map(f, a1::StaticArray, as::AbstractArray...)
    _map(f, a1, as...)
end
@inline function map(f, a1::AbstractArray, a2::StaticArray, as::AbstractArray...)
    _map(f, a1, a2, as...)
end
@inline function map(f, a1::StaticArray, a2::StaticArray, as::AbstractArray...)
    _map(f, a1, a2, as...)
end

@generated function _map(f, a::AbstractArray...)
    first_staticarray = findfirst(ai -> ai <: StaticArray, a)
    if first_staticarray === nothing
        return :(throw(ArgumentError("No StaticArray found in argument list")))
    end
    # Passing the Size as an argument to _map leads to inference issues when
    # recursively mapping over nested StaticArrays (see issue #593). Calling
    # Size in the generator here is valid because a[first_staticarray] is known to be a
    # StaticArray for which the default Size method is correct. If wrapped
    # StaticArrays (with a custom Size method) are to be supported, this will
    # no longer be valid.
    S = Size(a[first_staticarray])

    if prod(S) == 0
        # In the empty case only, use inference to try figuring out a sensible
        # eltype, as is done in Base.collect and broadcast.
        # See https://github.com/JuliaArrays/StaticArrays.jl/issues/528
        eltys = [:(eltype(a[$i])) for i ∈ 1:length(a)]
        return quote
            @_inline_meta
            S = same_size(a...)
            T = Core.Compiler.return_type(f, Tuple{$(eltys...)})
            @inbounds return similar_type(a[$first_staticarray], T, S)()
        end
    end

    exprs = Vector{Expr}(undef, prod(S))
    for i ∈ 1:prod(S)
        tmp = [:(a[$j][$i]) for j ∈ 1:length(a)]
        exprs[i] = :(f($(tmp...)))
    end

    return quote
        @_inline_meta
        S = same_size(a...)
        @inbounds elements = tuple($(exprs...))
        @inbounds return similar_type(typeof(a[$first_staticarray]), eltype(elements), S)(elements)
    end
end

struct StaticEnumerate{TA}
    itr::TA
end

enumerate_static(a::StaticArray) = StaticEnumerate(a)

@generated function map(f, a::StaticEnumerate{<:StaticArray})
    S = Size(a.parameters[1])
    if prod(S) == 0
        # In the empty case only, use inference to try figuring out a sensible
        # eltype, as is done in Base.collect and broadcast.
        # See https://github.com/JuliaArrays/StaticArrays.jl/issues/528
        return quote
            @_inline_meta
            T = Core.Compiler.return_type(f, Tuple{Tuple{Int,$(eltype(a.parameters[1]))}})
            @inbounds return similar_type(a.itr, T, $S)()
        end
    end

    exprs = Vector{Expr}(undef, prod(S))
    for i ∈ 1:prod(S)
        exprs[i] = :(f(($i, a.itr[$i])))
    end

    return quote
        @_inline_meta
        @inbounds elements = tuple($(exprs...))
        @inbounds return similar_type(typeof(a.itr), eltype(elements), $S)(elements)
    end
end

if VERSION >= v"1.12.0-beta3"
    @inline function map!(f, dest::StaticArray)
        _map!(f, dest, Size(dest), dest)
    end
end

@inline function map!(f, dest::StaticArray, a::StaticArray...)
    _map!(f, dest, same_size(dest, a...), a...)
end

# Ambiguities with Base:
@inline function map!(f, dest::StaticArray, a::StaticArray)
    _map!(f, dest, same_size(dest, a), a)
end
@inline function map!(f, dest::StaticArray, a::StaticArray, b::StaticArray)
    _map!(f, dest, same_size(dest, a, b), a, b)
end


@generated function _map!(f, dest, ::Size{S}, a::StaticArray...) where {S}
    exprs = Vector{Expr}(undef, prod(S))
    for i ∈ 1:prod(S)
        tmp = [:(a[$j][$i]) for j ∈ 1:length(a)]
        exprs[i] = :(dest[$i] = f($(tmp...)))
    end
    return quote
        @_inline_meta
        @inbounds $(Expr(:block, exprs...))
        return dest
    end
end

###############
## mapreduce ##
###############

@inline function mapreduce(f, op, a::StaticArray, b::StaticArray...; dims::D=:, init = _InitialValue()) where {D}
    _mapreduce(f, op, dims, init, same_size(a, b...), a, b...)
end

@inline _mapreduce(args::Vararg{Any,N}) where N = _mapfoldl(args...)

@generated function _mapfoldl(f, op, dims::Colon, init, ::Size{S}, a::StaticArray...) where {S}
    if prod(S) == 0
        if init === _InitialValue
            if length(a) == 1
                return :(Base.mapreduce_empty(f, op, $(eltype(a[1]))))
            else
                return :(throw(ArgumentError("reducing over an empty collection is not allowed")))
            end
        else
            return :init
        end
    end
    tmp = [:(a[$j][1]) for j ∈ 1:length(a)]
    expr = :(f($(tmp...)))
    if init === _InitialValue
        expr = :(Base.reduce_first(op, $expr))
    else
        expr = :(op(init, $expr))
    end
    for i ∈ 2:prod(S)
        tmp = [:(a[$j][$i]) for j ∈ 1:length(a)]
        expr = :(op($expr, f($(tmp...))))
    end
    return quote
        @_inline_meta
        @inbounds return $expr
    end
end

@inline function _mapreduce(f, op, D::Int, init, sz::Size{S}, a::StaticArray) where {S}
    # Body of this function is split because constant propagation (at least
    # as of Julia 1.2) can't always correctly propagate here and
    # as a result the function is not type stable and very slow.
    # This makes it at least fast for three dimensions but people should use
    # for example any(a; dims=Val(1)) instead of any(a; dims=1) anyway.
    if D == 1
        return _mapreduce(f, op, Val(1), init, sz, a)
    elseif D == 2
        return _mapreduce(f, op, Val(2), init, sz, a)
    elseif D == 3
        return _mapreduce(f, op, Val(3), init, sz, a)
    else
        return _mapreduce(f, op, Val(D), init, sz, a)
    end
end

@generated function _mapfoldl(f, op, dims::Val{D}, init,
                               ::Size{S}, a::StaticArray) where {S,D}
    N = length(S)
    Snew = ([n==D ? 1 : S[n] for n = 1:N]...,)

    exprs = Array{Expr}(undef, Snew)
    itr = [1:n for n ∈ Snew]
    for i ∈ Base.product(itr...)
        if S[D] == 0
            expr = :(Base.mapreduce_empty(f, op, eltype(a)))
        else
            expr = :(f(a[$(i...)]))
            if init === _InitialValue
                expr = :(Base.reduce_first(op, $expr))
            else
                expr = :(op(init, $expr))
            end
            for k = 2:S[D]
                ik = collect(i)
                ik[D] = k
                expr = :(op($expr, f(a[$(ik...)])))
            end
        end
        exprs[i...] = expr
    end

    return quote
        @_inline_meta
        @inbounds elements = tuple($(exprs...))
        @inbounds return similar_type(a, eltype(elements), Size($Snew))(elements)
    end
end

############
## reduce ##
############

@inline reduce(op::R, a::StaticArray; dims::D = :, init = _InitialValue()) where {D, R} =
    _reduce(op, a, dims, init)

# disambiguation
reduce(::typeof(vcat), A::StaticArray{<:Tuple,<:AbstractVecOrMat}) =
    Base._typed_vcat(mapreduce(eltype, promote_type, A), A)
reduce(::typeof(vcat), A::StaticArray{<:Tuple,<:StaticVecOrMatLike}) =
    _reduce(vcat, A, :, _InitialValue())

reduce(::typeof(hcat), A::StaticArray{<:Tuple,<:AbstractVecOrMat}) =
    Base._typed_hcat(mapreduce(eltype, promote_type, A), A)
reduce(::typeof(hcat), A::StaticArray{<:Tuple,<:StaticVecOrMatLike}) =
    _reduce(hcat, A, :, _InitialValue())

@inline _reduce(op::R, a::StaticArray, dims::D, init = _InitialValue()) where {D, R} =
    _mapreduce(identity, op, dims, init, Size(a), a)

################
## (map)foldl ##
################

# Using `where {R}` to force specialization. See:
# https://docs.julialang.org/en/v1.5-dev/manual/performance-tips/#Be-aware-of-when-Julia-avoids-specializing-1
# https://github.com/JuliaLang/julia/pull/33917

@inline mapfoldl(f::F, op::R, a::StaticArray; init = _InitialValue()) where {F,R} =
    _mapfoldl(f, op, :, init, Size(a), a)
@inline foldl(op::R, a::StaticArray; init = _InitialValue()) where {R} =
    _foldl(op, a, :, init)
@inline _foldl(op::R, a, dims::D, init = _InitialValue()) where {D, R} =
    _mapfoldl(identity, op, dims, init, Size(a), a)

#######################
## related functions ##
#######################

# These are all similar in Base but not @inline'd
#
# Implementation notes:
#
# 1. mapreduce and mapreducedim usually do not take initial value, because we don't
# always know the return type of an arbitrary mapping function f.  (We usually want to use
# some initial value such as one(T) or zero(T), where T is the return type of f, but
# if users provide type-unstable f, its return type cannot be known.)  Therefore, mapped
# versions of the functions implemented below usually require the collection to have at
# least two entries.
#
# 2. Exceptions are the ones that require Boolean mapping functions.  For example, f in
# all and any must return Bool, so we know the appropriate initial value is true and false,
# respectively.  Therefore, all(f, ...) and any(f, ...) are implemented by mapreduce(f, ...)
# with an initial value v0 = true and false.
#
# TODO: change to use Base.reduce_empty/Base.reduce_first
@inline iszero(a::StaticArray{<:Tuple,T}) where {T} = reduce((x,y) -> x && iszero(y), a, init=true)

@inline sum(a::StaticArray{<:Tuple,T}; dims::D=:, init=_InitialValue()) where {D, T} = _reduce(+, a, dims, init)
@inline sum(f, a::StaticArray{<:Tuple,T}; dims::D=:, init=_InitialValue()) where {D, T} = _mapreduce(f, +, dims, init, Size(a), a)
@inline sum(f::Union{Function, Type}, a::StaticArray{<:Tuple,T}; dims::D=:, init=_InitialValue()) where {D, T} = _mapreduce(f, +, dims, init, Size(a), a) # avoid ambiguity

@inline prod(a::StaticArray{<:Tuple,T}; dims::D=:, init=_InitialValue()) where {D, T} = _reduce(*, a, dims, init)
@inline prod(f, a::StaticArray{<:Tuple,T}; dims::D=:, init=_InitialValue()) where {D, T} = _mapreduce(f, *, dims, init, Size(a), a)
@inline prod(f::Union{Function, Type}, a::StaticArray{<:Tuple,T}; dims::D=:, init=_InitialValue()) where {D, T} = _mapreduce(f, *, dims, init, Size(a), a)

@inline count(a::StaticArray{<:Tuple,Bool}; dims::D=:, init=0) where {D} = _reduce(+, a, dims, init)
@inline count(f, a::StaticArray; dims::D=:, init=0) where {D} = _mapreduce(x->f(x)::Bool, +, dims, init, Size(a), a)

@inline all(a::StaticArray{<:Tuple,Bool}; dims::D=:) where {D} = _reduce(&, a, dims, true)  # non-branching versions
@inline all(f::Function, a::StaticArray; dims::D=:) where {D} = _mapreduce(x->f(x)::Bool, &, dims, true, Size(a), a)

@inline any(a::StaticArray{<:Tuple,Bool}; dims::D=:) where {D} = _reduce(|, a, dims, false) # (benchmarking needed)
@inline any(f::Function, a::StaticArray; dims::D=:) where {D} = _mapreduce(x->f(x)::Bool, |, dims, false, Size(a), a) # (benchmarking needed)

@inline Base.in(x, a::StaticArray) = _mapreduce(==(x), |, :, false, Size(a), a)

@inline minimum(a::StaticArray; dims::D=:) where {D} = _reduce(min, a, dims) # base has mapreduce(identity, scalarmin, a)
@inline minimum(f::Function, a::StaticArray; dims::D=:) where {D} = _mapreduce(f, min, dims, _InitialValue(), Size(a), a)

@inline maximum(a::StaticArray; dims::D=:) where {D} = _reduce(max, a, dims) # base has mapreduce(identity, scalarmax, a)
@inline maximum(f::Function, a::StaticArray; dims::D=:) where {D} = _mapreduce(f, max, dims, _InitialValue(), Size(a), a)

# Diff is slightly different
@inline diff(a::StaticArray; dims::D) where {D} = _diff(Size(a), a, dims)
@inline diff(a::StaticVector) = diff(a;dims=Val(1))

@inline function _diff(sz::Size{S}, a::StaticArray, D::Int) where {S}
    _diff(sz,a,Val(D))
end
@generated function _diff(::Size{S}, a::StaticArray, ::Val{D}) where {S,D}
    N = length(S)
    Snew = ([n==D ? S[n]-1 : S[n] for n = 1:N]...,)

    exprs = Array{Expr}(undef, Snew)
    itr = [1:n for n = Snew]

    for i1 = Base.product(itr...)
        i2 = copy([i1...])
        i2[D] = i1[D] + 1
        exprs[i1...] = :(a[$(i2...)] - a[$(i1...)])
    end

    return quote
        @_inline_meta
        elements = tuple($(exprs...))
        @inbounds return similar_type(a, eltype(elements), Size($Snew))(elements)
    end
end

_maybe_val(dims::Integer) = Val(Int(dims))
_maybe_val(dims::D) where {D} = dims
_valof(::Val{D}) where D = D

@inline Base.accumulate(op::F, a::StaticVector; dims::D = :, init = _InitialValue()) where {D, F} =
    _accumulate(op, a, _maybe_val(dims), init)

@inline Base.accumulate(op::F, a::StaticArray; dims::D, init = _InitialValue()) where {D, F} =
    _accumulate(op, a, _maybe_val(dims), init)

@inline function _accumulate(op::F, a::StaticArray, dims::Dimensions, init) where {Dimensions <: Union{Val,Colon}, F}
    # Adjoin the initial value to `op` (one-line version of `Base.BottomRF`):
    rf(x, y) = x isa _InitialValue ? Base.reduce_first(op, y) : op(x, y)

    if isempty(a)
        T = return_type(rf, Tuple{typeof(init), eltype(a)})
        return similar_type(a, T)()
    end

    results = _foldl(
        a,
        dims,
        (similar_type(a, Union{}, Size(0))(), init),
    ) do (ys, acc), x
        y = rf(acc, x)
        # Not using `push(ys, y)` here since we need to widen element type as
        # we iterate.
        (vcat(ys, SA[y]), y)
    end
    dims === (:) && return first(results)

    ys = map(first, results)
    # Now map over all indices of `a`.  Since `_map` needs at least
    # one `StaticArray` to be passed, we pass `a` here, even though
    # the values of `a` are not used.
    data = _map(a, CartesianIndices(a)) do _, CI
        D = _valof(dims)
        I = Tuple(CI)
        J = setindex(I, 1, D)
        ys[J...][I[D]]
    end
    return similar_type(a, eltype(data))(data)
end

@inline Base.cumsum(a::StaticArray; kw...) = accumulate(Base.add_sum, a; kw...)
@inline Base.cumprod(a::StaticArray; kw...) = accumulate(Base.mul_prod, a; kw...)

################
## broadcast! ##
################

using Base.Broadcast: AbstractArrayStyle, DefaultArrayStyle, Style, Broadcasted
using Base.Broadcast: broadcast_shape, _broadcast_getindex, combine_axes
import Base.Broadcast: BroadcastStyle, materialize!, instantiate
import Base.Broadcast: _bcs1  # for SOneTo axis information
using Base.Broadcast: _bcsm

BroadcastStyle(::Type{<:StaticArray{<:Tuple, <:Any, N}}) where {N} = StaticArrayStyle{N}()
BroadcastStyle(::Type{<:StaticMatrixLike}) = StaticArrayStyle{2}()
# Precedence rules
BroadcastStyle(::StaticArrayStyle{M}, ::DefaultArrayStyle{N}) where {M,N} =
    DefaultArrayStyle(Val(max(M, N)))
BroadcastStyle(::StaticArrayStyle{M}, ::DefaultArrayStyle{0}) where {M} =
    StaticArrayStyle{M}()

# combine_axes overload (for Tuple)
@inline static_combine_axes(A, B...) = broadcast_shape(static_axes(A), static_combine_axes(B...))
static_combine_axes(A) = static_axes(A)
static_axes(A) = axes(A)
static_axes(x::Tuple) = (SOneTo{length(x)}(),)
static_axes(bc::Broadcasted{Style{Tuple}}) = static_combine_axes(bc.args...)
Broadcast._axes(bc::Broadcasted{<:StaticArrayStyle}, ::Nothing) = static_combine_axes(bc.args...)

# instantiate overload
@inline function instantiate(B::Broadcasted{StaticArrayStyle{M}}) where M
    if B.axes isa Tuple{Vararg{SOneTo}} || B.axes isa Tuple && length(B.axes) > M
        return invoke(instantiate, Tuple{Broadcasted}, B)
    elseif B.axes isa Nothing
        ax = static_combine_axes(B.args...)
        return Broadcasted{StaticArrayStyle{M}}(B.f, B.args, ax)
    else
        # We need to update B.axes for `broadcast!` if it's not static and `ndims(dest) < M`.
        ax = static_check_broadcast_shape(B.axes, static_combine_axes(B.args...))
        return Broadcasted{StaticArrayStyle{M}}(B.f, B.args, ax)
    end
end
@inline function static_check_broadcast_shape(shp::Tuple, Ashp::Tuple{Vararg{SOneTo}})
    ax1 = if length(Ashp[1]) == 1
        shp[1]
    elseif Ashp[1] == shp[1]
        Ashp[1]
    else
        throw(DimensionMismatch("array could not be broadcast to match destination"))
    end
    return (ax1, static_check_broadcast_shape(Base.tail(shp), Base.tail(Ashp))...)
end
static_check_broadcast_shape(::Tuple{}, ::Tuple{SOneTo,Vararg{SOneTo}}) =
    throw(DimensionMismatch("cannot broadcast array to have fewer non-singleton dimensions"))
static_check_broadcast_shape(::Tuple{}, ::Tuple{SOneTo{1},Vararg{SOneTo{1}}}) = ()
static_check_broadcast_shape(::Tuple{}, ::Tuple{}) = ()
# copy overload
@inline function Base.copy(B::Broadcasted{StaticArrayStyle{M}}) where M
    flat = broadcast_flatten(B); as = flat.args; f = flat.f
    argsizes = broadcast_sizes(as...)
    ax = axes(B)
    ax isa Tuple{Vararg{SOneTo}} || error("Dimension is not static. Please file a bug.")
    return _broadcast(f, Size(map(length, ax)), argsizes, as...)
end
# copyto! overloads
@inline Base.copyto!(dest::AbstractArray, B::Broadcasted{<:StaticArrayStyle}) = _copyto!(dest, B)
@inline function _copyto!(dest, B::Broadcasted{StaticArrayStyle{M}}) where M
    flat = broadcast_flatten(B); as = flat.args; f = flat.f
    argsizes = broadcast_sizes(as...)
    ax = axes(B)
    if ax isa Tuple{Vararg{SOneTo}}
        @boundscheck axes(dest) == ax || Broadcast.throwdm(axes(dest), ax)
        return _broadcast!(f, Size(map(length, ax)), dest, argsizes, as...)
    end
    # destination dimension cannot be determined statically; fall back to generic broadcast!
    return copyto!(dest, convert(Broadcasted{DefaultArrayStyle{M}}, B))
end

# Resolving priority between dynamic and static axes
_bcs1(a::SOneTo, b::SOneTo) = _bcsm(b, a) ? b : (_bcsm(a, b) ? a : throw(DimensionMismatch("arrays could not be broadcast to a common size")))
function _bcs1(a::SOneTo, b::Base.OneTo)
    length(a) == 1 && return b
    if length(b) != length(a) && length(b) != 1
        throw(DimensionMismatch("arrays could not be broadcast to a common size"))
    end
    return a
end
_bcs1(a::Base.OneTo, b::SOneTo) = _bcs1(b, a)

###################################################
## Internal broadcast machinery for StaticArrays ##
###################################################

# TODO: just use map(broadcast_size, as)?
@inline broadcast_sizes(a, as...) = (broadcast_size(a), broadcast_sizes(as...)...)
@inline broadcast_sizes() = ()
@inline broadcast_size(a) = Size()
@inline broadcast_size(a::AbstractArray) = Size(a)
@inline broadcast_size(a::Tuple) = Size(length(a))

broadcast_getindex(::Tuple{}, i::Int, I::CartesianIndex) = return :(_broadcast_getindex(a[$i], $I))
function broadcast_getindex(oldsize::Tuple, i::Int, newindex::CartesianIndex)
    li = LinearIndices(oldsize)
    ind = _broadcast_getindex(li, newindex)
    return :(a[$i][$ind])
end

isstatic(::StaticArrayLike) = true
isstatic(_) = false

@inline first_statictype(x, y...) = isstatic(x) ? typeof(x) : first_statictype(y...)
first_statictype() = error("unresolved dest type")

@inline function _broadcast(f, sz::Size{newsize}, s::Tuple{Vararg{Size}}, a...) where newsize
    first_staticarray = first_statictype(a...)
    if prod(newsize) == 0
        # Use inference to get eltype in empty case (see also comments in _map)
        eltys = Tuple{map(eltype, a)...}
        T = Core.Compiler.return_type(f, eltys)
        @inbounds return similar_type(first_staticarray, T, Size(newsize))()
    end
    elements = __broadcast(f, sz, s, a...)
    @inbounds return similar_type(first_staticarray, eltype(elements), Size(newsize))(elements)
end

@generated function __broadcast(f, ::Size{newsize}, s::Tuple{Vararg{Size}}, a...) where newsize
    sizes = [sz.parameters[1] for sz ∈ s.parameters]

    indices = CartesianIndices(newsize)
    exprs = similar(indices, Expr)
    for (j, current_ind) ∈ enumerate(indices)
        exprs_vals = (broadcast_getindex(sz, i, current_ind) for (i, sz) in enumerate(sizes))
        exprs[j] = :(f($(exprs_vals...)))
    end

    return quote
        @_inline_meta
        return tuple($(exprs...))
    end
end

####################################################
## Internal broadcast! machinery for StaticArrays ##
####################################################

@generated function _broadcast!(f, ::Size{newsize}, dest::AbstractArray, s::Tuple{Vararg{Size}}, a...) where {newsize}
    sizes = [sz.parameters[1] for sz in s.parameters]

    indices = CartesianIndices(newsize)
    exprs_eval = similar(indices, Expr)
    exprs_setindex = similar(indices, Expr)
    for (j, current_ind) ∈ enumerate(indices)
        exprs_vals = (broadcast_getindex(sz, i, current_ind) for (i, sz) in enumerate(sizes))
        symb_val_j = Symbol(:val_, j)
        exprs_eval[j] = :($symb_val_j = f($(exprs_vals...)))
        exprs_setindex[j] = :(dest[$j] = $symb_val_j)
    end

    return quote
        @_inline_meta
        $(Expr(:block, exprs_eval...))
        @inbounds $(Expr(:block, exprs_setindex...))
        return dest
    end
end

# Work around for https://github.com/JuliaLang/julia/issues/27988
# The following code is borrowed from https://github.com/JuliaLang/julia/pull/43322
# with some modification to make it also works on 1.6.
module StableFlatten

export broadcast_flatten

if VERSION >= v"1.11.0-DEV.103"
    const broadcast_flatten = Broadcast.flatten
else
    using Base: tail
    using Base.Broadcast: isflat, Broadcasted

    maybeconstructor(f) = f
    maybeconstructor(::Type{F}) where {F} = (args...; kwargs...) -> F(args...; kwargs...)

    function broadcast_flatten(bc::Broadcasted{Style}) where {Style}
        isflat(bc) && return bc
        args = cat_nested(bc)
        len = Val{length(args)}()
        makeargs = make_makeargs(bc.args, len, ntuple(_->true, len))
        f = maybeconstructor(bc.f)
        @inline newf(args...) = f(prepare_args(makeargs, args)...)
        return Broadcasted{Style}(newf, args, bc.axes)
    end

    cat_nested(bc::Broadcasted) = cat_nested_args(bc.args)
    cat_nested_args(::Tuple{}) = ()
    cat_nested_args(t::Tuple) = (cat_nested(t[1])..., cat_nested_args(tail(t))...)
    cat_nested(@nospecialize(a)) = (a,)

    function make_makeargs(args::Tuple, len, flags)
        makeargs, r = _make_makeargs(args, len, flags)
        r isa Tuple{} || error("Internal error. Please file a bug")
        return makeargs
    end

    # We build `makeargs` by traversing the broadcast nodes recursively.
    # note: `len` isa `Val` indicates the length of whole flattened argument list.
    #       `flags` is a tuple of `Bool` with the same length of the rest arguments.
    @inline function _make_makeargs(args::Tuple, len::Val, flags::Tuple)
        head, flags′ = _make_makeargs1(args[1], len, flags)
        rest, flags″ = _make_makeargs(tail(args), len, flags′)
        (head, rest...), flags″
    end
    _make_makeargs(::Tuple{}, ::Val, x::Tuple) = (), x

    # For flat nodes:
    # 1. we just consume one argument, and return the "pick" function
    @inline function _make_makeargs1(@nospecialize(a), ::Val{N}, flags::Tuple) where {N}
        pickargs(::Val{N}) where {N} = (@nospecialize(x::Tuple)) -> x[N]
        return pickargs(Val{N-length(flags)+1}()), tail(flags)
    end

    # For nested nodes, we form the `makeargs1` based on the child `makeargs` (n += length(cat_nested(bc)))
    @inline function _make_makeargs1(bc::Broadcasted, len::Val, flags::Tuple)
        makeargs, flags′ = _make_makeargs(bc.args, len, flags)
        f = maybeconstructor(bc.f)
        @inline makeargs1(@nospecialize(args::Tuple)) = f(prepare_args(makeargs, args)...)
        makeargs1, flags′
    end

    prepare_args(::Tuple{}, @nospecialize(::Tuple)) = ()
    @inline prepare_args(makeargs::Tuple, @nospecialize(x::Tuple)) = (makeargs[1](x), prepare_args(tail(makeargs), x)...)
end
end
using .StableFlatten

@testset "SMatrix" begin
    @testset "Inner Constructors" begin
        @test SMatrix{1,1,Int,1}((1,)).data === (1,)
        @test SMatrix{1,1,Float64,1}((1,)).data === (1.0,)
        @test SMatrix{2,2,Float64,4}((1, 1.0, 1, 1)).data === (1.0, 1.0, 1.0, 1.0)

        # Bad input
        @test_throws Exception SMatrix{1,1,Int,1}()
        @test_throws Exception SMatrix{2,1,Int,2}((1,))
        @test_throws Exception SMatrix{1,1,Int,1}(())

        # Bad parameters
        @test_throws Exception SMatrix{1,1,Int,2}((1,))
        @test_throws ArgumentError SMatrix{1,1,1,1}((1,))
        @test_throws ArgumentError SMatrix{1,2,Int,1}((1,))
        @test_throws ArgumentError SMatrix{2,1,Int,1}((1,))
    end

    @testset "Outer constructors and macro" begin
        # The following tests are much similar in `test/MMatrix.jl`
        @test_throws Exception SMatrix(1,2,3,4) # unknown constructor

        @test SMatrix{1,1,Int}((1,)).data === (1,)
        @test SMatrix{1,1}((1,)).data === (1,)
        @test SMatrix{1}((1,)).data === (1,)

        @test SMatrix{2,2,Int}((1,2,3,4)).data === (1,2,3,4)
        @test SMatrix{2,2}((1,2,3,4)).data === (1,2,3,4)
        @test SMatrix{2}((1,2,3,4)).data === (1,2,3,4)
        @test_throws DimensionMismatch SMatrix{2}((1,2,3,4,5))

        # test for #557-like issues
        @test (@inferred SMatrix(MMatrix{0,0,Float64}()))::SMatrix{0,0,Float64} == SMatrix{0,0,Float64}()

        @test (SMatrix{2,3}(i+10j for i in 1:2, j in 1:3)::SMatrix{2,3}).data ===
            (11,12,21,22,31,32)
        @test (SMatrix{2,3}(float(i+10j) for i in 1:2, j in 1:3)::SMatrix{2,3}).data ===
            (11.0,12.0,21.0,22.0,31.0,32.0)
        @test (SMatrix{0,0,Int}()::SMatrix{0,0}).data === ()
        @test (SMatrix{0,3,Int}()::SMatrix{0,3}).data === ()
        @test (SMatrix{2,0,Int}()::SMatrix{2,0}).data === ()
        @test (SMatrix{2,3,Int}(i+10j for i in 1:2, j in 1:3)::SMatrix{2,3}).data ===
            (11,12,21,22,31,32)
        @test (SMatrix{2,3,Float64}(i+10j for i in 1:2, j in 1:3)::SMatrix{2,3}).data ===
            (11.0,12.0,21.0,22.0,31.0,32.0)
        @test_throws Exception SMatrix{2,3}(i+10j for i in 1:1, j in 1:3)
        @test_throws Exception SMatrix{2,3}(i+10j for i in 1:3, j in 1:3)
        @test_throws Exception SMatrix{2,3,Int}(i+10j for i in 1:1, j in 1:3)
        @test_throws Exception SMatrix{2,3,Int}(i+10j for i in 1:3, j in 1:3)

        @test ((@SMatrix [1.0])::SMatrix{1,1}).data === (1.0,)
        @test ((@SMatrix [1 2])::SMatrix{1,2}).data === (1, 2)
        @test ((@SMatrix [1 ; 2])::SMatrix{2,1}).data === (1, 2)
        @test ((@SMatrix [1 2 ; 3 4])::SMatrix{2,2}).data === (1, 3, 2, 4)

        @test ((@SMatrix Int[1.0])::SMatrix{1,1}).data === (1,)
        @test ((@SMatrix Float64[1 2])::SMatrix{1,2}).data === (1.0, 2.0)
        @test ((@SMatrix Float64[1 ; 2])::SMatrix{2,1}).data === (1.0, 2.0)
        @test ((@SMatrix Float64[1 2 ; 3 4])::SMatrix{2,2}).data === (1.0, 3.0, 2.0, 4.0)

        @test ((@SMatrix [i*j for i = 1:2, j=2:3])::SMatrix{2,2}).data === (2, 4, 3, 6)
        @test ((@SMatrix Float64[i*j for i = 1:2, j=2:3])::SMatrix{2,2}).data === (2.0, 4.0, 3.0, 6.0)

        @testset "expand error" begin
            test_expand_error(:(@SMatrix [1 2; 3]))
            test_expand_error(:(@SMatrix Float64[1 2; 3]))
            test_expand_error(:(@SMatrix [i*j*k for i = 1:2, j=2:3, k=3:4]))
            test_expand_error(:(@SMatrix Float64[i*j*k for i = 1:2, j=2:3, k=3:4]))
            test_expand_error(:(@SMatrix fill(1.5, 2, 3, 4)))
            test_expand_error(:(@SMatrix ones(2, 3, 4, 5)))
            test_expand_error(:(@SMatrix ones))
            test_expand_error(:(@SMatrix sin(1:5)))
            test_expand_error(:(@SMatrix [1; 2; 3; 4]...))
            test_expand_error(:(@SMatrix a))
        end

        @test ((@SMatrix [1 2.;3 4])::SMatrix{2, 2, Float64}).data === (1., 3., 2., 4.) #issue #911
        @test ((@SMatrix fill(1.3, 2,2))::SMatrix{2, 2, Float64}).data === (1.3, 1.3, 1.3, 1.3)
        @test ((@SMatrix zeros(2,2))::SMatrix{2, 2, Float64}).data === (0.0, 0.0, 0.0, 0.0)
        @test ((@SMatrix ones(2,2))::SMatrix{2, 2, Float64}).data === (1.0, 1.0, 1.0, 1.0)
        @test ((@SMatrix zeros(Float32, 2, 2))::SMatrix{2,2,Float32}).data === (0.0f0, 0.0f0, 0.0f0, 0.0f0)
        @test ((@SMatrix ones(Float32, 2, 2))::SMatrix{2,2,Float32}).data === (1.0f0, 1.0f0, 1.0f0, 1.0f0)

        @testset "@SMatrix rand*" begin
            n = 4
            @testset "zero-length" begin
                @test (@SMatrix rand(0, 0)) isa SMatrix{0, 0, Float64}
                @test (@SMatrix rand(0, n)) isa SMatrix{0, n, Float64}
                @test (@SMatrix rand(n, 0)) isa SMatrix{n, 0, Float64}
                @test (@SMatrix rand(Float32, 0, 0)) isa SMatrix{0, 0, Float32}
                @test (@SMatrix rand(Float32, 0, n)) isa SMatrix{0, n, Float32}
                @test (@SMatrix rand(Float32, n, 0)) isa SMatrix{n, 0, Float32}
                @test (@SMatrix rand(_rng(), Float32, 0, 0)) isa SMatrix{0, 0, Float32}
                @test (@SMatrix rand(_rng(), Float32, 0, n)) isa SMatrix{0, n, Float32}
                @test (@SMatrix rand(_rng(), Float32, n, 0)) isa SMatrix{n, 0, Float32}
            end

            @test (@SMatrix rand(n, n)) isa SMatrix{n, n, Float64}
            @test (@SMatrix randn(n, n)) isa SMatrix{n, n, Float64}
            @test (@SMatrix randexp(n, n)) isa SMatrix{n, n, Float64}
            @test (@SMatrix rand(4, 4)) isa SMatrix{4, 4, Float64}
            @test (@SMatrix randn(4, 4)) isa SMatrix{4, 4, Float64}
            @test (@SMatrix randexp(4, 4)) isa SMatrix{4, 4, Float64}
            @test (@SMatrix rand(_rng(), n, n)) isa SMatrix{n, n, Float64}
            @test (@SMatrix rand(_rng(), n, n)) == rand(_rng(), n, n)
            @test (@SMatrix randn(_rng(), n, n)) isa SMatrix{n, n, Float64}
            @test (@SMatrix randn(_rng(), n, n)) == randn(_rng(), n, n)
            @test (@SMatrix randexp(_rng(), n, n)) isa SMatrix{n, n, Float64}
            @test (@SMatrix randexp(_rng(), n, n)) == randexp(_rng(), n, n)
            @test (@SMatrix rand(_rng(), 4, 4)) isa SMatrix{4, 4, Float64}
            @test (@SMatrix rand(_rng(), 4, 4)) == rand(_rng(), 4, 4)
            @test (@SMatrix randn(_rng(), 4, 4)) isa SMatrix{4, 4, Float64}
            @test (@SMatrix randn(_rng(), 4, 4)) == randn(_rng(), 4, 4)
            @test (@SMatrix randexp(_rng(), 4, 4)) isa SMatrix{4, 4, Float64}
            @test (@SMatrix randexp(_rng(), 4, 4)) == randexp(_rng(), 4, 4)

            for T in (Float32, Float64)
                @test (@SMatrix rand(T, n, n)) isa SMatrix{n, n, T}
                @test (@SMatrix randn(T, n, n)) isa SMatrix{n, n, T}
                @test (@SMatrix randexp(T, n, n)) isa SMatrix{n, n, T}
                @test (@SMatrix rand(T, 4, 4)) isa SMatrix{4, 4, T}
                @test (@SMatrix randn(T, 4, 4)) isa SMatrix{4, 4, T}
                @test (@SMatrix randexp(T, 4, 4)) isa SMatrix{4, 4, T}
                @test (@SMatrix rand(_rng(), T, n, n)) isa SMatrix{n, n, T}
                VERSION≥v"1.7" && @test (@SMatrix rand(_rng(), T, n, n)) == rand(_rng(), T, n, n) broken=(T===Float32)
                @test (@SMatrix randn(_rng(), T, n, n)) isa SMatrix{n, n, T}
                @test (@SMatrix randn(_rng(), T, n, n)) == randn(_rng(), T, n, n)
                @test (@SMatrix randexp(_rng(), T, n, n)) isa SMatrix{n, n, T}
                @test (@SMatrix randexp(_rng(), T, n, n)) == randexp(_rng(), T, n, n)
                @test (@SMatrix rand(_rng(), T, 4, 4)) isa SMatrix{4, 4, T}
                VERSION≥v"1.7" && @test (@SMatrix rand(_rng(), T, 4, 4)) == rand(_rng(), T, 4, 4) broken=(T===Float32)
                @test (@SMatrix randn(_rng(), T, 4, 4)) isa SMatrix{4, 4, T}
                @test (@SMatrix randn(_rng(), T, 4, 4)) == randn(_rng(), T, 4, 4)
                @test (@SMatrix randexp(_rng(), T, 4, 4)) isa SMatrix{4, 4, T}
                @test (@SMatrix randexp(_rng(), T, 4, 4)) == randexp(_rng(), T, 4, 4)
            end
        end

        @inferred SMatrix(rand(SMatrix{3, 3})) # issue 356
        @test SMatrix(MMatrix{1,1,Int,1}((1,))).data == (1,)
        @test_throws DimensionMismatch SMatrix{3}((1,2,3,4))

        if VERSION >= v"1.7.0"
            @test ((@SMatrix Float64[1;2;3;;;])::SMatrix{3,1}).data === (1.0, 2.0, 3.0)
            @test ((@SMatrix [1;2;3;;;])::SMatrix{3,1}).data === (1, 2, 3)
            test_expand_error(:(@SMatrix [1;2;;;1;2]))
        end
    end

    @testset "Methods" begin
        m = @SMatrix [11 13; 12 14]

        @test isimmutable(m) == true

        @test m[1] === 11
        @test m[2] === 12
        @test m[3] === 13
        @test m[4] === 14

        @testinf Tuple(m) === (11, 12, 13, 14)

        @test size(m) === (2, 2)
        @test size(typeof(m)) === (2, 2)
        @test size(SMatrix{2,2}) === (2, 2)

        @test size(m, 1) === 2
        @test size(m, 2) === 2
        @test size(typeof(m), 1) === 2
        @test size(typeof(m), 2) === 2

        @test length(m) === 4

        @test_throws Exception m[1] = 1

        @test reverse(m) == reverse(reverse(collect(m), dims = 2), dims = 1)
    end
end

using StaticArrays, Test, LinearAlgebra

@testset "Solving linear system" begin
    @testset "Problem size: $n x $n. Matrix type: $m. Element type: $elty, Wrapper: $wrapper" for n in (1,2,3,4,5,8,15),
            (m, v) in ((SMatrix{n,n}, SVector{n}), (MMatrix{n,n}, MVector{n})),
                elty in (Float64, Int, BigFloat), wrapper in (identity, Symmetric, Hermitian)

        A = wrapper(elty.(rand(-99:2:99, n, n)))
        b = A * elty.(rand(2:5, n))
        @test wrapper(m(A))\v(b) ≈ wrapper(A)\b
    end

    m1 = SMatrix{5,5}(1.0I)
    m2 = SMatrix{2,2}(1.0I)
    v = @SVector ones(4)
    @test_throws DimensionMismatch m1\v
    @test_throws DimensionMismatch m1\m2

    # Mixed static/dynamic arrays
    # \ specializes for Diagonal, LowerTriangular, UpperTriangular, square, and non-square
    # So try all of these
    @testset "Mixed static/dynamic" begin
        v = @SVector([0.2,0.3])
        for m in (@SMatrix([1.0 0; 0 1.0]), @SMatrix([1.0 0; 1.0 1.0]),
                  @SMatrix([1.0 1.0; 0 1.0]), @SMatrix([1.0 0.5; 0.25 1.0]))
            # TODO: include @SMatrix([1.0 0.0 0.0; 1.0 2.0 0.5]), need qr methods
            @test m \ v ≈ Array(m) \ v ≈ m \ Array(v) ≈ Array(m) \ Array(v)
        end
    end
end


@testset "Solving linear system (multiple RHS)" begin
    @testset "Problem size: $n x $n. Matrix type: $m1. Element type: $elty" for n in (1,2,3,4,5,8,15),
            (m1, m2) in ((SMatrix{n,n}, SMatrix{n,2}), (MMatrix{n,n}, MMatrix{n,2})),
                elty in (Float64, Int, BigFloat)

        A = elty.(rand(-99:2:99, n, n))
        b = A * elty.(rand(2:5, n, 2))
        @test m1(A)\m2(b) ≈ A\b

    end

    # Solve with non-square left hand sides (#606)
    m1 = @SMatrix[0.2 0.3
                  0.0 0.1
                  0.5 0.1]
    m2 = @SVector[1,2,3]
    @test @inferred(m1\m2) ≈ Array(m1)\Array(m2)
    m2 = @SMatrix[1 4
                  2 5
                  3 6]
    @test @inferred(m1\m2) ≈ Array(m1)\Array(m2)

    @testset "Mixed static/dynamic" begin
        m2 = @SMatrix([0.2 0.3; 0.0 0.1])
        for m1 in (@SMatrix([1.0 0; 0 1.0]), @SMatrix([1.0 0; 1.0 1.0]),
                   @SMatrix([1.0 1.0; 0 1.0]), @SMatrix([1.0 0.5; 0.25 1.0]))
            # TODO: include @SMatrix([1.0 0.0 0.0; 1.0 2.0 0.5]), need qr methods
            @test m1 \ m2 ≈ Array(m1) \ m2 ≈ m1 \ Array(m2) ≈ Array(m1) \ Array(m2)
        end
    end
end

@inline (\)(a::StaticMatrix, b::StaticVecOrMat) = _solve(Size(a), Size(b), a, b)

@inline function _solve(::Size{(1,1)}, ::Size{(1,)}, a::StaticMatrix{<:Any, <:Any, Ta}, b::StaticVector{<:Any, Tb}) where {Ta, Tb}
    @inbounds return similar_type(b, typeof(a[1] \ b[1]))(a[1] \ b[1])
end

@inline function _solve(::Size{(2,2)}, ::Size{(2,)}, a::StaticMatrix{<:Any, <:Any, Ta}, b::StaticVector{<:Any, Tb}) where {Ta, Tb}
    d = det(a)
    T = typeof((one(Ta)*zero(Tb) + one(Ta)*zero(Tb))/d)
    @inbounds return similar_type(b, T)((a[2,2]*b[1] - a[1,2]*b[2])/d,
                                        (a[1,1]*b[2] - a[2,1]*b[1])/d)
end

@inline function _solve(::Size{(3,3)}, ::Size{(3,)}, a::StaticMatrix{<:Any, <:Any, Ta}, b::StaticVector{<:Any, Tb}) where {Ta, Tb}
    d = det(a)
    T = typeof((one(Ta)*zero(Tb) + one(Ta)*zero(Tb))/d)
    @inbounds return similar_type(b, T)(
        ((a[2,2]*a[3,3] - a[2,3]*a[3,2])*b[1] +
         (a[1,3]*a[3,2] - a[1,2]*a[3,3])*b[2] +
         (a[1,2]*a[2,3] - a[1,3]*a[2,2])*b[3]) / d,
        ((a[2,3]*a[3,1] - a[2,1]*a[3,3])*b[1] +
         (a[1,1]*a[3,3] - a[1,3]*a[3,1])*b[2] +
         (a[1,3]*a[2,1] - a[1,1]*a[2,3])*b[3]) / d,
        ((a[2,1]*a[3,2] - a[2,2]*a[3,1])*b[1] +
         (a[1,2]*a[3,1] - a[1,1]*a[3,2])*b[2] +
         (a[1,1]*a[2,2] - a[1,2]*a[2,1])*b[3]) / d )
end

for Sa in [(2,2), (3,3)]  # not needed for Sa = (1, 1);
    @eval begin
        @inline function _solve(::Size{$Sa}, ::Size{Sb}, a::StaticMatrix{<:Any, <:Any, Ta}, b::StaticMatrix{<:Any, <:Any, Tb}) where {Sb, Ta, Tb}
            d = det(a)
            T = typeof((one(Ta)*zero(Tb) + one(Ta)*zero(Tb))/d)
            if isbitstype(T)
                # This if block can be removed when https://github.com/JuliaArrays/StaticArrays.jl/pull/749 is merged.
                c = similar(b, T)
                for col in 1:Sb[2]
                    @inbounds c[:, col] = _solve(Size($Sa), Size($Sa[1],), a, b[:, col])
                end
                return similar_type(b, T)(c)
            else
                return _solve_general($(Size(Sa)), Size(Sb), a, b)
            end
        end
    end # @eval
end

@inline function _solve(sa::Size, sb::Size, a::StaticMatrix, b::StaticVecOrMat)
    _solve_general(sa, sb, a, b)
end

@generated function _solve_general(::Size{Sa}, ::Size{Sb}, a::StaticMatrix{<:Any, <:Any, Ta}, b::StaticVecOrMat{Tb}) where {Sa, Sb, Ta, Tb}
    if Sa[1] != Sb[1]
        return quote
            throw(DimensionMismatch("Left and right hand side first dimensions do not match in backdivide (got sizes $Sa and $Sb)"))
        end
    end
    if prod(Sa) ≤ 14*14 && Sa[1] == Sa[2]
        # TODO: Consider triangular special cases as in Base?
        quote
            @_inline_meta
            LUp = lu(a)
            LUp.U \ (LUp.L \ $(length(Sb) > 1 ? :(b[LUp.p,:]) : :(b[LUp.p])))
        end
        # TODO: Could also use static QR here if `a` is nonsquare.
        # Requires that we implement \(::StaticArrays.QR,::StaticVecOrMat)
    else
        # Fall back to LinearAlgebra, but carry across the statically known size.
        outsize = length(Sb) == 1 ? Size(Sa[2]) : Size(Sa[2],Sb[end])
        quote
            @_inline_meta
            T = typeof((one(Ta)*zero(Tb) + one(Ta)*zero(Tb))/one(Ta))
            similar_type(b, T, $outsize)(Matrix(a) \ b)
        end
    end
end

using StaticArrays, Test

@testset "Push, pop, pushfirst, popfirst, etc" begin
    v = @SVector [1, 2, 3]

    @test @inferred(push(v, 4)) === @SVector [1, 2, 3, 4]
    @test @inferred(pop(v)) === @SVector [1, 2]

    @test @inferred(pushfirst(v, 0)) === @SVector [0, 1, 2, 3]
    @test @inferred(popfirst(v)) === @SVector [2, 3]

    @test @inferred(insert(v, 2, -2)) === @SVector [1, -2, 2, 3]
    @test @inferred(deleteat(v, 2)) === @SVector [1, 3]

    @test @inferred(setindex(v, -2, 2)) === @SVector [1, -2, 3]

    # issue https://github.com/JuliaArrays/StaticArrays.jl/issues/1003
    @test @inferred(insert(SVector{0,Int}(), 1, 10)) === @SVector [10]

    @test_throws BoundsError insert(v, -2, 2)
    @test_throws BoundsError deleteat(v, -2)
    @test_throws BoundsError setindex(v, 2, -2)
end

@testset "setindex!" begin
    a = @MArray ones(3, 3, 3)
    a[2, 1, 3] = 2.
    @test a[2, 1, 3] == 2.
end

@testset "setindex" begin
    v1 = @SVector [1., 2., 3.]
    @test @inferred(setindex(v1, 5, 2)) == @SVector [1., 5., 3.]
    @test @inferred(setindex(v1, 5.0, 2)) == @SVector [1., 5., 3.]
    @test_throws BoundsError setindex(v1, 5.0, 0)
    @test_throws BoundsError setindex(v1, 5.0, 4)
    @test @inferred(setindex(v1, 5, CartesianIndex(2))) == setindex(v1, 5, 2)
    @test @inferred(setindex(v1, 5.0, CartesianIndex(2))) == setindex(v1, 5.0, 2)
    @test_throws BoundsError setindex(v1, 5.0, CartesianIndex(0))
    @test_throws BoundsError setindex(v1, 5.0, CartesianIndex(4))

    v2 = @SMatrix [1 2; 3 4]
    @test @inferred(setindex(v2, 7, 1)) == @SMatrix [7 2; 3 4]
    @test @inferred(setindex(v2, 7, 1, 1)) == @SMatrix [7 2; 3 4]
    @test @inferred(setindex(v2, 7, 2)) == @SMatrix [1 2; 7 4]
    @test @inferred(setindex(v2, 7, 2, 1)) == @SMatrix [1 2; 7 4]
    @test @inferred(setindex(v2, 7, 3)) == @SMatrix [1 7; 3 4]
    @test @inferred(setindex(v2, 7, 1, 2)) == @SMatrix [1 7; 3 4]
    @test @inferred(setindex(v2, 7, 4)) == @SMatrix [1 2; 3 7]
    @test @inferred(setindex(v2, 7, 2, 2)) == @SMatrix [1 2; 3 7]
    @test_throws BoundsError setindex(v2, 7, 0)
    @test_throws BoundsError setindex(v2, 7, 5)
    @test @inferred(setindex(v2, 7, CartesianIndex(1, 1))) == setindex(v2, 7, 1, 1)
    @test @inferred(setindex(v2, 7, CartesianIndex(2, 1))) == setindex(v2, 7, 2, 1)
    @test @inferred(setindex(v2, 7, CartesianIndex(1, 2))) == setindex(v2, 7, 1, 2)
    @test @inferred(setindex(v2, 7, CartesianIndex(2, 2))) == setindex(v2, 7, 2, 2)

    v3 = @SArray ones(2, 2, 2)
    @test @inferred(setindex(v3, 7, 2, 1, 2)) == reshape([1, 1, 1, 1, 1, 7, 1, 1], (2, 2, 2))
    @test_throws BoundsError setindex(v3, 7, 0)
    @test_throws BoundsError setindex(v3, 7, 9)
    @test @inferred(setindex(v3, 7, CartesianIndex(2, 1, 2))) == setindex(v3, 7, 2, 1, 2)

    # TODO: still missing proper multidimensional bounds checking
    # These should throw BoundsError, but don't
    @test_broken setindex(v3, 7, 3, 1, 2)
    @test_broken setindex(v3, 7, 2, 1, 0)
end

using StaticArrays, Test, LinearAlgebra

@testset "SVD factorization" begin
    m3 = @SMatrix Float64[3 9 4; 6 6 2; 3 7 9]
    m3_f32 = @SMatrix Float32[3 9 4; 6 6 2; 3 7 9]
    m3c = ComplexF64.(m3)
    m23 = @SMatrix Float64[3 9 4; 6 6 2]
    m23_f32 = @SMatrix Float32[3 9 4; 6 6 2]
    m_sing = @SMatrix [2.0 3.0 5.0; 4.0 6.0 10.0; 1.0 1.0 1.0]
    m_sing2 = @SMatrix [1 1; 1 0; 0 1]
    v = @SVector [1, 2, 3]
    v2 = @SVector [1, 2]
    mc_sing = @SMatrix [1.0+0.1im 0 0; 2.0+0.2im 0 0; 3.0 0.1im 0]
    mc_sing2 = @SMatrix [1.0+0.1im 0; 2.0+0.2im 1; 3.0 0.1im]
    vc = @SVector [1.0f0+8.0f0im, 0.2f0im, 2.5f0]
    vc2 = @SVector [1.0f0+8.0f0im, 0.2f0im]

    @testset "svd" begin
        @testinf svdvals(@SMatrix [2 0; 0 0])::StaticVector ≊ [2, 0]
        @testinf svdvals((@SMatrix [2 -2; 1 1]) / sqrt(2)) ≊ [2, 1]

        @testinf svdvals(m3) ≊ svdvals(Matrix(m3))
        @testinf svdvals(m3_f32) ≊ svdvals(Matrix(m3_f32))
        @testinf svdvals(m3c) isa SVector{3,Float64}

        @testinf svd(m3).U::StaticMatrix ≊ svd(Matrix(m3)).U
        @testinf svd(m3).S::StaticVector ≊ svd(Matrix(m3)).S
        @testinf svd(m3).V::StaticMatrix ≊ svd(Matrix(m3)).V
        @testinf svd(m3).Vt::StaticMatrix ≊ svd(Matrix(m3)).Vt

        @test svd(m3_f32).U::StaticMatrix ≈ svd(Matrix(m3_f32)).U atol = 5e-7
        @test svd(m3_f32).S::StaticVector ≈ svd(Matrix(m3_f32)).S atol = 5e-7
        @test svd(m3_f32).V::StaticMatrix ≈ svd(Matrix(m3_f32)).V atol = 5e-7
        @test svd(m3_f32).Vt::StaticMatrix ≈ svd(Matrix(m3_f32)).Vt atol = 5e-7

        @testinf svd(@SMatrix [2 0; 0 0]).U ≊ one(SMatrix{2,2})
        @testinf svd(@SMatrix [2 0; 0 0]).S ≊ SVector(2.0, 0.0)
        @testinf svd(@SMatrix [2 0; 0 0]).Vt ≊ one(SMatrix{2,2})

        @testinf svd((@SMatrix [2 -2; 1 1]) / sqrt(2)).U ≊ [-1 0; 0 1]
        @testinf svd((@SMatrix [2 -2; 1 1]) / sqrt(2)).S ≊ [2, 1]
        @testinf svd((@SMatrix [2 -2; 1 1]) / sqrt(2)).Vt ≊ [-1 1; 1 1]/sqrt(2)

        @testinf svd(m23).U  ≊ svd(Matrix(m23)).U
        @testinf svd(m23).S  ≊ svd(Matrix(m23)).S
        @testinf svd(m23).Vt ≊ svd(Matrix(m23)).Vt

        @testinf svd(m23').U  ≊ svd(Matrix(m23')).U
        @testinf svd(m23').S  ≊ svd(Matrix(m23')).S
        @testinf svd(m23').Vt ≊ svd(Matrix(m23')).Vt

        @test svd(m23_f32).U::StaticMatrix ≈ svd(Matrix(m23_f32)).U atol = 5e-7
        @test svd(m23_f32).S::StaticVector ≈ svd(Matrix(m23_f32)).S atol = 5e-7
        @test svd(m23_f32).V::StaticMatrix ≈ svd(Matrix(m23_f32)).V atol = 5e-7
        @test svd(m23_f32).Vt::StaticMatrix ≈ svd(Matrix(m23_f32)).Vt atol = 5e-7

        @test svd(m23_f32').U::StaticMatrix ≈ svd(Matrix(m23_f32')).U atol = 5e-7
        @test svd(m23_f32').S::StaticVector ≈ svd(Matrix(m23_f32')).S atol = 5e-7
        @test svd(m23_f32').V::StaticMatrix ≈ svd(Matrix(m23_f32')).V atol = 5e-7
        @test svd(m23_f32').Vt::StaticMatrix ≈ svd(Matrix(m23_f32')).Vt atol = 5e-7

        @testinf svd(m23, full=true).U::StaticMatrix  ≊ svd(Matrix(m23), full=true).U
        @testinf svd(m23, full=true).S::StaticVector  ≊ svd(Matrix(m23), full=true).S
        @testinf svd(m23, full=true).Vt::StaticMatrix ≊ svd(Matrix(m23), full=true).Vt
        @testinf svd(m23', full=true).U::StaticMatrix  ≊ svd(Matrix(m23'), full=true).U
        @testinf svd(m23', full=true).S::StaticVector  ≊ svd(Matrix(m23'), full=true).S
        @testinf svd(m23', full=true).Vt::StaticMatrix ≊ svd(Matrix(m23'), full=true).Vt

        @testinf svd(transpose(m23)).U  ≊ svd(Matrix(transpose(m23))).U
        @testinf svd(transpose(m23)).S  ≊ svd(Matrix(transpose(m23))).S
        @testinf svd(transpose(m23)).Vt ≊ svd(Matrix(transpose(m23))).Vt

        @testinf svd(m3c).U  ≊ svd(Matrix(m3c)).U
        @testinf svd(m3c).S  ≊ svd(Matrix(m3c)).S
        @testinf svd(m3c).Vt ≊ svd(Matrix(m3c)).Vt

        @testinf svd(m3c).U  isa SMatrix{3,3,ComplexF64}
        @testinf svd(m3c).S  isa SVector{3,Float64}
        @testinf svd(m3c).Vt isa SMatrix{3,3,ComplexF64}

        @testinf svd(m3) \ v ≈ svd(Matrix(m3)) \ Vector(v)
        @testinf svd(m_sing) \ v ≈ svd(Matrix(m_sing)) \ Vector(v)
        @testinf svd(m_sing2) \ v ≈ svd(Matrix(m_sing2)) \ Vector(v)
        @testinf svd(m_sing2') \ v2 ≈ svd(Matrix(m_sing2')) \ Vector(v2)
        @testinf svd(m3) \ m23' ≈ svd(Matrix(m3)) \ Matrix(m23')
        @testinf svd(m_sing) \ m23' ≈ svd(Matrix(m_sing)) \ Matrix(m23')
        @testinf svd(m_sing2) \ m23' ≈ svd(Matrix(m_sing2)) \ Matrix(m23')
        @testinf svd(m_sing2; full=Val(true)) \ v ≈ svd(Matrix(m_sing2); full=true) \ Vector(v)
        @testinf svd(m_sing2'; full=Val(true)) \ v2 ≈ svd(Matrix(m_sing2'); full=true) \ Vector(v2)
        @testinf svd(m_sing2; full=Val(true)) \ m23' ≈ svd(Matrix(m_sing2); full=true) \ Matrix(m23')
        @testinf svd(m_sing2'; full=Val(true)) \ m23 ≈ svd(Matrix(m_sing2'); full=true) \ Matrix(m23)

        # Test that svd of rectangular matrix is inferred.
        # Note the placement of @inferred brackets is important.
        #
        # This only seems to work on v"1.5" due to unknown compiler improvements; seems
        # to have stopped working again on v"1.6" and later?
        svd_full_false(A) = svd(A, full=false)
        if VERSION < v"1.10-"
            @test svd_full_false(m_sing2).S ≈ svd(Matrix(m_sing2)).S
        else
            @test @inferred(svd_full_false(m_sing2)).S ≈ svd(Matrix(m_sing2)).S
        end

        @testinf svd(mc_sing) \ v ≈ svd(Matrix(mc_sing)) \ Vector(v)
        @testinf svd(mc_sing) \ vc ≈ svd(Matrix(mc_sing)) \ Vector(vc)
        @testinf svd(mc_sing) \ m23' ≈ svd(Matrix(mc_sing)) \ Matrix(m23')
        @testinf svd(mc_sing2) \ v ≈ svd(Matrix(mc_sing2)) \ Vector(v)
        @testinf svd(mc_sing2) \ vc ≈ svd(Matrix(mc_sing2)) \ Vector(vc)
        @testinf svd(mc_sing2') \ vc2 ≈ svd(Matrix(mc_sing2')) \ Vector(vc2)
        @testinf svd(mc_sing2) \ m23' ≈ svd(Matrix(mc_sing2)) \ Matrix(m23')
        @testinf svd(mc_sing2') \ m23 ≈ svd(Matrix(mc_sing2')) \ Matrix(m23)
        @testinf svd(mc_sing2; full=Val(true)) \ v ≈ svd(Matrix(mc_sing2); full=true) \ Vector(v)
        @testinf svd(mc_sing2; full=Val(true)) \ vc ≈ svd(Matrix(mc_sing2); full=true) \ Vector(vc)
        @testinf svd(mc_sing2'; full=Val(true)) \ vc2 ≈ svd(Matrix(mc_sing2'); full=true) \ Vector(vc2)
        @testinf svd(mc_sing2; full=Val(true)) \ m23' ≈ svd(Matrix(mc_sing2); full=true) \ Matrix(m23')
        @testinf svd(mc_sing2'; full=Val(true)) \ m23 ≈ svd(Matrix(mc_sing2'); full=true) \ Matrix(m23)
    end
end

module StaticArraysChainRulesCoreExt

using StaticArrays
# ChainRulesCore imports
import ChainRulesCore: NoTangent, ProjectTo, Tangent, project_type, rrule
import ChainRulesCore as CRC

# Projecting a tuple to SMatrix leads to CRC._projection_mismatch by default, so
# overloaded here
function (project::ProjectTo{<:Tangent{<:Tuple}})(dx::StaticArraysCore.SArray)
    dy = reshape(dx, axes(project.elements))
    dz = ntuple(i -> project.elements[i](dy[i]), length(project.elements))
    return project_type(project)(dz...)
end

# Project SArray to SArray
function ProjectTo(x::SArray{S, T}) where {S, T}
    # We have a axes field because it is expected by other ProjectTo's like the one for Transpose
    return ProjectTo{SArray}(; element = CRC._eltype_projectto(T), axes = axes(x),
        size = Size(x))
end

@inline _sarray_from_array(::Size{T}, dx::AbstractArray) where {T} = SArray{Tuple{T...}}(dx)

(project::ProjectTo{SArray})(dx::AbstractArray) = _sarray_from_array(project.size, dx)

# Adjoint for SArray constructor
function rrule(::Type{T}, x::Tuple) where {T <: SArray}
    project_x = ProjectTo(x)
    ∇Array(∂y) = (NoTangent(), project_x(∂y))
    return T(x), ∇Array
end

function rrule(::Type{T}, xs::Number...) where {T <: SVector}
    project_x = ProjectTo(xs)
    ∇Array(∂y) = (NoTangent(), project_x(∂y)...)
    return T(xs...), ∇Array
end

end

# define our own struct since LinearAlgebra.QR are restricted to Matrix
struct QR{Q,R,P}
    Q::Q
    R::R
    p::P
end

# iteration for destructuring into components
Base.iterate(S::QR) = (S.Q, Val(:R))
Base.iterate(S::QR, ::Val{:R}) = (S.R, Val(:p))
Base.iterate(S::QR, ::Val{:p}) = (S.p, Val(:done))
Base.iterate(S::QR, ::Val{:done}) = nothing

pivot_options = if isdefined(LinearAlgebra, :PivotingStrategy) # introduced in Julia v1.7
    (:(Val{true}), :(Val{false}), :NoPivot, :ColumnNorm)
else
    (:(Val{true}), :(Val{false}))
end
for pv in pivot_options
    @eval begin
        @inline function qr(A::StaticMatrix, pivot::$pv)
            QRp = _qr(Size(A), A, pivot)
            if length(QRp) === 2
                # create an identity permutation since that is cheap,
                # and much safer since, in the case of isbits types, we can't
                # safely leave the field undefined.
                p = identity_perm(QRp[2])
                return QR(QRp[1], QRp[2], p)
            else # length(QRp) === 3
                return QR(QRp[1], QRp[2], QRp[3])
            end 
        end
    end
end
"""
    qr(A::StaticMatrix,
       pivot::Union{Val{true}, Val{false}, LinearAlgebra.PivotingStrategy} = Val(false))

Compute the QR factorization of `A`. The factors can be obtained by iteration:

```jldoctest qr
julia> A = @SMatrix rand(3,4);

julia> Q, R = qr(A);

julia> Q * R ≈ A
true
```

or by using `getfield`:

```jldoctest qr
julia> F = qr(A);

julia> F.Q * F.R ≈ A
true
```
"""
qr(A::StaticMatrix) = qr(A, Val(false))

function identity_perm(R::StaticMatrix{N,M,T}) where {N,M,T}
    return similar_type(R, Int, Size((M,)))(ntuple(x -> x, Val{M}()))
end

_qreltype(::Type{T}) where T = typeof(zero(T)/sqrt(abs2(one(T))))

@generated function _qr(::Size{sA}, A::StaticMatrix{<:Any, <:Any, TA},
                        pivot = Val(false)) where {sA, TA}

    SizeQ = Size( sA[1], diagsize(Size(A)) )
    SizeR = Size( diagsize(Size(A)), sA[2] )

    if pivot === Val{true} || (isdefined(LinearAlgebra, :PivotingStrategy) && pivot === ColumnNorm)
        _pivot = isdefined(LinearAlgebra, :PivotingStrategy) ? ColumnNorm() : Val(true)
        return quote
            @_inline_meta
            Q0, R0, p0 = qr(Matrix(A), $(_pivot))
            T = _qreltype(TA)
            return similar_type(A, T, $(SizeQ))(Matrix(Q0)),
                   similar_type(A, T, $(SizeR))(R0),
                   similar_type(A, Int, $(Size(sA[2])))(p0)
        end
    else
        if (sA[1]*sA[1] + sA[1]*sA[2])÷2 * diagsize(Size(A)) < 17*17*17
            return quote
                @_inline_meta
                return qr_unrolled(Size(A), A, Val(false))
            end
        else
            _pivot = isdefined(LinearAlgebra, :PivotingStrategy) ? NoPivot() : Val(false)
            return quote
                @_inline_meta
                Q0R0 = qr(Matrix(A), $(_pivot))
                Q0, R0 = Matrix(Q0R0.Q), Q0R0.R
                T = _qreltype(TA)
                return similar_type(A, T, $(SizeQ))(Q0),
                       similar_type(A, T, $(SizeR))(R0)
            end
        end
    end
end


# Compute the QR decomposition of `A` such that `A = Q*R`
# by Householder reflections without pivoting.
#
# For original source code see below.
@generated function qr_unrolled(::Size{sA}, A::StaticMatrix{<:Any, <:Any, TA}, pivot::Val{false}) where {sA, TA}
    m, n = sA[1], sA[2]

    Q = [Symbol("Q_$(i)_$(j)") for i = 1:m, j = 1:m]
    R = [Symbol("R_$(i)_$(j)") for i = 1:m, j = 1:n]

    initQ = [:($(Q[i, j]) = $(i == j ? one : zero)(T)) for i = 1:m, j = 1:m]  # Q .= I
    initR = [:($(R[i, j]) = T(A[$i, $j])) for i = 1:m, j = 1:n]               # R .= A

    code = quote end
    for k = 1:min(m - 1 + !(TA<:Real), n)
        #x = view(R, k:m, k)
        #τk = reflector!(x)
        push!(code.args, :(ξ1 = $(R[k, k])))
        ex = :(normu = abs2(ξ1))
        for i = k+1:m
            ex = :($ex + abs2($(R[i, k])))
        end
        push!(code.args, :(normu = sqrt($ex)))
        push!(code.args, :(ν = copysign(normu, real(ξ1))))
        push!(code.args, :(ξ1 += ν))
        push!(code.args, :(invξ1 = ξ1 == zero(T) ? zero(T) : inv(ξ1)))
        push!(code.args, :($(R[k, k]) = -ν))
        for i = k+1:m
            push!(code.args, :($(R[i, k]) *= invξ1))
        end
        push!(code.args, :(τk = ν == zero(T) ? zero(T) : ξ1/ν))

        #reflectorApply!(x, τk, view(R, k:m, k+1:n))
        for j = k+1:n
            ex = :($(R[k, j]))
            for i = k+1:m
                ex = :($ex + $(R[i, k])'*$(R[i, j]))
            end
            push!(code.args, :(vRj = τk'*$ex))
            push!(code.args, :($(R[k, j]) -= vRj))
            for i = k+1:m
                push!(code.args, :($(R[i, j]) -= $(R[i, k])*vRj))
            end
        end

        #reflectorApplyRight!(x, τk, view(Q, 1:m, k:m))
        for i = 1:m
            ex = :($(Q[i, k]))
            for j = k+1:m
                ex = :($ex + $(Q[i, j])*$(R[j, k]))
            end
            push!(code.args, :(Qiv = $ex*τk))
            push!(code.args, :($(Q[i, k]) -= Qiv))
            for j = k+1:m
                push!(code.args, :($(Q[i, j]) -= Qiv*$(R[j, k])'))
            end
        end

        for i = k+1:m
            push!(code.args, :($(R[i, k]) = zero(T)))
        end
    end

    # truncate Q and R sizes in LAPACK consilient way
    mQ, nQ = m, min(m, n)
    mR, nR = min(m, n), n

    return quote
        @_inline_meta
        T = _qreltype(TA)
        @inbounds $(Expr(:block, initQ...))
        @inbounds $(Expr(:block, initR...))
        @inbounds $code
        @inbounds return similar_type(A, T, $(Size(mQ, nQ)))( tuple($(Q[1:mQ, 1:nQ]...)) ),
                         similar_type(A, T, $(Size(mR, nR)))( tuple($(R[1:mR, 1:nR]...)) )
    end

end


## Source for @generated qr_unrolled() function above.
## Derived from base/linalg/qr.jl
## thin=true version of QR
#function qr_unrolled(A::StaticMatrix{<:Any, <:Any, TA}) where {TA}
#    m, n = size(A)
#    T = _qreltype(TA)
#    Q = MMatrix{m,m,T,m*m}(I)
#    R = MMatrix{m,n,T,m*n}(A)
#    for k = 1:min(m - 1 + !(TA<:Real), n)
#        #x = view(R, k:m, k)
#        #τk = reflector!(x)
#        ξ1 = R[k, k]
#        normu = abs2(ξ1)
#        for i = k+1:m
#            normu += abs2(R[i, k])
#        end
#        normu = sqrt(normu)
#        ν = copysign(normu, real(ξ1))
#        ξ1 += ν
#        invξ1 = ξ1 == zero(T) ? zero(T) : inv(ξ1)
#        R[k, k] = -ν
#        for i = k+1:m
#            R[i, k] *= invξ1
#        end
#        τk = ν == zero(T) ? zero(T) : ξ1/ν
#
#        #reflectorApply!(x, τk, view(R, k:m, k+1:n))
#        for j = k+1:n
#            vRj = R[k, j]
#            for i = k+1:m
#                vRj += R[i, k]'*R[i, j]
#            end
#            vRj = τk'*vRj
#            R[k, j] -= vRj
#            for i = k+1:m
#                R[i, j] -= R[i, k]*vRj
#            end
#        end
#
#        #reflectorApplyRight!(x, τk, view(Q, 1:m, k:m))
#        for i = 1:m
#            Qiv = Q[i, k]
#            for j = k+1:m
#                Qiv += Q[i, j]*R[j, k]
#            end
#            Qiv = Qiv*τk
#            Q[i, k] -= Qiv
#            for j = k+1:m
#                Q[i, j] -= Qiv*R[j, k]'
#            end
#        end
#
#        for i = k+1:m
#            R[i, k] = zero(T)
#        end
#
#    end
#    if m > n
#        return (similar_type(A, T, Size(m, n))(Q[1:m,1:n]), similar_type(A, T, Size(n, n))(R[1:n,1:n]))
#    else
#        return (similar_type(A, T, Size(m, m))(Q), similar_type(A, T, Size(n, n))(R))
#    end
#end

# Each file of the form "bench_$(name).jl" in this directory is `include`d and
# its last statement is assumed to be a `BenchmarkGroup`.  This group is added
# to the top-level group `SUITE` with the `$name` extracted from the file name.

using BenchmarkTools
const SUITE = BenchmarkGroup()
for file in sort(readdir(@__DIR__))
    if startswith(file, "bench_") && endswith(file, ".jl")
        SUITE[chop(file, head = length("bench_"), tail = length(".jl"))] =
            include(file)
    end
end

@testset "Initialization with SA" begin

SA_test_ref(x)   = SA[1,x,x]
SA_test_ref(x,T) = SA{T}[1,x,x]
@test @inferred(SA_test_ref(2))   === SVector{3,Int}((1,2,2))
@test @inferred(SA_test_ref(2.0)) === SVector{3,Float64}((1,2,2))
@test @inferred(SA_test_ref(2,Float32))   === SVector{3,Float32}((1,2,2))

SA_test_vcat(x)   = SA[1;x;x]
SA_test_vcat(x,T) = SA{T}[1;x;x]
@test @inferred(SA_test_vcat(2))   === SVector{3,Int}((1,2,2))
@test @inferred(SA_test_vcat(2.0)) === SVector{3,Float64}((1,2,2))
@test @inferred(SA_test_vcat(2,Float32))   === SVector{3,Float32}((1,2,2))

SA_test_hcat(x)   = SA[1 x x]
SA_test_hcat(x,T) = SA{T}[1 x x]
@test @inferred(SA_test_hcat(2))   === SMatrix{1,3,Int}((1,2,2))
@test @inferred(SA_test_hcat(2.0)) === SMatrix{1,3,Float64}((1,2,2))
@test @inferred(SA_test_hcat(2,Float32))   === SMatrix{1,3,Float32}((1,2,2))

# hvcat needs to be in a function for the row argument to constant propagate
SA_test_hvcat(x) = SA[1 x x;
                      x 2 x]
SA_test_hvcat(x,T) = SA{T}[1 x x;
                           x 2 x]
@test @inferred(SA_test_hvcat(3))   === SMatrix{2,3,Int}((1,3,3,2,3,3))
@test @inferred(SA_test_hvcat(3.0)) === SMatrix{2,3,Float64}((1,3,3,2,3,3))
@test @inferred(SA_test_hvcat(1.0im)) === SMatrix{2,3,ComplexF64}((1,1im,1im,2,1im,1im))
@test @inferred(SA_test_hvcat(3,Float32))   === SMatrix{2,3,Float32}((1,3,3,2,3,3))

@test SA[1] === SVector{1,Int}((1))

@test_throws ArgumentError("SA[...] matrix rows of length (3, 2) are inconsistent") SA[1 2 3;
                                                                                       4 5]
@test_throws ArgumentError("SA[...] matrix rows of length (2, 3) are inconsistent") SA[1 2;
                                                                                       3 4 5]
@test SA_F64[1, 2] === SVector{2,Float64}((1,2))
@test SA_F32[1, 2] === SVector{2,Float32}((1,2))

@test_inlined SA[1,2]
@test_inlined SA[1 2]
@test_inlined SA[1;2]
@test_inlined SA_test_hvcat(3)

SA_test_hvncat1(x) = SA[1 x;x 2;;;x 2;1 x]
SA_test_hvncat2(x) = SA[1;x;;x;2;;;x;2;;1;x]
if VERSION >= v"1.7.0"
    @test SA[1;;;2] === SArray{Tuple{1,1,2}}(1,2)
    @test SA[1;2;;1;2] === SMatrix{2,2}(1,2,1,2)
    @test SA[1 2;1 2 ;;; 1 2;1 2] === SArray{Tuple{2,2,2}}(Tuple([1 2;1 2 ;;; 1 2;1 2]))
    @test_inlined SA_test_hvncat1(3)
    @test_inlined SA_test_hvncat2(2)
    if VERSION < v"1.10-DEV"
        @test_throws ArgumentError SA[1;2;;3]
    else
        @test_throws DimensionMismatch SA[1;2;;3]
    end
end

# https://github.com/JuliaArrays/StaticArrays.jl/pull/685
@test Union{}[] isa Vector{Union{}}
@test Base.typed_vcat(Union{}) isa Vector{Union{}}
@test Base.typed_hcat(Union{}) isa Vector{Union{}}
@test Base.typed_hvcat(Union{}, ()) isa Vector{Union{}}
@test_throws Union{MethodError, ArgumentError} Union{}[1]
@test_throws Union{MethodError, ArgumentError} Union{}[1 2]
@test_throws Union{MethodError, ArgumentError} Union{}[1; 2]
@test_throws Union{MethodError, ArgumentError} Union{}[1 2; 3 4]

end

"""
    SHermitianCompact{N, T, L} <: StaticMatrix{N, N, T}

A [`StaticArray`](@ref) subtype that can represent a Hermitian matrix. Unlike
`LinearAlgebra.Hermitian`, `SHermitianCompact` stores only the lower triangle
of the matrix (as an `SVector`), and the diagonal may not be real. The lower
triangle is stored in column-major order and the superdiagonal entries are 
`adjoint` to the transposed subdiagonal entries. The diagonal is returned as-is.
For example, for an `SHermitianCompact{3}`, the indices of the stored elements
can be visualized as follows:

```
┌ 1 ⋅ ⋅ ┐
| 2 4 ⋅ |
└ 3 5 6 ┘
```

Type parameters:
* `N`: matrix dimension;
* `T`: element type for lower triangle;
* `L`: length of the `SVector` storing the lower triangular elements.

Note that `L` is always the `N`th [triangular number](https://en.wikipedia.org/wiki/Triangular_number).

An `SHermitianCompact` may be constructed either:

* from an `AbstractVector` containing the lower triangular elements; or
* from a `Tuple` containing both upper and lower triangular elements in column major order; or
* from another `StaticMatrix`.

For the latter two cases, only the lower triangular elements are used; the upper triangular
elements are ignored.

When its element type is real, then a `SHermitianCompact` is both Hermitian and
symmetric. Otherwise, to ensure that a `SHermitianCompact` matrix, `a`, is
Hermitian according to `LinearAlgebra.ishermitian`, take an average with its
adjoint, i.e. `(a+a')/2`, or take a Hermitian view of the data with
`LinearAlgebra.Hermitian(a)`. However, the latter case is not specialized to use
the compact storage.
"""
struct SHermitianCompact{N, T, L} <: StaticMatrix{N, N, T}
    lowertriangle::SVector{L, T}

    @inline function SHermitianCompact{N, T, L}(lowertriangle::SVector{L}) where {N, T, L}
        _check_hermitian_parameters(Val(N), Val(L))
        new{N, T, L}(lowertriangle)
    end
end

@inline function _check_hermitian_parameters(::Val{N}, ::Val{L}) where {N, L}
    if 2 * L !== N * (N + 1)
        throw(ArgumentError("Size mismatch in SHermitianCompact parameters. Got dimension $N and length $L."))
    end
end

triangularnumber(N::Int) = div(N * (N + 1), 2)
@generated function triangularroot(::Val{L}) where {L}
    return div(isqrt(8 * L + 1) - 1, 2) # from quadratic formula
end

lowertriangletype(::Type{SHermitianCompact{N, T, L}}) where {N, T, L} = SVector{L, T}
lowertriangletype(::Type{SHermitianCompact{N, T}}) where {N, T} = SVector{triangularnumber(N), T}
lowertriangletype(::Type{SHermitianCompact{N}}) where {N} = SVector{triangularnumber(N)}

@inline SHermitianCompact{N, T}(lowertriangle::SVector{L}) where {N, T, L} = SHermitianCompact{N, T, L}(lowertriangle)
@inline SHermitianCompact{N}(lowertriangle::SVector{L, T}) where {N, T, L} = SHermitianCompact{N, T, L}(lowertriangle)

@inline function SHermitianCompact(lowertriangle::SVector{L, T}) where {T, L}
    N = triangularroot(Val(L))
    SHermitianCompact{N, T, L}(lowertriangle)
end

@generated function SHermitianCompact{N, T, L}(a::Tuple) where {N, T, L}
    _check_hermitian_parameters(Val(N), Val(L))
    expr = Vector{Expr}(undef, L)
    i = 0
    for col = 1 : N, row = col : N
        index = N * (col - 1) + row
        expr[i += 1] = :(a[$index])
    end
    quote
        @_inline_meta
        @inbounds return SHermitianCompact{N, T, L}(SVector{L, T}(tuple($(expr...))))
    end
end

@inline function SHermitianCompact{N, T}(a::Tuple) where {N, T}
    L = triangularnumber(N)
    SHermitianCompact{N, T, L}(a)
end

@inline (::Type{SSC})(a::SHermitianCompact) where {SSC <: SHermitianCompact} = SSC(a.lowertriangle)

@inline (::Type{SSC})(a::AbstractVector) where {SSC <: SHermitianCompact} = SSC(convert(lowertriangletype(SSC), a))

# disambiguation
@inline (::Type{SSC})(a::StaticArray{<:Tuple,<:Any,1}) where {SSC <: SHermitianCompact} = SSC(convert(SVector, a))

@generated function _hermitian_compact_indices(::Val{N}) where N
    # Returns a Tuple{Pair{Int, Bool}} I such that for linear index i,
    # * I[i][1] is the index into the lowertriangle field of an SHermitianCompact{N};
    # * I[i][2] is true iff i is an index into the lower triangle of an N × N matrix.
    indexmat = Matrix{Pair{Int, Bool}}(undef, N, N)
    i = 0
    for col = 1 : N, row = 1 : N
        indexmat[row, col] = if row >= col
            (i += 1) => true
        else
            indexmat[col, row][1] => false
        end
    end
    quote
        @_inline_meta
        return $(tuple(indexmat...))
    end
end

Base.@propagate_inbounds function Base.getindex(a::SHermitianCompact{N}, i::Int) where {N}
    I = _hermitian_compact_indices(Val(N))
    j, lower = I[i]
    @inbounds value = a.lowertriangle[j]
    return lower ? value : adjoint(value)
end

Base.@propagate_inbounds function Base.setindex(a::SHermitianCompact{N, T, L}, x, i::Int) where {N, T, L}
    I = _hermitian_compact_indices(Val(N))
    j, lower = I[i]
    value = lower ? x : adjoint(x)
    return SHermitianCompact{N}(setindex(a.lowertriangle, value, j))
end

# needed because it is used in convert.jl and the generic fallback is slow
@generated function Base.Tuple(a::SHermitianCompact{N}) where N
    exprs = [:(a[$i]) for i = 1 : N^2]
    quote
        @_inline_meta
        tuple($(exprs...))
    end
end

LinearAlgebra.ishermitian(a::SHermitianCompact{<:Any,<:Real}) = true
LinearAlgebra.ishermitian(a::SHermitianCompact) = a == a'
LinearAlgebra.issymmetric(a::SHermitianCompact{<:Any,<:Real}) = true
LinearAlgebra.issymmetric(a::SHermitianCompact) = a == transpose(a)

# TODO: factorize?

@inline Base.:(==)(a::SHermitianCompact, b::SHermitianCompact) = a.lowertriangle == b.lowertriangle
@generated function _map(f, a::SHermitianCompact...)
    S = Size(a[1])
    N = S[1]
    L = triangularnumber(N)
    exprs = Vector{Expr}(undef, L)
    for i ∈ 1:L
        tmp = [:(a[$j].lowertriangle[$i]) for j ∈ 1:length(a)]
        exprs[i] = :(f($(tmp...)))
    end
    return quote
        @_inline_meta
        same_size(a...)
        @inbounds return SHermitianCompact(SVector(tuple($(exprs...))))
    end
end

@inline Base.:*(a::Real, b::SHermitianCompact) = SHermitianCompact(a * b.lowertriangle)
@inline Base.:*(a::SHermitianCompact, b::Real) = SHermitianCompact(a.lowertriangle * b)
@inline Base.:*(a::Number, b::SHermitianCompact) = a * SMatrix(b)
@inline Base.:*(a::SHermitianCompact, b::Number) = SMatrix(a) * b

@inline Base.:/(a::SHermitianCompact, b::Real) = SHermitianCompact(a.lowertriangle / b)
@inline Base.:\(a::Real, b::SHermitianCompact) = SHermitianCompact(a \ b.lowertriangle)
@inline Base.:/(a::SHermitianCompact, b::Number) = SMatrix(a) / b
@inline Base.:\(a::Number, b::SHermitianCompact) = a \ SMatrix(b)

@inline Base.muladd(scalar::Number, a::SHermitianCompact, b::StaticArray) = muladd(scalar, SMatrix(a), b)
@inline Base.muladd(a::SHermitianCompact, scalar::Number, b::StaticArray) = muladd(SMatrix(a), scalar, b)
@inline Base.muladd(scalar::Real, a::SHermitianCompact, b::StaticArray) = map((ai, bi) -> muladd(scalar, ai, bi), a, b)
@inline Base.muladd(a::SHermitianCompact, scalar::Real, b::StaticArray) = map((ai, bi) -> muladd(ai, scalar, bi), a, b)

@inline Base.FastMath.mul_fast(a::Number, b::SHermitianCompact) = Base.FastMath.mul_fast(a, SMatrix(b))
@inline Base.FastMath.mul_fast(a::SHermitianCompact, b::Number) = Base.FastMath.mul_fast(SMatrix(a), b)
@inline Base.FastMath.mul_fast(a::Real, b::SHermitianCompact) = map(c -> Base.FastMath.mul_fast(a, c), b)
@inline Base.FastMath.mul_fast(a::SHermitianCompact, b::Real) = map(c -> Base.FastMath.mul_fast(c, b), a)

@generated function _plus_uniform(::Size{S}, a::SHermitianCompact{N, T, L}, λ) where {S, N, T, L}
    @assert S[1] == N
    @assert S[2] == N
    exprs = Vector{Expr}(undef, L)
    i = 0
    for col = 1 : N, row = col : N
        i += 1
        exprs[i] = row == col ? :(a.lowertriangle[$i] + λ) : :(a.lowertriangle[$i])
    end
    return quote
        @_inline_meta
        R = promote_type(eltype(a), typeof(λ))
        SHermitianCompact{N, R, L}(SVector{L, R}(tuple($(exprs...))))
    end
end

@generated function LinearAlgebra.transpose(a::SHermitianCompact{N, T, L}) where {N, T, L}
    # To conform with LinearAlgebra, the transpose should be recursive.
    # For this compact representation of a Hermitian matrix, that means that
    # we should recursively transpose of the diagonal elements, but only
    # conjugate the off-diagonal elements:
    # [A  Bᴴ]ᵀ  =  [Aᵀ  Bᵀ]  =  [Aᵀ      Bᵀ]
    # [B  C ]      [Bᴴᵀ Cᵀ]     [conj(B) Cᵀ]
    exprs = Vector{Expr}(undef, L)
    i = 0
    for col = 1 : N, row = col : N
        i += 1
        exprs[i] = row == col ? :(transpose(a.lowertriangle[$i])) : :(conj(a.lowertriangle[$i]))
    end
    return quote
        @_inline_meta
        SHermitianCompact{N}(SVector{L}(tuple($(exprs...))))
    end
end

@generated function LinearAlgebra.adjoint(a::SHermitianCompact{N, T, L}) where {N, T, L}
    # To conform with LinearAlgebra, the adjoint should be recursive.
    # Taking the adjoint of a Hermitian matrix is the identity, but
    # with this compact representation of a Hermitian matrix, care
    # should be taken that only the diagonal elements should be
    # recursively conjugate-transposed; the off-diagonal elements should
    # not:
    # [A  Bᴴ]ᴴ  =  [Aᴴ  Bᴴ]  =  [Aᴴ Bᴴ]
    # [B  C ]      [Bᴴᴴ Cᴴ]     [B  Cᴴ]
    exprs = Vector{Expr}(undef, L)
    i = 0
    for col = 1 : N, row = col : N
        i += 1
        exprs[i] = row == col ? :(adjoint(a.lowertriangle[$i])) : :(a.lowertriangle[$i])
    end
    return quote
        @_inline_meta
        SHermitianCompact{N}(SVector{L}(tuple($(exprs...))))
    end
end

@generated function _one(::Size{S}, ::Type{SSC}) where {S, SSC <: SHermitianCompact}
    N = S[1]
    L = triangularnumber(N)
    T = eltype(SSC)
    if T == Any
        T = Float64
    end
    exprs = Vector{Expr}(undef, L)
    i = 0
    for col = 1 : N, row = col : N
        exprs[i += 1] = row == col ? :(one($T)) : :(zero($T))
    end
    quote
        @_inline_meta
        return SHermitianCompact(SVector(tuple($(exprs...))))
    end
end

@inline _scalar_matrix(s::Size{S}, t::Type{SSC}) where {S, SSC <: SHermitianCompact} = _one(s, t)

# _fill covers fill, zeros, and ones:
@generated function _fill(val, ::Size{s}, ::Type{SSC}) where {s, SSC <: SHermitianCompact}
    N = s[1]
    L = triangularnumber(N)
    v = [:val for i = 1:L]
    return quote
        @_inline_meta
        $SSC(SVector(tuple($(v...))))
    end
end

@generated function _rand(randfun, rng::AbstractRNG, ::Type{SSC}) where {N, SSC <: SHermitianCompact{N}}
    T = eltype(SSC)
    if T == Any
        T = Float64
    end
    L = triangularnumber(N)
    v = [:(randfun(rng, $T)) for i = 1:L]
    return quote
        @_inline_meta
        $SSC(SVector(tuple($(v...))))
    end
end

@inline Random.rand(rng::AbstractRNG, ::Type{SSC}) where {SSC <: SHermitianCompact} = _rand(rand, rng, SSC)
@inline Random.randn(rng::AbstractRNG, ::Type{SSC}) where {SSC <: SHermitianCompact} = _rand(randn, rng, SSC)
@inline Random.randexp(rng::AbstractRNG, ::Type{SSC}) where {SSC <: SHermitianCompact} = _rand(randexp, rng, SSC)

using StaticArrays
using BenchmarkTools

import BenchmarkTools: prettytime, prettymemory

@noinline plus(a,b) = a+b
@noinline plus!(c,a,b) = broadcast!(+, c, a, b)

@noinline mul(a,b) = a*b
@noinline mul!(c,a,b) = A_mul_B!(c, a, b)


for T ∈ [Int64, Float64]
    for N ∈ [1,2,4,8,16,32,64,128,256]
        println("=====================================================================")
        println(" Vectors of length ", N, " and eltype ", T)
        println("=====================================================================")
        immutables = [rand(SVector{N,T})]
        mutables = [rand(T,N), rand(MVector{N,T}), SizedVector{N}(rand(T,N))]
        instances = vcat(immutables, mutables)

        namelengths = [length(string(nameof(typeof(v)))) for v ∈ instances]
        maxnamelength = maximum(namelengths)

        for v ∈ instances
            result = mean(@benchmark plus($(copy(v)), $(copy(v))))
            padding = maxnamelength - length(string(nameof(typeof(v))))
            println(nameof(typeof(v)), ":", " " ^ padding, " v3 = v1 + v2 takes ", prettytime(time(result)), ", ", prettymemory(memory(result)), " (GC ", prettytime(gctime(result)) , ")")
        end

        println()

        for v ∈ mutables
            result = mean(@benchmark plus!($(copy(v)), $(copy(v)), $(copy(v))))
            padding = maxnamelength - length(string(nameof(typeof(v))))
            println(nameof(typeof(v)), ":", " " ^ padding, " v3 .= +.(v1, v2) takes ", prettytime(time(result)), ", ", prettymemory(memory(result)), " (GC ", prettytime(gctime(result)) , ")")
        end

        println()

        if N > 16
            continue
        end
        println("=====================================================================")
        println(" Matrices of size ", N, "×", N, " and eltype ", T)
        println("=====================================================================")
        immutables = [rand(SMatrix{N,N,T})]
        mutables = [rand(T,N,N), rand(MMatrix{N,N,T}), SizedMatrix{N,N}(rand(T,N,N))]
        instances = vcat(immutables, mutables)

        namelengths = [length(string(nameof(typeof(v)))) for v ∈ instances]
        maxnamelength = maximum(namelengths)

        for m ∈ instances
            result = mean(@benchmark mul($(copy(m)), $(copy(m))))
            padding = maxnamelength - length(string(nameof(typeof(m))))
            println(nameof(typeof(m)), ":", " " ^ padding, " m3 = m1 * m2 takes ", prettytime(time(result)), ", ", prettymemory(memory(result)), " (GC ", prettytime(gctime(result)) , ")")
        end

        println()

        for m ∈ mutables
            result = mean(@benchmark mul!($(copy(m)), $(copy(m)), $(copy(m))))
            padding = maxnamelength - length(string(nameof(typeof(m))))
            println(nameof(typeof(m)), ":", " " ^ padding, " A_mul_B!(m3, m1, m2) takes ", prettytime(time(result)), ", ", prettymemory(memory(result)), " (GC ", prettytime(gctime(result)) , ")")
        end

        println()

    end
end

const SOneToSupertype = isdefined(Base, :AbstractOneTo) ?  Base.AbstractOneTo : AbstractUnitRange

"""
    SOneTo(n)

Return a statically-sized `AbstractUnitRange` starting at `1`, functioning as the `axes` of
a `StaticArray`.
"""
struct SOneTo{n} <: SOneToSupertype{Int}
end

SOneTo(n::Int) = SOneTo{n}()
function SOneTo{n}(r::AbstractUnitRange) where n
    ((first(r) == 1) & (last(r) == n)) && return SOneTo{n}()

    errmsg(r) = throw(DimensionMismatch("$r is inconsistent with SOneTo{$n}")) # avoid GC frame
    errmsg(r)
end

Base.Tuple(::SOneTo{N}) where N = ntuple(identity, Val(N))

Base.axes(s::SOneTo) = (s,)
Base.size(s::SOneTo) = (length(s),)
Base.length(s::SOneTo{n}) where {n} = n

# The axes of a Slice'd SOneTo use the SOneTo itself
Base.axes(S::Base.Slice{<:SOneTo}) = (S.indices,)
Base.unsafe_indices(S::Base.Slice{<:SOneTo}) = (S.indices,)
Base.axes1(S::Base.Slice{<:SOneTo}) = S.indices

@propagate_inbounds function Base.getindex(s::SOneTo, i::Int)
    @boundscheck checkbounds(s, i)
    return i
end
@propagate_inbounds function Base.getindex(s::SOneTo, s2::SOneTo)
    @boundscheck checkbounds(s, s2)
    return s2
end

Base.first(::SOneTo) = 1
Base.last(::SOneTo{n}) where {n} = n::Int

function Base.iterate(::SOneTo{n}) where {n}
    if n::Int < 1
        return nothing
    else
        (1, 1)
    end
end
function Base.iterate(::SOneTo{n}, s::Int) where {n}
    if s < n::Int
        s2 = s + 1
        return (s2, s2)
    else
        return nothing
    end
end

function Base.getproperty(::SOneTo{n}, s::Symbol) where {n}
    if s === :start
        return 1
    elseif s === :stop
        return n::Int
    else
        error("type SOneTo has no property $s")
    end
end

function Base.show(io::IO, @nospecialize(x::SOneTo))
    print(io, "SOneTo(", length(x)::Int, ")")
end

Base.@pure function Base.checkindex(::Type{Bool}, ::SOneTo{n1}, ::SOneTo{n2}) where {n1, n2}
    return n1::Int >= n2::Int
end

Base.promote_rule(a::Type{Base.OneTo{T}}, ::Type{SOneTo{n}}) where {T,n} =
    Base.OneTo{promote_type(T, Int)}

function Base.reduced_indices(inds::Tuple{SOneTo,Vararg{SOneTo}}, d::Int)
    Base.reduced_indices(map(Base.OneTo, inds), d)
end

Base.intersect(r::SOneTo{n1}, s::SOneTo{n2}) where {n1,n2} = SOneTo(min(n1, n2))
Base.union(r::SOneTo{n1}, s::SOneTo{n2}) where {n1,n2} = SOneTo(max(n1, n2))

@generated function (::Type{MArray{S,T,N}})(::UndefInitializer) where {S,T,N}
    return quote
        $(Expr(:meta, :inline))
        MArray{S, T, N, $(tuple_prod(S))}(undef)
    end
end

@generated function (::Type{MArray{S,T}})(::UndefInitializer) where {S,T}
    return quote
        $(Expr(:meta, :inline))
        MArray{S, T, $(tuple_length(S)), $(tuple_prod(S))}(undef)
    end
end

####################
## MArray methods ##
####################

@propagate_inbounds function getindex(v::MArray, i::Int)
    @boundscheck checkbounds(v,i)
    T = eltype(v)

    if isbitstype(T)
        return GC.@preserve v unsafe_load(Base.unsafe_convert(Ptr{T}, pointer_from_objref(v)), i)
    end
    getfield(v,:data)[i]
end

@propagate_inbounds function setindex!(v::MArray, val, i::Int)
    @boundscheck checkbounds(v,i)
    T = eltype(v)

    if isbitstype(T)
        GC.@preserve v unsafe_store!(Base.unsafe_convert(Ptr{T}, pointer_from_objref(v)), convert(T, val), i)
    else
        # This one is unsafe (#27)
        # unsafe_store!(Base.unsafe_convert(Ptr{Ptr{Nothing}}, pointer_from_objref(v.data)), pointer_from_objref(val), i)
        error("setindex!() with non-isbitstype eltype is not supported by StaticArrays. Consider using SizedArray.")
    end

    return v
end

@inline Base.Tuple(v::MArray) = getfield(v,:data)

Base.dataids(ma::MArray) = (UInt(pointer(ma)),)

@inline function Base.unsafe_convert(::Type{Ptr{T}}, a::MArray{S,T}) where {S,T}
    Base.unsafe_convert(Ptr{T}, pointer_from_objref(a))
end

"""
    @MArray [a b; c d]
    @MArray [[a, b];[c, d]]
    @MArray [i+j for i in 1:2, j in 1:2]
    @MArray ones(2, 2, 2)

A convenience macro to construct `MArray` with arbitrary dimension.
See [`@SArray`](@ref) for detailed features.
"""
macro MArray(ex)
    static_array_gen(MArray, ex, __module__)
end

function promote_rule(::Type{<:MArray{S,T,N,L}}, ::Type{<:MArray{S,U,N,L}}) where {S,T,U,N,L}
    MArray{S,promote_type(T,U),N,L}
end

@generated function _indices_have_bools(indices::Tuple)
    return any(index -> index <: StaticVector{<:Any,Bool}, indices.parameters)
end

function Base.view(
    a::MArray{S},
    indices::Union{Integer, Colon, StaticVector, Base.Slice, SOneTo}...,
) where {S}
    view_from_invoke = invoke(view, Tuple{AbstractArray, typeof(indices).parameters...}, a, indices...)
    if _indices_have_bools(indices)
        return view_from_invoke
    else
        new_size = new_out_size(S, indices...)
        return SizedArray{new_size}(view_from_invoke)
    end
end

Base.elsize(::Type{<:MArray{<:Any, T}}) where T = Base.elsize(Vector{T})

module BenchMatrixOps

import Random
using BenchmarkTools
using LinearAlgebra
using StaticArrays

const suite = BenchmarkGroup()
const matrix_sizes = if haskey(ENV, "GITHUB_EVENT_PATH")
    (1, 2, 3, 4, 10)
else
    1:10
end

# Use same arrays across processes (at least with the same Julia version):
Random.seed!(1234)

# Unary operators
for f in [det, inv, exp]
    s1 = suite["$f"] = BenchmarkGroup()
    for N in matrix_sizes
        SA = @SMatrix rand(N, N)
        A = Array(SA)
        s2 = s1[string(N, pad=2)] = BenchmarkGroup()
        s2["SMatrix"] = @benchmarkable $f($SA)
        s2["Matrix"] = @benchmarkable $f($A)
    end
end

# Binary operators
for f in [*, \]
    s1 = suite["$f"] = BenchmarkGroup()
    for N in matrix_sizes
        SA = @SMatrix rand(N, N)
        SB = @SMatrix rand(N, N)
        A = Array(SA)
        B = Array(SB)
        s2 = s1[string(N, pad=2)] = BenchmarkGroup()
        s2["SMatrix"] = @benchmarkable $f($SA, $SB)
        s2["Matrix"] = @benchmarkable $f($A, $B)
    end
end

# Multiply-add
function benchmark_matmul(s,N1,N2,ArrayType)
    if ArrayType <: MArray
        Mat = MMatrix
        A = rand(Mat{N1,N2})
        B = rand(Mat{N2,N2})
        C = rand(Mat{N1,N2})
        label = "MMatrix"
    elseif ArrayType <: SizedArray
        Mat = SizedMatrix
        A = rand(Mat{N1,N2})
        B = rand(Mat{N2,N2})
        C = rand(Mat{N1,N2})
        label = "SizedMatrix"
    elseif ArrayType <: Array
        A = rand(N1,N2)
        B = rand(N2,N2)
        C = rand(N1,N2)
        label = "Matrix"
    end
    α,β = 1.0, 1.0
    s1 = s["mul!(C,A,B)"][string(N1, pad=2) * string(N2, pad=2)] = BenchmarkGroup()
    s2 = s["mul!(C,A,B,α,β)"][string(N1, pad=2) * string(N2, pad=2)] = BenchmarkGroup()
    s3 = s["mul!(B,A',C)"][string(N1, pad=2) * string(N2, pad=2)] = BenchmarkGroup()
    s4 = s["mul!(B,A',C,α,β)"][string(N1, pad=2) * string(N2, pad=2)] = BenchmarkGroup()

    s1[label] = @benchmarkable mul!($C,$A,$B)
    s2[label] = @benchmarkable mul!($C,$A,$B,$α,$β)
    s3[label] = @benchmarkable mul!($B,Transpose($A),$C)
    s4[label] = @benchmarkable mul!($B,Transpose($A),$C,$α,$β)
end

begin
    suite["mul!(C,A,B)"] = BenchmarkGroup(["inplace", "multiply-add"])
    suite["mul!(C,A,B,α,β)"] = BenchmarkGroup(["inplace", "multiply-add"])
    suite["mul!(B,A',C)"] = BenchmarkGroup(["inplace", "multiply-add"])
    suite["mul!(B,A',C,α,β)"] = BenchmarkGroup(["inplace", "multiply-add"])
    for N in matrix_sizes
        for Mat in (MMatrix, SizedMatrix, Matrix)
            benchmark_matmul(suite, N+1, N, Mat)
        end
    end
end


end  # module
BenchMatrixOps.suite

module TestCheckBoundsNo

using Test
using StaticArrays

# https://github.com/JuliaArrays/StaticArrays.jl/issues/1155
@testset "Issue #1155" begin
  u = @inferred(SVector(1, 2))
  v = @inferred(SVector(3.0, 4.0))
  a = 1.0
  b = 2
  result = @inferred(a * u + b * v)
  @test result ≈ @inferred(SVector(7, 10))
end

end # module

using StaticArrays, Test

@testset "Indexing" begin
    @testset "Linear getindex() on SVector" begin
        sv = SVector{4}(4,5,6,7)

        # SVector
        @test (@inferred getindex(sv, SVector(4,3,2,1))) === SVector((7,6,5,4))

        # Colon
        @test (@inferred getindex(sv,:)) === sv

        # SArray
        @test (@inferred getindex(sv, SMatrix{2,2}(1,4,2,3))) === SMatrix{2,2}(4,7,5,6)
    end

    @testset "Linear getindex() on SMatrix" begin
        sv = SVector{4}(4,5,6,7)
        sm = SMatrix{2,2}(4,5,6,7)

        # SVector
        @test (@inferred getindex(sm, SVector(4,3,2,1))) === SVector((7,6,5,4))

        # Colon
        @test (@inferred getindex(sm,:)) === sv

        # SArray
        @test (@inferred getindex(sm, SMatrix{2,2}(1,4,2,3))) === SMatrix{2,2}(4,7,5,6)
    end

    @testset "Linear getindex()/setindex!() on MVector" begin
        vec = @SVector [4,5,6,7]

        # SVector
        mv = MVector{4,Int}(undef)
        @test (mv[SVector(1,2,3,4)] = vec; (@inferred getindex(mv, SVector(4,3,2,1)))::MVector{4,Int} == MVector((7,6,5,4)))
        @test setindex!(mv, vec, SVector(1,2,3,4)) === mv

        mv = MVector{4,Int}(undef)
        @test (mv[SVector(1,2,3,4)] = [4, 5, 6, 7]; (@inferred getindex(mv, SVector(4,3,2,1)))::MVector{4,Int} == MVector((7,6,5,4)))
        @test (mv[SVector(1,2,3,4)] = 2; (@inferred getindex(mv, SVector(4,3,2,1)))::MVector{4,Int} == MVector((2,2,2,2)))

        mv = MVector(0,0,0)
        @test (mv[SVector(1,3)] = [4, 5]; (@inferred mv == MVector(4,0,5)))

        mv = MVector(0,0,0)
        @test (mv[SVector(1,3)] = SVector(4, 5); (@inferred mv == MVector(4,0,5)))

        mv = MVector(0,0,0)
        @test (mv[SMatrix{2,1}(1,3)] = SMatrix{2,1}(4, 5); (@inferred mv == MVector(4,0,5)))

        # Colon
        mv = MVector{4,Int}(undef)
        @test (mv[:] = vec; (@inferred getindex(mv, :))::MVector{4,Int} == MVector((4,5,6,7)))
        @test (mv[:] = [4, 5, 6, 7]; (@inferred getindex(mv, :))::MVector{4,Int} == MVector((4,5,6,7)))
        @test (mv[:] = 2; (@inferred getindex(mv, :))::MVector{4,Int} == MVector((2,2,2,2)))
        @test setindex!(mv, 2, :) === mv

        @test_throws DimensionMismatch setindex!(mv, SVector(1,2,3), SVector(1,2,3,4))
        @test_throws DimensionMismatch setindex!(mv, SVector(1,2,3), :)
        @test_throws DimensionMismatch setindex!(mv, view(ones(8), 1:5), :)
        @test_throws DimensionMismatch setindex!(mv, [1,2,3], SVector(1,2,3,4))
    end

    @testset "Linear getindex()/setindex!() on MMatrix" begin
        vec = @SVector [4,5,6,7]

        # SVector
        mm = MMatrix{2,2,Int}(undef)
        @test (mm[SVector(1,2,3,4)] = vec; (@inferred getindex(mm, SVector(4,3,2,1)))::MVector{4,Int} == MVector((7,6,5,4)))

        # Colon
        mm = MMatrix{2,2,Int}(undef)
        @test (mm[:] = vec; (@inferred getindex(mm, :))::MVector{4,Int} == MVector((4,5,6,7)))

        # SMatrix
        mm = MMatrix{2,2,Int}(undef)
        mi = MMatrix{2,2}(4,2,1,3)
        data = @SMatrix [4 5; 6 7]
        @test (mm[mi] = data; (@inferred getindex(mm, :))::MVector{4,Int} == MVector((5,6,7,4)))
    end

    @testset "Linear getindex()/setindex!() with a SVector on an Array" begin
        v = [11,12,13]

        @test (v[SVector(2,3)] = [22,23]; (v[2] == 22) & (v[3] == 23))
    end

    @testset "Fancy APL indexing" begin
        @test @SVector([1,2,3,4])[@SMatrix([1 2; 3 4])] === @SMatrix([1 2; 3 4])
    end

    @testset "2D getindex() on SVector" begin
        v = @SVector [1,2]
        @test v[1,1] == 1
        @test v[2,1] == 2
        @test_throws BoundsError v[1,2]
        @test_throws BoundsError v[3,1]
    end

    @testset "2D getindex() on SMatrix" begin
        sm = @SMatrix [1 3; 2 4]

        # Scalar
        @test sm[1,1] === 1
        @test sm[2,1] === 2
        @test sm[1,2] === 3
        @test sm[2,2] === 4

        # SVector, scalar
        @test (@inferred getindex(sm, SVector(2,1), SVector(2,1))) === @SMatrix [4 2; 3 1]
        @test (@inferred getindex(sm, 1, SVector(1,2))) === @SVector [1,3]
        @test (@inferred getindex(sm, SVector(1,2), 1)) === @SVector [1,2]

        # Colon
        @test (@inferred getindex(sm, :, :)) === @SMatrix [1 3; 2 4]
        @test (@inferred getindex(sm, SVector(2,1), :)) === @SMatrix [2 4; 1 3]
        @test (@inferred getindex(sm, :, SVector(2,1))) === @SMatrix [3 1; 4 2]
        @test (@inferred getindex(sm, 1, :)) === @SVector [1,3]
        @test (@inferred getindex(sm, :, 1)) === @SVector [1,2]

        # SOneTo
        @testinf sm[SOneTo(1),:] === @SMatrix [1 3]
        @testinf sm[:,SOneTo(1)] === @SMatrix [1;2]
    end

    @testset "2D getindex()/setindex! on MMatrix" begin
        sm = @MMatrix [1 3; 2 4]

        # Tuple, scalar
        @test (mm = MMatrix{2,2,Int}(undef); mm[SVector(2,1),SVector(2,1)] = sm[SVector(2,1),SVector(2,1)]; (@inferred getindex(mm, SVector(2,1), SVector(2,1)))::MMatrix == @MMatrix [4 2; 3 1])
        @test (mm = MMatrix{2,2,Int}(undef); mm[1,SVector(1,2)] = sm[1,SVector(1,2)]; (@inferred getindex(mm, 1, SVector(1,2)))::MVector == @MVector [1,3])
        @test (mm = MMatrix{2,2,Int}(undef); mm[SVector(1,2),1] = sm[SVector(1,2),1]; (@inferred getindex(mm, SVector(1,2), 1))::MVector == @MVector [1,2])

        # Colon
        @test (mm = MMatrix{2,2,Int}(undef); mm[:,:] = sm[:,:]; (@inferred getindex(mm, :, :))::MMatrix == @MMatrix [1 3; 2 4])
        @test (mm = MMatrix{2,2,Int}(undef); mm[SVector(2,1),:] = sm[SVector(2,1),:]; (@inferred getindex(mm, SVector(2,1), :))::MMatrix == @MMatrix [2 4; 1 3])
        @test (mm = MMatrix{2,2,Int}(undef); mm[:,SVector(2,1)] = sm[:,SVector(2,1)]; (@inferred getindex(mm, :, SVector(2,1)))::MMatrix == @MMatrix [3 1; 4 2])
        @test (mm = MMatrix{2,2,Int}(undef); mm[1,:] = sm[1,:]; (@inferred getindex(mm, 1, :))::MVector == @MVector [1,3])
        @test (mm = MMatrix{2,2,Int}(undef); mm[:,1] = sm[:,1]; (@inferred getindex(mm, :, 1))::MVector == @MVector [1,2])

        # SOneTo
        @test (mm = MMatrix{2,2,Int}(undef); mm[SOneTo(1),:] = sm[SOneTo(1),:]; (@inferred getindex(mm, SOneTo(1), :))::MMatrix == @MMatrix [1 3])
        @test (mm = MMatrix{2,2,Int}(undef); mm[:,SOneTo(1)] = sm[:,SOneTo(1)]; (@inferred getindex(mm, :, SOneTo(1)))::MMatrix == @MMatrix [1;2])

        # #866
        @test_throws DimensionMismatch setindex!(MMatrix(SA[1 2; 3 4]), SA[3,4], 1, SA[1,2,3])
        @test_throws DimensionMismatch setindex!(MMatrix(SA[1 2; 3 4]), [3,4], 1, SA[1,2,3])
    end

    @testset "3D scalar indexing" begin
        sa = SArray{Tuple{2,2,2}, Int}([i*j*k for i = 1:2, j = 2:3, k=3:4])

        @test sa[1,1,2] === 8
        @test sa[1,2,1] === 9
        @test sa[2,1,1] === 12

        ma = MArray{Tuple{2,2,2}, Int}(undef)
        @test (ma[1,1,2] = 8; ma[1,1,2] === 8)
        @test (ma[1,2,1] = 9; ma[1,2,1] === 9)
        @test (ma[2,1,1] = 12; ma[2,1,1] === 12)
    end

    @testset "4D scalar indexing" begin
        sa = SArray{Tuple{2,2,2,2}, Int}([i*j*k*l for i = 1:2, j = 2:3, k=3:4, l=4:5])

        @test sa[1,1,1,2] === 30
        @test sa[1,1,2,1] === 32
        @test sa[1,2,1,1] === 36
        @test sa[2,1,1,1] === 48

        ma = MArray{Tuple{2,2,2,2}, Int}(undef)
        @test (ma[1,1,1,2] = 30; ma[1,1,1,2] === 30)
        @test (ma[1,1,2,1] = 32; ma[1,1,2,1] === 32)
        @test (ma[1,2,1,1] = 36; ma[1,2,1,1] === 36)
        @test (ma[2,1,1,1] = 48; ma[2,1,1,1] === 48)
    end

    @testset "4D StaticArray indexing" begin
        sa = SArray{Tuple{2,2,2,2}, Int}([i*j*k*l for i = 1:2, j = 2:3, k=3:4, l=4:5])
        @test (@inferred getindex(sa, 1, 1, 1, SVector(1,2))) === @SVector [24,30]
        @test (@inferred getindex(sa, 1, 1, SVector(1,2), 1)) === @SVector [24,32]
        @test (@inferred getindex(sa, 1, SVector(1,2), 1, 1)) === @SVector [24,36]
        @test (@inferred getindex(sa, SVector(1,2), 1, 1, 1)) === @SVector [24,48]
        a = [i*j*k*l for i = 1:2, j = 2:3, k=3:4, l=4:5]
        @test (@inferred getindex(a, 1, 1, 1, SVector(1,2))) == [24,30]
        @test (@inferred getindex(a, 1, 1, SVector(1,2), 1)) == [24,32]
        @test (@inferred getindex(a, 1, SVector(1,2), 1, 1)) == [24,36]
        @test (@inferred getindex(a, SVector(1,2), 1, 1, 1)) == [24,48]
    end

    @testset "Indexing with empty vectors" begin
        a = [1.0 2.0; 3.0 4.0]
        @test a[SVector{0,Int}()] == SVector{0,Float64}(())
        @test a[SVector{0,Int}(),SVector{0,Int}()] == SMatrix{0,0,Float64,0}(())
        b = copy(a)
        a[SVector{0,Int}()] = 5.0
        @test b == a
    end

    @testset "Indexing empty arrays" begin
        @test size(SVector{0,Float64}()[:]) == (0,)
        @test size(SMatrix{0,0,Float64}()[:,:]) == (0,0)
        @test size(SMatrix{5,0,Float64}()[1,:]) == (0,)
        @test size(SMatrix{5,0,Float64}()[:,:]) == (5,0)
        @test size(SMatrix{0,5,Float64}()[:,1]) == (0,)
        @test size(SMatrix{0,5,Float64}()[:,:]) == (0,5)

        @test (zeros(0)[SVector{0,Int}()] = 0) == 0
        @test (zeros(0,2)[SVector{0,Int}(),SVector(1)] = 0) == 0
        @test (zeros(2,0)[SVector(1),SVector{0,Int}()] = 0) == 0
    end

    @testset "Viewing zero-dimensional arrays" begin
        # issue #705
        A = zeros()
        B = MArray{Tuple{},Float64,0,1}(0.0)
        @test @inferred(view(A))[] == 0.0
        @test @inferred(view(B))[] == 0.0
    end

    @testset "Using SArray as index for view" begin
        a = collect(11:20)
        @test view(a, SVector(1,2,3)) == [11,12,13]
        @test_throws BoundsError view(a, SVector(1,11,3))
        B = rand(Int,3,4,5,6)
        Bv = view(B, 1, (@SVector [2, 1]), [2, 3], (@SVector [4]))
        @test Bv == B[1, [2,1], 2:3, [4]]
        @test axes(Bv, 1) === SOneTo(2)
        @test axes(Bv, 3) === SOneTo(1)
        Bvv = view(Bv, (@SVector [1, 2]), 2, 1)
        @test axes(Bvv) === (SOneTo(2),)
        @test Bvv[1] == B[1, 2, 3, 4]
        Bvv[1] = 100
        @test Bvv[1] == 100
        @test B[1,2,3,4] == 100
        @test eltype(Bvv) == Int
        @test Bvv[:] == [B[1,2,3,4], B[1,1,3,4]]
    end

    @testset "Supporting external code calling to_indices on StaticArray (issue #878)" begin
        a = @SArray randn(2, 3, 4)
        ind = to_indices(a, (CartesianIndex(1, 2), SA[2, 3]))
        @test ind[1] === StaticArrays.StaticIndexing(1)
        @test ind[3][2] === 3
        @test (@inferred Base.to_index(ind[1])) === 1
        @test (@inferred Base.to_index(ind[2])) === 2
        @test (@inferred Base.to_index(ind[3])) === SA[2, 3]
        @test (ind[3]...,) === (2, 3)
        @test (@inferred length(ind[3])) === 2
        @test length(ind) === 3
        @test firstindex(ind[3]) === 1
        @test lastindex(ind[3]) === 2
        @test size(ind[3]) === (2,)
    end

    @testset "Array view into `Any` eltype `SArray`" begin
        A = SVector{4, Any}(1,2,3,4)
        v = @inferred view(A, SA[3, 1])
        @test v == SVector{2, Any}(3, 1)
        A = SMatrix{2, 2, Any}(1, 2, 3, 4)
        v = @inferred view(A, @SArray(fill(1, 1, 1)))
        @test v == SMatrix{1, 1, Any}(1)
        A = SArray{Tuple{2, 2, 2}, Any}(1, 2, 3, 4, 5, 6, 7, 8)
        v = @inferred view(A, @SArray(fill(1, 1, 1, 1)))
        @test v == SArray{Tuple{1, 1, 1}, Any}(1)
    end
end

using StaticArrays
using BenchmarkTools

a = m = 0
for K = 1:22
    a = rand(SMatrix{K,K,Float64,K*K})
    m = Matrix(a)
    print("Size($K,$K)\n  Compilation time:")
    @time qr(a)
    @btime qr($a)
    @btime qr($m)
end

using StaticArrays, Test, LinearAlgebra

"""
Create an almost singular `Matrix{Float64}` of size `N×N`.

The first `rank` columns are chosen randomly, followed by `N-rank` linear
combinations with random weights to create an `N×N` singular matrix `S`.
A noise matrix of norm `ϵ*norm(S)` is added.

The condition number of this matrix should be approximately ϵ/eps(Float64)
"""
function almost_singular_matrix(N, rank, ϵ)
    B = rand(N,rank)
    weights = rand(rank, N-rank) ./ rank
    S = [B B*weights]
    S = S ./ norm(S)
    noise = rand(N,N)
    S + ϵ*norm(S)/norm(noise) * noise
end

@testset "Matrix inverse" begin
    @test inv(SMatrix{0,0,Int}())::SMatrix === SMatrix{0,0,Float64}()
    @test inv(@SMatrix [2])::SMatrix ≈ @SMatrix [0.5]
    @test inv(@SMatrix [1 2; 2 1])::SMatrix ≈ [-1/3 2/3; 2/3 -1/3]
    @test inv(@SMatrix [1 2 0; 2 1 0; 0 0 1])::SMatrix ≈ [-1/3 2/3 0; 2/3 -1/3 0; 0 0 1]
    @test inv(@SMatrix [1+im 2 0; 1 2-im 1; 1 1 2+im])::SMatrix ≈ [2-2im  -3+1im   1-1im
                                                         -1+0im   2+1im  -1+0im
                                                          0+1im   0-1im   1-0.0im]/2

    m = randn(Float64, 10,10) + 10*I # well conditioned
    @test inv(SMatrix{10,10}(m))::StaticMatrix ≈ inv(m)


    # Unsigned versions
    @test inv(@SMatrix [0x01 0x02; 0x02 0x01])::SMatrix ≈ [-1/3 2/3; 2/3 -1/3]
    @test inv(@SMatrix [0x01 0x02 0x00; 0x02 0x01 0x00; 0x00 0x00 0x01])::SMatrix ≈ [-1/3 2/3 0; 2/3 -1/3 0; 0 0 1]

    m = triu(randn(Float64, 4,4) + 4*I)
    @test inv(SMatrix{4,4}(m))::StaticMatrix ≈ inv(m)
    m = tril(randn(Float64, 4,4) + 4*I)
    @test inv(SMatrix{4,4}(m))::StaticMatrix ≈ inv(m)
end


@testset "Matrix inverse 4x4" begin
    # A random well-conditioned matrix generated with `rand(1:10,4,4)`
    m = Float64[8 4 3 1;
                9 1 9 8;
                5 0 2 1;
                7 5 7 2]
    sm = SMatrix{4,4}(m)
    @test isapprox(inv(sm)::StaticMatrix, inv(m), rtol=2e-15)

    # A permutation matrix which can cause problems for inversion methods
    # without pivoting, eg 2x2 block decomposition (see #250)
    mperm = [1 0 0 0;
             0 0 1 0;
             0 1 0 0;
             0 0 0 1]
    @test inv(SMatrix{4,4}(mperm))::StaticMatrix ≈ inv(mperm)  rtol=2e-16

    # Poorly conditioned matrix; almost_singular_matrix(4, 3, 1e-7)
    m = [
        2.83056817904263402e-01 1.26822318692296848e-01 2.59665505365002547e-01 1.24524798964590747e-01
        4.29869029098094768e-01 2.29977256378012789e-03 4.63841570354149135e-01 1.51975221831027241e-01
        2.33883312850939995e-01 7.69469213907006122e-02 3.16525493661056589e-01 1.06181613512460249e-01
        1.63327582123091175e-01 1.70552365412100865e-01 4.55720450934200327e-01 1.23299968650232419e-01
    ]
    sm = SMatrix{4,4}(m)
    @test norm(Matrix(sm*inv(sm) - 4*I)) < 12*norm(m*inv(m) - 4*I)
    @test norm(Matrix(inv(sm)*sm - 4*I)) < 12*norm(inv(m)*m - 4*I)

    # Poorly conditioned matrix, generated by fuzz testing with
    # almost_singular_matrix(N, 3, 1e-7)
    # Case where the 4x4 algorithm fares badly compared to Base inv
    m = [1.80589503332920231e-02 2.37595944073211218e-01 3.80770755039433806e-01 5.70474286930408372e-02
         2.17494123374967520e-02 2.94069278741667661e-01 2.57334651147732463e-01 4.02348559939922357e-02
         3.42945636322714076e-01 3.29329508494837497e-01 2.25635541033857107e-01 6.03912636987153917e-02
         4.77828437366344727e-01 4.86406974015710591e-01 1.95415684569693188e-01 6.74775080892497797e-02]
    sm = SMatrix{4,4}(m)
    @test norm(Matrix(inv(sm)*sm - 4*I)) < 12*norm(inv(m)*m - 4*I)
    @test norm(Matrix(sm*inv(sm) - 4*I)) < 12*norm(m*inv(m) - 4*I)
end

@testset "Matrix inverse 5x5" begin
    m = randn(Float64, 5,5) + 5*I
    @test inv(SMatrix{5,5}(m))::StaticMatrix ≈ inv(m)
    m = triu(randn(Float64, 5,5) + 5*I)
    @test inv(SMatrix{5,5}(m))::StaticMatrix ≈ inv(m)
    m = tril(randn(Float64, 5,5) + 5*I)
    @test inv(SMatrix{5,5}(m))::StaticMatrix ≈ inv(m)
end

@testset "Matrix inverse ($typ, $sz×$sz)" for sz in (5, 8, 15), typ in (Float64, Complex{Float64})
    A = rand(typ, sz, sz)
    SA = SMatrix{sz,sz,typ}(A)
    @test inv(A) ≈ inv(SA)
end

@testset "LU to inverse" for sz in (5, 8, 15), typ in (Float64, Complex{Float64})
    A = rand(typ, sz, sz)
    SA = SMatrix{sz,sz,typ}(A)
    @test inv(lu(A)) ≈ inv(lu(SA))
    @test_throws DimensionMismatch inv(lu(SMatrix{sz,sz+1,typ}(rand(typ, sz, sz+1))))
    @test_throws DimensionMismatch inv(lu(SMatrix{sz+1,sz,typ}(rand(typ, sz+1, sz))))
end

#-------------------------------------------------------------------------------
# More comprehensive but qualitative testing for inv() accuracy
#=
using PyPlot

inv_residual(A::AbstractMatrix) = norm(A*inv(A) - Matrix(I, size(A)...))

"""
    plot_residuals(N, rank, ϵ)

Plot `inv_residual(::StaticMatrix)` vs `inv_residual(::Matrix)`

"""
function plot_residuals(N, rank, ϵ)
    A_residuals = []
    SA_residuals = []
    for i=1:10000
        A = almost_singular_matrix(N, rank, ϵ)
        SA = SMatrix{N,N}(A)
        SA_residual = norm(Matrix(SA*inv(SA) - Matrix(I, N, N)))
        A_residual = norm(A*inv(A) - Matrix(I, N, N))
        push!(SA_residuals, SA_residual)
        push!(A_residuals, A_residual)
        #= if SA_residual/A_residual > 10000 =#
        #=     @printf("%10e %.4f\n", SA_residual, SA_residual/A_residual) =#
        #=     println("[") =#
        #=     for i=1:4 =#
        #=         for j=1:4 =#
        #=             @printf("%.17e ", A[i,j]) =#
        #=         end =#
        #=         println() =#
        #=     end =#
        #=     println("]") =#
        #= end =#
    end
    loglog(A_residuals, SA_residuals, ".", markersize=1.5)
end

# Plot the accuracy of inv implementations for almost singular matrices of
# various rank
clf()
N = 4
title("inv() accuracy for poorly conditioned $(N)x$(N) - Base vs block decomposition")
labels = []
for i in N:-1:1
    plot_residuals(N, i, 1e-7)
    push!(labels, "rank $i")
end
xlabel("Residual norm: `inv(::Array)`")
ylabel("Residual norm: `inv(::StaticArray)`")
legend(labels)
=#

@testset "MVector" begin
    @testset "Inner Constructors" begin
        @test MVector{1,Int}((1,)).data === (1,)
        @test MVector{1,Float64}((1,)).data === (1.0,)
        @test MVector{2,Float64}((1,1.0)).data === (1.0,1.0)
        @test isa(MVector{1,Int}(undef), MVector{1,Int})

        @test_throws Exception MVector{2,Int}((1,))
        @test_throws Exception MVector{1,Int}(())
        @test_throws Exception MVector{Int,1}((1,))
    end

    @testset "Outer constructors and macro" begin
        @test MVector{1}((1,)).data === (1,)
        @test MVector{1}((1.0,)).data === (1.0,)
        @test MVector((1,)).data === (1,)
        @test MVector((1.0,)).data === (1.0,)

        # Constructors should create a copy (#335)
        v = MVector(1,2)
        @test MVector(v) !== v && MVector(v) == v

        # test for #557-like issues
        @test (@inferred MVector(SVector{0,Float64}()))::MVector{0,Float64} == MVector{0,Float64}()

        @test MVector{3}(i for i in 1:3).data === (1,2,3)
        @test MVector{3}(float(i) for i in 1:3).data === (1.0,2.0,3.0)
        @test MVector{0,Int}().data === ()
        @test MVector{3,Int}(i for i in 1:3).data === (1,2,3)
        @test MVector{3,Float64}(i for i in 1:3).data === (1.0,2.0,3.0)
        @test MVector{1}(MVector(MVector(1.0), MVector(2.0))[j] for j in 1:1) == MVector((MVector(1.0),))
        @test_throws Exception MVector{3}(i for i in 1:2)
        @test_throws Exception MVector{3}(i for i in 1:4)
        @test_throws Exception MVector{3,Int}(i for i in 1:2)
        @test_throws Exception MVector{3,Int}(i for i in 1:4)

        @test MVector(1).data === (1,)
        @test MVector(1,1.0).data === (1.0,1.0)

        @test ((@MVector [1.0])::MVector{1}).data === (1.0,)
        @test ((@MVector [1, 2, 3])::MVector{3}).data === (1, 2, 3)
        @test ((@MVector Float64[1,2,3])::MVector{3}).data === (1.0, 2.0, 3.0)
        @test ((@MVector [i for i = 1:3])::MVector{3}).data === (1, 2, 3)
        @test ((@MVector Float64[i for i = 1:3])::MVector{3}).data === (1.0, 2.0, 3.0)

        @test ((@MVector zeros(2))::MVector{2, Float64}).data === (0.0, 0.0)
        @test ((@MVector ones(2))::MVector{2, Float64}).data === (1.0, 1.0)
        @test ((@MVector fill(2.5, 2))::MVector{2,Float64}).data === (2.5, 2.5)
        @test ((@MVector zeros(Float32, 2))::MVector{2,Float32}).data === (0.0f0, 0.0f0)
        @test ((@MVector ones(Float32, 2))::MVector{2,Float32}).data === (1.0f0, 1.0f0)

        @testset "@MVector rand*" begin
            n = 4
            @test (@MVector rand(n)) isa MVector{n, Float64}
            @test (@MVector randn(n)) isa MVector{n, Float64}
            @test (@MVector randexp(n)) isa MVector{n, Float64}
            @test (@MVector rand(4)) isa MVector{4, Float64}
            @test (@MVector randn(4)) isa MVector{4, Float64}
            @test (@MVector randexp(4)) isa MVector{4, Float64}
            @test (@MVector rand(_rng(), n)) isa MVector{n, Float64}
            @test (@MVector rand(_rng(), n)) == rand(_rng(), n)
            @test (@MVector randn(_rng(), n)) isa MVector{n, Float64}
            @test (@MVector randn(_rng(), n)) == randn(_rng(), n)
            @test (@MVector randexp(_rng(), n)) isa MVector{n, Float64}
            @test (@MVector randexp(_rng(), n)) == randexp(_rng(), n)
            @test (@MVector rand(_rng(), 4)) isa MVector{4, Float64}
            @test (@MVector rand(_rng(), 4)) == rand(_rng(), 4)
            @test (@MVector randn(_rng(), 4)) isa MVector{4, Float64}
            @test (@MVector randn(_rng(), 4)) == randn(_rng(), 4)
            @test (@MVector randexp(_rng(), 4)) isa MVector{4, Float64}
            @test (@MVector randexp(_rng(), 4)) == randexp(_rng(), 4)

            for T in (Float32, Float64)
                @test (@MVector rand(T, n)) isa MVector{n, T}
                @test (@MVector randn(T, n)) isa MVector{n, T}
                @test (@MVector randexp(T, n)) isa MVector{n, T}
                @test (@MVector rand(T, 4)) isa MVector{4, T}
                @test (@MVector randn(T, 4)) isa MVector{4, T}
                @test (@MVector randexp(T, 4)) isa MVector{4, T}
                @test (@MVector rand(_rng(), T, n)) isa MVector{n, T}
                VERSION≥v"1.7" && @test (@MVector rand(_rng(), T, n)) == rand(_rng(), T, n) broken=(T===Float32)
                @test (@MVector randn(_rng(), T, n)) isa MVector{n, T}
                @test (@MVector randn(_rng(), T, n)) == randn(_rng(), T, n)
                @test (@MVector randexp(_rng(), T, n)) isa MVector{n, T}
                @test (@MVector randexp(_rng(), T, n)) == randexp(_rng(), T, n)
                @test (@MVector rand(_rng(), T, 4)) isa MVector{4, T}
                VERSION≥v"1.7" && @test (@MVector rand(_rng(), T, 4)) == rand(_rng(), T, 4) broken=(T===Float32)
                @test (@MVector randn(_rng(), T, 4)) isa MVector{4, T}
                @test (@MVector randn(_rng(), T, 4)) == randn(_rng(), T, 4)
                @test (@MVector randexp(_rng(), T, 4)) isa MVector{4, T}
                @test (@MVector randexp(_rng(), T, 4)) == randexp(_rng(), T, 4)
            end
        end

        @testset "expand error" begin
            test_expand_error(:(@MVector fill(1.5, 2, 3)))
            test_expand_error(:(@MVector ones(2, 3, 4)))
            test_expand_error(:(@MVector rand(Float64, 2, 3, 4)))
            test_expand_error(:(@MVector sin(1:5)))
            test_expand_error(:(@MVector [i*j for i in 1:2, j in 2:3]))
            test_expand_error(:(@MVector Float32[i*j for i in 1:2, j in 2:3]))
            test_expand_error(:(@MVector [1; 2; 3]...))
            test_expand_error(:(@MVector a))
            test_expand_error(:(@MVector [[1 2];[3 4]]))
        end

        if VERSION >= v"1.7.0"
            @test ((@MVector Float64[1;2;3;;;])::MVector{3}).data === (1.0, 2.0, 3.0)
            @test ((@MVector [1;2;3;;;])::MVector{3}).data === (1, 2, 3)
        end
    end

    @testset "Methods" begin
        v = @MVector [11, 12, 13]

        @test isimmutable(v) == false

        @test v[1] === 11
        @test v[2] === 12
        @test v[3] === 13

        @testinf Tuple(v) === (11, 12, 13)

        @test size(v) === (3,)
        @test size(typeof(v)) === (3,)
        @test size(MVector{3}) === (3,)

        @test size(v, 1) === 3
        @test size(v, 2) === 1
        @test size(typeof(v), 1) === 3
        @test size(typeof(v), 2) === 1

        @test length(v) === 3

        @test reverse(v) == reverse(collect(v), dims = 1)
    end

    @testset "setindex!" begin
        v = @MVector [1,2,3]
        v[1] = 11
        v[2] = 12
        v[3] = 13
        @test v.data === (11, 12, 13)
        @test setindex!(v, 13, 3) === v

        v = @MVector [1.,2.,3.]
        v[1] = Float16(11)
        @test v.data === (11., 2., 3.)

        @test_throws BoundsError setindex!(v, 4., -1)
        @test_throws BoundsError setindex!(v, 4., 4)

        # setindex with non-elbits type
        v = MVector{2,String}(undef)
        @test_throws ErrorException setindex!(v, "a", 1)
    end

    @testset "Named field access - getproperty/setproperty!" begin
        # getproperty
        v4 = @MVector [10,20,30,40]
        @test v4.x == 10
        @test v4.y == 20
        @test v4.z == 30
        @test v4.w == 40

        v2 = @MVector [10,20]
        @test v2.x == 10
        @test v2.y == 20
        @test_throws ErrorException v2.z
        @test_throws ErrorException v2.w

        # setproperty!
        @test (v4.x = 100) == 100
        @test (v4.y = 200) == 200
        @test (v4.z = 300) == 300
        @test (v4.w = 400) == 400
        @test v4[1] == 100
        @test v4[2] == 200
        @test v4[3] == 300
        @test v4[4] == 400

        @test (v2.x = 100) == 100
        @test (v2.y = 200) == 200
        @test_throws ErrorException (v2.z = 200)
        @test_throws ErrorException (v2.w = 200)
    end
end

using BenchmarkTools
using LinearAlgebra
using StaticArrays

add!(C, A, B) = (C .= A .+ B)

function simple_bench(N, T=Float64)
    A = rand(T,N,N)
    A = A'*A
    B = copy(A)
    SA = SMatrix{N,N}(A)
    MA = MMatrix{N,N}(A)
    MB = copy(MA)

    print("""
============================================
    Benchmarks for $N×$N $T matrices
============================================
""")
    ops = [
           ("Matrix multiplication              ", *,        (A, A),     (SA, SA)),
           ("Matrix multiplication (mutating)   ", mul!,     (B, A, A),  (MB, MA, MA)),
           ("Matrix addition                    ", +,        (A, A),     (SA, SA)),
           ("Matrix addition (mutating)         ", add!,     (B, A, A),  (MB, MA, MA)),
           ("Matrix determinant                 ", det,      (A,),       (SA,)),
           ("Matrix inverse                     ", inv,      (A,),       (SA,)),
           ("Matrix symmetric eigendecomposition", eigen,    (A,),       (SA,)),
           ("Matrix Cholesky decomposition      ", cholesky, (A,),       (SA,)),
           ("Matrix LU decomposition            ", lu,       (A,),       (SA,)),
           ("Matrix QR decomposition            ", qr,       (A,),       (SA,)),
    ]
    for (name, op, Aargs, SAargs) in ops
        # We load from Ref's here to avoid the compiler completely removing the
        # benchmark in some cases.
        #
        # Like any microbenchmark, the speedups you see here should only be
        # taken as roughly indicative of the speedup you may see in real code.
        if length(Aargs) == 1
            A1  = Ref(Aargs[1])
            SA1 = Ref(SAargs[1])
            speedup = @belapsed($op($A1[])) / @belapsed($op($SA1[]))
        elseif length(Aargs) == 2
            A1  = Ref(Aargs[1])
            A2  = Ref(Aargs[2])
            SA1 = Ref(SAargs[1])
            SA2 = Ref(SAargs[2])
            speedup = @belapsed($op($A1[], $A2[])) / @belapsed($op($SA1[], $SA2[]))
        elseif length(Aargs) == 3
            A1  = Ref(Aargs[1])
            A2  = Ref(Aargs[2])
            A3  = Ref(Aargs[3])
            SA1 = Ref(SAargs[1])
            SA2 = Ref(SAargs[2])
            SA3 = Ref(SAargs[3])
            speedup = @belapsed($op($A1[], $A2[], $A3[])) / @belapsed($op($SA1[], $SA2[], $SA3[]))
        else
        end
        println(name*" -> $(round(speedup, digits=1))x speedup")
    end
end

simple_bench(3)

@testset "MMatrix" begin
    @testset "Inner Constructors" begin
        @test MMatrix{1,1,Int,1}((1,)).data === (1,)
        @test MMatrix{1,1,Float64,1}((1,)).data === (1.0,)
        @test MMatrix{2,2,Float64,4}((1, 1.0, 1, 1)).data === (1.0, 1.0, 1.0, 1.0)
        @test isa(MMatrix{1,1,Int,1}(undef), MMatrix{1,1,Int,1})
        @test isa(MMatrix{1,1,Int}(undef), MMatrix{1,1,Int,1})

        # Bad input
        @test_throws Exception MMatrix{2,1,Int,2}((1,))
        @test_throws Exception MMatrix{1,1,Int,1}(())

        # Bad parameters
        @test_throws Exception MMatrix{1,1,Int,2}((1,))
        @test_throws Exception MMatrix{1,1,1,1}((1,))
        @test_throws ArgumentError MMatrix{1,2,Int,1}((1,))
        @test_throws ArgumentError MMatrix{2,1,Int,1}((1,))
    end

    @testset "Outer constructors and macro" begin
        # The following tests are much similar in `test/SMatrix.jl`
        @test_throws Exception MMatrix(1,2,3,4) # unknown constructor

        @test MMatrix{1,1,Int}((1,)).data === (1,)
        @test MMatrix{1,1}((1,)).data === (1,)
        @test MMatrix{1}((1,)).data === (1,)

        @test MMatrix{2,2,Int}((1,2,3,4)).data === (1,2,3,4)
        @test MMatrix{2,2}((1,2,3,4)).data === (1,2,3,4)
        @test MMatrix{2}((1,2,3,4)).data === (1,2,3,4)
        @test_throws DimensionMismatch MMatrix{2}((1,2,3,4,5))

        # test for #557-like issues
        @test (@inferred MMatrix(SMatrix{0,0,Float64}()))::MMatrix{0,0,Float64} == MMatrix{0,0,Float64}()

        @test (MMatrix{2,3}(i+10j for i in 1:2, j in 1:3)::MMatrix{2,3}).data ===
            (11,12,21,22,31,32)
        @test (MMatrix{2,3}(float(i+10j) for i in 1:2, j in 1:3)::MMatrix{2,3}).data ===
            (11.0,12.0,21.0,22.0,31.0,32.0)
        @test (MMatrix{0,0,Int}()::MMatrix{0,0}).data === ()
        @test (MMatrix{0,3,Int}()::MMatrix{0,3}).data === ()
        @test (MMatrix{2,0,Int}()::MMatrix{2,0}).data === ()
        @test (MMatrix{2,3,Int}(i+10j for i in 1:2, j in 1:3)::MMatrix{2,3}).data ===
            (11,12,21,22,31,32)
        @test (MMatrix{2,3,Float64}(i+10j for i in 1:2, j in 1:3)::MMatrix{2,3}).data ===
            (11.0,12.0,21.0,22.0,31.0,32.0)
        @test_throws Exception MMatrix{2,3}(i+10j for i in 1:1, j in 1:3)
        @test_throws Exception MMatrix{2,3}(i+10j for i in 1:3, j in 1:3)
        @test_throws Exception MMatrix{2,3,Int}(i+10j for i in 1:1, j in 1:3)
        @test_throws Exception MMatrix{2,3,Int}(i+10j for i in 1:3, j in 1:3)

        @test ((@MMatrix [1.0])::MMatrix{1,1}).data === (1.0,)
        @test ((@MMatrix [1 2])::MMatrix{1,2}).data === (1, 2)
        @test ((@MMatrix [1 ; 2])::MMatrix{2,1}).data === (1, 2)
        @test ((@MMatrix [1 2 ; 3 4])::MMatrix{2,2}).data === (1, 3, 2, 4)

        @test ((@MMatrix Int[1.0])::MMatrix{1,1}).data === (1,)
        @test ((@MMatrix Float64[1 2])::MMatrix{1,2}).data === (1.0, 2.0)
        @test ((@MMatrix Float64[1 ; 2])::MMatrix{2,1}).data === (1.0, 2.0)
        @test ((@MMatrix Float64[1 2 ; 3 4])::MMatrix{2,2}).data === (1.0, 3.0, 2.0, 4.0)

        @test ((@MMatrix [i*j for i = 1:2, j=2:3])::MMatrix{2,2}).data === (2, 4, 3, 6)
        @test ((@MMatrix Float64[i*j for i = 1:2, j=2:3])::MMatrix{2,2}).data === (2.0, 4.0, 3.0, 6.0)

        @testset "expand error" begin
            test_expand_error(:(@MMatrix [1 2; 3]))
            test_expand_error(:(@MMatrix Float32[1 2; 3]))
            test_expand_error(:(@MMatrix [i*j*k for i = 1:2, j=2:3, k=3:4]))
            test_expand_error(:(@MMatrix Float32[i*j*k for i = 1:2, j=2:3, k=3:4]))
            test_expand_error(:(@MMatrix fill(2.3, 4, 5, 6)))
            test_expand_error(:(@MMatrix ones(4, 5, 6, 7)))
            test_expand_error(:(@MMatrix ones))
            test_expand_error(:(@MMatrix sin(1:5)))
            test_expand_error(:(@MMatrix [1; 2; 3; 4]...))
            test_expand_error(:(@MMatrix a))
        end

        @test ((@MMatrix [1 2.;3 4])::MMatrix{2, 2, Float64}).data === (1., 3., 2., 4.) #issue #911
        @test ((@MMatrix fill(3.4, 2,2))::MMatrix{2, 2, Float64}).data === (3.4, 3.4, 3.4, 3.4)
        @test ((@MMatrix zeros(2,2))::MMatrix{2, 2, Float64}).data === (0.0, 0.0, 0.0, 0.0)
        @test ((@MMatrix ones(2,2))::MMatrix{2, 2, Float64}).data === (1.0, 1.0, 1.0, 1.0)
        @test ((@MMatrix zeros(Float32, 2, 2))::MMatrix{2,2,Float32}).data === (0.0f0, 0.0f0, 0.0f0, 0.0f0)
        @test ((@MMatrix ones(Float32, 2, 2))::MMatrix{2,2,Float32}).data === (1.0f0, 1.0f0, 1.0f0, 1.0f0)

        @testset "@MMatrix rand*" begin
            n = 4
            @testset "zero-length" begin
                @test (@MMatrix rand(0, 0)) isa MMatrix{0, 0, Float64}
                @test (@MMatrix rand(0, n)) isa MMatrix{0, n, Float64}
                @test (@MMatrix rand(n, 0)) isa MMatrix{n, 0, Float64}
                @test (@MMatrix rand(Float32, 0, 0)) isa MMatrix{0, 0, Float32}
                @test (@MMatrix rand(Float32, 0, n)) isa MMatrix{0, n, Float32}
                @test (@MMatrix rand(Float32, n, 0)) isa MMatrix{n, 0, Float32}
                @test (@MMatrix rand(_rng(), Float32, 0, 0)) isa MMatrix{0, 0, Float32}
                @test (@MMatrix rand(_rng(), Float32, 0, n)) isa MMatrix{0, n, Float32}
                @test (@MMatrix rand(_rng(), Float32, n, 0)) isa MMatrix{n, 0, Float32}
            end

            @test (@MMatrix rand(n, n)) isa MMatrix{n, n, Float64}
            @test (@MMatrix randn(n, n)) isa MMatrix{n, n, Float64}
            @test (@MMatrix randexp(n, n)) isa MMatrix{n, n, Float64}
            @test (@MMatrix rand(4, 4)) isa MMatrix{4, 4, Float64}
            @test (@MMatrix randn(4, 4)) isa MMatrix{4, 4, Float64}
            @test (@MMatrix randexp(4, 4)) isa MMatrix{4, 4, Float64}
            @test (@MMatrix rand(_rng(), n, n)) isa MMatrix{n, n, Float64}
            @test (@MMatrix rand(_rng(), n, n)) == rand(_rng(), n, n)
            @test (@MMatrix randn(_rng(), n, n)) isa MMatrix{n, n, Float64}
            @test (@MMatrix randn(_rng(), n, n)) == randn(_rng(), n, n)
            @test (@MMatrix randexp(_rng(), n, n)) isa MMatrix{n, n, Float64}
            @test (@MMatrix randexp(_rng(), n, n)) == randexp(_rng(), n, n)
            @test (@MMatrix rand(_rng(), 4, 4)) isa MMatrix{4, 4, Float64}
            @test (@MMatrix rand(_rng(), 4, 4)) == rand(_rng(), 4, 4)
            @test (@MMatrix randn(_rng(), 4, 4)) isa MMatrix{4, 4, Float64}
            @test (@MMatrix randn(_rng(), 4, 4)) == randn(_rng(), 4, 4)
            @test (@MMatrix randexp(_rng(), 4, 4)) isa MMatrix{4, 4, Float64}
            @test (@MMatrix randexp(_rng(), 4, 4)) == randexp(_rng(), 4, 4)

            for T in (Float32, Float64)
                @test (@MMatrix rand(T, n, n)) isa MMatrix{n, n, T}
                @test (@MMatrix randn(T, n, n)) isa MMatrix{n, n, T}
                @test (@MMatrix randexp(T, n, n)) isa MMatrix{n, n, T}
                @test (@MMatrix rand(T, 4, 4)) isa MMatrix{4, 4, T}
                @test (@MMatrix randn(T, 4, 4)) isa MMatrix{4, 4, T}
                @test (@MMatrix randexp(T, 4, 4)) isa MMatrix{4, 4, T}
                @test (@MMatrix rand(_rng(), T, n, n)) isa MMatrix{n, n, T}
                VERSION≥v"1.7" && @test (@MMatrix rand(_rng(), T, n, n)) == rand(_rng(), T, n, n) broken=(T===Float32)
                @test (@MMatrix randn(_rng(), T, n, n)) isa MMatrix{n, n, T}
                @test (@MMatrix randn(_rng(), T, n, n)) == randn(_rng(), T, n, n)
                @test (@MMatrix randexp(_rng(), T, n, n)) isa MMatrix{n, n, T}
                @test (@MMatrix randexp(_rng(), T, n, n)) == randexp(_rng(), T, n, n)
                @test (@MMatrix rand(_rng(), T, 4, 4)) isa MMatrix{4, 4, T}
                VERSION≥v"1.7" && @test (@MMatrix rand(_rng(), T, 4, 4)) == rand(_rng(), T, 4, 4) broken=(T===Float32)
                @test (@MMatrix randn(_rng(), T, 4, 4)) isa MMatrix{4, 4, T}
                @test (@MMatrix randn(_rng(), T, 4, 4)) == randn(_rng(), T, 4, 4)
                @test (@MMatrix randexp(_rng(), T, 4, 4)) isa MMatrix{4, 4, T}
                @test (@MMatrix randexp(_rng(), T, 4, 4)) == randexp(_rng(), T, 4, 4)
            end
        end

        @inferred MMatrix(rand(MMatrix{3, 3})) # issue 356
        @test MMatrix(SMatrix{1,1,Int,1}((1,))).data == (1,)
        @test_throws DimensionMismatch MMatrix{3}((1,2,3,4))

        if VERSION >= v"1.7.0"
            @test ((@MMatrix Float64[1;2;3;;;])::MMatrix{3,1}).data === (1.0, 2.0, 3.0)
            @test ((@MMatrix [1;2;3;;;])::MMatrix{3,1}).data === (1, 2, 3)
            test_expand_error(:(@MMatrix [1;2;;;1;2]))
        end
    end

    @testset "Methods" begin
        m = @MMatrix [11 13; 12 14]

        @test isimmutable(m) == false

        @test m[1] === 11
        @test m[2] === 12
        @test m[3] === 13
        @test m[4] === 14

        @testinf Tuple(m) === (11, 12, 13, 14)

        @test size(m) === (2, 2)
        @test size(typeof(m)) === (2, 2)
        @test size(MMatrix{2,2}) === (2, 2)

        @test size(m, 1) === 2
        @test size(m, 2) === 2
        @test size(typeof(m), 1) === 2
        @test size(typeof(m), 2) === 2

        @test length(m) === 4

        @test reverse(m) == reverse(reverse(collect(m), dims = 2), dims = 1)
    end

    @testset "setindex!" begin
        m = @MMatrix [0 0; 0 0]
        m[1] = 11
        m[2] = 12
        m[3] = 13
        m[4] = 14
        @test m.data === (11, 12, 13, 14)
        @test setindex!(m, 13, 3) === m
        @test setindex!(m, 12, 2, 1) === m

        m = @MMatrix [0 0; 0 0]
        m[1] = Int8(11)
        m[2] = Int8(12)
        m[3] = Int8(13)
        m[4] = Int8(14)
        @test m.data === (11, 12, 13, 14)

        # setindex with non-elbits type
        m = MMatrix{2,2,String}(undef)
        @test_throws ErrorException setindex!(m, "a", 1, 1)
    end
end

using StaticArrays, Test
# Serialize `xs` as type `T` to an IOBuffer one by one using Base.write.
# Return the buffer positioned at the start, ready for reading
write_buf(::Type{T}, xs...) where {T} = write_buf(map(T, xs)...)

function write_buf(xs...)
    io = IOBuffer()
    foreach(x->write(io, x), xs)
    seek(io, 0)
    io
end

@testset "Binary IO" begin
    @testset "read!" begin
        # Read static arrays from a stream which was serialized elementwise
        @test read(write_buf(UInt8, 1,2,3), SVector{3,UInt8})         === SVector{3,UInt8}(1,2,3)
        @test read(write_buf(Int32, -1,2,3), SVector{3,Int32})        === SVector{3,Int32}(-1,2,3)
        @test read(write_buf(Float64, 1,2,3), SVector{3,Float64})     === SVector{3,Float64}(1,2,3)
        @test read(write_buf(Float64, 1,2,3,4), SMatrix{2,2,Float64}) === @SMatrix [1.0 3.0; 2.0 4.0]
    end

    @testset "write" begin
        # Compare serialized bytes
        @test take!(write_buf(UInt8, 1,2,3))     == take!(write_buf(SVector{3,UInt8}(1,2,3)))
        @test take!(write_buf(Int32, -1,2,3))    == take!(write_buf(SVector{3,Int32}(-1,2,3)))
        @test take!(write_buf(Float64, 1,2,3))   == take!(write_buf(SVector{3,Float64}(1,2,3)))
        @test take!(write_buf(Float64, 1,2,3,4)) == take!(write_buf(@SMatrix [1.0 3.0; 2.0 4.0]))
    end

    @testset "read!" begin
        # Read static arrays from a stream which was serialized elementwise
        @test read!(write_buf(UInt8, 1,2,3),     zeros(MVector{3,UInt8}))     == MVector{3,UInt8}(1,2,3)
        @test read!(write_buf(Int32, -1,2,3),    zeros(MVector{3,Int32}))     == MVector{3,Int32}(-1,2,3)
        @test read!(write_buf(Float64, 1,2,3),   zeros(MVector{3,Float64}))   == MVector{3,Float64}(1,2,3)
        @test read!(write_buf(Float64, 1,2,3,4), zeros(MMatrix{2,2,Float64})) == @MMatrix [1.0 3.0; 2.0 4.0]
        # Test that read! does, in fact, modify an MVector rather than return a copy.
        m = zeros(MVector{3,UInt8})
        read!(write_buf(UInt8, 1,2,3), m)
        @test m == MVector{3,UInt8}(1,2,3)
    end
end

@inline function read(io::IO, ::Type{SA}) where {SA<:StaticArray}
    elements = Ref{NTuple{length(SA),eltype(SA)}}()
    read!(io, elements)
    SA(elements[])
end

@inline function read!(io::IO, a::SA) where {SA<:StaticArray}
    unsafe_read(io, Base.unsafe_convert(Ptr{eltype(SA)}, a), sizeof(a))
    a
end

@inline function write(io::IO, a::SA) where {SA<:StaticArray}
    write(io, Ref(Tuple(a)))
end

import Base: +, -, *, /, \

#--------------------------------------------------
# Vector space algebra

# Unary ops
@inline +(a::StaticArray) = map(+, a)
@inline -(a::StaticArray) = map(-, a)

# Binary ops
# Between arrays
@inline +(a::StaticArray, b::StaticArray) = map(+, a, b)
@inline +(a::AbstractArray, b::StaticArray) = map(+, a, b)
@inline +(a::StaticArray, b::AbstractArray) = map(+, a, b)

@inline -(a::StaticArray, b::StaticArray) = map(-, a, b)
@inline -(a::AbstractArray, b::StaticArray) = map(-, a, b)
@inline -(a::StaticArray, b::AbstractArray) = map(-, a, b)

# Scalar-array
@inline *(a::Number, b::StaticArray) = map(c->a*c, b)
@inline *(a::StaticArray, b::Number) = map(c->c*b, a)

@inline /(a::StaticArray, b::Number) = map(c->c/b, a)
@inline \(a::Number, b::StaticArray) = map(c->a\c, b)


# With UniformScaling
@inline +(a::StaticMatrix, b::UniformScaling) = _plus_uniform(Size(a), a, b.λ)
@inline +(a::UniformScaling, b::StaticMatrix) = _plus_uniform(Size(b), b, a.λ)
@inline -(a::StaticMatrix, b::UniformScaling) = _plus_uniform(Size(a), a, -b.λ)
@inline -(a::UniformScaling, b::StaticMatrix) = _plus_uniform(Size(b), -b, a.λ)

@generated function _plus_uniform(::Size{S}, a::StaticMatrix, λ) where {S}
    n = checksquare(a)
    exprs = [i == j ? :(a[$(LinearIndices(S)[i, j])] + λ) : :(a[$(LinearIndices(S)[i, j])]) for i = 1:n, j = 1:n]
    return quote
        $(Expr(:meta, :inline))
        @inbounds return similar_type(a, promote_type(eltype(a), typeof(λ)))(tuple($(exprs...)))
    end
end

@inline _plus_uniform_parent(A, λ) = _plus_uniform(Size(A), parent(A), λ)
@inline _minus_uniform_parent(A, λ) = _plus_uniform(Size(A), -parent(A), λ)
@inline _sym_uplo(A) = A.uplo == 'U' ? :U : :L

# Self-adjoint wrappers over StaticMatrix with UniformScaling
@inline +(A::Symmetric{T,<:StaticMatrix{N,M,T}}, J::UniformScaling) where {N,M,T} =
    Symmetric(_plus_uniform_parent(A, J.λ), _sym_uplo(A))
@inline -(J::UniformScaling, A::Symmetric{T,<:StaticMatrix{N,M,T}}) where {N,M,T} =
    Symmetric(_minus_uniform_parent(A, J.λ), _sym_uplo(A))

@inline +(A::Hermitian{T,<:StaticMatrix{N,M,T}}, J::UniformScaling) where {N,M,T} =
    Hermitian(_plus_uniform_parent(A, J.λ), _sym_uplo(A))
@inline -(J::UniformScaling, A::Hermitian{T,<:StaticMatrix{N,M,T}}) where {N,M,T} =
    Hermitian(_minus_uniform_parent(A, J.λ), _sym_uplo(A))

# Lose Hermitian wrapper when adding complex UniformScaling, in-line with Base behavior
@inline function +(A::Hermitian{T,<:StaticMatrix{N,M,T}}, J::UniformScaling{<:Complex}) where {N,M,T}
    TS = Base.promote_op(+, eltype(A), typeof(J))
    _plus_uniform(Size(A), similar_type(A, TS)(A), J.λ)
end
@inline function -(J::UniformScaling{<:Complex}, A::Hermitian{T,<:StaticMatrix{N,M,T}}) where {N,M,T}
    TS = Base.promote_op(+, eltype(A), typeof(J))
    _plus_uniform(Size(A), -similar_type(A, TS)(A), J.λ)
end

# Triangular wrappers over StaticMatrix with UniformScaling
for TWR in (:UpperTriangular, :LowerTriangular)
    @eval begin
        @inline +(A::$TWR{T,<:StaticMatrix{N,M,T}}, J::UniformScaling) where {N,M,T} = $TWR(_plus_uniform_parent(A, J.λ))
        @inline -(J::UniformScaling, A::$TWR{T,<:StaticMatrix{N,M,T}}) where {N,M,T} = $TWR(_minus_uniform_parent(A, J.λ))
    end
end

# Unit triangular wrappers over StaticMatrix with UniformScaling
@inline _plus_uniform_materialized(A, λ) = _plus_uniform(Size(A), similar_type(A, promote_type(eltype(A), typeof(λ)))(A), λ)
@inline _minus_uniform_materialized(A, λ) = _plus_uniform(Size(A), -similar_type(A, promote_type(eltype(A), typeof(λ)))(A), λ)

for (TWR1, TWR2) in ((:UnitUpperTriangular, :UpperTriangular), (:UnitLowerTriangular, :LowerTriangular))
    @eval begin
        @inline +(A::$TWR1{T,<:StaticMatrix{N,M,T}}, J::UniformScaling) where {N,M,T} = $TWR2(_plus_uniform_materialized(A, J.λ))
        @inline -(J::UniformScaling, A::$TWR1{T,<:StaticMatrix{N,M,T}}) where {N,M,T} = $TWR2(_minus_uniform_materialized(A, J.λ))
    end
end

@inline *(a::UniformScaling, b::Union{StaticMatrix,StaticVector}) = a.λ * b
@inline *(a::StaticMatrix, b::UniformScaling) = a * b.λ
@inline \(a::UniformScaling, b::Union{StaticMatrix,StaticVector}) = a.λ \ b
@inline /(a::StaticMatrix, b::UniformScaling) = a / b.λ


# Ternary ops
@inline Base.muladd(scalar::Number, a::StaticArray, b::StaticArray) = map((ai, bi) -> muladd(scalar, ai, bi), a, b)
@inline Base.muladd(a::StaticArray, scalar::Number, b::StaticArray) = map((ai, bi) -> muladd(ai, scalar, bi), a, b)


# @fastmath operators
@inline Base.FastMath.mul_fast(a::Number, b::StaticArray) = map(c -> Base.FastMath.mul_fast(a, c), b)
@inline Base.FastMath.mul_fast(a::StaticArray, b::Number) = map(c -> Base.FastMath.mul_fast(c, b), a)

@inline Base.FastMath.add_fast(a::StaticArray, b::StaticArray) = map(Base.FastMath.add_fast, a, b)
@inline Base.FastMath.sub_fast(a::StaticArray, b::StaticArray) = map(Base.FastMath.sub_fast, a, b)


#--------------------------------------------------
# Matrix algebra

# _adjointtype returns the eltype of the container when computing the adjoint/transpose
# of a static array. Using this method instead of calling `Base.promote_op` directly
# helps with type-inference, particularly for nested static arrays,
# where the adjoint is applied recursively.
@inline _adjointtype(f, ::Type{T}) where {T} = Base.promote_op(f, T)
for S in (:SMatrix, :MMatrix)
    @eval @inline _adjointtype(f, ::Type{$S{M,N,T,L}}) where {M,N,T,L} = $S{N,M,_adjointtype(f, T),L}
end

# Transpose, etc
@inline transpose(m::StaticMatrix) = _transpose(Size(m), m)
# note: transpose of StaticVector is a Transpose, handled by Base
@inline transpose(a::Transpose{<:Any,<:Union{StaticVector,StaticMatrix}}) = a.parent
@inline transpose(a::Adjoint{<:Any,<:Union{StaticVector,StaticMatrix}}) = conj(a.parent)
@inline transpose(a::Adjoint{<:Real,<:Union{StaticVector,StaticMatrix}}) = a.parent

@generated function _transpose(::Size{S}, m::StaticMatrix{n1, n2, T}) where {n1, n2, S, T}
    exprs = [:(transpose(m[$(LinearIndices(S)[j1, j2])])) for j2 in 1:n2, j1 in 1:n1]
    return quote
        $(Expr(:meta, :inline))
        elements = tuple($(exprs...))
        @inbounds return similar_type($m, _adjointtype(transpose, T), Size($(n2,n1)))(elements)
    end
end

@inline adjoint(m::StaticMatrix) = _adjoint(Size(m), m)
@inline adjoint(a::Transpose{<:Any,<:Union{StaticVector,StaticMatrix}}) = conj(a.parent)
@inline adjoint(a::Transpose{<:Real,<:Union{StaticVector,StaticMatrix}}) = a.parent
@inline adjoint(a::Adjoint{<:Any,<:Union{StaticVector,StaticMatrix}}) = a.parent

@generated function _adjoint(::Size{S}, m::StaticMatrix{n1, n2, T}) where {n1, n2, S, T}
    exprs = [:(adjoint(m[$(LinearIndices(S)[j1, j2])])) for j2 in 1:n2, j1 in 1:n1]
    return quote
        $(Expr(:meta, :inline))
        elements = tuple($(exprs...))
        @inbounds return similar_type($m, _adjointtype(adjoint, T), Size($(n2,n1)))(elements)
    end
end

@inline Base.zero(a::SA) where {SA <: StaticArray} = zeros(SA)
@inline Base.zero(a::Type{SA}) where {SA <: StaticArray} = zeros(SA)

# Wrappers over StaticArray (see StaticMatrixLike definition)
for WR in (:Symmetric, :Hermitian)
    @eval @inline Base.zero(a::$WR{<:Any,<:StaticMatrix}) = $WR(zero(parent(a)), _sym_uplo(a))
end
for WR in (:UpperTriangular, :LowerTriangular, :UnitUpperTriangular, :UnitLowerTriangular, :Transpose, :Adjoint)
    @eval @inline Base.zero(a::$WR{<:Any,<:StaticArray}) = $WR(zero(parent(a)))
end

@inline _construct_sametype(a::Type, elements) = a(elements)
@inline _construct_sametype(a, elements) = typeof(a)(elements)

@inline one(m::StaticMatrixLike) = _one(Size(m), m)
@inline one(::Type{SM}) where {SM<:StaticMatrixLike}= _one(Size(SM), SM)
function _one(s::Size, m_or_SM)
    if (length(s) != 2) || (s[1] != s[2])
        throw(DimensionMismatch("multiplicative identity defined only for square matrices"))
    end
    λ = one(_eltype_or(m_or_SM, Float64))
    _construct_sametype(m_or_SM, _scalar_matrix_elements(s, λ))
    # TODO: Bring back the use of _construct_similar here:
    # _construct_similar(m_or_SM, s, _scalar_matrix_elements(s, λ))
    #
    # However, because _construct_similar uses `similar_type`, it will be
    # breaking for some StaticMatrix types (in particular Rotations.RotMatrix)
    # which must have similar_type return a general type able to hold any
    # matrix in the full general linear group.
    #
    # (Generally we're stuck here and things like RotMatrix really need to
    # override one() and zero() themselves: on the one hand, one(RotMatrix)
    # should return a RotMatrix, but zero(RotMatrix) can not be a RotMatrix.
    # The best StaticArrays can do is to use similar_type to return an SMatrix
    # for both of these, and let the more specialized library define the
    # correct algebraic properties.)
end

# StaticMatrix(I::UniformScaling)
(::Type{SM})(I::UniformScaling) where {SM<:StaticMatrix} =
    SM(_scalar_matrix_elements(Size(SM), I.λ))
# The following oddity is needed if we want `SArray{Tuple{2,3}}(I)` to work
# because we do not have `SArray{Tuple{2,3}} <: StaticMatrix`.
(::Type{SM})(I::UniformScaling) where {SM<:(StaticArray{Tuple{N,M}} where {N,M})} =
    SM(_scalar_matrix_elements(Size(SM), I.λ))

# Construct a matrix with the scalar λ on the diagonal and zeros off the
# diagonal. The matrix can be non-square.
@generated function _scalar_matrix_elements(s::Size{S}, λ) where {S}
    elements = Symbol[i == j ? :λ : :λzero for i in 1:S[1], j in 1:S[2]]
    return quote
        $(Expr(:meta, :inline))
        λzero = zero(λ)
        tuple($(elements...))
    end
end

@generated function diagm(kv1::Pair{<:Val,<:StaticVector}, other_kvs::Pair{<:Val,<:StaticVector}...)
    kvs = (kv1, other_kvs...)
    diag_ind_and_length = [(kv.parameters[1].parameters[1], length(kv.parameters[2])) for kv in kvs]
    N = maximum(abs(di) + dl for (di,dl) in diag_ind_and_length)
    vs = [Symbol("v$i") for i=1:length(kvs)]
    vs_exprs = [:(@inbounds $(vs[i]) = kvs[$i].second) for i=eachindex(kvs)]
    element_exprs = Any[false for _=1:N*N]
    for (i, (di, dl)) in enumerate(diag_ind_and_length)
        diaginds = diagind(N, N, di)
        for n = 1:dl
            element_exprs[diaginds[n]] = :($(vs_exprs[i])[$n])
        end
    end
    return quote
        $(Expr(:meta, :inline))
        kvs = (kv1, other_kvs...)
        $(vs_exprs...)
        @inbounds elements = tuple($(element_exprs...))
        T = promote_tuple_eltype(elements)
        @inbounds return similar_type(v1, T, Size($N,$N))(elements)
    end
end
@inline diagm(v::StaticVector) = diagm(Val(0)=>v)

@inline diag(m::StaticMatrix, k::Type{Val{D}}=Val{0}) where {D} = _diag(Size(m), m, k)
@generated function _diag(::Size{S}, m::StaticMatrix, ::Type{Val{D}}) where {S,D}
    S1, S2 = S
    rng = D ≤ 0 ? range(1-D, step=S1+1, length=min(S1+D, S2)) :
                  range(D*S1+1, step=S1+1, length=min(S1, S2-D))
    Snew = length(rng)
    T = eltype(m)
    exprs = [:(m[$i]) for i = rng]
    return quote
        $(Expr(:meta, :inline))
        @inbounds return similar_type($m, Size($Snew))(tuple($(exprs...)))
    end
end

#--------------------------------------------------
# Vector products
@inline cross(a::StaticVector, b::StaticVector) = _cross(same_size(a, b), a, b)
_cross(::Size{S}, a::StaticVector, b::StaticVector) where {S} = error("Cross product not defined for $(S[1])-vectors")
@inline function _cross(::Size{(2,)}, a::StaticVector, b::StaticVector)
    @inbounds return a[1]*b[2] - a[2]*b[1]
end
@inline function _cross(::Size{(3,)}, a::StaticVector, b::StaticVector)
    @inbounds return similar_type(a, typeof(a[2]*b[3]-a[3]*b[2]))((a[2]*b[3]-a[3]*b[2], a[3]*b[1]-a[1]*b[3], a[1]*b[2]-a[2]*b[1]))
end
@inline function _cross(::Size{(2,)}, a::StaticVector{<:Any, <:Unsigned}, b::StaticVector{<:Any, <:Unsigned})
    @inbounds return Signed(a[1]*b[2]) - Signed(a[2]*b[1])
end
@inline function _cross(::Size{(3,)}, a::StaticVector{<:Any, <:Unsigned}, b::StaticVector{<:Any, <:Unsigned})
    @inbounds return similar_type(a, typeof(Signed(a[2]*b[3])-Signed(a[3]*b[2])))(((Signed(a[2]*b[3])-Signed(a[3]*b[2]), Signed(a[3]*b[1])-Signed(a[1]*b[3]), Signed(a[1]*b[2])-Signed(a[2]*b[1]))))
end

@inline dot(a::StaticArray, b::StaticArray) = _vecdot(same_size(a, b), a, b, dot)
@inline bilinear_vecdot(a::StaticArray, b::StaticArray) = _vecdot(same_size(a, b), a, b, *)

@inline function _vecdot(::Size{S}, a::StaticArray, b::StaticArray, product) where {S}
    if prod(S) == 0
        za, zb = zero(eltype(a)), zero(eltype(b))
    else
        # Use an actual element if there is one, to support e.g. Vector{<:Number}
        # element types for which runtime size information is required to construct
        # a zero element.
        za, zb = zero(a[1]), zero(b[1])
    end
    ret = product(za, zb) + product(za, zb)
    @inbounds @simd for j = 1 : prod(S)
        ret += product(a[j], b[j])
    end
    return ret
end

#--------------------------------------------------
# Norms
_inner_eltype(v::AbstractArray) = isempty(v) ? eltype(v) : _inner_eltype(first(v))
_inner_eltype(x::Number) = typeof(x)
@inline _init_zero(v::AbstractArray) = float(norm(zero(_inner_eltype(v))))

@inline function LinearAlgebra.norm_sqr(v::StaticArray)
    init = float(LinearAlgebra.norm_sqr(zero(_inner_eltype(v))))
    return mapreduce(LinearAlgebra.norm_sqr, +, v; init=init)
end

@inline maxabs_nested(a::Number) = abs(a)
@inline function maxabs_nested(a::AbstractArray)
    prod(size(a)) == 0 && (return _init_zero(a))

    m = maxabs_nested(a[1])
    for j = 2:prod(size(a))
        m = max(m, maxabs_nested(a[j]))
    end

    return m
end

@generated function _norm_scaled(::Size{S}, a::StaticArray) where {S}
    expr = :(LinearAlgebra.norm_sqr(a[1]/scale))
    for j = 2:prod(S)
        expr = :($expr + LinearAlgebra.norm_sqr(a[$j]/scale))
    end

    return quote
        $(Expr(:meta, :inline))
        scale = maxabs_nested(a)
        !isfinite(scale) && return scale

        iszero(scale) && return _init_zero(a)
        return @inbounds scale * sqrt($expr)
    end
end

@inline norm(a::StaticArray) = _norm(Size(a), a)
@generated function _norm(::Size{S}, a::StaticArray) where {S}
    prod(S) == 0 && return :(_init_zero(a))

    expr = :(LinearAlgebra.norm_sqr(a[1]))
    for j = 2:prod(S)
        expr = :($expr + LinearAlgebra.norm_sqr(a[$j]))
    end

    return quote
        $(Expr(:meta, :inline))
        l = @inbounds sqrt($expr)

        zero(l) < l && isfinite(l) && return l
        return _norm_scaled(Size(a), a)
    end
end

function _norm_p0(x)
    T = _inner_eltype(x)
    return float(norm(iszero(x) ? zero(T) : one(T)))
end

# Do not need to deal with p == 0, 2, Inf; see norm(a, p).
@generated function _norm_scaled(::Size{S}, a::StaticArray, p::Real) where {S}
    expr = :(norm(a[1]/scale)^p)
    for j = 2:prod(S)
        expr = :($expr + norm(a[$j]/scale)^p)
    end

    expr_p1 = :(norm(a[1]/scale))
    for j = 2:prod(S)
        expr_p1 = :($expr_p1 + norm(a[$j]/scale))
    end

    return quote
        $(Expr(:meta, :inline))
        scale = maxabs_nested(a)

        iszero(scale) && return _init_zero(a)
        p == 1 && return @inbounds scale * $expr_p1
        return @inbounds scale * ($expr)^(inv(p))
    end
end

@inline norm(a::StaticArray, p::Real) = _norm(Size(a), a, p)
@generated function _norm(::Size{S}, a::StaticArray, p::Real) where {S}
    prod(S) == 0 && return :(_init_zero(a))

    expr = :(norm(a[1])^p)
    for j = 2:prod(S)
        expr = :($expr + norm(a[$j])^p)
    end

    expr_p1 = :(norm(a[1]))
    for j = 2:prod(S)
        expr_p1 = :($expr_p1 + norm(a[$j]))
    end

    return quote
        $(Expr(:meta, :inline))
        p == 0 && return mapreduce(_norm_p0, +, a)  # no need for scaling
        p == 2 && return norm(a)  # norm(a) takes care of scaling
        p == Inf && return mapreduce(norm, max, a)  # no need for scaling

        l = p==1 ? @inbounds($expr_p1) : @inbounds(($expr)^(inv(p)))
        zero(l) < l && isfinite(l) && return l
        return _norm_scaled(Size(a), a, p)  # p != 0, 2, Inf
    end
end

@inline normalize(a::StaticArray) = inv(norm(a))*a
@inline normalize(a::StaticArray, p::Real) = inv(norm(a, p))*a

@inline normalize!(a::StaticArray) = (a .*= inv(norm(a)); return a)
@inline normalize!(a::StaticArray, p::Real) = (a .*= inv(norm(a, p)); return a)

@inline tr(a::StaticMatrix) = _tr(Size(a), a)
@generated function _tr(::Size{S}, a::StaticMatrix) where {S}
    checksquare(a)

    if S[1] == 0
        return :(zero(eltype(a)))
    end

    exprs = [:(a[$(LinearIndices(S)[i, i])]) for i = 1:S[1]]
    total = reduce((ex1, ex2) -> :($ex1 + $ex2), exprs)

    return quote
        @_inline_meta
        @inbounds return $total
    end
end


#--------------------------------------------------
# Outer products

const _length_limit = Length(200)

@inline kron(a::StaticMatrix, b::StaticMatrix) = _kron(_length_limit, Size(a), Size(b), a, b)
@generated function _kron(::Length{length_limit}, ::Size{SA}, ::Size{SB}, a, b) where {length_limit,SA,SB}
    outsize = SA .* SB
    if prod(outsize) > length_limit
        return :( SizedMatrix{$(outsize[1]),$(outsize[2])}( kron(drop_sdims(a), drop_sdims(b)) ) )
    end

    M = [ :(a[$ia,$ja] * b[$ib,$jb]) for ib in 1:SB[1], ia in 1:SA[1], jb in 1:SB[2], ja in 1:SA[2] ]

    return quote
        @_inline_meta
        @inbounds return  similar_type($a, promote_type(eltype(a),eltype(b)), Size($(outsize)))(tuple($(M...)))
    end
end

@inline kron(a::StaticVector, b::StaticVector) = _kron_vec_x_vec(_length_limit, Size(a), Size(b), a, b)
@generated function _kron_vec_x_vec(::Length{length_limit}, ::Size{SA}, ::Size{SB}, a, b) where {length_limit,SA,SB}
    outsize = SA .* SB
    if prod(outsize) > length_limit
        return :( SizedVector{$(outsize[1])}( kron(drop_sdims(a), drop_sdims(b)) ) )
    end

    m = [ :(a[$ia] * b[$ib]) for ib in 1:SB[1], ia in 1:SA[1]]

    return quote
        @_inline_meta
        @inbounds return similar_type($a, promote_type(eltype(a),eltype(b)), Size($(outsize)))(tuple($(m...)))
    end
end

@inline function kron(
        a::Union{Transpose{<:Number,<:StaticVector}, Adjoint{<:Number,<:StaticVector}},
        b::Union{Transpose{<:Number,<:StaticVector}, Adjoint{<:Number,<:StaticVector}})
    _kron_tvec_x_tvec(_length_limit, Size(a), Size(b), a, b)
end
@generated function _kron_tvec_x_tvec(::Length{length_limit}, ::Size{SA}, ::Size{SB}, a, b) where {length_limit,SA,SB}
    outsize = SA .* SB
    if prod(outsize) > length_limit
        return :( SizedMatrix{$(outsize[1]),$(outsize[2])}( kron(drop_sdims(a), drop_sdims(b)) ) )
    end

    m = [ :(a[$ia] * b[$ib]) for ib in 1:SB[2], ia in 1:SA[2]]

    return quote
        @_inline_meta
        @inbounds return similar_type($a, promote_type(eltype(a),eltype(b)), Size($(outsize)))(tuple($(m...)))
    end
end

@inline function kron(
        a::Union{Transpose{<:Number,<:StaticVector}, Adjoint{<:Number,<:StaticVector}},
        b::StaticVector)
    _kron_tvec_x_vec(_length_limit, Size(a), Size(b), a, b)
end
@generated function _kron_tvec_x_vec(::Length{length_limit}, ::Size{SA}, ::Size{SB}, a, b) where {length_limit,SA,SB}
    outsize = (SA[1] * SB[1], SA[2])
    if prod(outsize) > length_limit
        return :( SizedMatrix{$(outsize[1]),$(outsize[2])}( kron(drop_sdims(a), drop_sdims(b)) ) )
    end

    M = [ :(a[$ia] * b[$ib]) for ib in 1:SB[1], ia in 1:SA[2]]

    return quote
        @_inline_meta
        @inbounds return similar_type($a, promote_type(eltype(a),eltype(b)), Size($(outsize)))(tuple($(M...)))
    end
end

@inline function kron(
        a::StaticVector,
        b::Union{Transpose{<:Number,<:StaticVector}, Adjoint{<:Number,<:StaticVector}})
    _kron_vec_x_tvec(_length_limit, Size(a), Size(b), a, b)
end
@generated function _kron_vec_x_tvec(::Length{length_limit}, ::Size{SA}, ::Size{SB}, a, b) where {length_limit,SA,SB}
    outsize = (SA[1] * SB[1], SB[2])
    if prod(outsize) > length_limit
        return :( SizedMatrix{$(outsize[1]),$(outsize[2])}( kron(drop_sdims(a), drop_sdims(b)) ) )
    end

    M = [ :(a[$ia] * b[$ib]) for  ia in 1:SA[1], ib in 1:SB[2]]

    return quote
        @_inline_meta
        @inbounds return similar_type($a, promote_type(eltype(a),eltype(b)), Size($(outsize)))(tuple($(M...)))
    end
end

@inline kron(a::StaticVector, b::StaticMatrix) = _kron_vec_x_mat(_length_limit, Size(a), Size(b), a, b)
@generated function _kron_vec_x_mat(::Length{length_limit}, ::Size{SA}, ::Size{SB}, a, b) where {length_limit,SA,SB}
    outsize = (SA[1] * SB[1], SB[2])
    if prod(outsize) > length_limit
        return :( SizedMatrix{$(outsize[1]),$(outsize[2])}( kron(drop_sdims(a), drop_sdims(b)) ) )
    end

    M = [ :(a[$ia] * b[$ib,$jb]) for ib in 1:SB[1], ia in 1:SA[1], jb in 1:SB[2]]

    return quote
        @_inline_meta
        @inbounds return similar_type($b, promote_type(eltype(a),eltype(b)), Size($(outsize)))(tuple($(M...)))
    end
end

@inline kron(a::StaticMatrix, b::StaticVector) = _kron_mat_x_vec(_length_limit, Size(a), Size(b), a, b)
@generated function _kron_mat_x_vec(::Length{length_limit}, ::Size{SA}, ::Size{SB}, a, b) where {length_limit,SA,SB}
    outsize = (SA[1] * SB[1], SA[2])
    if prod(outsize) > length_limit
        return :( SizedMatrix{$(outsize[1]),$(outsize[2])}( kron(drop_sdims(a), drop_sdims(b)) ) )
    end

    M = [ :(a[$ia,$ja] * b[$ib]) for ib in 1:SB[1], ia in 1:SA[1], ja in 1:SA[2] ]

    return quote
        @_inline_meta
        @inbounds return similar_type($a, promote_type(eltype(a),eltype(b)), Size($(outsize)))(tuple($(M...)))
    end
end

@inline function kron(
        a::StaticMatrix,
        b::Union{Transpose{<:Number,<:StaticVector}, Adjoint{<:Number,<:StaticVector}})
    _kron_mat_x_tvec(_length_limit, Size(a), Size(b), a, b)
end
@generated function _kron_mat_x_tvec(::Length{length_limit}, ::Size{SA}, ::Size{SB}, a, b) where {length_limit,SA,SB}
    outsize = SA .* SB
    if prod(outsize) > length_limit
        return :( SizedMatrix{$(outsize[1]),$(outsize[2])}( kron(drop_sdims(a), drop_sdims(b)) ) )
    end

    M = [ :(a[$ia,$ja] * b[$ib,$jb]) for ib in 1:SB[1], ia in 1:SA[1], jb in 1:SB[2], ja in 1:SA[2] ]

    return quote
        @_inline_meta
        @inbounds return  similar_type($a, promote_type(eltype(a),eltype(b)), Size($(outsize)))(tuple($(M...)))
    end
end

@inline function kron(
        a::Union{Transpose{<:Number,<:StaticVector}, Adjoint{<:Number,<:StaticVector}},
        b::StaticMatrix)
    _kron_tvec_x_mat(_length_limit, Size(a), Size(b), a, b)
end
@generated function _kron_tvec_x_mat(::Length{length_limit}, ::Size{SA}, ::Size{SB}, a, b) where {length_limit,SA,SB}
    outsize = SA .* SB
    if prod(outsize) > length_limit
        return :( SizedMatrix{$(outsize[1]),$(outsize[2])}( kron(drop_sdims(a), drop_sdims(b)) ) )
    end

    M = [ :(a[$ia,$ja] * b[$ib,$jb]) for ib in 1:SB[1], ia in 1:SA[1], jb in 1:SB[2], ja in 1:SA[2] ]

    return quote
        @_inline_meta
        @inbounds return  similar_type($b, promote_type(eltype(a),eltype(b)), Size($(outsize)))(tuple($(M...)))
    end
end


#--------------------------------------------------
# Some shimming for special linear algebra matrix types
@inline LinearAlgebra.Symmetric(A::StaticMatrix, uplo::Char='U') = (checksquare(A); Symmetric{eltype(A),typeof(A)}(A, uplo))
@inline LinearAlgebra.Hermitian(A::StaticMatrix, uplo::Char='U') = (checksquare(A); Hermitian{eltype(A),typeof(A)}(A, uplo))

# triu/tril
function triu(S::StaticMatrix, k::Int=0)
    if length(S) <= 32
        C = CartesianIndices(S)
        t = Tuple(S)
        for (linind, CI) in enumerate(C)
            i, j = Tuple(CI)
            if j-i < k
                t = Base.setindex(t, zero(t[linind]), linind)
            end
        end
        similar_type(S)(t)
    else
        M = triu!(copyto!(similar(S), S), k)
        similar_type(S)(M)
    end
end
function tril(S::StaticMatrix, k::Int=0)
    if length(S) <= 32
        C = CartesianIndices(S)
        t = Tuple(S)
        for (linind, CI) in enumerate(C)
            i, j = Tuple(CI)
            if j-i > k
                t = Base.setindex(t, zero(t[linind]), linind)
            end
        end
        similar_type(S)(t)
    else
        M = tril!(copyto!(similar(S), S), k)
        similar_type(S)(M)
    end
end

using StaticArrays, Test, LinearAlgebra

@testset "Triangular-matrix multiplication" begin
    for n in (1, 2, 3, 4),
        eltyA in (Float64, ComplexF64, Int),
            (t, uplo) in ((UpperTriangular, :U), (LowerTriangular, :L)),
                eltyB in (Float64, ComplexF64)

        A = t(eltyA == Int ? rand(1:7, n, n) : rand(eltyA, n, n))
        B = rand(eltyB, n, n)
        SA = t(SMatrix{n,n}(A.data))
        SB = SMatrix{n,n}(B)

        @test (SA*SB[:,1])::SVector{n} ≈ A*B[:,1]
        @test (SA*SB)::SMatrix{n,n} ≈ A*B
        @test (SA*transpose(SB))::SMatrix{n,n} ≈ A*transpose(B)
        @test (SA*SB')::SMatrix{n,n} ≈ A*B'
        @test (SA'*SB[:,1])::SVector{n} ≈ A'*B[:,1]
        @test (SA'*SB)::SMatrix{n,n} ≈ A'*B
        @test (SA'*SB')::SMatrix{n,n} ≈ A'*B'
        @test (transpose(SA)*SB[:,1])::SVector{n} ≈ transpose(A)*B[:,1]
        @test (transpose(SA)*SB)::SMatrix{n,n} ≈ transpose(A)*B
        @test (transpose(SA)*transpose(SB))::SMatrix{n,n} ≈ transpose(A)*transpose(B)
        @test (SB*SA)::SMatrix{n,n} ≈ B*A
        @test (SB[:,1]'*SA)::Adjoint{<:Any,<:SVector{n}} ≈ B[:,1]'*A
        @test (transpose(SB[:,1])*SA)::Transpose{<:Any,<:SVector{n}} ≈ transpose(B[:,1])*A
        @test (transpose(SB)*SA)::SMatrix{n,n} ≈ transpose(B)*A
        @test SB[:,1]'*SA ≈ B[:,1]'*A
        @test (SB'*SA)::SMatrix{n,n} ≈ B'*A
        @test (SB*SA')::SMatrix{n,n} ≈ B*A'
        @test (SB*transpose(SA))::SMatrix{n,n} ≈ B*transpose(A)
        @test (SB[:,1]'*transpose(SA))::Adjoint{<:Any,<:SVector{n}} ≈ B[:,1]'*transpose(A)
        @test (transpose(SB[:,1])*transpose(SA))::Transpose{<:Any,<:SVector{n}} ≈ transpose(B[:,1])*transpose(A)
        @test (transpose(SB)*transpose(SA))::SMatrix{n,n} ≈ transpose(B)*transpose(A)
        @test (SB[:,1]'*SA') ≈ SB[:,1]'*SA'
        @test (SB'*SA')::SMatrix{n,n} ≈ B'*A'

        @test_throws DimensionMismatch SA*ones(SVector{n+1,eltyB})
        @test_throws DimensionMismatch ones(SMatrix{n+1,n+1,eltyB})*SA
        @test_throws DimensionMismatch transpose(SA)*ones(SVector{n+1,eltyB})
        @test_throws DimensionMismatch SA'*ones(SVector{n+1,eltyB})
        @test_throws DimensionMismatch ones(SMatrix{n+1,n+1,eltyB})*transpose(SA)
        @test_throws DimensionMismatch ones(SMatrix{n+1,n+1,eltyB})*SA'
    end
end

@testset "Triangular-Adjoint multiplication" begin
    for n in (1,),
        eltyA in (Float64, ComplexF64, Int),
            (t, uplo) in ((UpperTriangular, :U), (LowerTriangular, :L)),
                eltyB in (Float64, ComplexF64)

        A = t(eltyA == Int ? rand(1:7, n, n) : rand(eltyA, n, n))
        B = rand(eltyB, n)
        SA = t(SMatrix{n,n}(A.data))
        SB = transpose(SVector{n}(B))

        @test (SA*SB)::SMatrix{n,n} ≈ A*transpose(B)
        @test (SA*transpose(SB))::SVector{n} ≈ A*B
        @test (SA*SB')::SVector{n} ≈ A*conj(B)
        @test (SA'*SB)::SMatrix{n,n} ≈ A'*transpose(B)
        @test (SA'*transpose(SB))::SVector{n} ≈ A'*B
        @test (SA'*SB')::SVector{n} ≈ A'*conj(B)
        @test (transpose(SA)*SB)::SMatrix{n,n} ≈ transpose(A)*transpose(B)
        @test (transpose(SA)*transpose(SB))::SVector{n} ≈ transpose(A)*B
        @test (transpose(SA)*SB')::SVector{n} ≈ transpose(A)*conj(B)
        @test (SB*SA)::Transpose{<:Any,<:SVector{n}} ≈ transpose(B)*A
        @test (SB*SA')::Transpose{<:Any,<:SVector{n}} ≈ transpose(B)*A'
        @test (SB*transpose(SA))::Transpose{<:Any,<:SVector{n}} ≈ transpose(B)*transpose(A)
        @test (transpose(SB)*SA)::SMatrix{n,n} ≈ B*A
        @test (SB'*SA)::SMatrix{n,n} ≈ conj(B)*A
        @test (transpose(SB)*transpose(SA))::SMatrix{n,n} ≈ B*transpose(A)
        @test (transpose(SB)*SA')::SMatrix{n,n} ≈ B*A'
        @test (SB'*transpose(SA))::SMatrix{n,n} ≈ conj(B)*transpose(A)
        @test (SB'*SA')::SMatrix{n,n} ≈ conj(B)*A'
    end
end

@testset "Triangular-triangular multiplication" begin
    for n in (1, 2, 3, 4),
        eltyA in (Float64, ComplexF64, Int),
            eltyB in (Float64, ComplexF64, Int),
                (ta, uploa) in ((UpperTriangular, :U), (LowerTriangular, :L)),
                    (tb, uplob) in ((UpperTriangular, :U), (LowerTriangular, :L))

        A = ta(eltyA == Int ? rand(1:7, n, n) : rand(eltyA, n, n))
        B = tb(eltyB == Int ? rand(1:7, n, n) : rand(eltyB, n, n))

        SA = ta(SMatrix{n,n}(A.data))
        SB = tb(SMatrix{n,n}(B.data))

        eltyAB = Base.promote_op(*, eltyA, eltyB)

        @test SA*SB ≈ A*B
        @test eltype(SA*SB) == eltyAB
        @test SA*SB isa (ta===tb ? ta : SMatrix)

    end

end

@testset "Triangular-matrix division" begin
    for n in (1, 2, 3, 4),
        eltyA in (Float64, ComplexF64, Int),
            (t, uplo) in ((UpperTriangular, :U), (LowerTriangular, :L), (UnitUpperTriangular, :U)),
                eltyB in (Float64, ComplexF64),
                    tb in (identity, LowerTriangular, Symmetric)

        A = t(eltyA == Int ? rand(1:7, n, n) : convert(Matrix{eltyA}, (eltyA <: Complex ? complex.(randn(n, n), randn(n, n)) : randn(n, n)) |> t -> cholesky(t't).U |> t -> uplo == :U ? t : adjoint(t)))
        B = tb(convert(Matrix{eltyB}, eltyA <: Complex ? real(A)*ones(n, n) : A*ones(n, n)))
        SA = t(SMatrix{n,n}(A.data))
        SB = tb(SMatrix{n,n}(parent(B)))

        if tb === identity
            @test (SA\SB[:,1])::SVector{n} ≈ A\B[:,1]
            @test (transpose(SA)\SB[:,1])::SVector{n} ≈ transpose(A)\B[:,1]
            @test (SA'\SB[:,1])::SVector{n} ≈ A'\B[:,1]
        end
        @test (SA\SB)::SMatrix{n,n} ≈ A\B
        @test (transpose(SA)\SB)::SMatrix{n,n} ≈ transpose(A)\B
        @test (SA'\SB)::SMatrix{n,n} ≈ A'\B

        @test_throws DimensionMismatch SA\ones(SVector{n+2,eltyB})
        @test_throws DimensionMismatch transpose(SA)\ones(SVector{n+2,eltyB})
        @test_throws DimensionMismatch SA'\ones(SVector{n+2,eltyB})

        if t != UnitUpperTriangular
            @test_throws LinearAlgebra.SingularException t(zeros(SMatrix{n,n,eltyA}))\ones(SVector{n,eltyB})
            @test_throws LinearAlgebra.SingularException t(transpose(zeros(SMatrix{n,n,eltyA})))\ones(SVector{n,eltyB})
            @test_throws LinearAlgebra.SingularException t(zeros(SMatrix{n,n,eltyA}))'\ones(SVector{n,eltyB})
        end

        @test (SB/SA)::SMatrix{n,n} ≈ B/A
        @test (SB/transpose(SA))::SMatrix{n,n} ≈ B/transpose(A)
        @test (SB/SA')::SMatrix{n,n} ≈ B/A'
    end
end

using StaticArrays, Test
using Statistics: mean

@testset "Map, reduce, mapreduce, broadcast" begin
    @testset "map and map!" begin
        v1 = @SVector [2,4,6,8]
        v2 = @SVector [4,3,2,1]
        mv1 = @MVector [2,4,6,8]
        mv2 = @MVector [4,3,2,1]
        mv = MVector{4, Int}(undef)

        normal_v1 = [2,4,6,8]
        normal_v2 = [4,3,2,1]

        @test @inferred(map(-, v1)) === @SVector [-2, -4, -6, -8]
        @test @inferred(map(+, v1, v2)) === @SVector [6, 7, 8, 9]
        @test @inferred(map(+, normal_v1, v2)) === @SVector [6, 7, 8, 9]
        @test @inferred(map(+, v1, normal_v2)) === @SVector [6, 7, 8, 9]

        # Make sure similar_type is based on first <: StaticArray
        @test @inferred(map(+, normal_v1, mv2))::MVector{4,Int} == @MVector [6, 7, 8, 9]
        @test @inferred(map(+, mv1, normal_v2))::MVector{4,Int} == @MVector [6, 7, 8, 9]

        @test map!(+, mv, v1, v2) === mv
        @test mv == @MVector [6, 7, 8, 9]
        mv2 = MVector{4, Int}(undef)
        map!(x->x^2, mv2, v1)
        @test mv2 == @MVector [4, 16, 36, 64]
        mv3 = MVector{4, Int}(undef)
        v3 = @SVector [1, 2, 3, 4]
        map!(+, mv3, v1, v2, v3)
        @test mv3 == @MVector [7, 9, 11, 13]

        if VERSION >= v"1.12.0-beta3"
            @testset "map!(function, array)" begin
                local mv = MVector(1,2,3)
                map!(x->x^2, mv)
                @test mv == SA[1,4,9]
            end
        end

        # Output eltype for empty cases #528
        @test @inferred(map(/, SVector{0,Int}(), SVector{0,Int}())) === SVector{0,Float64}()
        @test @inferred(map(+, SVector{0,Int}(), SVector{0,Float32}())) === SVector{0,Float32}()
        @test @inferred(map(length, SVector{0,String}())) === SVector{0,Int}()
        # similar_type based on first <: StaticArray
        @test @inferred(map(+, MVector{0,Int}(), Int[]))::MVector{0,Int} == MVector{0,Int}()
        @test @inferred(map(+, Int[], MVector{0,Int}()))::MVector{0,Int} == MVector{0,Int}()
    end

    @testset "[map]reduce and [map]reducedim" begin
        a = rand(4,3); sa = SMatrix{4,3}(a); (I,J) = size(a)
        v1 = [2,4,6,8]; sv1 = SVector{4}(v1)
        v2 = [4,3,2,1]; sv2 = SVector{4}(v2)
        @test reduce(+, sv1) === reduce(+, v1)
        @test reduce(+, sv1; init=0) === reduce(+, v1; init=0)
        @test reduce(max, sa; dims=Val(1), init=-1.) === SMatrix{1,J}(reduce(max, a, dims=1, init=-1.))
        @test reduce(max, sa; dims=1, init=-1.) === SMatrix{1,J}(reduce(max, a, dims=1, init=-1.))
        @test reduce(max, sa; dims=2, init=-1.) === SMatrix{I,1}(reduce(max, a, dims=2, init=-1.))
        @test mapreduce(-, +, sv1) === mapreduce(-, +, v1)
        @test mapreduce(-, +, sv1; init=0) === mapreduce(-, +, v1, init=0)
        @test mapreduce(*, +, sv1, sv2) === 40
        @test mapreduce(*, +, sv1, sv2; init=0) === 40
        @test mapreduce(x->x^2, max, sa; dims=Val(1), init=-1.) == SMatrix{1,J}(mapreduce(x->x^2, max, a, dims=1, init=-1.))
        @test mapreduce(x->x^2, max, sa; dims=1, init=-1.) == SMatrix{1,J}(mapreduce(x->x^2, max, a, dims=1, init=-1.))
        @test mapreduce(x->x^2, max, sa; dims=2, init=-1.) == SMatrix{I,1}(mapreduce(x->x^2, max, a, dims=2, init=-1.))
    end

    @testset "[map]foldl" begin
        a = rand(4,3)
        v1 = [2,4,6,8]; sv1 = SVector{4}(v1)
        @test foldl(+, sv1) === foldl(+, v1)
        @test foldl(+, sv1; init=0) === foldl(+, v1; init=0)
        @test mapfoldl(-, +, sv1) === mapfoldl(-, +, v1)
        @test mapfoldl(-, +, sv1; init=0) === mapfoldl(-, +, v1, init=0)
    end

    @testset "empty array" begin
        # issue #778
        @test iszero(SVector{0,Int}())

        @testset "$fold" for fold in [reduce, foldl]
            @test fold(+, SVector{0,Bool}()) === 0
            @test fold(nothing, SVector{0,Int}(), init=:INIT) === :INIT
        end

        @testset "$mapfold" for mapfold in [mapreduce, mapfoldl]
            @test mapfold(identity, +, SVector{0,Bool}()) === 0
            @test mapfold(abs, +, SVector{0,Bool}()) === 0
            @test mapfold(nothing, nothing, SVector{0,Int}(), init=:INIT) === :INIT
        end

        @test mapreduce(
            (a, b) -> a + b,
            (a, b) -> a * b,
            SVector{0,Int}(),
            SVector{0,Int}();
            init = :INIT,
        ) == :INIT

        # When there are multiple inputs, the error is thrown by
        # StaticArrays.jl:
        @test_throws(
            ArgumentError("reducing over an empty collection is not allowed"),
            mapreduce((a, b) -> a + b, (a, b) -> a * b, SVector{0,Int}(), SVector{0,Int}())
        )

        # When the mapping and/or reducing functions are unsupported,
        # the error is thrown by `Base.mapreduce_empty`:
        if Base.VERSION >= v"1.8.0-DEV.363"
            @test_throws(
                "reducing over an empty collection is not allowed",
                mapreduce(nothing, nothing, SVector{0,Int}())
            )
        else
            @test_throws(
                ArgumentError("reducing over an empty collection is not allowed"),
                mapreduce(nothing, nothing, SVector{0,Int}())
            )
        end
    end

    @testset "implemented by [map]reduce and [map]reducedim" begin
        I, J, K = 2, 2, 2
        OSArray = SArray{Tuple{I,J,K}}  # original
        RSArray1 = SArray{Tuple{1,J,K}}  # reduced in dimension 1
        RSArray2 = SArray{Tuple{I,1,K}}  # reduced in dimension 2
        RSArray3 = SArray{Tuple{I,J,1}}  # reduced in dimension 3
        a = randn(I,J,K); sa = OSArray(a)
        b = rand(Bool,I,J,K); sb = OSArray(b)
        z = zeros(I,J,K); sz = OSArray(z)

        @test iszero(sz) == iszero(z)

        @test sum(sa) === sum(a)
        @test sum(abs2, sa) === sum(abs2, a)
        @test sum(sa, dims=2) === RSArray2(sum(a, dims=2))
        @test sum(sa, dims=Val(2)) === RSArray2(sum(a, dims=2))
        @test sum(abs2, sa; dims=2) === RSArray2(sum(abs2, a, dims=2))
        @test sum(abs2, sa; dims=Val(2)) === RSArray2(sum(abs2, a, dims=2))
        @test sum(sa, init=2) == sum(a, init=2) ≈ sum(sa) + 2 # Float64 is non-associative
        @test sum(sb, init=2) == sum(b, init=2) == sum(sb) + 2

        @test prod(sa) === prod(a)
        @test prod(abs2, sa) === prod(abs2, a)
        @test prod(sa, dims=Val(2)) === RSArray2(prod(a, dims=2))
        @test prod(abs2, sa, dims=Val(2)) === RSArray2(prod(abs2, a, dims=2))
        @test prod(sa, init=2) == prod(a, init=2) ≈ 2*prod(sa) # Float64 is non-associative
        @test prod(sb, init=2) == prod(b, init=2) == 2*prod(sb)

        @test count(sb) === count(b)
        @test count(x->x>0, sa) === count(x->x>0, a)
        @test count(sb, dims=Val(2)) === RSArray2(reshape([count(b[i,:,k]) for i = 1:I, k = 1:K], (I,1,K)))
        @test count(x->x>0, sa, dims=Val(2)) === RSArray2(reshape([count(x->x>0, a[i,:,k]) for i = 1:I, k = 1:K], (I,1,K)))
        @test count(sb, init=3) == count(b, init=3) == count(sb) + 3
        @test count(x->x>0, sa, init=-2) == count(x->x>0, a, init=-2) == count(x->x>0, sa) - 2

        @test all(sb) === all(b)
        @test all(x->x>0, sa) === all(x->x>0, a)
        @test all(sb, dims=Val(2)) === RSArray2(all(b, dims=2))
        @test all(x->x>0, sa, dims=Val(2)) === RSArray2(all(x->x>0, a, dims=2))

        @test any(sb) === any(b)
        @test any(x->x>0, sa) === any(x->x>0, a)
        @test any(sb, dims=Val(2)) === RSArray2(any(b, dims=2))
        @test any(x->x>0, sa, dims=Val(2)) === RSArray2(any(x->x>0, a, dims=2))

        @test all(in(x, sa) for x in sa)
        @test all(in(x, sa) === in(x, a) for x in randn(10))

        @test mean(sa) === mean(a)
        @test mean(abs2, sa) === mean(abs2, a)
        @test mean(sa, dims=Val(2)) === RSArray2(mean(a, dims=2))
        @test mean(abs2, sa, dims=Val(2)) === RSArray2(mean(abs2.(a), dims=2))

        @test minimum(sa) === minimum(a)
        @test minimum(abs2, sa) === minimum(abs2, a)
        @test minimum(sa, dims=Val(2)) === RSArray2(minimum(a, dims=2))
        @test minimum(abs2, sa, dims=Val(2)) === RSArray2(minimum(abs2, a, dims=2))

        @test maximum(sa) === maximum(a)
        @test maximum(abs2, sa) === maximum(abs2, a)
        @test maximum(sa, dims=Val(2)) === RSArray2(maximum(a, dims=2))
        @test maximum(abs2, sa, dims=Val(2)) === RSArray2(maximum(abs2, a, dims=2))

        @test diff(sa, dims=Val(1)) === RSArray1(a[2:end,:,:] - a[1:end-1,:,:])
        @test diff(sa, dims=1) === RSArray1(a[2:end,:,:] - a[1:end-1,:,:])
        @test diff(sa, dims=Val(2)) === RSArray2(a[:,2:end,:] - a[:,1:end-1,:])
        @test diff(sa, dims=2) === RSArray2(a[:,2:end,:] - a[:,1:end-1,:])
        @test diff(sa, dims=Val(3)) === RSArray3(a[:,:,2:end] - a[:,:,1:end-1])
        @test diff(sa, dims=3) === RSArray3(a[:,:,2:end] - a[:,:,1:end-1])

        v = randn(4); sv = SVector{4}(v)
        m = randn(4,3); sm = SMatrix{4,3}(m)
        @test diff(sv, dims=Val(1)) == diff(sv, dims=1) == diff(sv) == diff(v)
        @test diff(sm, dims=Val(1)) == diff(sm, dims=1) == diff(m, dims=1)
        @test diff(sm, dims=Val(2)) == diff(sm, dims=2) == diff(m, dims=2)

        # diff on nested arrays should result in the correct eltype
        @test @inferred(diff(SA[SA[1,2],SA[3,4]])) === SVector{1,SVector{2,Int}}(((2,2),))
        @test @inferred(diff(SA[[1,2],[3,4]]))::SVector{1,Vector{Int}} == SA[[2,2]]
        # For larger cases, check eltype infers correctly
        @test @inferred(diff(zeros(SVector{100,SVector{2,Int}}))) == fill(SA[0,0],99)
    end

    @testset "broadcast and broadcast!" begin
        c = 2
        v1 = @SVector [2,4,6,8]
        v2 = @SVector [4,3,2,1]
        mv = MVector{4, Int}(undef)
        mm = MMatrix{4, 2, Int}(undef)
        M = @SMatrix [1 2; 3 4; 5 6; 7 8]

        @test_throws DimensionMismatch broadcast(+, v1, @SMatrix [4 3 2 1; 5 6 7 8])

        @test @inferred(broadcast(convert, Float64, v1)) === SVector{4,Float64}(2,4,6,8)
        # issue 329
        @test @inferred(broadcast(round, Int, SVector(1.0,2.0))) === SVector{2,Int}(1,2)

        @test @inferred(broadcast(-, v1)) === map(-, v1)

        @test @inferred(broadcast(+, v1, c)) === @SVector [4, 6, 8, 10]
        @test @inferred(broadcast(+, v1, v2)) === map(+, v1, v2)
        @test @inferred(broadcast(+, v1, M)) === @SMatrix [3 4; 7 8; 11 12; 15 16]

        @test_throws DimensionMismatch broadcast!(-, MVector{5, Int}(undef), v1)

        broadcast!(-, mv, v1)
        @test mv == @MVector [-2, -4, -6, -8]

        broadcast!(+, mv, v1, v2)
        @test mv == @MVector [6, 7, 8, 9]

        broadcast!(+, mm, v1, M)
        @test mm == @MMatrix [3 4; 7 8; 11 12; 15 16]
        # issue #103
        @test map(+, M, M) == [2 4; 6 8; 10 12; 14 16]

        @test ((@SVector Int64[]) + (@SVector Int64[])) == (@SVector Int64[])
    end
    @testset "Nested SVectors" begin
        # issue #593
        v = SVector(SVector(3, 2), SVector(5, 7))
        @test @inferred(v + v) == SVector(SVector(6, 4), SVector(10, 14))
        v = SVector(SVector(3, 2, 1), SVector(5, 7, 9))
        @test @inferred(v + v) == SVector(SVector(6, 4, 2), SVector(10, 14, 18))
    end
    @testset "hcat and vcat" begin
        # issue #641
        v = SVector([1,2], [3,4])
        @test reduce(vcat, v) == [1,2,3,4]
        @test reduce(hcat, v) == [1 3; 2 4]
        v2 = SVector(SVector(1,2), SVector(3,4))
        @test @inferred(reduce(vcat, v2)) === @SVector [1,2,3,4]
        @test @inferred(reduce(hcat, v2)) === @SMatrix [1 3; 2 4]
    end
    @testset "map over enumerate" begin
        # issue #1106
        v = @SVector [1, -2, 3, -4]
        m = @SMatrix [1 -2; 3 -4]
        v0 = SVector{0,Float64}()
        m0 = SMatrix{0,0,Float64}()
        @test @inferred(map(f -> f[1] * f[2], enumerate_static(v))) === @SVector [1, -4, 9, -16]
        @test @inferred(map(f -> f[1] * f[2], enumerate_static(m))) === @SMatrix [1 -6; 6 -16]
        @test @inferred(map(f -> f, enumerate_static(v0))) === SVector{0,Tuple{Int,Float64}}()
        @test @inferred(map(f -> f, enumerate_static(m0))) === SMatrix{0,0,Tuple{Int,Float64}}()
    end
    @testset "reduce over empty array" begin
        # issue #1114
        @test (@inferred reduce(|,zeros(SMatrix{0,3,Bool}); dims=Val(1), init=false)) ==
            reduce(|,zeros(Bool,0,3); dims=1, init=false)
        @test reduce(|,zeros(SMatrix{0,3,Bool}); dims=1, init=false) ==
            reduce(|,zeros(Bool,0,3); dims=1, init=false)
    end
end

function bc(x,i)
    (i > 0 && i <= length(x)) || error("bc failed")
end

@inline function mygetindex(x,i)
    #@boundscheck bc(x,i)
    @boundscheck error("Always an error")
    @inbounds return x[i]
end

foo(x,i) = @inbounds return mygetindex(x,i)
bar(x,i) = return mygetindex(x,i)


#=function getindex1(n, i)
    @boundscheck error("YOU SHALL NEVER CHECK MY BOUNDS!!")
    @inbounds return n[i]
end

#foo(x) = @inbounds return getindex1(x,1)
function foo(x)
    @inbounds out = getindex1(x,1)
    out
end

julia> getindex1((1,2,3),1)
ERROR: YOU SHALL NEVER CHECK MY BOUNDS!!
 in getindex1(::Tuple{Int64,Int64,Int64}, ::Int64) at /home/aferris/.julia/v0.5/StaticArrays/perf/boundscheck.jl:2

julia> f1((1,2,3))
ERROR: StackOverflowError:
# I have also got, by modifying the above in trivial ways:
#   * ERROR: ReadOnlyMemoryError()
#   * signal (11): Segmentation fault (... quits)


julia> @code_warntype foo((1,2,3))
Variables:
  #self#::#foo
  x::Tuple{Int64,Int64,Int64}
  out::Union{}

Body:
  begin
      $(Expr(:inbounds, true))
      $(Expr(:inbounds, false))
      # meta: location /home/aferris/.julia/v0.5/StaticArrays/perf/boundscheck.jl getindex1 2
      $(Expr(:boundscheck, true))
      (Base.throw)($(Expr(:new, :(Core.ErrorException), "YOU SHALL NEVER CHECK MY BOUNDS!!")))::Union{}
      $(Expr(:boundscheck, :pop))
      $(Expr(:inbounds, true))
      $(Expr(:inbounds, :pop))
      # meta: pop location
      $(Expr(:inbounds, :pop))
      out::Union{} = nothing
      $(Expr(:inbounds, :pop))
  end::Union{}

=#
#=immutable NeverInBounds
    x::Tuple{Int,Int,Int}
end

function getindex1(n::NeverInBounds, i)
    @boundscheck error("YOU SHALL NEVER CHECK MY BOUNDS!!")
    @inbounds return n.x[1]
end

n = NeverInBounds((1,2,3))

f0(x) = getindex1(x, 1)
#function f1(x)
#    @inbounds return getindex1(x, 1)
#end
f1(x) = @inbounds return getindex1(x,1)

try
    f0(n)
    error("There should have been an error")
catch
    println("f0 throws an error")
end

#println("f1 returns $(f1(n))")
=#

if VERSION ≥ v"1.7-"
    Aqua.test_all(StaticArrays, piracies=false)
    Aqua.test_piracies(StaticArrays, treat_as_own=[
            StaticArray
            Size
            SArray
            MArray
            SizedArray
            FieldArray
            StaticArrays.StaticArrayStyle
            StaticArrays.SOneTo
            StaticArrays.StaticArraysCore
            StaticArrays.check_array_parameters
            StaticArrays.convert_ntuple
        ],
        broken=true)

elseif VERSION ≥ v"1.6-"
    Aqua.test_all(StaticArrays, piracies=false, ambiguities=false)
    Aqua.test_piracies(StaticArrays, treat_as_own=[
            StaticArray
            Size
            SArray
            MArray
            SizedArray
            FieldArray
            StaticArrays.StaticArrayStyle
            StaticArrays.SOneTo
            StaticArrays.StaticArraysCore
            StaticArrays.check_array_parameters
            StaticArrays.convert_ntuple
        ],
        broken=true)

    # Allow no new ambiguities (see #18), unless you fix some old ones first!
    # TODO: Revisit and fix. See
    #   https://github.com/JuliaLang/julia/pull/36962
    #   https://github.com/JuliaLang/julia/issues/36951
    # Let's not allow new ambiguities. If any change makes the ambiguity count decrease, the
    # change should decrement `allowable_ambiguities` accordingly
    allowable_ambiguities = 1
    @test length(detect_ambiguities(StaticArrays)) == allowable_ambiguities

end

using StaticArrays, Test
using Statistics: Statistics, median, median!, middle

@testset "sort" begin

    @testset "basics" for T in (Int, Float64)
        for N in (0, 1, 2, 3, 10, 20, 30)
            vs = rand(SVector{N,T})
            vm = MVector{N,T}(vs)
            vref = sort(Vector(vs))

            @test @inferred(sort(vs)) isa SVector
            @test @inferred(sort(vs, alg=QuickSort)) isa SVector
            @test @inferred(sort(vm)) isa MVector
            @test vref == sort(vs)
            @test vref == sort(vm)

            # @allocated seems broken since 1.4
            #N <= 20 && @test 0 == @allocated sort(vs)
        end
    end

    @testset "sortperm" for T in (Int, Float64)
        for N in (0, 1, 2, 3, 10, 20, 30)
            v = rand(SVector{N,T})
            vp = sortperm(v)
            @test v[vp] == sort(v)
        end

        # stability
        @test sortperm(SA[1, 1, 1, 0]) == SA[4, 1, 2, 3]
    end

    @testset "median" begin
        @test_throws ArgumentError median(SA[])
        @test ismissing(median(SA[1, missing]))
        @test isnan(median(SA[1., NaN]))

        @testset for T in (Int, Float64)
            for N in (1, 2, 3, 10, 20, 30)
                v = rand(SVector{N,T})
                mref = median(Vector(v))

                @test @inferred(median(v) == mref)
            end
        end

        # Tests based on upstream `Statistics.jl`.
        # https://github.com/JuliaStats/Statistics.jl/blob/d49c2bf4f81e1efb4980a35fe39c815ef8396297/test/runtests.jl#L31-L92
        @test median(SA[1.]) === 1.
        @test median(SA[1.,3]) === 2.
        @test median(SA[1.,3,2]) === 2.

        @test median(SA[1,3,2]) === 2.0
        @test median(SA[1,3,2,4]) === 2.5

        @test median(SA[0.0,Inf]) == Inf
        @test median(SA[0.0,-Inf]) == -Inf
        @test median(SA[0.,Inf,-Inf]) == 0.0
        @test median(SA[1.,-1.,Inf,-Inf]) == 0.0
        @test isnan(median(SA[-Inf,Inf]))

        X = SA[2 3 1 -1; 7 4 5 -4]
        @test all(median(X, dims=2) .== SA[1.5, 4.5])
        @test all(median(X, dims=1) .== SA[4.5 3.5 3.0 -2.5])
        @test X == SA[2 3 1 -1; 7 4 5 -4] # issue #17153

        @test_throws ArgumentError median(SA[])
        @test isnan(median(SA[NaN]))
        @test isnan(median(SA[0.0,NaN]))
        @test isnan(median(SA[NaN,0.0]))
        @test isnan(median(SA[NaN,0.0,1.0]))
        @test isnan(median(SA{Any}[NaN,0.0,1.0]))
        @test isequal(median(SA[NaN 0.0; 1.2 4.5], dims=2), reshape(SA[NaN; 2.85], 2, 1))

        # the specific NaN value is propagated from the input
        @test median(SA[NaN]) === NaN
        @test median(SA[0.0,NaN]) === NaN
        @test median(SA[0.0,NaN,NaN]) === NaN
        @test median(SA[-NaN]) === -NaN
        @test median(SA[0.0,-NaN]) === -NaN
        @test median(SA[0.0,-NaN,-NaN]) === -NaN

        @test ismissing(median(SA[1, missing]))
        @test ismissing(median(SA[1, 2, missing]))
        @test ismissing(median(SA[NaN, 2.0, missing]))
        @test ismissing(median(SA[NaN, missing]))
        @test ismissing(median(SA[missing, NaN]))
        @test ismissing(median(SA{Any}[missing, 2.0, 3.0, 4.0, NaN]))
        @test median(skipmissing(SA[1, missing, 2])) === 1.5

        @test median!(Base.copymutable(SA[1 2 3 4])) == 2.5
        @test median!(Base.copymutable(SA[1 2; 3 4])) == 2.5

        @test @inferred(median(SA{Float16}[1, 2, NaN])) === Float16(NaN)
        @test @inferred(median(SA{Float16}[1, 2, 3]))   === Float16(2)
        @test @inferred(median(SA{Float32}[1, 2, NaN])) === NaN32
        @test @inferred(median(SA{Float32}[1, 2, 3]))   === 2.0f0

        # custom type implementing minimal interface
        struct A
            x
        end
        Statistics.middle(x::A, y::A) = A(middle(x.x, y.x))
        Base.isless(x::A, y::A) = isless(x.x, y.x)
        @test median(SA[A(1), A(2)]) === A(1.5)
        @test median(SA{Any}[A(1), A(2)]) === A(1.5)
    end

end

@inline function inv(A::StaticMatrix)
    T = eltype(A)
    S = arithmetic_closure(T)
    A_S = convert(similar_type(A,S),A)
    _inv(Size(A_S),A_S)
end

@inline _inv(::Size{(0,0)}, A) = similar_type(A,typeof(inv(one(eltype(A)))))()

@inline _inv(::Size{(1,1)}, A) = similar_type(A)(inv(A[1]))

@inline function _inv(::Size{(2,2)}, A)
    newtype = similar_type(A)
    idet = 1/det(A)
    @inbounds return newtype((A[4]*idet, -(A[2]*idet), -(A[3]*idet), A[1]*idet))
end

@inline function _inv(::Size{(3,3)}, A)
    newtype = similar_type(A)

    @inbounds x0 = SVector{3}(A[1], A[2], A[3])
    @inbounds x1 = SVector{3}(A[4], A[5], A[6])
    @inbounds x2 = SVector{3}(A[7], A[8], A[9])

    y0 = cross(x1,x2)
    d  = bilinear_vecdot(x0, y0)
    x0 = x0 / d
    y0 = y0 / d
    y1 = cross(x2,x0)
    y2 = cross(x0,x1)

    @inbounds return newtype((y0[1], y1[1], y2[1], y0[2], y1[2], y2[2], y0[3], y1[3], y2[3]))
end

@inline function _inv(::Size{(4,4)}, A)
    # https://www.geometrictools.com/Documentation/LaplaceExpansionTheorem.pdf

    s0 = A[1] * A[6]  - A[2]  * A[5]
    s1 = A[1] * A[10] - A[2]  * A[9]
    s2 = A[1] * A[14] - A[2]  * A[13]
    s3 = A[5] * A[10] - A[6]  * A[9]
    s4 = A[5] * A[14] - A[6]  * A[13]
    s5 = A[9] * A[14] - A[10] * A[13]

    c5 = A[11] * A[16]  - A[12] * A[15]
    c4 = A[7]  * A[16]  - A[8]  * A[15]
    c3 = A[7]  * A[12]  - A[8]  * A[11]
    c2 = A[3]  * A[16]  - A[4]  * A[15]
    c1 = A[3]  * A[12]  - A[4]  * A[11]
    c0 = A[3]  * A[8]   - A[4]  * A[7]

    invdet = 1 / (s0 * c5 - s1 * c4 + s2 * c3 + s3 * c2 - s4 * c1 + s5 * c0)

    B =  @SMatrix [
        ( A[6] * c5 - A[10] * c4 + A[14] * c3) * invdet
    	(-A[2] * c5 + A[10] * c2 - A[14] * c1) * invdet
        ( A[2] * c4 - A[6]  * c2 + A[14] * c0) * invdet
        (-A[2] * c3 + A[6]  * c1 - A[10] * c0) * invdet
        (-A[5] * c5 + A[9]  * c4 - A[13] * c3) * invdet
    	( A[1] * c5 - A[9]  * c2 + A[13] * c1) * invdet
    	(-A[1] * c4 + A[5]  * c2 - A[13] * c0) * invdet
    	( A[1] * c3 - A[5]  * c1 + A[9]  * c0) * invdet
    	( A[8] * s5 - A[12] * s4 + A[16] * s3) * invdet
    	(-A[4] * s5 + A[12] * s2 - A[16] * s1) * invdet
    	( A[4] * s4 - A[8]  * s2 + A[16] * s0) * invdet
    	(-A[4] * s3 + A[8]  * s1 - A[12] * s0) * invdet
        (-A[7] * s5 + A[11] * s4 - A[15] * s3) * invdet
        ( A[3] * s5 - A[11] * s2 + A[15] * s1) * invdet
        (-A[3] * s4 + A[7]  * s2 - A[15] * s0) * invdet
        ( A[3] * s3 - A[7]  * s1 + A[11] * s0) * invdet]
    return similar_type(A)(B)
end

@generated function _inv(::Size{S}, A) where S
    LinearAlgebra.checksquare(A)
    if prod(S) ≤ 14*14
        quote
            @_inline_meta
            inv(lu(A))
        end
    else
        :(@_inline_meta; similar_type(A)(inv(Matrix(A))))
    end
end

function inv(LUp::LU)
    if !(LUp.L isa LowerTriangular)
        checksquare(LUp.L)
        checksquare(LUp.U)
    end
    LUp.U \ (LUp.L \ typeof(parent(LUp.L))(I)[LUp.p,:])
end

# Generic Cholesky decomposition for fixed-size matrices, mostly unrolled
non_hermitian_error() = throw(LinearAlgebra.PosDefException(-1))
@inline function LinearAlgebra.cholesky(A::StaticMatrix; check::Bool = true)
    ishermitian(A) || non_hermitian_error()
    _cholesky(Size(A), A, check)
end

@inline function LinearAlgebra.cholesky(A::LinearAlgebra.RealHermSymComplexHerm{<:Real, <:StaticMatrix}; check::Bool = true)
    _cholesky(Size(A), A.data, check)
end
@inline LinearAlgebra._chol!(A::StaticMatrix, ::Type{UpperTriangular}) = (cholesky(A).U, 0)

@inline function _chol_failure(A, info, check)
    if check
        throw(LinearAlgebra.PosDefException(info))
    else
        Cholesky(A, 'U', info)
    end
end
# x < zero(x) is check used in `sqrt`, letting LLVM eliminate that check and remove error code.
@inline _nonpdcheck(x::Real) = x ≥ zero(x)
@inline _nonpdcheck(x) = x == x

@generated function _cholesky(::Size{S}, A::StaticMatrix{M,M}, check::Bool) where {S,M}
    @assert (M,M) == S
    M > 24 && return :(_cholesky_large(Size{$S}(), A, check))
    q = Expr(:block)
    for n ∈ 1:M
        for m ∈ n:M
            L_m_n = Symbol(:L_,m,:_,n)
            push!(q.args, :($L_m_n = @inbounds A[$n, $m]))
        end
        for k ∈ 1:n-1, m ∈ n:M
            L_m_n = Symbol(:L_,m,:_,n)
            L_m_k = Symbol(:L_,m,:_,k)
            L_n_k = Symbol(:L_,n,:_,k)
            push!(q.args, :($L_m_n = muladd(-$L_m_k, $L_n_k', $L_m_n)))
        end
        L_n_n = Symbol(:L_,n,:_,n)
        L_n_n_ltz = Symbol(:L_,n,:_,n,:_,:ltz)
        push!(q.args, :(_nonpdcheck($L_n_n) || return _chol_failure(A, $n, check)))
        push!(q.args, :($L_n_n = Base.FastMath.sqrt_fast($L_n_n)))
        Linv_n_n = Symbol(:Linv_,n,:_,n)
        push!(q.args, :($Linv_n_n = inv($L_n_n)))
        for m ∈ n+1:M
            L_m_n = Symbol(:L_,m,:_,n)
            push!(q.args, :($L_m_n *= $Linv_n_n))
        end
    end
    push!(q.args, :(T = promote_type(typeof(sqrt(one(eltype(A)))), Float32)))
    ret = Expr(:tuple)
    for n ∈ 1:M
        for m ∈ 1:n
            push!(ret.args, Symbol(:L_,n,:_,m))
        end
        for m ∈ n+1:M
            push!(ret.args, :(zero(T)))
        end
    end
    push!(q.args, :(Cholesky(similar_type(A, T)($ret), 'U', 0)))
    return Expr(:block, Expr(:meta, :inline), q)
end

# Otherwise default algorithm returning wrapped SizedArray
@inline function _cholesky_large(::Size{S}, A::StaticArray, check::Bool) where {S}
    C = cholesky(Hermitian(Matrix(A)); check=check)
    Cholesky(similar_type(A)(C.U), 'U', C.info)
end

LinearAlgebra.hermitian_type(::Type{SA}) where {T, S, SA<:SArray{S,T}} = Hermitian{T,SA}

function inv(A::Cholesky{T,<:StaticMatrix{N,N,T}}) where {N,T}
    # We can't use M = inv(A.U) here since it returns an `UpperTriangular` of a `Matrix`
    M = UpperTriangular(A.U \ SDiagonal{N}(I))
    return M * M'
end

function Base.:\(A::Cholesky{T,<:StaticMatrix{N,N,T}}, B::StaticVecOrMatLike) where {N,T}
    return A.U \ (A.U' \ B)
end

function Base.:/(B::StaticMatrixLike, A::Cholesky{T,<:StaticMatrix{N,N,T}}) where {N,T}
    return (B / A.U) / A.U'
end

@inline exp(A::StaticMatrix) = _exp(Size(A), A)

@inline function _exp(::Size{(0,0)}, A::StaticMatrix)
    T = typeof(exp(zero(eltype(A))))
    newtype = similar_type(A,T)

    (newtype)()
end

@inline function _exp(::Size{(1,1)}, A::StaticMatrix)
    T = typeof(exp(zero(eltype(A))))
    newtype = similar_type(A,T)

    (newtype)((exp(A[1]), ))
end

# Bernstein, D. S. & So, W. 1993. "Some Explicit Formulas for the Matrix Exponential"
@inline function _exp(::Size{(2,2)}, A::StaticMatrix{<:Any,<:Any,<:Real})
    T = typeof(exp(zero(eltype(A))))
    newtype = similar_type(A,T)

    @inbounds a = A[1]
    @inbounds c = A[2]
    @inbounds b = A[3]
    @inbounds d = A[4]

    v = (a-d)^2 + 4*b*c

    m = (a + d) / 2

    if v > 0
        # In this case the formulas in the entries of the matrix
        # are a function of cosh and sinh, and could (in theory)
        # follow the same code pattern of the other branches (v ≤ 0).
        # However, cosh and sinh explode with large arguments and
        # we use the following identity to avoid numerical issues:
        #
        # exp(m) * [c₁ * cohs(δ) + c₂ * sinh(δ)] =
        #   c₁ * (e₊ + e₋) / 2 + c₂ * (e₊ - e₋) / 2
        #
        # where e₊ = exp(m + δ) and e₋ = exp(m - δ).
        #
        # See https://github.com/JuliaArrays/StaticArrays.jl/issues/1295
        δ = sqrt(v) / 2
        e₊ = exp(m + δ)
        e₋ = exp(m - δ)
        e₁ = (e₊ + e₋) / 2
        e₂ = (e₊ - e₋) / 2
        c₂ = (a - d) / 2δ
        m11 = (e₁ + c₂ * e₂)
        m12 = (b / δ) * e₂
        m21 = (c / δ) * e₂
        m22 = (e₁ - c₂ * e₂)
    elseif v < 0
        z = sqrt(-v)
        r = exp(m)
        z1 = cos(z / 2)
        z2 = sin(z / 2) / z
        m11 = r * (z1 + (a - d) * z2)
        m12 = r * 2b * z2
        m21 = r * 2c * z2
        m22 = r * (z1 - (a - d) * z2)
    else # if v == 0
        r = exp(m)
        z1 = T(1.0)
        z2 = T(0.5)
        m11 = r * (z1 + (a - d) * z2)
        m12 = r * 2b * z2
        m21 = r * 2c * z2
        m22 = r * (z1 - (a - d) * z2)
    end

    (newtype)((m11, m21, m12, m22))
end

@inline function _exp(::Size{(2,2)}, A::StaticMatrix{<:Any,<:Any,<:Complex})
    T = typeof(exp(zero(eltype(A))))
    newtype = similar_type(A,T)

    @inbounds a = A[1]
    @inbounds c = A[2]
    @inbounds b = A[3]
    @inbounds d = A[4]

    z = sqrt((a - d)*(a - d) + 4*b*c )
    e = expm1((a + d - z) / 2)
    f = expm1((a + d + z) / 2)
    ϵ = eps()
    g = abs2(z) < ϵ^2 ? exp((a + d) / 2) * (1 + z^2 / 24) : (f - e) / z

    m11 = (g * (a - d) + f + e) / 2 + 1
    m12 = g * b
    m21 = g * c
    m22 = (-g * (a - d) + f + e) / 2 + 1

    (newtype)((m11, m21, m12, m22))
end

# Adapted from implementation in Base; algorithm from
# Higham, "Functions of Matrices: Theory and Computation", SIAM, 2008
function _exp(::Size, _A::StaticMatrix{<:Any,<:Any,T}) where T
    S = typeof((zero(T)*zero(T) + zero(T)*zero(T))/one(T))
    A = S.(_A)
    # omitted: matrix balancing, i.e., LAPACK.gebal!
    nA = maximum(sum(abs.(A); dims=Val(1)))    # marginally more performant than norm(A, 1)
    ## For sufficiently small nA, use lower order Padé-Approximations
    if (nA <= 2.1)
        A2 = A*A
        if nA > 0.95
            U = @evalpoly(A2, S(8821612800)*I, S(302702400)*I, S(2162160)*I, S(3960)*I, S(1)*I)
            U = A*U
            V = @evalpoly(A2, S(17643225600)*I, S(2075673600)*I, S(30270240)*I, S(110880)*I, S(90)*I)
        elseif nA > 0.25
            U = @evalpoly(A2, S(8648640)*I, S(277200)*I, S(1512)*I, S(1)*I)
            U = A*U
            V = @evalpoly(A2, S(17297280)*I, S(1995840)*I, S(25200)*I, S(56)*I)
        elseif nA > 0.015
            U = @evalpoly(A2, S(15120)*I, S(420)*I, S(1)*I)
            U = A*U
            V = @evalpoly(A2, S(30240)*I, S(3360)*I, S(30)*I)
        else
            U = @evalpoly(A2, S(60)*I, S(1)*I)
            U = A*U
            V = @evalpoly(A2, S(120)*I, S(12)*I)
        end
        expA = (V - U) \ (V + U)
    else
        s  = log2(nA/5.4)               # power of 2 later reversed by squaring
        if s > 0
            si = ceil(Int,s)
            A = A / S(2^si)
        end

        A2 = A*A
        A4 = A2*A2
        A6 = A2*A4

        U = A6*(S(1)*A6 + S(16380)*A4 + S(40840800)*A2) +
            (S(33522128640)*A6 + S(10559470521600)*A4 + S(1187353796428800)*A2) +
            S(32382376266240000)*I
        U = A*U
        V = A6*(S(182)*A6 + S(960960)*A4 + S(1323241920)*A2) +
            (S(670442572800)*A6 + S(129060195264000)*A4 + S(7771770303897600)*A2) +
            S(64764752532480000)*I
        expA = (V - U) \ (V + U)

        if s > 0            # squaring to reverse dividing by power of 2
            for t=1:si
                expA = expA*expA
            end
        end
    end

    expA
end

# import LinearAlgebra.MulAddMul

abstract type MulAddMul{TA,TB} end

struct AlphaBeta{TA,TB} <: MulAddMul{TA,TB}
    α::TA
    β::TB
end
@inline alpha(ab::AlphaBeta) = ab.α
@inline beta(ab::AlphaBeta) = ab.β

struct NoMulAdd{TA,TB} <: MulAddMul{TA,TB} end
@inline alpha(ma::NoMulAdd{TA,TB}) where {TA,TB} = one(TA)
@inline beta(ma::NoMulAdd{TA,TB}) where {TA,TB} = zero(TB)

"""
    StaticMatMulLike

Static wrappers used for multiplication dispatch.
"""
const StaticMatMulLike{s1, s2, T} = Union{
    StaticMatrix{s1, s2, T},
    Symmetric{T, <:StaticMatrix{s1, s2, T}},
    Hermitian{T, <:StaticMatrix{s1, s2, T}},
    LowerTriangular{T, <:StaticMatrix{s1, s2, T}},
    UpperTriangular{T, <:StaticMatrix{s1, s2, T}},
    UnitLowerTriangular{T, <:StaticMatrix{s1, s2, T}},
    UnitUpperTriangular{T, <:StaticMatrix{s1, s2, T}},
    Adjoint{T, <:StaticMatrix{s1, s2, T}},
    Transpose{T, <:StaticMatrix{s1, s2, T}},
    Diagonal{T, <:StaticVector{s1, T}}}

"""
    gen_by_access(expr_gen, a::Type{<:AbstractArray}, asym = :wrapped_a)

Statically generate outer code for fully unrolled multiplication loops.
Returned code does wrapper-specific tests (for example if a symmetric matrix view is
`U` or `L`) and the body of the if expression is then generated by function `expr_gen`.
The function `expr_gen` receives access pattern description symbol as its argument
and this symbol is then consumed by uplo_access to generate the right code for matrix
element access.

The name of the matrix to test is indicated by `asym`.
"""
function gen_by_access(expr_gen, a::Type{<:StaticVecOrMat}, asym = :wrapped_a)
    return expr_gen(:any)
end
function gen_by_access(expr_gen, a::Type{<:Symmetric{<:Any, <:StaticMatrix}}, asym = :wrapped_a)
    return quote
        if $(asym).uplo == 'U'
            $(expr_gen(:up))
        else
            $(expr_gen(:lo))
        end
    end
end
function gen_by_access(expr_gen, a::Type{<:Hermitian{<:Any, <:StaticMatrix}}, asym = :wrapped_a)
    return quote
        if $(asym).uplo == 'U'
            $(expr_gen(:up_herm))
        else
            $(expr_gen(:lo_herm))
        end
    end
end
function gen_by_access(expr_gen, a::Type{<:UpperTriangular{<:Any, <:StaticMatrix}}, asym = :wrapped_a)
    return expr_gen(:upper_triangular)
end
function gen_by_access(expr_gen, a::Type{<:LowerTriangular{<:Any, <:StaticMatrix}}, asym = :wrapped_a)
    return expr_gen(:lower_triangular)
end
function gen_by_access(expr_gen, a::Type{<:UnitUpperTriangular{<:Any, <:StaticMatrix}}, asym = :wrapped_a)
    return expr_gen(:unit_upper_triangular)
end
function gen_by_access(expr_gen, a::Type{<:UnitLowerTriangular{<:Any, <:StaticMatrix}}, asym = :wrapped_a)
    return expr_gen(:unit_lower_triangular)
end
function gen_by_access(expr_gen, a::Type{<:Transpose{<:Any, <:StaticVecOrMat}}, asym = :wrapped_a)
    return expr_gen(:transpose)
end
function gen_by_access(expr_gen, a::Type{<:Adjoint{<:Any, <:StaticVecOrMat}}, asym = :wrapped_a)
    return expr_gen(:adjoint)
end
function gen_by_access(expr_gen, a::Type{<:Diagonal{<:Any, <:StaticVector}}, asym = :wrapped_a)
    return expr_gen(:diagonal)
end
"""
    gen_by_access(expr_gen, a::Type{<:AbstractArray}, b::Type{<:AbstractArray})

Similar to `gen_by_access` with only one type argument. The difference is that tests for both
arrays of type `a` and `b` are generated and `expr_gen` receives two access arguments,
first for matrix `a` and the second for matrix `b`.
"""
function gen_by_access(expr_gen, a::Type{<:StaticMatrix}, b::Type)
    return quote
        return $(gen_by_access(b, :wrapped_b) do access_b
            expr_gen(:any, access_b)
        end)
    end
end
function gen_by_access(expr_gen, a::Type{<:Symmetric{<:Any, <:StaticMatrix}}, b::Type)
    return quote
        if wrapped_a.uplo == 'U'
            return $(gen_by_access(b, :wrapped_b) do access_b
                expr_gen(:up, access_b)
            end)
        else
            return $(gen_by_access(b, :wrapped_b) do access_b
                expr_gen(:lo, access_b)
            end)
        end
    end
end
function gen_by_access(expr_gen, a::Type{<:Hermitian{<:Any, <:StaticMatrix}}, b::Type)
    return quote
        if wrapped_a.uplo == 'U'
            return $(gen_by_access(b, :wrapped_b) do access_b
                expr_gen(:up_herm, access_b)
            end)
        else
            return $(gen_by_access(b, :wrapped_b) do access_b
                expr_gen(:lo_herm, access_b)
            end)
        end
    end
end
function gen_by_access(expr_gen, a::Type{<:UpperTriangular{<:Any, <:StaticMatrix}}, b::Type)
    return quote
        return $(gen_by_access(b, :wrapped_b) do access_b
            expr_gen(:upper_triangular, access_b)
        end)
    end
end
function gen_by_access(expr_gen, a::Type{<:LowerTriangular{<:Any, <:StaticMatrix}}, b::Type)
    return quote
        return $(gen_by_access(b, :wrapped_b) do access_b
            expr_gen(:lower_triangular, access_b)
        end)
    end
end
function gen_by_access(expr_gen, a::Type{<:UnitUpperTriangular{<:Any, <:StaticMatrix}}, b::Type)
    return quote
        return $(gen_by_access(b, :wrapped_b) do access_b
            expr_gen(:unit_upper_triangular, access_b)
        end)
    end
end
function gen_by_access(expr_gen, a::Type{<:UnitLowerTriangular{<:Any, <:StaticMatrix}}, b::Type)
    return quote
        return $(gen_by_access(b, :wrapped_b) do access_b
            expr_gen(:unit_lower_triangular, access_b)
        end)
    end
end
function gen_by_access(expr_gen, a::Type{<:Transpose{<:Any, <:StaticMatrix}}, b::Type)
    return quote
        return $(gen_by_access(b, :wrapped_b) do access_b
            expr_gen(:transpose, access_b)
        end)
    end
end
function gen_by_access(expr_gen, a::Type{<:Adjoint{<:Any, <:StaticMatrix}}, b::Type)
    return quote
        return $(gen_by_access(b, :wrapped_b) do access_b
            expr_gen(:adjoint, access_b)
        end)
    end
end
function gen_by_access(expr_gen, a::Type{<:Diagonal{<:Any, <:StaticVector}}, b::Type)
    return quote
        return $(gen_by_access(b, :wrapped_b) do access_b
            expr_gen(:diagonal, access_b)
        end)
    end
end


"""
    TSize{S,T}

Size that stores whether a Matrix is a Transpose.
Useful when selecting multiplication methods, and avoiding allocations when dealing with
the `Transpose` type by passing around the original matrix.
Should pair with `parent`.
"""
struct TSize{S,T}
    function TSize{S,T}() where {S,T}
        new{S::Tuple{Vararg{StaticDimension}},T::Symbol}()
    end
end
TSize(A::Type{<:StaticArrayLike}) = TSize{size(A), gen_by_access(identity, A)}()
TSize(A::StaticArrayLike) = TSize(typeof(A))
TSize(S::Size{s}, T=:any) where s = TSize{s,T}()
TSize(s::Number) = TSize(Size(s))
istranspose(::TSize{<:Any,T}) where T = (T === :transpose)
size(::TSize{S}) where S = S
Size(::TSize{S}) where S = Size{S}()
access_type(::TSize{<:Any,T}) where T = T
Base.transpose(::TSize{S,:transpose}) where {S} = TSize{reverse(S),:any}()
Base.transpose(::TSize{S,:any}) where {S} = TSize{reverse(S),:transpose}()

# Get the parent of transposed arrays, or the array itself if it has no parent
# Different from Base.parent because we only want to get rid of Transpose and Adjoint
# The two last methods can't be combined into one for StaticVecOrMat because then dispatch
# goes wrong for SizedArray
@inline mul_parent(A::Union{StaticMatMulLike, Adjoint{<:Any,<:StaticVector}, Transpose{<:Any,<:StaticVector}}) = Base.parent(A)
@inline mul_parent(A::StaticMatrix) = A
@inline mul_parent(A::StaticVector) = A

# Using the full StaticVecOrMatLike in dest of that one method of mul! takes a lot of load time
const StaticVecOrMatLikeForFiveArgMulDest{T} = Union{
    StaticVector{<:Any, T},
    StaticMatrix{<:Any, <:Any, T},
    Transpose{T, <:StaticVecOrMat{T}},
    Adjoint{T, <:StaticVecOrMat{T}}
}

# 5-argument matrix multiplication
#    To avoid allocations, strip away Transpose type and store transpose info in Size
@inline LinearAlgebra.mul!(dest::StaticVecOrMatLikeForFiveArgMulDest, A::StaticVecOrMatLike, B::StaticVecOrMatLike,
    α::Number, β::Number) = _mul!(TSize(dest), mul_parent(dest), Size(A), Size(B), A, B,
    AlphaBeta(α,β))

# See https://github.com/JuliaArrays/StaticArrays.jl/issues/857.
# `StaticVecOrMatLike` is a very large union, and this caused Julia 1.0.x to
# use a large amount of memory when compiling StaticArrays in the presence
# of other packages that also extend `LinearAlgebra.mul!` in a similar
# fashion. As an example, this led to JuMP using more than 4 GB of RAM when
# running `using JuMP`, causing its CI to crash.
#
# Computing the eltypes within the function, rather than specifying them in
# the type arguments greatly improves the issue, with `using JuMP` going
# from:
#     julia> @time using JuMP
#     [ Info: Precompiling JuMP [4076af6c-e467-56ae-b986-b466b2749572]
#     Killed
# to:
#     julia> @time using JuMP
#     [ Info: Precompiling JuMP [4076af6c-e467-56ae-b986-b466b2749572]
#     101.723598 seconds (12.85 M allocations: 812.902 MiB, 0.31% gc time)
@inline function LinearAlgebra.mul!(
    dest::StaticVecOrMatLike,
    A::StaticVecOrMatLike,
    B::StaticVecOrMatLike,
)
    TDest, TA, TB = eltype(dest), eltype(A), eltype(B)
    TMul = promote_op(matprod, TA, TB)
    return _mul!(TSize(dest), mul_parent(dest), Size(A), Size(B), A, B, NoMulAdd{TMul, TDest}())
end

"""
    multiplied_dimension(A, B)

Calculate the product of the dimensions being multiplied. Useful as a heuristic for unrolling.
"""
@inline multiplied_dimension(A::Type{<:StaticVecOrMatLike}, B::Type{<:StaticVecOrMatLike}) =
    prod(size(A)) * size(B,2)

"""
    check_dims(sc, sa, sb)

Validate the dimensions of a matrix multiplication, including matrix-vector products
"""
function check_dims(::Size{sc}, ::Size{sa}, ::Size{sb}) where {sa,sb,sc}
    if sb[1] != sa[2] || sc[1] != sa[1]
        return false
    elseif length(sc) == 2 || length(sb) == 2
        sc2 = length(sc) == 1 ? 1 : sc[2]
        sb2 = length(sb) == 1 ? 1 : sb[2]
        if sc2 != sb2
            return false
        end
    end
    return true
end

"""
    uplo_access(sa, asym, k, j, uplo)

Generate code for matrix element access, for a matrix of size `sa` locally referred to
as `asym` in the context where the result will be used. Both indices `k` and `j` need to be
statically known for this function to work. `uplo` is the access pattern mode generated
by the `gen_by_access` function.
"""
function uplo_access(sa, asym, k, j, uplo)
    TAsym = Symbol("T"*string(asym))
    if uplo == :any
        return :($asym[$(LinearIndices(sa)[k, j])])
    elseif uplo == :up
        if k < j
            return :($asym[$(LinearIndices(sa)[k, j])])
        elseif k == j
            return :(LinearAlgebra.symmetric($asym[$(LinearIndices(sa)[k, j])], :U))
        else
            return :(transpose($asym[$(LinearIndices(sa)[j, k])]))
        end
    elseif uplo == :lo
        if k > j
            return :($asym[$(LinearIndices(sa)[k, j])])
        elseif k == j
            return :(LinearAlgebra.symmetric($asym[$(LinearIndices(sa)[k, j])], :L))
        else
            return :(transpose($asym[$(LinearIndices(sa)[j, k])]))
        end
    elseif uplo == :up_herm
        if k < j
            return :($asym[$(LinearIndices(sa)[k, j])])
        elseif k == j
            return :(LinearAlgebra.hermitian($asym[$(LinearIndices(sa)[k, j])], :U))
        else
            return :(adjoint($asym[$(LinearIndices(sa)[j, k])]))
        end
    elseif uplo == :lo_herm
        if k > j
            return :($asym[$(LinearIndices(sa)[k, j])])
        elseif k == j
            return :(LinearAlgebra.hermitian($asym[$(LinearIndices(sa)[k, j])], :L))
        else
            return :(adjoint($asym[$(LinearIndices(sa)[j, k])]))
        end
    elseif uplo == :upper_triangular
        if k <= j
            return :($asym[$(LinearIndices(sa)[k, j])])
        else
            return :(zero($TAsym))
        end
    elseif uplo == :lower_triangular
        if k >= j
            return :($asym[$(LinearIndices(sa)[k, j])])
        else
            return :(zero($TAsym))
        end
    elseif uplo == :unit_upper_triangular
        if k < j
            return :($asym[$(LinearIndices(sa)[k, j])])
        elseif k == j
            return :(oneunit($TAsym))
        else
            return :(zero($TAsym))
        end
    elseif uplo == :unit_lower_triangular
        if k > j
            return :($asym[$(LinearIndices(sa)[k, j])])
        elseif k == j
            return :(oneunit($TAsym))
        else
            return :(zero($TAsym))
        end
    elseif uplo == :upper_hessenberg
        if k <= j+1
            return :($asym[$(LinearIndices(sa)[k, j])])
        else
            return :(zero($TAsym))
        end
    elseif uplo == :transpose
        return :(transpose($asym[$(LinearIndices(reverse(sa))[j, k])]))
    elseif uplo == :adjoint
        return :(adjoint($asym[$(LinearIndices(reverse(sa))[j, k])]))
    elseif uplo == :diagonal
        if k == j
            return :($asym[$k])
        else
            return :(zero($TAsym))
        end
    else
        error("Unknown uplo: $uplo")
    end
end

"""
    _muladd_expr(lhs, rhs, coeffs)

Combine left and right sides of an assignment expression, short-cutting
`lhs = α * rhs + β * lhs`, element-wise.
If `α = 1`, the multiplication by `α` is removed. If `β = 0`, the second `rhs` term is removed.
"""
function _muladd_expr(lhs::Array{Expr}, rhs::Array{Expr}, ::Type{<:AlphaBeta})
    @assert length(lhs) == length(rhs)
    n = length(rhs)
    rhs = [:(α * $(expr)) for expr in rhs]
    rhs = [:($(lhs[k]) * β + $(rhs[k])) for k = 1:n]
    exprs = [:($(lhs[k]) = $(rhs[k])) for k = 1:n]
    _assign(lhs, rhs)
    return exprs
end

@inline _muladd_expr(lhs::Array{Expr}, rhs::Array{Expr}, ::Type{<:MulAddMul}) = _assign(lhs, rhs)

@inline function _assign(lhs::Array{Expr}, rhs::Array{Expr})
    @assert length(lhs) == length(rhs)
    [:($(lhs[k]) = $(rhs[k])) for k = 1:length(lhs)]
end

"""
    _lind(var, A, k, j)

Obtain an expression for the linear index of `var[k,j]`, taking transposes into account.
"""
function _lind(var::Symbol, A::Type{TSize{sa,tA}}, k::Int, j::Int) where {sa,tA}
    ula = uplo_access(sa, var, k, j, tA)
    if ula.head == :call && ula.args[1] == :transpose
        # TODO: can this be properly fixed at all?
        return ula.args[2]
    end
    return ula
end

function combine_products(expr_list)
    filtered = filter(expr_list) do expr
        if expr.head != :call || expr.args[1] !== :*
            error("expected call to *")
        end
        for arg in expr.args[2:end]
            if isa(arg, Expr) && arg.head == :call && arg.args[1] === :zero
                return false
            end
        end
        return true
    end
    if isempty(filtered)
        return :(zero(T))
    else
        return reduce(filtered) do ex1, ex2
            if ex2.head != :call || ex2.args[1] !== :*
                error("expected call to *")
            end

            return :(muladd($(ex2.args[2]), $(ex2.args[3]), $ex1))
        end
    end
end

# Matrix-vector multiplication
@generated function _mul!(Sc::TSize{sc}, c::StaticVecOrMatLike, Sa::Size{sa}, Sb::Size{sb},
        wrapped_a::StaticMatMulLike{<:Any, <:Any, Ta}, b::StaticVector{<:Any, Tb}, _add::MulAddMul,
        ::Val{col}=Val(1)) where {sa, sb, sc, col, Ta, Tb}
    if sa[2] != sb[1] || sc[1] != sa[1]
        throw(DimensionMismatch("Tried to multiply arrays of size $sa and $sb and assign to array of size $sc"))
    end

    if sa[2] != 0
        assign_expr = gen_by_access(wrapped_a) do access_a
            lhs = [_lind(:c,Sc,k,col) for k = 1:sa[1]]
            ab = [combine_products([:($(uplo_access(sa, :a, k, j, access_a)) * b[$j]) for j = 1:sa[2]]) for k = 1:sa[1]]
            exprs = _muladd_expr(lhs, ab, _add)

            return :(@inbounds $(Expr(:block, exprs...)))
        end
    else
        exprs = [:(c[$k] = zero(eltype(c))) for k = 1:sa[1]]
        assign_expr = :(@inbounds $(Expr(:block, exprs...)))
    end

    return quote
        # @_inline_meta
        α = alpha(_add)
        β = beta(_add)
        a = mul_parent(wrapped_a)
        $assign_expr
        return c
    end
end

# Outer product
@generated function _mul!(::TSize{sc}, c::StaticMatrix, tsa::Size{sa}, tsb::Size{sb},
        a::StaticVector, b::Union{Transpose{<:Any, <:StaticVector}, Adjoint{<:Any, <:StaticVector}}, _add::MulAddMul) where {sa, sb, sc}
    if sc[1] != sa[1] || sc[2] != sb[2]
        throw(DimensionMismatch("Tried to multiply arrays of size $sa and $sb and assign to array of size $sc"))
    end

    conjugate_b = b <: Adjoint

    lhs = [:(c[$(LinearIndices(sc)[i,j])]) for i = 1:sa[1], j = 1:sb[2]]
    if conjugate_b
        ab = [:(a[$i] * adjoint(b[$j])) for i = 1:sa[1], j = 1:sb[2]]
    else
        ab = [:(a[$i] * transpose(b[$j])) for i = 1:sa[1], j = 1:sb[2]]
    end

    exprs = _muladd_expr(lhs, ab, _add)

    return quote
        @_inline_meta
        α = alpha(_add)
        β = beta(_add)
        @inbounds $(Expr(:block, exprs...))
        return c
    end
end

# Matrix-matrix multiplication
@generated function _mul!(Sc::TSize{sc}, c::StaticMatMulLike,
        Sa::Size{sa}, Sb::Size{sb},
        a::StaticMatMulLike, b::StaticMatMulLike,
        _add::MulAddMul) where {sa, sb, sc}
    Ta,Tb,Tc = eltype(a), eltype(b), eltype(c)
    can_blas = Tc == Ta && Tc == Tb && Tc <: BlasFloat && a <: Union{StaticMatrix,Transpose} && b <: Union{StaticMatrix,Transpose}

    mult_dim = multiplied_dimension(a,b)
    a_tri_mul = a <: LinearAlgebra.AbstractTriangular ? 2 : 1
    b_tri_mul = b <: LinearAlgebra.AbstractTriangular ? 2 : 1
    ab_tri_mul = (a == 2 && b == 2) ? 2 : 1
    if mult_dim < 4*4*4*a_tri_mul*b_tri_mul*ab_tri_mul || a <: Diagonal || b <: Diagonal
        return quote
            @_inline_meta
            muladd_unrolled_all!(Sc, c, Sa, Sb, a, b, _add)
            return c
        end
    elseif mult_dim < 14*14*14 # Something seems broken for this one with large matrices (becomes allocating)
        return quote
            @_inline_meta
            muladd_unrolled_chunks!(Sc, c, Sa, Sb, a, b, _add)
            return c
        end
    else
        if can_blas
            return quote
                @_inline_meta
                mul_blas!(Sc, c, TSize(a), TSize(b), mul_parent(a), mul_parent(b), _add)
                return c
            end
        else
            return quote
                @_inline_meta
                muladd_unrolled_chunks!(Sc, c, Sa, Sb, a, b, _add)
                return c
            end
        end
    end
end


@generated function muladd_unrolled_all!(Sc::TSize{sc}, wrapped_c::StaticMatMulLike, Sa::Size{sa}, Sb::Size{sb},
        wrapped_a::StaticMatMulLike{<:Any,<:Any,Ta}, wrapped_b::StaticMatMulLike{<:Any,<:Any,Tb}, _add::MulAddMul) where {sa, sb, sc, Ta, Tb}
    if !check_dims(Size(sc),Size(sa),Size(sb))
        throw(DimensionMismatch("Tried to multiply arrays of size $sa and $sb and assign to array of size $sc"))
    end

    if sa[2] != 0
        lhs = [_lind(:c, Sc, k1, k2) for k1 = 1:sa[1], k2 = 1:sb[2]]

        assign_expr = gen_by_access(wrapped_a, wrapped_b) do access_a, access_b

            ab = [combine_products([:($(uplo_access(sa, :a, k1, j, access_a)) * $(uplo_access(sb, :b, j, k2, access_b))) for j = 1:sa[2]]
                ) for k1 = 1:sa[1], k2 = 1:sb[2]]

            exprs = _muladd_expr(lhs, ab, _add)
            return :(@inbounds $(Expr(:block, exprs...)))
        end
    else
        exprs = [:(c[$k] = zero(eltype(c))) for k = 1:sc[1]*sc[2]]
        assign_expr = :(@inbounds $(Expr(:block, exprs...)))
    end

    return quote
        @_inline_meta
        # α = _add.alpha
        # β = _add.beta
        α = alpha(_add)
        β = beta(_add)
        c = mul_parent(wrapped_c)
        a = mul_parent(wrapped_a)
        b = mul_parent(wrapped_b)
        T = promote_op(matprod,Ta,Tb)
        $assign_expr
        return c
    end
end


@generated function muladd_unrolled_chunks!(Sc::TSize{sc}, wrapped_c::StaticMatMulLike, ::Size{sa}, Sb::Size{sb},
        wrapped_a::StaticMatMulLike{<:Any,<:Any,Ta}, wrapped_b::StaticMatMulLike{<:Any,<:Any,Tb}, _add::MulAddMul) where {sa, sb, sc, Ta, Tb}
    if sb[1] != sa[2] || sa[1] != sc[1] || sb[2] != sc[2]
        throw(DimensionMismatch("Tried to multiply arrays of size $sa and $sb and assign to array of size $sc"))
    end

    # This will not work for Symmetric and Hermitian wrappers of c
    lhs = [_lind(:c, Sc, k1, k2) for k1 = 1:sa[1], k2 = 1:sb[2]]

    #vect_exprs = [:($(Symbol("tmp_$k2")) = partly_unrolled_multiply(A, B[:, $k2])) for k2 = 1:sB[2]]

    # Do a custom b[:, k2] to return a SVector (an isbitstype type) rather than a mutable type. Avoids allocation == faster
    tmp_type = SVector{sb[1], eltype(wrapped_c)}

    assign_expr = gen_by_access(wrapped_a, wrapped_b) do access_a, access_b
        vect_exprs = [:($(Symbol("tmp_$k2")) = partly_unrolled_multiply($(Size{sa}()), $(Size{(sb[1],)}()),
            a, $(Expr(:call, tmp_type, [uplo_access(sb, :b, i, k2, access_b) for i = 1:sb[1]]...)), $(Val(access_a)))) for k2 = 1:sb[2]]

        # exprs = [:(c[$(LinearIndices(sc)[k1, k2])] = $(Symbol("tmp_$k2"))[$k1]) for k1 = 1:sa[1], k2 = 1:sb[2]]
        rhs = [:($(Symbol("tmp_$k2"))[$k1]) for k1 = 1:sa[1], k2 = 1:sb[2]]
        exprs = _muladd_expr(lhs, rhs, _add)

        return quote
            @inbounds $(Expr(:block, vect_exprs...))
            @inbounds $(Expr(:block, exprs...))
        end
    end

    return quote
        @_inline_meta
        α = alpha(_add)
        β = beta(_add)
        c = mul_parent(wrapped_c)
        a = mul_parent(wrapped_a)
        b = mul_parent(wrapped_b)
        $assign_expr
    end
end

# @inline partly_unrolled_multiply(Sa::Size, Sb::Size, a::StaticMatrix, b::StaticArray) where {sa, sb, Ta, Tb} =
#     partly_unrolled_multiply(TSize(Sa), TSize(Sb), a, b)
@generated function partly_unrolled_multiply(Sa::Size{sa}, ::Size{sb}, a::StaticMatMulLike{<:Any, <:Any, Ta}, b::StaticArray{<:Tuple, Tb}, ::Val{access_a}) where {sa, sb, Ta, Tb, access_a}
    if sa[2] != sb[1]
        throw(DimensionMismatch("Tried to multiply arrays of size $sa and $sb"))
    end

    if sa[2] != 0
        exprs = [combine_products([:($(uplo_access(sa, :a, k, j, access_a))*b[$j]) for j = 1:sa[2]]) for k = 1:sa[1]]
    else
        exprs = [:(zero(promote_op(matprod,Ta,Tb))) for k = 1:sa[1]]
    end

    return quote
        $(Expr(:meta,:noinline))
        @inbounds return SVector(tuple($(exprs...)))
    end
end

@inline _get_raw_data(A::SizedArray) = A.data
@inline _get_raw_data(A::StaticArray) = A
# we need something heap-allocated to make sure BLAS calls are safe
@inline _get_raw_data(A::SArray) = MArray(A)

function mul_blas!(::TSize{<:Any,:any}, c::StaticMatrix,
        Sa::Union{TSize{<:Any,:any}, TSize{<:Any,:transpose}}, Sb::Union{TSize{<:Any,:any}, TSize{<:Any,:transpose}},
        a::StaticMatrix, b::StaticMatrix, _add::MulAddMul)
    mat_char(s) = istranspose(s) ? 'T' : 'N'
    T = eltype(a)
    A = _get_raw_data(a)
    B = _get_raw_data(b)
    C = _get_raw_data(c)
    BLAS.gemm!(mat_char(Sa), mat_char(Sb), T(alpha(_add)), A, B, T(beta(_add)), C)
end

# if C is transposed, transpose the entire expression
@inline mul_blas!(Sc::TSize{<:Any,:transpose}, c::StaticMatrix, Sa::TSize, Sb::TSize,
        a::StaticMatrix, b::StaticMatrix, _add::MulAddMul) =
    mul_blas!(transpose(Sc), c, transpose(Sb), transpose(Sa), b, a, _add)

using StaticArrays
using LinearAlgebra
using BenchmarkTools
using Test

macro test_noalloc(ex)
    esc(quote
        $ex
        @test(@allocated($ex) == 0)
    end)
end

mul_add_wrappers = [
    m -> m,
    m -> Symmetric(m, :U),
    m -> Symmetric(m, :L),
    m -> Hermitian(m, :U),
    m -> Hermitian(m, :L),
    m -> UpperTriangular(m),
    m -> LowerTriangular(m),
    m -> UnitUpperTriangular(m),
    m -> UnitLowerTriangular(m),
    m -> Adjoint(m),
    m -> Transpose(m),
    m -> Diagonal(m)]


# check_dims
@test StaticArrays.check_dims(Size(4,), Size(4,3), Size(3,))
@test !StaticArrays.check_dims(Size(4,), Size(4,3), Size(4,))
@test !StaticArrays.check_dims(Size(4,), Size(3,4), Size(4,))

@test StaticArrays.check_dims(Size(4,), Size(4,3), Size(3,1))
@test StaticArrays.check_dims(Size(4,1), Size(4,3), Size(3,))
@test StaticArrays.check_dims(Size(4,1), Size(4,3), Size(3,1))
@test !StaticArrays.check_dims(Size(4,2), Size(4,3), Size(3,))
@test !StaticArrays.check_dims(Size(4,), Size(4,3), Size(3,2))
@test StaticArrays.check_dims(Size(4,2), Size(4,3), Size(3,2))
@test !StaticArrays.check_dims(Size(4,2), Size(4,3), Size(3,3))

function test_multiply_add(N1,N2,ArrayType=MArray)
    if ArrayType <: MArray
        Mat = MMatrix
        Vec = MVector
    elseif ArrayType <: SizedArray
        Mat = SizedMatrix
        Vec = SizedVector
    end
    α,β = 2.0, 1.0

    A = rand(Mat{N1,N2})
    At = Transpose(A)
    b = rand(Vec{N2})
    c = rand(Vec{N1})

    # Parent
    if !(ArrayType <: SizedArray)
        @test parent(A) === A
    end
    @test parent(At) === A
    @test size(parent(At)) == (N1,N2)
    @test parent(b') === b
    @test size(parent(b')) == (N2,)

    # TSize
    ta = StaticArrays.TSize(A)
    @test !StaticArrays.istranspose(ta)
    @test size(ta) == (N1,N2)
    @test Size(ta) == Size(N1,N2)
    ta = StaticArrays.TSize(At)
    @test StaticArrays.istranspose(ta)
    @test size(ta) == (N2,N1)
    @test Size(ta) == Size(N2,N1)
    tb = StaticArrays.TSize(b')
    @test StaticArrays.access_type(tb) === :adjoint
    ta = transpose(ta)
    @test !StaticArrays.istranspose(ta)
    @test size(ta) == (N1,N2)
    @test Size(ta) == Size(N1,N2)

    # A*b
    mul!(c,A,b)
    @test c ≈ A*b
    mul!(c,A,b,1.0,0.0)
    @test c ≈ A*b
    mul!(c,A,b,1.0,1.0)
    @test c ≈ 2A*b

    # matrix-transpose × vector
    mul!(b,At,c)
    @test b ≈ A'c
    mul!(b,At,c,2.0,0.0)
    @test b ≈ 2A'c
    mul!(b,At,c,1.0,2.0)
    @test b ≈ 5A'c

    if !(ArrayType <: SizedArray)
        @test_noalloc mul!(c,A,b)
    else
        mul!(c,A,b)
        if VERSION < v"1.12"
            @test_broken(@allocated(mul!(c,A,b)) == 0)
        else
            @test (@allocated(mul!(c,A,b)) == 0)
        end
    end
    expected_transpose_allocs = 0
    bmark = @benchmark mul!($c,$A,$b,$α,$β) samples=10 evals=10
    @test minimum(bmark).allocs == 0
    # @test_noalloc mul!(c, A, b, α, β)  # records 32 bytes
    bmark = @benchmark mul!($b,Transpose($A),$c) samples=10 evals=10
    @test minimum(bmark).allocs <= expected_transpose_allocs
    # @test_noalloc mul!(b, Transpose(A), c)  # records 16 bytes
    bmark = @benchmark mul!($b,Transpose($A),$c,$α,$β) samples=10 evals=10
    @test minimum(bmark).allocs <= expected_transpose_allocs
    # @test_noalloc mul!(b, Transpose(A), c, α, β)  # records 48 bytes

    # outer product
    C = rand(Mat{N1,N2})
    a = rand(Vec{N1})
    b = rand(Vec{N2})
    mul!(C,a,b')
    @test C ≈ a*b'
    mul!(C,a,b',2.,0.)
    @test C ≈ 2a*b'
    mul!(C,a,b',1.,1.)
    @test C ≈ 3a*b'

    b = @benchmark mul!($C,$a,$(b')) samples=10 evals=10
    @test minimum(b).allocs <= expected_transpose_allocs
    # @test_noalloc mul!(C, a, b')  # records 16 bytes

    # A × B
    A = rand(Mat{N1,N2})
    B = rand(Mat{N2,N2})
    C = rand(Mat{N1,N2})
    mul!(C,A,B)
    @test C ≈ A*B
    mul!(C,A,B,2.0,0.0)
    @test C ≈ 2A*B
    mul!(C,A,B,2.0,1.0)
    @test C ≈ 4A*B

    b = @benchmark mul!($C,$A,$B,$α,$β) samples=10 evals=10
    @test minimum(b).allocs == 0
    # @test_noalloc mul!(C, A, B, α, β)  # records 32 bytes

    # A'B
    At = Transpose(A)
    mul!(B,At,C)
    @test B ≈ A'C
    mul!(B,At,C,2.0,0.0)
    @test B ≈ 2A'C
    mul!(B,At,C,2.0,1.0)
    @test B ≈ 4A'C

    b = @benchmark mul!($B,Transpose($A),$C,$α,$β) samples=10 evals=10
    @test minimum(b).allocs <= expected_transpose_allocs
    # @test_noalloc mul!(B, Transpose(A), C, α, β)  # records 48 bytes

    # A*B'
    Bt = Transpose(B)
    mul!(C,A,Bt)
    @test C ≈ A*B'
    mul!(C,A,Bt,2.0,0.0)
    @test C ≈ 2A*B'
    mul!(C,A,Bt,2.0,1.0)
    @test C ≈ 4A*B'

    b = @benchmark mul!($C,$A,Transpose($B),$α,$β) samples=10 evals=10
    @test minimum(b).allocs <= expected_transpose_allocs
    # @test_noalloc mul!(C, A, Transpose(B), α, β)  # records 48 bytes

    # A'B'
    B = rand(Mat{N1,N1})
    C = rand(Mat{N2,N1})
    mul!(C,Transpose(A),Transpose(B))
    @test C ≈ A'B'
    mul!(C,Transpose(A),Transpose(B),2.0,0.0)
    @test C ≈ 2A'B'
    mul!(C,Transpose(A),Transpose(B),2.0,1.0)
    @test C ≈ 4A'B'

    b = @benchmark mul!($C,Transpose($A),Transpose($B),$α,$β) samples=10 evals=10
    @test minimum(b).allocs <= 2*expected_transpose_allocs
    # @test_noalloc mul!(C, Transpose(A), Transpose(B), α, β)  # records 64 bytes

    # Transpose Output
    C = rand(Mat{N1,N2})
    mul!(Transpose(C),Transpose(A),Transpose(B))
    @test C' ≈ A'B'
    b = @benchmark mul!(Transpose($C),Transpose($A),Transpose($B),$α,$β) samples=10 evals=10
    @test minimum(b).allocs <= expected_transpose_allocs*3
    # @test_noalloc mul!(Transpose(C), Transpose(A), Transpose(B), α, β)  # records 80 bytes
end

# Test the three different
@testset "matrix multiply-add" begin
    test_multiply_add(3,4)
    test_multiply_add(5,6)
    test_multiply_add(15,16)
    test_multiply_add(3,4,SizedArray)
    test_multiply_add(5,6,SizedArray)
    test_multiply_add(15,16,SizedArray)
end

function test_wrappers_for_size(N, test_block)
    C = rand(MMatrix{N,N,Int})
    Cv = rand(MVector{N,Int})
    A = rand(SMatrix{N,N,Int})
    B = rand(SMatrix{N,N,Int})
    bv = rand(SVector{N,Int})
    # matrix-vector
    for wrapper in mul_add_wrappers
        mul!(Cv, wrapper(A), bv)
        @test Cv == wrapper(Array(A))*Array(bv)
    end

    # matrix-matrix
    for wrapper_c in [identity, Transpose], wrapper_a in mul_add_wrappers, wrapper_b in mul_add_wrappers
        mul!(wrapper_c(C), wrapper_a(A), wrapper_b(B))
        @test wrapper_c(C) == wrapper_a(Array(A))*wrapper_b(Array(B))
    end

    # block matrices
    if test_block

        C_block = rand(MMatrix{N,N,SMatrix{2,2,Int,4}})
        Cv_block = rand(MVector{N,SMatrix{2,2,Int,4}})
        A_block = rand(SMatrix{N,N,SMatrix{2,2,Int,4}})
        B_block = rand(SMatrix{N,N,SMatrix{2,2,Int,4}})
        bv_block = rand(SVector{N,SMatrix{2,2,Int,4}})
        
        # matrix-vector
        for wrapper in mul_add_wrappers
            # LinearAlgebra can't handle these
            if all(T -> !isa(wrapper([1 2; 3 4]), T), [Symmetric, Hermitian, Diagonal])
                mul!(Cv_block, wrapper(A_block), bv_block)
                @test Cv_block == wrapper(Array(A_block))*Array(bv_block)
            end
        end

        # matrix-matrix
        for wrapper_a in mul_add_wrappers, wrapper_b in mul_add_wrappers
            if all(T -> !isa(wrapper_a([1 2; 3 4]), T) && !isa(wrapper_b([1 2; 3 4]), T), [Symmetric, Hermitian, Diagonal])
                mul!(C_block, wrapper_a(A_block), wrapper_b(B_block))
                @test C_block == wrapper_a(Array(A_block))*wrapper_b(Array(B_block))
            end
        end
    end

end

@testset "Testing different wrappers" begin
    test_wrappers_for_size(2, true)
    test_wrappers_for_size(8, false)
    test_wrappers_for_size(16, false)
end

using StaticArrays, Test, LinearAlgebra

@testset "AbstractArray interface" begin
    @testset "size and length" begin
        m = @SMatrix [1 2 3; 4 5 6; 7 8 9; 10 11 12]

        @test length(m) == 12
        @test IndexStyle(m) == IndexLinear()
        @test Base.isassigned(m, 2, 2) == true
        @test eachindex(m) isa SOneTo
    end

    @testset "axes" begin
        v = @SVector [1, 2, 3]
        @test @inferred(axes(v)) == (SOneTo(3),)
        for T in (Adjoint, Transpose)
            @test @inferred(axes(T(v))) == (SOneTo(1), SOneTo(3))
        end

        m = @SMatrix [1 2; 3 4]
        @test @inferred(axes(m)) == (SOneTo(2), SOneTo(2))
        for T in (Adjoint, Transpose, Diagonal, Symmetric, Hermitian, UpperTriangular, LowerTriangular, UnitUpperTriangular, UnitLowerTriangular)
            @test @inferred(axes(T(m))) == (SOneTo(2), SOneTo(2))
        end
    end

    @testset "strides" begin
        m1 = MArray{Tuple{3, 4, 5}}(rand(Int, 3, 4, 5))
        m2 = SizedArray{Tuple{3,4,5}}(rand(Int, 3, 4, 5))
        @test strides(m1) === (1, 3, 12)
        @test strides(m2) === (1, 3, 12)
    end

    @testset "similar_type" begin
        @test @inferred(similar_type(SVector{3,Int})) == SVector{3,Int}
        @test @inferred(similar_type(@SVector [1,2,3])) == SVector{3,Int}

        @test @inferred(similar_type(SVector{3,Int}, Float64)) == SVector{3,Float64}
        @test @inferred(similar_type(SMatrix{3,3,Int,9}, Size(2))) == SVector{2, Int}
        @test @inferred(similar_type(SMatrix{3,3,Int,9}, Float64, Size(2))) == SVector{2, Float64}
        @test @inferred(similar_type(SMatrix{3,3,Int,9}, Float64, Size(2))) == SVector{2, Float64}

        @test @inferred(similar_type(SMatrix{3,3,Int,9}, Float64)) == SMatrix{3, 3, Float64, 9}
        @test @inferred(similar_type(SVector{2,Int}, Size(3,3))) == SMatrix{3, 3, Int, 9}
        @test @inferred(similar_type(SVector{2,Int}, Float64, Size(3,3))) == SMatrix{3, 3, Float64, 9}

        @test @inferred(similar_type(SArray{Tuple{4,4,4},Int,3,64}, Float64)) == SArray{Tuple{4,4,4}, Float64, 3, 64}
        @test @inferred(similar_type(SVector{2,Int}, Size(3,3,3))) == SArray{Tuple{3,3,3}, Int, 3, 27}
        @test @inferred(similar_type(SVector{2,Int}, Float64, Size(3,3,3))) == SArray{Tuple{3,3,3}, Float64, 3, 27}

        # Some specializations for the mutable case
        @test @inferred(similar_type(MVector{3,Int}, Float64)) == MVector{3,Float64}
        @test @inferred(similar_type(MMatrix{3,3,Int,9}, Size(2))) == MVector{2, Int}
        @test @inferred(similar_type(MMatrix{3,3,Int,9}, Float64, Size(2))) == MVector{2, Float64}
        @test @inferred(similar_type(MMatrix{3,3,Int,9}, Float64, Size(2))) == MVector{2, Float64}

        @test @inferred(similar_type(MMatrix{3,3,Int,9}, Float64)) == MMatrix{3, 3, Float64, 9}
        @test @inferred(similar_type(MVector{2,Int}, Size(3,3))) == MMatrix{3, 3, Int, 9}
        @test @inferred(similar_type(MVector{2,Int}, Float64, Size(3,3))) == MMatrix{3, 3, Float64, 9}

        @test @inferred(similar_type(MArray{Tuple{4,4,4},Int,3,64}, Float64)) == MArray{Tuple{4,4,4}, Float64, 3, 64}
        @test @inferred(similar_type(MVector{2,Int}, Size(3,3,3))) == MArray{Tuple{3,3,3}, Int, 3, 27}
        @test @inferred(similar_type(MVector{2,Int}, Float64, Size(3,3,3))) == MArray{Tuple{3,3,3}, Float64, 3, 27}

        # wrapped mutable cases (issue #828)
        for Wrapper in [Symmetric, Hermitian, Adjoint, Transpose, UpperTriangular, LowerTriangular, UnitUpperTriangular, UnitLowerTriangular]
            @test @inferred(similar_type(Wrapper{Int,MArray{Tuple{4,4},Int,2,16}}, Float64)) === MArray{Tuple{4,4}, Float64, 2, 16}
        end
        @test @inferred(similar_type(Diagonal{Int,MArray{Tuple{4},Int,1,4}}, Float64)) === MArray{Tuple{4,4}, Float64, 2, 16}
    end

    @testset "similar" begin
        sv = @SVector [1,2,3]
        sm = @SMatrix [1 2; 3 4]
        sa = SArray{Tuple{1,1,1},Int,3,1}((1,))
        sn = @SVector [1, missing]

        @test isa(@inferred(similar(sv)), MVector{3,Int})
        @test isa(@inferred(similar(sv, Float64)), MVector{3,Float64})
        @test isa(@inferred(similar(sv, Size(4))), MVector{4,Int})
        @test isa(@inferred(similar(sv, Float64, Size(4))), MVector{4,Float64})

        @test isa(@inferred(similar(sm)), MMatrix{2,2,Int,4})
        @test isa(@inferred(similar(sm, Float64)), MMatrix{2,2,Float64,4})
        @test isa(@inferred(similar(sv, Size(3,3))), MMatrix{3,3,Int,9})
        @test isa(@inferred(similar(sv, Float64, Size(3,3))), MMatrix{3,3,Float64,9})
        @test isa(@inferred(similar(sn)), SizedVector{2, Union{Missing, Int}})
        @test isa(@inferred(similar(sn, Float64, Size(3, 3))), MMatrix{3, 3, Float64, 9})

        @test isa(@inferred(similar(sa)), MArray{Tuple{1,1,1},Int,3,1})
        @test isa(@inferred(similar(SArray{Tuple{1,1,1},Int,3,1})), MArray{Tuple{1,1,1},Int,3,1})
        @test isa(@inferred(similar(sa, Float64)), MArray{Tuple{1,1,1},Float64,3,1})
        @test isa(@inferred(similar(SArray{Tuple{1,1,1},Int,3,1}, Float64)), MArray{Tuple{1,1,1},Float64,3,1})
        @test isa(@inferred(similar(sv, Size(3,3,3))), MArray{Tuple{3,3,3},Int,3,27})
        @test isa(@inferred(similar(sv, Float64, Size(3,3,3))), MArray{Tuple{3,3,3},Float64,3,27})

        @test isa(@inferred(similar(Diagonal{Int}, Size(2,2))), MArray{Tuple{2, 2}, Int, 2, 4})
        @test isa(@inferred(similar(SizedArray, Int, Size(2,2))), SizedArray{Tuple{2, 2}, Int, 2, 2})
        @test isa(@inferred(similar(Matrix{Int}, Int, Size(2,2))), SizedArray{Tuple{2, 2}, Int, 2, 2})

        @testset "disambiguate similar" begin
            struct CustomArray{T} <: AbstractVector{T}
                sz :: Int
            end

            Base.size(C::CustomArray) = (C.sz,)
            Base.getindex(C::CustomArray{T}, i::Int) where {T} = T(i)
            Base.similar(C::CustomArray, ::Type{T}, ax::Tuple{Vararg{Int}}) where {T} =
                Array{T}(undef, ax)
            function Base.similar(C::CustomArray, ::Type{T}, ax::Tuple{Vararg{Union{Int, SOneTo, Base.OneTo{Int}}}}) where {T}
                sz = last.(ax)
                Array{T}(undef, sz)
            end

            c = CustomArray{Int}(4)
            for (ax, sz) in (((SOneTo(2), Base.OneTo(3)), (2,3)),
                                ((2, SOneTo(2), Base.OneTo(3)), (2,2,3)))
                for A in (similar(c, Float64, ax), similar(c, Float64, ax...))
                    @test A isa Array{Float64, length(sz)}
                    @test size(A) == sz
                end
            end

            @test similar(c, ()) isa Array{Int,0}
            @test similar(c, Float64, ()) isa Array{Float64,0}

            @test size(similar(zeros(), (1,1,1,SOneTo(1)))) == (1,1,1,1)

            # ensure that the more specific Base method works
            @test similar(1:2, ()) isa AbstractArray{Int,0}
        end
    end

    @testset "similar and Base.Slice/IdentityUnitRange (issues #548, #556)" begin
        v = @SVector [1,2,3]
        m = @SMatrix [1 2 3; 4 5 6]
        @test similar(v, Int, SOneTo(3)) isa MVector{3,Int}
        @test similar(v, Int, SOneTo(3), SOneTo(4)) isa MMatrix{3,4,Int}
        @test similar(v, Int, 3, SOneTo(4)) isa Matrix
        @test similar(v, SOneTo(3)) isa MVector{3,Int}
        @test similar(v, SOneTo(3), SOneTo(4)) isa MMatrix{3,4,Int}
        @test similar(v, 3, SOneTo(4)) isa Matrix

        @test m[:, 1:2] isa Matrix
        @test m[:, [true, false, false]] isa Matrix
        @test m[:, SOneTo(2)] isa SMatrix{2, 2, Int}
        @test m[:, :] isa SMatrix{2, 3, Int}
        @test m[:, 1] isa SVector{2, Int}
        @test m[2, :] isa SVector{3, Int}

        # Test case that failed in AstroLib.jl
        r = @view(m[:, 2:3]) * @view(v[1:2])
        @test r == m[:, 2:3] * v[1:2] == Array(m)[:, 2:3] * Array(v)[1:2]
    end


    @testset "reshape" begin
        @test @inferred(reshape(SVector(1,2,3,4), axes(SMatrix{2,2}(1,2,3,4)))) === SMatrix{2,2}(1,2,3,4)
        @test @inferred(reshape(SVector(1,2,3,4), Size(2,2))) === SMatrix{2,2}(1,2,3,4)
        @test @inferred(reshape([1,2,3,4], Size(2,2)))::SizedArray{Tuple{2,2},Int,2,1} == [1 3; 2 4]
        @test @inferred(reshape([1,2,3,4], axes(SMatrix{2,2}(1,2,3,4))))::SizedArray{Tuple{2,2},Int,2,1} == [1 3; 2 4]
        @test @inferred(reshape([1 2 3 4], axes(SMatrix{2,2}(1,2,3,4))))::SizedArray{Tuple{2,2},Int,2,2} == [1 3; 2 4]
        @test_throws DimensionMismatch reshape([1 2; 3 4], Size(2,2,2))
        @test_throws DimensionMismatch reshape([1 2 3], axes(SMatrix{2,2}(1,2,3,4)))

        @test @inferred(vec(SMatrix{2, 2}([1 2; 3 4])))::SVector{4,Int} == [1, 3, 2, 4]
        a = @MVector [1, 2, 3, 4]
        @test @inferred(vec(a)) === a

        as = SizedVector(a)
        @test @inferred(vec(as)) === as

        # AbstractArray
        # CartesianIndex
        @test reshape(view(ones(4, 4), 1:4, 1:2), Size(4, 2)) == SMatrix{4,2}(ones(4, 2))
        # IndexLinear
        @test reshape(view(ones(4, 4), 1, 1:4), Size(4, 1)) == SMatrix{4,1}(ones(4, 1))
        @test_throws DimensionMismatch reshape(view(ones(4,4), 1:4, 1:2), Size(5, 2))

        # mutation
        m = @MMatrix [1 2; 3 4]
        mr = reshape(m, SOneTo(4))
        mr[2] = 10
        @test m == SA[1 2; 10 4]

        mrs = reshape(m, Size(4))
        mrs[2] = 10
        @test m == SA[1 2; 10 4]

        ms = SizedMatrix{2,2}([1 2; 3 4])
        msr = reshape(ms, SOneTo(4))
        msr[2] = 10
        @test ms == SA[1 2; 10 4]
    end

    @testset "copy" begin
        M = [1 2; 3 4]
        SM = SMatrix{2, 2}(M)
        MM = MMatrix{2, 2}(M)
        SizeM = SizedMatrix{2,2}(M)
        @test @inferred(copy(SM)) === @SMatrix [1 2; 3 4]
        @test @inferred(copy(MM))::MMatrix == M
        @test copy(SM).data !== M
        @test copy(SizeM).data !== M
    end

    @testset "reverse" begin
        @test @inferred(reverse(SVector(1, 2, 3))) ≡ SVector(3, 2, 1)
        m = MVector(1, 2, 3)
        @test @inferred(reverse(m))::typeof(m) == MVector(3, 2, 1)
    end

    @testset "rotate" begin
        M = [1 2; 3 4]
        SM = SMatrix{2, 2}(M)
        @test @inferred(rotl90(SM)) === @SMatrix [2 4; 1 3]
        @test @inferred(rot180(SM)) === @SMatrix [4 3; 2 1]
        @test @inferred(rotr90(SM)) === @SMatrix [3 1; 4 2]
        M23 = rand(2, 3)
        SM23 = SMatrix{2, 3}(M23)
        @test @inferred(rotl90(SM23)) == rotl90(M23)
        @test @inferred(rot180(SM23)) == rot180(M23)
        @test @inferred(rotr90(SM23)) == rotr90(M23)
    end

    @testset "Conversion to AbstractArray" begin
        # Issue #746
        # conversion to AbstractArray changes the eltype from Int to Float64
        sv = SVector(1,2)
        @test @inferred(convert(AbstractArray{Float64}, sv)) isa SVector{2,Float64}
        @test @inferred(convert(AbstractVector{Float64}, sv)) isa SVector{2,Float64}
        @test convert(AbstractArray{Float64}, sv) == sv
        @test convert(AbstractArray{Int}, sv) === sv
        sm = SMatrix{2,2}(1,2,3,4)
        @test @inferred(convert(AbstractArray{Float64,2}, sm)) isa SMatrix{2,2,Float64}
        @test convert(AbstractArray{Float64,2}, sm) == sm
        @test convert(AbstractArray{Int,2}, sm) === sm
        mv = MVector(1, 2, 3)
        @test @inferred(convert(AbstractArray{Float64}, mv)) isa MVector{3,Float64}
        @test @inferred(convert(AbstractVector{Float64}, mv)) isa MVector{3,Float64}
        @test convert(AbstractArray{Float64}, mv) == mv
        @test convert(AbstractArray{Int}, mv) === mv
        mm = MMatrix{2, 2}(1, 2, 3, 4)
        @test @inferred(convert(AbstractArray{Float64,2}, mm)) isa MMatrix{2,2,Float64}
        @test convert(AbstractArray{Float64,2}, mm) == mm
        @test convert(AbstractArray{Int,2}, mm) === mm

        # Test some of the types in StaticMatrixLike
        sym = Symmetric(SA[1 2; 2 3])
        @test @inferred(convert(AbstractArray{Float64}, sym)) isa Symmetric{Float64,SMatrix{2,2,Float64,4}}
        @test @inferred(convert(AbstractArray{Float64,2}, sym)) isa Symmetric{Float64,SMatrix{2,2,Float64,4}}
        @test convert(AbstractArray{Float64}, sym) == sym
        her = Hermitian(SA[1 2+im; 2-im 3])
        @test @inferred(convert(AbstractArray{ComplexF64}, her)) isa Hermitian{ComplexF64,SMatrix{2,2,ComplexF64,4}}
        @test convert(AbstractArray{ComplexF64}, her) == her
        diag = Diagonal(SVector(1,2))
        @test @inferred(convert(AbstractArray{Float64}, diag)) isa Diagonal{Float64,SVector{2,Float64}}
        @test convert(AbstractArray{Float64}, diag) == diag
        # The following cases currently convert the SMatrix into an MMatrix, because
        # the constructor in Base invokes `similar`, rather than `convert`, on the static
        # array. This was fixed in https://github.com/JuliaLang/julia/pull/40831; so should
        # work from Julia v1.8.0-DEV.55
        trans = Transpose(SVector(1,2))
        @test_was_once_broken v"1.8.0-DEV.55" @inferred(convert(AbstractArray{Float64}, trans)) isa Transpose{Float64,SVector{2,Float64}}
        adj = Adjoint(SVector(1,2))
        @test_was_once_broken v"1.8.0-DEV.55" @inferred(convert(AbstractArray{Float64}, adj)) isa Adjoint{Float64,SVector{2,Float64}}
        uptri = UpperTriangular(SA[1 2; 0 3])
        @test_was_once_broken v"1.8.0-DEV.55" @inferred(convert(AbstractArray{Float64}, uptri)) isa UpperTriangular{Float64,SMatrix{2,2,Float64,4}}
        lotri = LowerTriangular(SA[1 0; 2 3])
        @test_was_once_broken v"1.8.0-DEV.55" @inferred(convert(AbstractArray{Float64}, lotri)) isa LowerTriangular{Float64,SMatrix{2,2,Float64,4}}
        unituptri = UnitUpperTriangular(SA[1 2; 0 1])
        @test_was_once_broken v"1.8.0-DEV.55" @inferred(convert(AbstractArray{Float64}, unituptri)) isa UnitUpperTriangular{Float64,SMatrix{2,2,Float64,4}}
        unitlotri = UnitLowerTriangular(SA[1 0; 2 1])
        @test_was_once_broken v"1.8.0-DEV.55" @inferred(convert(AbstractArray{Float64}, unitlotri)) isa UnitLowerTriangular{Float64,SMatrix{2,2,Float64,4}}
    end

    @testset "type inference in length" begin
        s1 = SA[1,2];
        s2 = SA[1,2,3];
        v = [s1, s2];
        f(v, i) = length(v[i]);
        for i in 1:2
            @test (@inferred f(v, i)) == length(v[i])
        end
    end

    @testset "reduced_indices" begin
        s = SArray{Tuple{2,2,2},Int,3,8}((1,2,3,4,5,6,7,8))
        a = Array(s)
        for i in 1:ndims(s)
            rs = @inferred Base.reduced_indices(axes(s), i)
            @test rs == Base.reduced_indices(axes(a), i)
        end
    end
end

@testset "permutedims" begin
    # vector -> one-row matrix
    @test @inferred(permutedims(SVector(1,2,3))) === SMatrix{1,3}(1,2,3)
    @test @inferred(permutedims(MVector(1,2,3))) isa MMatrix{1,3}
    @test @inferred(permutedims(MVector(1,2,3))) == [1 2 3]
    @test @inferred(permutedims(SizedVector{3}([1,2,3]))) isa SizedMatrix{1,3}
    @test @inferred(permutedims(SizedVector{3}([1,2,3]))) == [1 2 3]

    # matrix
    @test @inferred(permutedims(SMatrix{2,2}(1,2,3,4))) === SMatrix{2,2}(1,3,2,4)
    A = rand(2,3)
    @test @inferred(permutedims(SMatrix{2,3}(A))) === SMatrix{3,2}(A')
    @test @inferred(permutedims(MMatrix{2,3}(A))) isa MMatrix{3,2}
    @test @inferred(permutedims(MMatrix{2,3}(A))) == A'
    @test @inferred(permutedims(SizedMatrix{2,3}(A))) isa SizedMatrix{3,2}
    @test @inferred(permutedims(SizedMatrix{2,3}(A))) == A'
end

@testset "vcat() and hcat()" begin
    @test @inferred(vcat(SVector(1,2,3))) === SVector(1,2,3)
    @test @inferred(hcat(SVector(1,2,3))) === SMatrix{3,1}(1,2,3)
    @test @inferred(hcat(SMatrix{3,1}(1,2,3))) === SMatrix{3,1}(1,2,3)

    @test @inferred(vcat(SVector(1,2,3), SVector(4,5,6))) === SVector(1,2,3,4,5,6)
    @test @inferred(hcat(SVector(1,2,3), SVector(4,5,6))) === @SMatrix [1 4; 2 5; 3 6]
    @test_throws DimensionMismatch vcat(SVector(1,2,3), @SMatrix [1 4; 2 5])
    @test_throws DimensionMismatch hcat(SVector(1,2,3), SVector(4,5))

    @test @inferred(vcat(@SMatrix([1;2;3]), SVector(4,5,6))) === @SMatrix([1;2;3;4;5;6])
    @test @inferred(vcat(SVector(1,2,3), @SMatrix([4;5;6]))) === @SMatrix([1;2;3;4;5;6])
    @test @inferred(hcat(@SMatrix([1;2;3]), SVector(4,5,6))) === @SMatrix [1 4; 2 5; 3 6]
    @test @inferred(hcat(SVector(1,2,3), @SMatrix([4;5;6]))) === @SMatrix [1 4; 2 5; 3 6]

    @test @inferred(vcat(@SMatrix([1;2;3]), @SMatrix([4;5;6]))) === @SMatrix([1;2;3;4;5;6])
    @test @inferred(hcat(@SMatrix([1;2;3]), @SMatrix([4;5;6]))) === @SMatrix [1 4; 2 5; 3 6]

    @test @inferred(vcat(SVector(1),SVector(2),SVector(3),SVector(4))) === SVector(1,2,3,4)
    @test @inferred(hcat(SVector(1),SVector(2),SVector(3),SVector(4))) === SMatrix{1,4}(1,2,3,4)

    vcat(SVector(1.0f0), SVector(1.0)) === SVector(1.0, 1.0)
    hcat(SVector(1.0f0), SVector(1.0)) === SMatrix{1,2}(1.0, 1.0)

    # issue #388
    if VERSION < v"1.12"
        # these tests fail on CI but work locally with Julia 1.12.3
        let x = SVector(1, 2, 3)
            # current limit: 34 arguments
            hcat(
                x, x, x, x, x, x, x, x, x, x, x, x, x, x, x, x, x,
                x, x, x, x, x, x, x, x, x, x, x, x, x, x, x, x, x)
            allocs = @allocated hcat(
                x, x, x, x, x, x, x, x, x, x, x, x, x, x, x, x, x,
                x, x, x, x, x, x, x, x, x, x, x, x, x, x, x, x, x)
            
            @test allocs == 0
            vcat(
                x, x, x, x, x, x, x, x, x, x, x, x, x, x, x, x, x,
                x, x, x, x, x, x, x, x, x, x, x, x, x, x, x, x, x)
            allocs = @allocated vcat(
                x, x, x, x, x, x, x, x, x, x, x, x, x, x, x, x, x,
                x, x, x, x, x, x, x, x, x, x, x, x, x, x, x, x, x)
            @test allocs == 0
        end
    end

    # issue #561
    let A = Diagonal(SVector(1, 2)), B = @SMatrix [3 4; 5 6]
        @test @inferred(hcat(A, B)) === SMatrix{2, 4}([Matrix(A) Matrix(B)])
    end

    let A = Transpose(@SMatrix [1 2; 3 4]), B = Adjoint(@SMatrix [5 6; 7 8])
        @test @inferred(hcat(A, B)) === SMatrix{2, 4}([Matrix(A) Matrix(B)])
    end

    let A = Diagonal(SVector(1, 2)), B = @SMatrix [3 4; 5 6]
        @test @inferred(vcat(A, B)) === SMatrix{4, 2}([Matrix(A); Matrix(B)])
    end

    let A = Transpose(@SMatrix [1 2; 3 4]), B = Adjoint(@SMatrix [5 6; 7 8])
        @test @inferred(vcat(A, B)) === SMatrix{4, 2}([Matrix(A); Matrix(B)])
    end

    # hcat/vcat + mixtures of Number and SVector / SMatrix
    @test @inferred(vcat(SA[1,2,3], 4, 5, 6)) === SVector{6}((1,2,3,4,5,6))
    @test @inferred(vcat(0, SA[1,2,3])) === SVector{4}((0,1,2,3))
    @test @inferred(hcat(SMatrix{1,3}((1,2,3)), 4, 5, 6)) === SMatrix{1,6}((1,2,3,4,5,6))
    @test @inferred(hcat(0, SMatrix{1,3}((1,2,3)))) === SMatrix{1,4}((0,1,2,3))
    @test @inferred(vcat(MVector((1,2,3)), 4, 5, 6))::MVector == [1,2,3,4,5,6]

    @test @inferred(vcat(SA[1,2,3])) === SA[1,2,3]
    @test @inferred(vcat(SA[1 2 3])) === SA[1 2 3]
    @test @inferred(hcat(SA[1,2,3])) === SMatrix{3,1}(1,2,3)
    @test @inferred(hcat(SA[1 2 3])) === SA[1 2 3]
end

@testset "Base.rest" begin
    x = SA[1, 2, 3]
    @test Base.rest(x) == x
    a, b... = x
    @test b == SA[2, 3]

    x = SA[1 2; 3 4]
    @test Base.rest(x) == vec(x)
    a, b... = x
    @test b == SA[3, 2, 4]

    a, b... = SA[1]
    @test b == []
    @test b isa SVector{0}

    for (Vec, Mat) in [(MVector, MMatrix), (SizedVector, SizedMatrix)]
        x = Vec(1, 2, 3)
        @test Base.rest(x) == x
        @test pointer(Base.rest(x)) != pointer(x)
        a, b... = x
        @test b == Vec(2, 3)

        x = Mat{2,2}(1, 2, 3, 4)
        @test Base.rest(x) == vec(x)
        @test pointer(Base.rest(x)) != pointer(x)
        a, b... = x
        @test b == Vec(2, 3, 4)

        a, b... = Vec(1)
        @test b == []
        @test b isa Vec{0}
    end
end

@testset "zeros/ones/fill" begin
    for ax in ((SOneTo(2),), (SOneTo(2),SOneTo(3)))
        @test @inferred(fill(:abc, ax...)) === @inferred(fill(:abc, ax))
        @test fill(:abc, ax) == fill(:abc, length.(ax)) == fill(:abc, Base.OneTo.(length.(ax)))
        for fz in (zeros, ones)
            @test @inferred(fz(Float32, ax...)) === @inferred(fz(Float32, ax))
            @test fz(Float32, ax) == fz(Float32, length.(ax)) == fz(Float32, Base.OneTo.(length.(ax)))
        end
    end
end

@inline function det(A::StaticMatrix)
    T = eltype(A)
    S = arithmetic_closure(T)
    A_S = convert(similar_type(A,S),A)
    _det(Size(A_S),A_S)
end

@inline _det(::Size{(1,1)}, A::StaticMatrix) = @inbounds return A[1]

@inline function _det(::Size{(2,2)}, A::StaticMatrix)
    @inbounds return A[1]*A[4] - A[3]*A[2]
end

@inline function _det(::Size{(3,3)}, A::StaticMatrix)
    @inbounds x0 = SVector(A[1], A[2], A[3])
    @inbounds x1 = SVector(A[4], A[5], A[6])
    @inbounds x2 = SVector(A[7], A[8], A[9])
    return bilinear_vecdot(x0, cross(x1, x2))
end

@inline function _prod2x2minors(A, a,b,c,d)
     @inbounds return (A[a]*A[b+4] - A[b]*A[a+4])*(A[c+8]*A[d+12] - A[c+12]*A[d+8])
end

@inline function _det(::Size{(4,4)}, A::StaticMatrix)
    @inbounds return (_prod2x2minors(A,1,2,3,4) - _prod2x2minors(A,1,3,2,4) + _prod2x2minors(A,1,4,2,3) 
                     +_prod2x2minors(A,2,3,1,4) - _prod2x2minors(A,2,4,1,3) + _prod2x2minors(A,3,4,1,2))
end


@inline function _parity(p)    # inefficient compared to computing cycle lengths, but non-allocating
    s = 0
    for i in 1:length(p), j in i+1:length(p)
        s += p[i] > p[j]
    end
    -2*rem(s, 2) + 1
end

det(F::LU) = det(F.U) * _parity(F.p)

function logabsdet(A::Union{LowerTriangular{<:Any,<:StaticMatrix},
                            UpperTriangular{<:Any,<:StaticMatrix}})
    checksquare(A)
    mapreduce(x -> (log(abs(x)), sign(x)), ((l1, s1), (l2, s2)) -> (l1 + l2, s1 * s2),
              diag(A))
end

function logdet(F::LU)
    d, s = logabsdet(F.U)
    d + log(s * _parity(F.p))
end

function logabsdet(F::LU)
    d, s = logabsdet(F.U)
    d, s * _parity(F.p)
end

@generated function _det(::Size{S}, A::StaticMatrix) where S
    checksquare(A)
    if prod(S) ≤ 14*14
        quote
            @_inline_meta
            det(lu(A, Val(true); check = false))
        end
    else
        :(@_inline_meta; det(Matrix(A)))
    end
end

@inline logdet(A::StaticMatrix) = _logdet(Size(A), A)
@inline _logdet(::Union{Size{(1,1)}, Size{(2,2)}, Size{(3,3)}, Size{(4,4)}}, A::StaticMatrix) = log(det(A))
@generated function _logdet(::Size{S}, A::StaticMatrix) where S
    checksquare(A)
    if prod(S) ≤ 14*14
        quote
            @_inline_meta
            logdet(lu(A, Val(true); check = false))
        end
    else
        :(@_inline_meta; logdet(drop_sdims(A)))
    end
end

@inline logabsdet(A::StaticMatrix) = _logabsdet(Size(A), A)
@generated function _logabsdet(::Size{S}, A::StaticMatrix) where S
    checksquare(A)
    if prod(S) ≤ 14*14
        quote
            @_inline_meta
            logabsdet(lu(A, Val(true); check = false))
        end
    else
        :(@_inline_meta; logabsdet(drop_sdims(A)))
    end
end

# Some more advanced constructor-like functions
@inline one(::Type{SMatrix{N}}) where {N} = one(SMatrix{N,N})

#####################
## SMatrix methods ##
#####################

function check_matrix_size(x::Tuple, T = :S)
    if length(x) > 2
        all(isone, x[3:end]) || error("Bad input for @$(T)Matrix, must be matrix like.")
    end
    x1 = length(x) >= 1 ? x[1] : 1
    x2 = length(x) >= 2 ? x[2] : 1
    x1, x2
end

# @SMatrix rand(...)
@inline _rand_with_Val(::Type{SM}, rng::AbstractRNG, ::Val{n1}, ::Val{n2}) where {SM, n1, n2} = rand(rng, SM{n1, n2})
@inline _rand_with_Val(::Type{SM}, T::DataType,      ::Val{n1}, ::Val{n2}) where {SM, n1, n2} = _rand(Random.GLOBAL_RNG, T, Size(n1, n2), SM{n1, n2, T})
@inline _rand_with_Val(::Type{SM}, sampler,          ::Val{n1}, ::Val{n2}) where {SM, n1, n2} = _rand(Random.GLOBAL_RNG, sampler, Size(n1, n2), SM{n1, n2, Random.gentype(sampler)})
@inline _rand_with_Val(::Type{SM}, rng::AbstractRNG, T::DataType, ::Val{n1}, ::Val{n2}) where {SM, n1, n2} = rand(rng, SM{n1, n2, T})
@inline _rand_with_Val(::Type{SM}, rng::AbstractRNG, sampler,     ::Val{n1}, ::Val{n2}) where {SM, n1, n2} = _rand(rng, sampler, Size(n1, n2), SM{n1, n2, Random.gentype(sampler)})
# @SMatrix randn(...)
@inline _randn_with_Val(::Type{SM}, rng::AbstractRNG, ::Val{n1}, ::Val{n2}) where {SM, n1, n2} = randn(rng, SM{n1, n2})
@inline _randn_with_Val(::Type{SM}, T::DataType,      ::Val{n1}, ::Val{n2}) where {SM, n1, n2} = _randn(Random.GLOBAL_RNG, Size(n1, n2), SM{n1, n2, T})
@inline _randn_with_Val(::Type{SM}, rng::AbstractRNG, T::DataType, ::Val{n1}, ::Val{n2}) where {SM, n1, n2} = randn(rng, SM{n1, n2, T})
# @SMatrix randexp(...)
@inline _randexp_with_Val(::Type{SM}, rng::AbstractRNG, ::Val{n1}, ::Val{n2}) where {SM, n1, n2} = randexp(rng, SM{n1, n2})
@inline _randexp_with_Val(::Type{SM}, T::DataType,      ::Val{n1}, ::Val{n2}) where {SM, n1, n2} = _randexp(Random.GLOBAL_RNG, Size(n1, n2), SM{n1, n2, T})
@inline _randexp_with_Val(::Type{SM}, rng::AbstractRNG, T::DataType, ::Val{n1}, ::Val{n2}) where {SM, n1, n2} = randexp(rng, SM{n1, n2, T})

function static_matrix_gen(::Type{SM}, @nospecialize(ex), mod::Module) where {SM}
    if !isa(ex, Expr)
        error("Bad input for @$SM")
    end
    head = ex.head
    if head === :vect && length(ex.args) == 1 # 1 x 1
        return :($SM{1,1}($tuple($(esc(ex.args[1])))))
    elseif head === :ref && length(ex.args) == 2 # typed, 1 x 1
        return :($SM{1,1,$(esc(ex.args[1]))}($tuple($(esc(ex.args[2])))))
    elseif head === :typed_vcat || head === :typed_hcat || head === :typed_ncat # typed, cat
        args = parse_cat_ast(ex)
        sz1, sz2 = check_matrix_size(size(args))
        return :($SM{$sz1,$sz2,$(esc(ex.args[1]))}($tuple($(escall(args)...))))
    elseif head === :vcat || head === :hcat || head === :ncat # untyped, cat
        args = parse_cat_ast(ex)
        sz1, sz2 = check_matrix_size(size(args))
        return :($SM{$sz1,$sz2}($tuple($(escall(args)...))))
    elseif head === :comprehension
        if length(ex.args) != 1 || !isa(ex.args[1], Expr) || (ex.args[1]::Expr).head != :generator
            error("Expected generator in comprehension, e.g. [f(i,j) for i = 1:3, j = 1:3]")
        end
        ex = ex.args[1]
        if length(ex.args) != 3
            error("Use a 2-dimensional comprehension for @$SM")
        end
        rng1 = Core.eval(mod, ex.args[2].args[2])
        rng2 = Core.eval(mod, ex.args[3].args[2])
        exprs = (:(f($j1, $j2)) for j1 in rng1, j2 in rng2)
        return quote
            let
                f($(esc(ex.args[2].args[1])), $(esc(ex.args[3].args[1]))) = $(esc(ex.args[1]))
                $SM{$(length(rng1)),$(length(rng2))}($tuple($(exprs...)))
            end
        end
    elseif head === :typed_comprehension
        if length(ex.args) != 2 || !isa(ex.args[2], Expr) || (ex.args[2]::Expr).head != :generator
            error("Expected generator in typed comprehension, e.g. Float64[f(i,j) for i = 1:3, j = 1:3]")
        end
        T = esc(ex.args[1])
        ex = ex.args[2]
        if length(ex.args) != 3
            error("Use a 2-dimensional comprehension for @$SM")
        end
        rng1 = Core.eval(mod, ex.args[2].args[2])
        rng2 = Core.eval(mod, ex.args[3].args[2])
        exprs = (:(f($j1, $j2)) for j1 in rng1, j2 in rng2)
        return quote
            let 
                f($(esc(ex.args[2].args[1])), $(esc(ex.args[3].args[1]))) = $(esc(ex.args[1]))
                $SM{$(length(rng1)),$(length(rng2)),$T}($tuple($(exprs...)))
            end
        end
    elseif head === :call
        f = ex.args[1]
        fargs = ex.args[2:end]
        if f === :zeros || f === :ones
            if length(fargs) == 2
                # for calls like `zeros(dim1, dim2)`
                return :($f($SM{$(escall(fargs)...)}))
            elseif length(fargs[2:end]) == 2
                # for calls like `zeros(type, dim1, dim2)`
                return :($f($SM{$(escall(fargs[2:end])...), $(esc(fargs[1]))}))
            else
                error("@$SM got bad expression: $(ex)")
            end
        elseif f === :fill
            # for calls like `fill(value, dim1, dim2)`
            if length(fargs[2:end]) == 2
                return :($f($(esc(fargs[1])), $SM{$(escall(fargs[2:end])...)}))
            else
                error("@$SM expected a 2-dimensional array expression")
            end
        elseif f === :rand || f === :randn || f === :randexp
            _f_with_Val = Symbol(:_, f, :_with_Val)
            if length(fargs) == 2
                # for calls like `rand(dim1, dim2)`
                # for calls like `randn(dim1, dim2)`
                # for calls like `randexp(dim1, dim2)`
                return :($f($SM{$(escall(fargs)...)}))
            elseif length(fargs) == 3
                # for calls like `rand(rng, dim1, dim2)`
                # for calls like `rand(type, dim1, dim2)`
                # for calls like `rand(sampler, dim1, dim2)`
                # for calls like `randn(rng, dim1, dim2)`
                # for calls like `randn(type, dim1, dim2)`
                # for calls like `randexp(rng, dim1, dim2)`
                # for calls like `randexp(type, dim1, dim2)`
                return :($_f_with_Val($SM, $(esc(fargs[1])), Val($(esc(fargs[2]))), Val($(esc(fargs[3])))))
            elseif length(fargs) == 4
                # for calls like `rand(rng, type, dim1, dim2)`
                # for calls like `rand(rng, sampler, dim1, dim2)`
                # for calls like `randn(rng, type, dim1, dim2)`
                # for calls like `randexp(rng, type, dim1, dim2)`
                return :($_f_with_Val($SM, $(esc(fargs[1])), $(esc(fargs[2])), Val($(esc(fargs[3]))), Val($(esc(fargs[4])))))
            else
                error("@$SM got bad expression: $(ex)")
            end
        else
            error("@$SM only supports the zeros(), ones(), fill(), rand(), randn(), and randexp() functions.")
        end
    else
        error("Bad input for @$SM")
    end
end


"""
    @SMatrix [a b c d]
    @SMatrix [[a, b];[c, d]]
    @SMatrix [i+j for i in 1:2, j in 1:2]
    @SMatrix ones(2, 2)

A convenience macro to construct `SMatrix`.
See [`@SArray`](@ref) for detailed features.
"""
macro SMatrix(ex)
    static_matrix_gen(SMatrix, ex, __module__)
end

# define our own LU type, since LinearAlgebra.LU requires p::Vector
struct LU{L,U,p}
    L::L
    U::U
    p::p
end

# iteration for destructuring into components
Base.iterate(S::LU) = (S.L, Val(:U))
Base.iterate(S::LU, ::Val{:U}) = (S.U, Val(:p))
Base.iterate(S::LU, ::Val{:p}) = (S.p, Val(:done))
Base.iterate(S::LU, ::Val{:done}) = nothing

@inline function Base.getproperty(F::LU, s::Symbol)
    if s === :P
        U = getfield(F, :U)
        p = getfield(F, :p)
        one(similar_type(p, Size(U)))[:,invperm(p)]
    else
        getfield(F, s)
    end
end

function Base.show(io::IO, mime::MIME{Symbol("text/plain")}, F::LU)
    println(io, LU) # Don't show full type - this will be in the factors
    println(io, "L factor:")
    show(io, mime, F.L)
    println(io, "\nU factor:")
    show(io, mime, F.U)
end

const StaticLUMatrix{N,M,T} = Union{StaticMatrix{N,M,T}, Symmetric{T,<:StaticMatrix{N,M,T}}, Hermitian{T,<:StaticMatrix{N,M,T}}}

# LU decomposition
pivot_options = if isdefined(LinearAlgebra, :PivotingStrategy) # introduced in Julia v1.7
    (:(Val{true}), :(Val{false}), :NoPivot, :RowMaximum)
else
    (:(Val{true}), :(Val{false}))
end
for pv in pivot_options
    # ... define each `pivot::Val{true/false}` method individually to avoid ambiguities
    @eval function lu(A::StaticLUMatrix, pivot::$pv; check = true)
        L, U, p = _lu(A, pivot, check)
        LU(L, U, p)
    end

    # For the square version, return explicit lower and upper triangular matrices.
    # We would do this for the rectangular case too, but Base doesn't support that.
    @eval function lu(A::StaticLUMatrix{N,N}, pivot::$pv; check = true) where {N}
        L, U, p = _lu(A, pivot, check)
        LU(LowerTriangular(L), UpperTriangular(U), p)
    end
end
lu(A::StaticLUMatrix; check = true) = lu(A, Val(true); check=check)

# location of the first zero on the diagonal, 0 when not found
function _first_zero_on_diagonal(A::StaticLUMatrix{M,N,T}) where {M,N,T}
    if @generated
        quote
            $(map(i -> :(A[$i, $i] == zero(T) && return $i), 1:min(M, N))...)
            0
        end
    else
        for i in 1:min(M, N)
            A[i, i] == 0 && return i
        end
        0
    end
end

issuccess(F::LU) = _first_zero_on_diagonal(F.U) == 0

@generated function _lu(A::StaticLUMatrix{M,N,T}, pivot, check) where {M,N,T}
    if M*N ≤ 14*14
        _pivot = if isdefined(LinearAlgebra, :PivotingStrategy) # v1.7 feature
            pivot === RowMaximum ? Val(true) : pivot === NoPivot ? Val(false) : pivot()
        else
            pivot()
        end
        quote
            L, U, P = __lu(A, $(_pivot))
            if check
                i = _first_zero_on_diagonal(U)
                i == 0 || throw(SingularException(i))
            end
            L, U, P
        end
    else
        _pivot = if isdefined(LinearAlgebra, :PivotingStrategy) # v1.7 feature
            pivot === Val{true} ? RowMaximum() : pivot === Val{false} ? NoPivot() : pivot()
        else
            pivot()
        end
        quote
            # call through to Base to avoid excessive time spent on type inference for large matrices
            f = lu(Matrix(A), $(_pivot); check = check)
            # Trick to get the output eltype - can't rely on the result of f.L as
            # it's not type inferable.
            T2 = arithmetic_closure(T)
            L = similar_type(A, T2, Size($M, $(min(M,N))))(f.L)
            U = similar_type(A, T2, Size($(min(M,N)), $N))(f.U)
            p = similar_type(A, Int, Size($M))(f.p)
            L, U, p
        end
    end
end

__lu(A::StaticMatrix{0,0,T}, ::Val{Pivot}) where {T,Pivot} =
    (SMatrix{0,0,typeof(one(T))}(), A, SVector{0,Int}())

__lu(A::StaticMatrix{0,1,T}, ::Val{Pivot}) where {T,Pivot} =
    (SMatrix{0,0,typeof(one(T))}(), A, SVector{0,Int}())

__lu(A::StaticMatrix{0,N,T}, ::Val{Pivot}) where {T,N,Pivot} =
    (SMatrix{0,0,typeof(one(T))}(), A, SVector{0,Int}())

__lu(A::StaticMatrix{1,0,T}, ::Val{Pivot}) where {T,Pivot} =
    (SMatrix{1,0,typeof(one(T))}(), SMatrix{0,0,T}(), SVector{1,Int}(1))

__lu(A::StaticMatrix{M,0,T}, ::Val{Pivot}) where {T,M,Pivot} =
    (SMatrix{M,0,typeof(one(T))}(), SMatrix{0,0,T}(), SVector{M,Int}(1:M))

__lu(A::StaticMatrix{1,1,T}, ::Val{Pivot}) where {T,Pivot} =
    (SMatrix{1,1}(one(T)), A, SVector(1))

__lu(A::LinearAlgebra.HermOrSym{T,<:StaticMatrix{1,1,T}}, ::Val{Pivot}) where {T,Pivot} =
    (SMatrix{1,1}(one(T)), A.data, SVector(1))

__lu(A::StaticMatrix{1,N,T}, ::Val{Pivot}) where {N,T,Pivot} =
    (SMatrix{1,1,T}(one(T)), A, SVector{1,Int}(1))

function __lu(A::StaticMatrix{M,1}, ::Val{Pivot}) where {M,Pivot}
    @inbounds begin
        kp = 1
        if Pivot
            amax = abs(A[1,1])
            for i = 2:M
                absi = abs(A[i,1])
                if absi > amax
                    kp = i
                    amax = absi
                end
            end
        end
        ps = tailindices(Val{M})
        if kp != 1
            ps = setindex(ps, 1, kp-1)
        end
        U = SMatrix{1,1}(A[kp,1])
        # Scale first column
        Akkinv = inv(A[kp,1])
        Ls = A[ps,1] * Akkinv
        if !isfinite(Akkinv)
            Ls = zeros(typeof(Ls))
        end
        L = [SVector{1}(one(eltype(Ls))); Ls]
        p = [SVector{1,Int}(kp); ps]
    end
    return (SMatrix{M,1}(L), U, p)
end

function __lu(A::StaticLUMatrix{M,N,T}, ::Val{Pivot}) where {M,N,T,Pivot}
    @inbounds begin
        kp = 1
        if Pivot
            amax = abs(A[1,1])
            for i = 2:M
                absi = abs(A[i,1])
                if absi > amax
                    kp = i
                    amax = absi
                end
            end
        end
        ps = tailindices(Val{M})
        if kp != 1
            ps = setindex(ps, 1, kp-1)
        end
        Ufirst = SMatrix{1,N}(A[kp,:])
        # Scale first column
        Akkinv = inv(A[kp,1])
        Ls = A[ps,1] * Akkinv
        if !isfinite(Akkinv)
            Ls = zeros(typeof(Ls))
        end

        # Update the rest
        Arest = A[ps,tailindices(Val{N})] - Ls*Ufirst[:,tailindices(Val{N})]
        Lrest, Urest, prest = __lu(Arest, Val(Pivot))
        p = [SVector{1,Int}(kp); ps[prest]]
        L = [[SVector{1}(one(eltype(Ls))); Ls[prest]] [zeros(typeof(SMatrix{1}(Lrest[1,:]))); Lrest]]
        U = [Ufirst; [zeros(typeof(Urest[:,1])) Urest]]
    end
    return (L, U, p)
end

# Create SVector(2,3,...,M)
# Note that
#     tailindices(::Type{Val{M}}) where {M} = SVector(Base.tail(ntuple(identity, Val{M})))
# works, too, but is only inferable for M ≤ 14 (at least up to Julia 0.7.0-DEV.4021)
@generated function tailindices(::Type{Val{M}}) where {M}
    :(SVector{$(M-1),Int}($(tuple(2:M...))))
end

\(F::LU, v::AbstractVector) = F.U \ (F.L \ v[F.p])
\(F::LU, B::AbstractMatrix) = F.U \ (F.L \ B[F.p,:])

/(B::AbstractMatrix, F::LU) = @inbounds ((B/F.U)/F.L)[:,invperm(F.p)]

using StaticArrays, Test, Random, LinearAlgebra
using InteractiveUtils
using Aqua

# We generate a lot of matrices using rand(), but unit tests should be
# deterministic. Therefore seed the RNG here (and further down, to avoid test
# file order dependence)
Random.seed!(42)
# Useful function to regenerate rng
_rng() = Random.MersenneTwister(42)
include("testutil.jl")

# Hook into Pkg.test so that tests from a single file can be run.  For example,
# to run only the MVector and SVector tests, use:
#
#   Pkg.test("StaticArrays", test_args=["MVector", "SVector"])
#
enabled_tests = lowercase.(ARGS)
function addtests(fname)
    key = lowercase(splitext(fname)[1])
    if isempty(enabled_tests) || key in enabled_tests
        Random.seed!(42)
        include(fname)
    end
end

TEST_GROUP = get(ENV, "STATICARRAYS_TEST_GROUP", "all")

if TEST_GROUP ∈ ["group-A", "group-B"]
    println("Using test group: ", TEST_GROUP)
end

if TEST_GROUP ∈ ["", "all", "group-A"]
    addtests("SVector.jl")
    addtests("MVector.jl")
    addtests("SMatrix.jl")
    addtests("MMatrix.jl")
    addtests("SArray.jl")
    addtests("MArray.jl")
    addtests("FieldVector.jl")
    addtests("FieldMatrix.jl")
    addtests("Scalar.jl")
    addtests("SUnitRange.jl")
    addtests("SizedArray.jl")
    addtests("SDiagonal.jl")
    addtests("SHermitianCompact.jl")
    if VERSION >= v"1.8.0-beta1"
        addtests("empty_array_syntax.jl")
    end

    addtests("aqua.jl")
    addtests("custom_types.jl")
    addtests("convert.jl")
    addtests("core.jl")
    addtests("abstractarray.jl")
    addtests("indexing.jl")
    addtests("initializers.jl")
    addtests("mapreduce.jl")
    addtests("sort.jl")
    addtests("accumulate.jl")
    addtests("arraymath.jl")
    addtests("broadcast.jl")
    addtests("linalg.jl")
    addtests("matrix_multiply.jl")
    addtests("matrix_multiply_add.jl")
    addtests("triangular.jl")
    addtests("det.jl")
    addtests("inv.jl")
    addtests("pinv.jl")

    # special logic required since we need to start a new
    # Julia process for these tests
    if isempty(enabled_tests) || "check_bounds_no" in enabled_tests
        Random.seed!(42)
        run(`$(Base.julia_cmd()) --check-bounds=no $(abspath("check_bounds_no.jl"))`)
    end
end

if TEST_GROUP ∈ ["", "all", "group-B"]
    addtests("solve.jl")
    addtests("eigen.jl")
    addtests("expm.jl")
    addtests("sqrtm.jl")
    addtests("lyap.jl")
    addtests("lu.jl")
    addtests("qr.jl")
    addtests("chol.jl") # hermitian_type(::Type{Any}) for block algorithm
    addtests("deque.jl")
    addtests("flatten.jl")
    addtests("io.jl")
    addtests("svd.jl")
    addtests("unitful.jl")

    # chain rules integration via pkg extensions is available only in Julia 1.9+
    if VERSION ≥ v"1.9-"
        addtests("chainrules.jl")
    end
end

@setup_workload begin
    @compile_workload begin
        for T in (Float32, Float64, Int)   # some common eltypes
            for S = 2:4                    # some common sizes
                L = S*S
                x = fill(0., SMatrix{S, S, T, L})
                x * x
                y = fill(0., SVector{S, T})
                x * y
                inv(x)
                transpose(x)
                _adjoint(Size(S, S), x)
                minimum(x; dims=1)
                minimum(x; dims=2)
                maximum(x; dims=1)
                maximum(x; dims=2)
                getindex(x, SOneTo(S-1), SOneTo(S-1))
                y .* x .* y'
                zero(y)
                zero(x)
            end
        end

        # broadcast_getindex
        for m = 0:5, n = m:5
            broadcast_getindex(Tuple(1:m), 1, CartesianIndex(n))
        end
    end
end

"""
    dimmatch(x::StaticDimension, y::StaticDimension)

Return whether dimensions `x` and `y` match at compile time, that is:

* if `x` and `y` are both `Int`s, check that they are equal
* if `x` or `y` are `Dynamic()`, return true
"""
function dimmatch end
@inline dimmatch(x::Int, y::Int) = x === y
@inline dimmatch(x::StaticDimension, y::StaticDimension) = true

Size(::Type{Adjoint{T, A}}) where {T, A <: AbstractVecOrMat{T}} = Size(Size(A)[2], Size(A)[1])
Size(::Type{Transpose{T, A}}) where {T, A <: AbstractVecOrMat{T}} = Size(Size(A)[2], Size(A)[1])
Size(::Type{Symmetric{T, A}}) where {T, A <: AbstractMatrix{T}} = Size(A)
Size(::Type{Hermitian{T, A}}) where {T, A <: AbstractMatrix{T}} = Size(A)
Size(::Type{Diagonal{T, A}}) where {T, A <: AbstractVector{T}} = Size(Size(A)[1], Size(A)[1])
Size(::Type{UpperTriangular{T, A}}) where {T,A} = Size(A)
Size(::Type{UnitUpperTriangular{T, A}}) where {T,A} = Size(A)
Size(::Type{LowerTriangular{T, A}}) where {T,A} = Size(A)
Size(::Type{UnitLowerTriangular{T, A}}) where {T,A} = Size(A)

struct Length{L}
    function Length{L}() where L
        check_length(L)
        new{L}()
    end
end

check_length(L::Int) = nothing
check_length(L::Dynamic) = nothing
check_length(L) = error("Length was expected to be an `Int` or `Dynamic`")

Base.show(io::IO, ::Length{L}) where {L} = print(io, "Length(", L, ")")

Length(a::AbstractArray) = Length(Size(a))
Length(::Type{A}) where {A <: AbstractArray} = Length(Size(A))
Length(L::Int) = Length{L}()
Length(::Size{S}) where {S} = _Length(S...)
_Length(S::Int...) = Length{prod(S)}()
@inline _Length(S...) = Length{Dynamic()}()

# Some convenience functions for `Size`
(::Type{Tuple})(::Size{S}) where {S} = S

getindex(::Size{S}, i::Int) where {S} = i <= length(S) ? S[i] : 1

length(::Size{S}) where {S} = length(S)
length_val(::Size{S}) where {S} = Val{length(S)}

# Note - using === here, as Base doesn't inline == for tuples as of julia-0.6
Base.:(==)(::Size{S}, s::Tuple{Vararg{Int}}) where {S} = S === s
Base.:(==)(s::Tuple{Vararg{Int}}, ::Size{S}) where {S} = s === S

Base.prod(::Size{S}) where {S} = prod(S)

Base.LinearIndices(::Size{S}) where {S} = LinearIndices(S)

size_tuple(::Size{S}) where {S} = Tuple{S...}

# Some convenience functions for `Length`
(::Type{Int})(::Length{L}) where {L} = Int(L)

Base.:(==)(::Length{L}, l::Int) where {L} = L == l
Base.:(==)(l::Int, ::Length{L}) where {L} = l == L

"""
    sizematch(::Size, ::Size)
    sizematch(::Tuple, ::Tuple)

Determine whether two sizes match, in the sense that they have the same
number of dimensions, and their dimensions match as determined by [`dimmatch`](@ref).
"""
sizematch(::Size{S1}, ::Size{S2}) where {S1, S2} = sizematch(S1, S2)
@inline sizematch(::Tuple{}, ::Tuple{}) = true
@inline sizematch(S1::Tuple{Vararg{StaticDimension, N}}, S2::Tuple{Vararg{StaticDimension, N}}) where {N} =
    dimmatch(S1[1], S2[1]) && sizematch(Base.tail(S1), Base.tail(S2))
@inline sizematch(::Tuple{Vararg{StaticDimension}}, ::Tuple{Vararg{StaticDimension}}) = false # mismatch in number of dimensions

"""
    sizematch(::Size, A::AbstractArray)

Determine whether array `A` matches the given size. If `A` is a
`StaticArray`, the check is performed at compile time, otherwise,
the check is performed at runtime.
"""
@inline sizematch(::Size{S}, A::StaticArray) where {S} = sizematch(Size{S}(), Size(A))
@inline sizematch(::Size{S}, A::AbstractArray) where {S} = sizematch(S, size(A))

"""
    _size(a)

Return either the statically known `Size()` or runtime `size()`
"""
@inline _size(a) = size(a)
@inline _size(a::StaticArray) = Size(a)

# Return static array from a set of arrays
@inline _first_static(a1::StaticArray, as...) = a1
@inline _first_static(a1, as...) = _first_static(as...)
@inline _first_static() = throw(ArgumentError("No StaticArray found in argument list"))

"""
    same_size(as...)

Returns the common `Size` of the inputs (or else throws a `DimensionMismatch`)
"""
@inline function same_size(as...)
    s = Size(_first_static(as...))
    _sizes_match(s, as...) || _throw_size_mismatch(as...)
    s
end
@inline _sizes_match(s::Size, a1, as...) = ((s == _size(a1)) ? _sizes_match(s, as...) : false)
@inline _sizes_match(s::Size) = true
@noinline function _throw_size_mismatch(as...)
    throw(DimensionMismatch("Sizes $(map(_size, as)) of input arrays do not match"))
end

# Return the "diagonal size" of a matrix - the minimum of the two dimensions
diagsize(A::StaticMatrix) = diagsize(Size(A))
diagsize(::Size{S}) where {S} = min(S...)

using StaticArrays, Test, LinearAlgebra
@testset "Determinant" begin
    @test det(@SMatrix [1]) == 1
    @test logdet(@SMatrix [1]) == 0.0
    @test det(@SMatrix [0 1; 1 0]) == -1
    @test logdet(@SMatrix Complex{Float64}[0 1; 1 0]) == log(det(@SMatrix Complex{Float64}[0 1; 1 0]))
    @test det(one(SMatrix{3,3})*im) == det([1.0*im 0.0 0.0; 0.0 1.0*im 0.0; 0.0 0.0 1.0*im])

    @test det(@SMatrix [0 1 0; 1 0 0; 0 0 1]) == -1
    m = [0.570085  0.667147  0.264427  0.561446
         0.115197  0.141744  0.83314   0.0457302
         0.249238  0.841643  0.809544  0.908978
         0.72068   0.6155    0.210278  0.607331]
    @test det(SMatrix{4,4}(m)) ≈ det(m)
    #triu/tril
    @test det(@SMatrix [1 2; 0 3]) == 3
    @test det(@SMatrix [1 2 3 4; 0 5 6 7; 0 0 8 9; 0 0 0 10]) == 400.0
    @test logdet(@SMatrix [1 2 3 4; 0 5 6 7; 0 0 8 9; 0 0 0 10]) ≈ log(400.0)
    @test @inferred(det(ones(SMatrix{10,10,Complex{Float64}}))) == 0

    # Unsigned specializations , compare to Base
    M = @SMatrix [1 2 3 4; 200 5 6 7; 0 0 8 9; 0 0 0 10]
    for sz in (2,3,4), typ in (UInt8,UInt16,UInt32,UInt64)
        Mtag = SMatrix{sz,sz,typ}(M[1:sz,1:sz])
        @test det(Mtag) == det(Array(Mtag))
    end

    # lu-based (sz up to 14) and fallback (sz >= 15)
    for sz in (5, 8, 15), typ in (Float64, Complex{Float64})
        A = rand(typ, sz, sz)
        SA = SMatrix{sz,sz,typ}(A)
        @test det(A) ≈ det(SA) == det(lu(SA))
        if typ == Float64 && det(A) < 0
            A[:,1], A[:,2] = A[:,2], A[:,1]
            SA = SMatrix{sz,sz,typ}(A)
        end
        @test logdet(A) ≈ logdet(SA) == logdet(lu(SA))
        dA, sA = logabsdet(A)
        dSA, sSA = logabsdet(SA)
        dLU, sLU = logabsdet(lu(SA))
        @test dA ≈ dSA == dLU
        @test sA ≈ sSA == sLU
    end

    @test_throws DimensionMismatch det(@SMatrix [0; 1])
end

using StaticArrays, BenchmarkTools, DataFrames, DataStructures

Nmax = 20
unary = (det, inv, exp)
binary = (\,)

data = OrderedDict{Symbol,Any}()
data[:SIZE] = vcat(([i, "", "", ""] for i in 1:Nmax)...)
data[:STAT] = [stat for sz in 1:Nmax for stat in ("compile time (s)", "StaticArrays (μs)", "Base (μs)", "max error")]

for f in unary
    f_data = Float64[]
    for N in 1:Nmax
        print("\r$((f,N))")
        SA = @SMatrix rand(N,N)
        A = Array(SA)
        push!(f_data, @elapsed f(SA))
        push!(f_data, 1e6*@belapsed $f($SA))
        push!(f_data, 1e6*@belapsed $f($A))
        push!(f_data, maximum([begin
                                   SA = @SMatrix rand(N,N)
                                   A = Array(SA)
                                   norm(f(A) - f(SA))
                               end for i in 1:1000]))
    end
    data[Symbol(f)] = f_data
end

for f in binary
    f_data = Float64[]
    for N in 1:Nmax
        print("\r$((f,N))")
        SA = @SMatrix rand(N,N)
        A = Array(SA)
        SB = @SMatrix rand(N,N)
        B = Array(SB)
        push!(f_data, @elapsed f(SA,SB))
        push!(f_data, 1e6*@belapsed $f($SA,$SB))
        push!(f_data, 1e6*@belapsed $f($A,$B))
        push!(f_data, maximum([begin
                                   SA = @SMatrix rand(N,N)
                                   A = Array(SA)
                                   SB = @SMatrix rand(N,N)
                                   B = Array(SB)
                                   norm(f(A,B) - f(SA,SB))
                               end for i in 1:1000]))
    end
    data[Symbol(f)] = f_data
end

df = DataFrame(data...)

open("bench_matrix_ops.txt", "w") do f
    versioninfo(f)
    showall(f, df)
end

module StaticArrays

import Base: @_propagate_inbounds_meta, @propagate_inbounds, @pure

import Base: getindex, setindex!, size, similar, vec, show, length, convert, promote_op,
             promote_rule, map, map!, reduce, mapreduce, foldl, mapfoldl, broadcast,
             broadcast!, conj, hcat, vcat, ones, zeros, one, reshape, fill, fill!, inv,
             iszero, sum, prod, count, any, all, minimum, maximum, extrema,
             copy, read, read!, write, reverse

using Random
import Random: rand, randn, randexp, rand!, randn!, randexp!
using Core.Compiler: return_type
import Base: sqrt, exp, log, float, real
using LinearAlgebra
import LinearAlgebra: transpose, adjoint, dot, eigvals, eigen, lyap, tr,
                      kron, diag, norm, dot, diagm, lu, svd, svdvals, pinv,
                      factorize, ishermitian, issymmetric, isposdef, issuccess, normalize,
                      normalize!, Eigen, det, logdet, logabsdet, cross, diff, qr, \,
                      triu, tril
using LinearAlgebra: checksquare

using PrecompileTools

# StaticArraysCore imports
# there is intentionally no "using StaticArraysCore" to not take all symbols exported
# from StaticArraysCore to make transitioning definitions to StaticArraysCore easier.
using StaticArraysCore: StaticArraysCore, StaticArray, StaticScalar, StaticVector,
                        StaticMatrix, StaticVecOrMat, tuple_length, tuple_prod,
                        tuple_minimum, size_to_tuple
using StaticArraysCore: FieldArray, FieldMatrix, FieldVector
using StaticArraysCore: StaticArrayStyle
using StaticArraysCore: Dynamic, StaticDimension
import StaticArraysCore: SArray, SVector, SMatrix
import StaticArraysCore: MArray, MVector, MMatrix
import StaticArraysCore: SizedArray, SizedVector, SizedMatrix
import StaticArraysCore: check_array_parameters, convert_ntuple
import StaticArraysCore: similar_type, Size

# end of StaticArraysCore imports
# StaticArraysCore exports
export StaticScalar, StaticArray, StaticVector, StaticMatrix
export Scalar, SArray, SVector, SMatrix
export MArray, MVector, MMatrix
export SizedArray, SizedVector, SizedMatrix
# end of StaticArraysCore exports

export SOneTo
export Scalar
export FieldVector, FieldMatrix, FieldArray
export SDiagonal
export SHermitianCompact

export Size, Length

export SA, SA_F32, SA_F64
export @SVector, @SMatrix, @SArray
export @MVector, @MMatrix, @MArray

export similar_type
export push, pop, pushfirst, popfirst, insert, deleteat, setindex
export enumerate_static

export StaticArraysCore

include("SOneTo.jl")

# Being a member of StaticMatrixLike, StaticVecOrMatLike, or StaticArrayLike implies that Size(A)
# returns a static Size instance (none of the dimensions are Dynamic). The converse may not be true.
# These are akin to aliases like StridedArray and in similarly bad taste, but the current approach
# in Base necessitates their existence.
const StaticMatrixLike{T} = Union{
    StaticMatrix{<:Any, <:Any, T},
    Transpose{T, <:StaticVecOrMat{T}},
    Adjoint{T, <:StaticVecOrMat{T}},
    Symmetric{T, <:StaticMatrix{<:Any, <:Any, T}},
    Hermitian{T, <:StaticMatrix{<:Any, <:Any, T}},
    Diagonal{T, <:StaticVector{<:Any, T}},
    # We specifically list *Triangular here rather than using
    # AbstractTriangular to avoid ambiguities in size() etc.
    UpperTriangular{T, <:StaticMatrix{<:Any, <:Any, T}},
    LowerTriangular{T, <:StaticMatrix{<:Any, <:Any, T}},
    UnitUpperTriangular{T, <:StaticMatrix{<:Any, <:Any, T}},
    UnitLowerTriangular{T, <:StaticMatrix{<:Any, <:Any, T}}
}
const StaticVecOrMatLike{T} = Union{StaticVector{<:Any, T}, StaticMatrixLike{T}}
const StaticArrayLike{T} = Union{StaticVecOrMatLike{T}, StaticArray{<:Tuple, T}}

const AbstractScalar{T} = AbstractArray{T, 0} # not exported, but useful none-the-less
const StaticArrayNoEltype{S, N, T} = StaticArray{S, T, N}

include("util.jl")
include("traits.jl")

include("SUnitRange.jl")
include("FieldArray.jl")
include("SArray.jl")
include("SMatrix.jl")
include("SVector.jl")
include("Scalar.jl")
include("MArray.jl")
include("MVector.jl")
include("MMatrix.jl")
include("SizedArray.jl")
include("SDiagonal.jl")
include("SHermitianCompact.jl")

include("initializers.jl")
include("convert.jl")

include("abstractarray.jl")
include("indexing.jl")
include("broadcast.jl")
include("mapreduce.jl")
include("sort.jl")
include("arraymath.jl")
include("linalg.jl")
include("matrix_multiply_add.jl")
include("matrix_multiply.jl")
include("lu.jl")
include("det.jl")
include("inv.jl")
include("solve.jl")
include("eigen.jl")
include("expm.jl")
include("sqrtm.jl")
include("lyap.jl")
include("triangular.jl")
include("cholesky.jl")
include("svd.jl")
include("qr.jl")
include("deque.jl")
include("flatten.jl")
include("io.jl")
include("pinv.jl")

@static if VERSION >= v"1.7"
    include("blas.jl")
end

@static if !isdefined(Base, :get_extension) # VERSION < v"1.9-"
    include("../ext/StaticArraysStatisticsExt.jl")
end

include("precompile.jl")

end # module

module SHermitianCompactTest

using StaticArrays
using LinearAlgebra
using Random
using Test

macro test_noalloc(ex)
    esc(quote
        $ex
        @test(@allocated($ex) == 0)
    end)
end

function check_lower_triangle(a::SHermitianCompact, triangle::SVector)
    N = size(a, 1)
    i = 0
    for col = 1 : N, row = 1 : N
        if row >= col
            i += 1
            @test a[row, col] == triangle[i]
        else
            @test a[row, col] == adjoint(a[col, row])
        end
    end
end

function check_lower_triangle(a::SHermitianCompact{3}, triangle::SVector)
    # because the generic check_lower_triangle uses almost the same code as what's being tested
    @test a[1, 1] == triangle[1]
    @test a[2, 1] == triangle[2]
    @test a[3, 1] == triangle[3]
    @test a[1, 2] == adjoint(a[2, 1])
    @test a[2, 2] == triangle[4]
    @test a[3, 2] == triangle[5]
    @test a[1, 3] == adjoint(a[3, 1])
    @test a[2, 3] == adjoint(a[3, 2])
    @test a[3, 3] == triangle[6]
end

fill3(x) = fill(3, x)

@testset "SHermitianCompact" begin
    @testset "Inner Constructor" begin
        for (N, L) in ((3, 6), (4, 10), (6, 21))
            for T in (Int32, Int64)
                @eval begin
                    let lowertriangle = rand(SVector{$L, Int32})
                        a = SHermitianCompact{$N, $T, $L}(lowertriangle)
                        check_lower_triangle(a, lowertriangle)
                        @test a isa SHermitianCompact{$N, $T, $L}
                        @test(@allocated(SHermitianCompact{$N, $T, $L}(lowertriangle)) == 0)
                    end
                end
            end
        end
        @test_throws ArgumentError SHermitianCompact{3, Int64, 7}(rand(SVector{7, Int32}))
    end

    @testset "Outer Constructors" begin
        @test @inferred(SHermitianCompact(MVector(1,2,3))) === SHermitianCompact(SVector(1,2,3))
        @test_throws Exception SHermitianCompact(1,2,3)
        @test_throws Exception SHermitianCompact(1,2,3,4,5)
        @test @inferred(SHermitianCompact(1,2,3,4)) === SHermitianCompact(SVector(1,2,4))

        for (N, L) in ((3, 6), (4, 10), (6, 21))
            for T in (Int32, Int64)
                @eval begin
                    let lowertriangle = rand(SVector{$L, Int32})
                        a1 = SHermitianCompact{$N, $T}(lowertriangle)
                        check_lower_triangle(a1, $T.(lowertriangle))
                        @test a1 isa SHermitianCompact{$N, $T, $L}
                        @test_noalloc SHermitianCompact{$N, $T}(lowertriangle)

                        a2 = SHermitianCompact{$N}(lowertriangle)
                        check_lower_triangle(a2, lowertriangle)
                        @test a2 isa SHermitianCompact{$N, Int32, $L}
                        @test_noalloc SHermitianCompact{$N}(lowertriangle)

                        a3 = SHermitianCompact(lowertriangle)
                        check_lower_triangle(a3, lowertriangle)
                        @test a3 isa SHermitianCompact{$N, Int32, $L}
                        @test_noalloc SHermitianCompact(lowertriangle)

                        a4 = SHermitianCompact{$N, $T}(a3)
                        @test a4 === a1
                        @test_noalloc SHermitianCompact{$N, $T}(a3)
                    end
                    let a = rand(SMatrix{$N, $N, Int32})
                        @test SHermitianCompact{$N, $T, $L}(a) isa SHermitianCompact{$N, $T, $L}
                        @test_noalloc SHermitianCompact{$N, $T, $L}(a)
                        @test SHermitianCompact{$N, $T, $L}(a) == Hermitian($T.(a), :L)

                        @test SHermitianCompact{$N, $T}(a) isa SHermitianCompact{$N, $T, $L}
                        @test_noalloc SHermitianCompact{$N, $T}(a)
                        @test SHermitianCompact{$N, $T}(a) == Hermitian($T.(a), :L)

                        @test SHermitianCompact{$N}(a) isa SHermitianCompact{$N, Int32, $L}
                        @test_noalloc SHermitianCompact{$N}(a)
                        @test SHermitianCompact{$N}(a) == Hermitian(a, :L)

                        @test SHermitianCompact(a) isa SHermitianCompact{$N, Int32, $L}
                        @test_noalloc SHermitianCompact(a)
                        @test SHermitianCompact(a) == Hermitian(a, :L)
                    end
                end
            end
        end
    end

    @testset "convert" begin
        a = SHermitianCompact(SMatrix{3, 3}(1 : 9))
        @test convert(typeof(a), a) === a
        @test convert(SHermitianCompact{3, Float64}, a) isa SHermitianCompact{3, Float64, 6}
        @test convert(SHermitianCompact{3, Float64}, a) == Float64.(Array(a))
        @test convert(SHermitianCompact{3, Float64, 6}, a) isa SHermitianCompact{3, Float64, 6}
    end

    @testset "setindex" begin
        for (N, L) in ((3, 6), (4, 10), (6, 21))
            @eval begin
                let lowertriangle = zero(SVector{$L, Int32})
                    a = SHermitianCompact(lowertriangle)
                    @test_noalloc setindex(a, 2., 1, 1)
                    for col = 1 : $N, row = 1 : $N
                        x = Float64(rand(Int32))
                        a2 = setindex(a, x, row, col)
                        @test a2[row, col] === Int32(x)
                        @test setindex(a2, 0, row, col) === a
                    end
                end
            end
        end
    end

    @testset "ishermitian / issymmetric" begin
        a = rand(SHermitianCompact{5, Float64})
        @test ishermitian(a)
        @test issymmetric(a)

        b = rand(SHermitianCompact{5, ComplexF64})
        @test !ishermitian(b)
        @test !issymmetric(b)

        c = b + conj(b)
        @test ishermitian(c)
        @test issymmetric(c)
        @test_noalloc ishermitian(c)

        d = b + b'
        @test ishermitian(d)
        @test !issymmetric(d)

        e = rand(SHermitianCompact{5, Float64}) + im*I
        @test !ishermitian(e)
        @test issymmetric(e)
    end

    @testset "==" begin
        a = SHermitianCompact(SVector{6}(-5 : 0))
        b = setindex(a, 5, 3)
        @test a == a
        @test !(a == b)
        @test_noalloc a == a
    end

    @testset "Arithmetic" begin
        a = SHermitianCompact(SVector{6, Int}(1 : 6))
        b = SHermitianCompact(SVector(-4, 5, 4, 8, -10, 11))
        c = SMatrix{3, 3}(-9 : -1)

        let a = a
            @test -a == -SMatrix(a)
            @test -a isa SHermitianCompact{3, Int, 6}
        end
        for (x, y) in ((a, b), (a, c), (c, a))
            @eval begin
                let x = $x, y = $y
                    @test x + y == SMatrix(x) + SMatrix(y)
                    @test_noalloc x + y

                    @test x - y == SMatrix(x) - SMatrix(y)
                    @test_noalloc x - y

                    if x isa SHermitianCompact && y isa SHermitianCompact
                        @test x + y isa SHermitianCompact{3, Int, 6}
                        @test x - y isa SHermitianCompact{3, Int, 6}
                    end
                end
            end
        end
    end

    @testset "Scalar-array" begin
        x = SHermitianCompact(SVector{6, Int}(1 : 6))
        for y = (-5, 1.1+4.3im)
            for op in (:*, :/, :\, :(Base.FastMath.mul_fast))
                if op != :\
                    @eval begin
                        @test $op($x, $y) == $op(SMatrix($x), $y)
                        @test_noalloc $op($x, $y)
                    end
                end

                if op != :/
                    @eval begin
                        @test $op($y, $x) == $op($y, SMatrix($x))
                        @test_noalloc $op($y, $x)
                    end
                end
            end
            @eval begin
                @test muladd($y, $x, $x) == muladd($y, SMatrix($x), $x)
                @test_noalloc muladd($y, $x, $x)
                @test muladd($x, $y, $x) == muladd(SMatrix($x), $y, $x)
                @test_noalloc muladd($x, $y, $x)
            end
        end
    end

    @testset "UniformScaling" begin
        let a = SHermitianCompact(SVector{21, Int}(1 : 21))
            @test a + 3I == SMatrix(a) + 3I
            @test a + 3I isa typeof(a)

            @test a - 4I == SMatrix(a) - 4I
            @test a - 4I isa typeof(a)

            @test a * 3I === a * 3
            @test 3I * a === 3 * a
            @test 3I \ a == 3 \ a
            @test a / 3I == a / 3
        end
    end

    @testset "transpose/adjoint" begin
        a = Hermitian([[rand(Complex{Int}) for i = 1 : 2, j = 1 : 2] for row = 1 : 3, col = 1 : 3])
        @test transpose(SHermitianCompact{3}(a)) == transpose(a)
        @test adjoint(SHermitianCompact{3}(a)) == adjoint(a)

        b = Hermitian([rand(Complex{Int}) for i = 1 : 3, j = 1 : 3])
        @test adjoint(SHermitianCompact{3}(b)) == adjoint(b)
    end

    @testset "one/ones/zeros/fill" begin
        for N = 3 : 5, f in (:one, :ones, :zeros, :fill3)
            @eval begin
                @test $f(SHermitianCompact{$N, Int}) == $f(SMatrix{$N, $N, Int})
                @test $f(SHermitianCompact{$N, Int}) isa SHermitianCompact{$N, Int}
                @test_noalloc $f(SHermitianCompact{$N, Int})

                @test $f(SHermitianCompact{$N}) == $f(SMatrix{$N, $N})
                @test $f(SHermitianCompact{$N}) isa SHermitianCompact{$N, eltype($f(SMatrix{$N, $N}))}
                @test_noalloc $f(SHermitianCompact{$N})
            end
        end
    end

    @testset "rand" begin
        for N = 3 : 5, f in (:rand, :randn, :randexp)
            @eval begin
                @test_noalloc $f(SHermitianCompact{$N, Float32})
                @test $f(SHermitianCompact{$N, Float32}) isa SHermitianCompact{$N, Float32}

                @test_noalloc $f(SHermitianCompact{$N})
                @test $f(SHermitianCompact{$N}) isa SHermitianCompact{$N, Float64}
            end
        end
    end
end

end # module

using StaticArrays, Test, LinearAlgebra

@testset "SDiagonal" begin
    @testset "Constructors" begin
        @test SDiagonal{1,Int64}((1,)).diag === SVector{1,Int64}((1,))
        @test SDiagonal{1,Float64}((1,)).diag === SVector{1,Float64}((1,))

        @test SDiagonal{4,Float64}((1, 1.0, 1, 1)).diag.data === (1.0, 1.0, 1.0, 1.0)
        @test SDiagonal{4}((1, 1.0, 1, 1)).diag.data === (1.0, 1.0, 1.0, 1.0)
        @test SDiagonal((1, 1.0, 1, 1)).diag.data === (1.0, 1.0, 1.0, 1.0)

        # Bad input
        @test_throws Exception SMatrix{1,Int}()
        @test_throws Exception SMatrix{2,Int}((1,))

        # From SMatrix
        @test SDiagonal(SMatrix{2,2,Int}((1,2,3,4))).diag.data === (1,4)

        @test SDiagonal{1,Int}(SDiagonal{1,Float64}((1,))).diag[1] === 1

    end

    @testset "Methods" begin

        m = SDiagonal(@SVector [11, 12, 13, 14])

        @test diag(m) === m.diag

        m2 = diagm(0 => [11, 12, 13, 14])

        @test logdet(m) == logdet(m2)
        @test logdet(im*m) ≈ logdet(im*m2)
        @test det(m) == det(m2)
        @test tr(m) == tr(m2)
        @test log(m) == log(m2)
        @test exp(m) == exp(m2)
        @test sqrt(m) == sqrt(m2)
        @test cholesky(m).U == cholesky(m2).U

        # Apparently recursive chol never really worked
        #@test_broken chol(reshape([1.0*m, 0.0*m, 0.0*m, 1.0*m], 2, 2)) ==
        #    reshape([chol(1.0*m), 0.0*m, 0.0*m, chol(1.0*m)], 2, 2)

        @test isimmutable(m) == true

        @test m[1,1] === 11
        @test m[2,2] === 12
        @test m[3,3] === 13
        @test m[4,4] === 14

        for i in 1:4
            for j in 1:4
                i == j || @test m[i,j] === 0
            end
        end

        @test_throws BoundsError m[5,5]

        @test_throws BoundsError m[1,5]


        @test size(m) === (4, 4)
        @test size(typeof(m)) === (4, 4)
        @test size(SDiagonal{4}) === (4, 4)

        @test size(m, 1) === 4
        @test size(m, 2) === 4
        @test size(typeof(m), 1) === 4
        @test size(typeof(m), 2) === 4

        @test length(m) === 4*4

        @test_throws Exception m[1] = 1

        b = @SVector [2,-1,2,1]
        b2 = Vector(b)


        @test m*b ==  @SVector [22,-12,26,14]
        @test (b'*m)' ==  @SVector [22,-12,26,14]
        @test transpose(transpose(b)*m) ==  @SVector [22,-12,26,14]

        @test m\b == m2\b

        @test b'/m == b'/m2
        @test transpose(b)/m == transpose(b)/m2
        # @test_throws Exception b/m # Apparently this is now some kind of minimization problem
        @test m*m == m2*m

        @test ishermitian(m) == ishermitian(m2)
        @test ishermitian(m/2)
        m_ireal = SDiagonal(@SVector [11+0im, 12+0im, 13+0im, 14+0im])
        @test ishermitian(m_ireal)

        @test isposdef(m) == isposdef(m2)
        @test issymmetric(m) == issymmetric(m2)

        @test (2*m/2)' == m
        @test transpose(2*m/2) == m
        @test 2m == m + m
        @test -(-m) == m
        @test m - SMatrix{4,4}(zeros(4,4)) == m
        @test m*0 == m - m

        @test m*inv(m) == m/m == m\m == one(SDiagonal{4,Float64})

        @test factorize(m) == m
        @test m*[1; 1; 1; 1] == [11; 12; 13; 14]
        @test m\[1; 1; 1; 1] == [11; 12; 13; 14].\[1; 1; 1; 1]
        @test SMatrix{4,4}(Matrix{Float64}(I, 4, 4))*m == m
        @test m*SMatrix{4,4}(Matrix{Float64}(I, 4, 4)) == m
        @test SMatrix{4,4}(Matrix{Float64}(I, 4, 4))/m == diagm(0 => [11; 12; 13; 14].\[1; 1; 1; 1])
        @test m\SMatrix{4,4}(Matrix{Float64}(I, 4, 4)) == diagm(0 => [11; 12; 13; 14].\[1; 1; 1; 1])

        @test m + zero(m) == m
        @test m + zero(typeof(m)) == m
    end
end

using StaticArrays, Test

@testset "accumulate" begin
    @testset "cumsum(::$label)" for (label, T) in [
        # label, T
        ("SVector", SVector),
        ("MVector", MVector),
        ("SizedVector", SizedVector),
    ]
        @testset "$label" for (label, a) in [
            ("[1, 2, 3]", T{3}(SA[1, 2, 3])),
            ("[]", T{0,Int}(())),
        ]
            @test cumsum(a) == cumsum(collect(a))
            @test cumsum(a) isa similar_type(a)
            @inferred cumsum(a)
        end
        @test eltype(cumsum(T{0,Int8}(()))) == eltype(cumsum(Int8[]))
        @test eltype(cumsum(T{1,Int8}((1)))) == eltype(cumsum(Int8[1]))
        @test eltype(cumsum(T{2,Int8}((1, 2)))) == eltype(cumsum(Int8[1, 2]))
    end

    @testset "cumsum(::$label; dims=2)" for (label, T) in [
        # label, T
        ("SMatrix", SMatrix),
        ("MMatrix", MMatrix),
        ("SizedMatrix", SizedMatrix),
    ]
        @testset "$label" for (label, a) in [
            ("[1 2; 3 4; 5 6]", T{3,2}(SA[1 2; 3 4; 5 6])),
            ("0 x 2 matrix", T{0,2,Float64}()),
            ("2 x 0 matrix", T{2,0,Float64}()),
        ]
            @test cumsum(a; dims = 2) == cumsum(collect(a); dims = 2)
            @test cumsum(a; dims = 2) isa similar_type(a)
            @inferred cumsum(a; dims = Val(2))
        end
    end

    @testset "cumsum(a::SArray; dims=$i); ndims(a) = $d" for d in 1:4, i in 1:d
        shape = Tuple(1:d)
        a = similar_type(SArray, Int, Size(shape))(1:prod(shape))
        @test cumsum(a; dims = i) == cumsum(collect(a); dims = i)
        @test cumsum(a; dims = i) isa SArray
        @inferred cumsum(a; dims = Val(i))
    end

    @testset "cumprod" begin
        a = SA[1, 2, 3]
        @test cumprod(a)::SArray == cumprod(collect(a))
        @inferred cumprod(a)

        @test eltype(cumsum(SA{Int8}[])) == eltype(cumsum(Int8[]))
        @test eltype(cumsum(SA{Int8}[1])) == eltype(cumsum(Int8[1]))
        @test eltype(cumsum(SA{Int8}[1, 2])) == eltype(cumsum(Int8[1, 2]))
    end

    @testset "empty vector with init" begin
        a = SA{Int}[]
        right(_, x) = x
        @test accumulate(right, a; init = Val(1)) === SA{Int}[]
        @inferred accumulate(right, a; init = Val(1))
    end
end

@testset "SVector" begin
    @testset "Inner Constructors" begin
        @test SVector{1,Int}((1,)).data === (1,)
        @test SVector{1,Float64}((1,)).data === (1.0,)
        @test SVector{2,Float64}((1, 1.0)).data === (1.0, 1.0)

        @test_throws Exception SVector{1,Int}()
        @test_throws Exception SVector{2,Int}((1,))
        @test_throws Exception SVector{1,Int}(())
        @test_throws Exception SVector{Int,1}((1,))
    end

    @testset "Outer constructors and macro" begin
        @test SVector{1}((1,)).data === (1,)
        @test SVector{1}((1.0,)).data === (1.0,)
        @test SVector((1,)).data === (1,)
        @test SVector((1.0,)).data === (1.0,)

        # test for #557-like issues
        @test (@inferred SVector(MVector{0,Float64}()))::SVector{0,Float64} == SVector{0,Float64}()

        @test SVector{3}(i for i in 1:3).data === (1,2,3)
        @test SVector{3}(float(i) for i in 1:3).data === (1.0,2.0,3.0)
        @test SVector{0,Int}().data === ()
        @test SVector{3,Int}(i for i in 1:3).data === (1,2,3)
        @test SVector{3,Float64}(i for i in 1:3).data === (1.0,2.0,3.0)
        @test SVector{1}(SVector(SVector(1.0), SVector(2.0))[j] for j in 1:1) == SVector((SVector(1.0),))
        @test_throws Exception SVector{3}(i for i in 1:2)
        @test_throws Exception SVector{3}(i for i in 1:4)
        @test_throws Exception SVector{3,Int}(i for i in 1:2)
        @test_throws Exception SVector{3,Int}(i for i in 1:4)

        @test SVector(1).data === (1,)
        @test SVector(1,1.0).data === (1.0,1.0)

        @test ((@SVector [1.0])::SVector{1}).data === (1.0,)
        @test ((@SVector [1, 2, 3])::SVector{3}).data === (1, 2, 3)
        @test ((@SVector Float64[1,2,3])::SVector{3}).data === (1.0, 2.0, 3.0)
        @test ((@SVector [i for i = 1:3])::SVector{3}).data === (1, 2, 3)
        @test ((@SVector Float64[i for i = 1:3])::SVector{3}).data === (1.0, 2.0, 3.0)

        @test ((@SVector zeros(2))::SVector{2, Float64}).data === (0.0, 0.0)
        @test ((@SVector ones(2))::SVector{2, Float64}).data === (1.0, 1.0)
        @test ((@SVector fill(2.5, 2))::SVector{2,Float64}).data === (2.5, 2.5)
        @test ((@SVector zeros(Float32, 2))::SVector{2,Float32}).data === (0.0f0, 0.0f0)
        @test ((@SVector ones(Float32, 2))::SVector{2,Float32}).data === (1.0f0, 1.0f0)

        @testset "@SVector rand*" begin
            n = 4
            @test (@SVector rand(n)) isa SVector{n, Float64}
            @test (@SVector randn(n)) isa SVector{n, Float64}
            @test (@SVector randexp(n)) isa SVector{n, Float64}
            @test (@SVector rand(4)) isa SVector{4, Float64}
            @test (@SVector randn(4)) isa SVector{4, Float64}
            @test (@SVector randexp(4)) isa SVector{4, Float64}
            @test (@SVector rand(_rng(), n)) isa SVector{n, Float64}
            @test (@SVector rand(_rng(), n)) == rand(_rng(), n)
            @test (@SVector randn(_rng(), n)) isa SVector{n, Float64}
            @test (@SVector randn(_rng(), n)) == randn(_rng(), n)
            @test (@SVector randexp(_rng(), n)) isa SVector{n, Float64}
            @test (@SVector randexp(_rng(), n)) == randexp(_rng(), n)
            @test (@SVector rand(_rng(), 4)) isa SVector{4, Float64}
            @test (@SVector rand(_rng(), 4)) == rand(_rng(), 4)
            @test (@SVector randn(_rng(), 4)) isa SVector{4, Float64}
            @test (@SVector randn(_rng(), 4)) == randn(_rng(), 4)
            @test (@SVector randexp(_rng(), 4)) isa SVector{4, Float64}
            @test (@SVector randexp(_rng(), 4)) == randexp(_rng(), 4)

            for T in (Float32, Float64)
                @test (@SVector rand(T, n)) isa SVector{n, T}
                @test (@SVector randn(T, n)) isa SVector{n, T}
                @test (@SVector randexp(T, n)) isa SVector{n, T}
                @test (@SVector rand(T, 4)) isa SVector{4, T}
                @test (@SVector randn(T, 4)) isa SVector{4, T}
                @test (@SVector randexp(T, 4)) isa SVector{4, T}
                @test (@SVector rand(_rng(), T, n)) isa SVector{n, T}
                VERSION≥v"1.7" && @test (@SVector rand(_rng(), T, n)) == rand(_rng(), T, n) broken=(T===Float32)
                @test (@SVector randn(_rng(), T, n)) isa SVector{n, T}
                @test (@SVector randn(_rng(), T, n)) == randn(_rng(), T, n)
                @test (@SVector randexp(_rng(), T, n)) isa SVector{n, T}
                @test (@SVector randexp(_rng(), T, n)) == randexp(_rng(), T, n)
                @test (@SVector rand(_rng(), T, 4)) isa SVector{4, T}
                VERSION≥v"1.7" && @test (@SVector rand(_rng(), T, 4)) == rand(_rng(), T, 4) broken=(T===Float32)
                @test (@SVector randn(_rng(), T, 4)) isa SVector{4, T}
                @test (@SVector randn(_rng(), T, 4)) == randn(_rng(), T, 4)
                @test (@SVector randexp(_rng(), T, 4)) isa SVector{4, T}
                @test (@SVector randexp(_rng(), T, 4)) == randexp(_rng(), T, 4)
            end
        end

        @testset "expand error" begin
            test_expand_error(:(@SVector fill(1.5, 2, 3)))
            test_expand_error(:(@SVector ones(2, 3, 4)))
            test_expand_error(:(@SVector rand(Float64, 2, 3, 4)))
            test_expand_error(:(@SVector sin(1:5)))
            test_expand_error(:(@SVector [i*j for i in 1:2, j in 2:3]))
            test_expand_error(:(@SVector Float32[i*j for i in 1:2, j in 2:3]))
            test_expand_error(:(@SVector [1; 2; 3]...))
            test_expand_error(:(@SVector a))
            test_expand_error(:(@SVector [[1 2];[3 4]]))
        end

        if VERSION >= v"1.7.0"
            @test ((@SVector Float64[1;2;3;;;])::SVector{3}).data === (1.0, 2.0, 3.0)
            @test ((@SVector [1;2;3;;;])::SVector{3}).data === (1, 2, 3)
        end
    end

    @testset "Methods" begin
        v = @SVector [11, 12, 13]

        @test isimmutable(v) == true

        @test v[1] === 11
        @test v[2] === 12
        @test v[3] === 13

        @testinf Tuple(v) === (11, 12, 13)

        @test size(v) === (3,)
        @test size(typeof(v)) === (3,)
        @test size(SVector{3}) === (3,)

        @test size(v, 1) === 3
        @test size(v, 2) === 1
        @test size(typeof(v), 1) === 3
        @test size(typeof(v), 2) === 1

        @test length(v) === 3

        @test_throws Exception v[1] = 1

        @test (@inferred view(v, :)) === v
        @test (@inferred view(v, 1)) === Scalar(v[1])
        @test (@inferred view(v, CartesianIndex(1))) === Scalar(v[1])
        @test (@inferred view(v, CartesianIndex(1,1))) === Scalar(v[1])
        @test (@inferred view(v, 1, CartesianIndex(1))) === Scalar(v[1])
        @test (@inferred view(v, SVector{2,Int}(1,2))) === @SArray [11, 12]
        @test (@inferred view(v, SOneTo(2))) === @SArray [11, 12]

        @test reverse(v) == reverse(collect(v), dims = 1)
    end

    @testset "CartesianIndex" begin
        a, b = SVector(0x01, 0x02), SVector(1.0f0, 1.2f0)
        c = CartesianIndex((1,2))
        @test @inferred(eltype([a,c])) == SVector{2,Int}
        @test @inferred(eltype([b,c])) == SVector{2,Float32}
        @test @inferred(convert(SVector, c)) == SVector{2,Int}([1, 2])
        @test @inferred(convert(SVector{2}, c)) == SVector{2,Int}([1, 2])
    end

    @testset "Named field access - getproperty" begin
        @test propertynames(SA[1,2,3,4,5]) == ()
        @test propertynames(SA[1,2,3,4,5], true) == (:data,)
        @test propertynames(SA[1 2; 3 4], true) == (:data,)
        v4 = SA[10,20,30,40]
        @test propertynames(v4) == (:x, :y, :z, :w)
        @test propertynames(v4, true) == (:x, :y, :z, :w, :data)
        @test v4.x == 10
        @test v4.y == 20
        @test v4.z == 30
        @test v4.w == 40
        v2 = SA[10,20]
        @test propertynames(v2) == (:x, :y)
        @test propertynames(v2, true) == (:x, :y, :data)
        @test v2.x == 10
        @test v2.y == 20
        @test_throws ErrorException v2.z
        @test_throws ErrorException v2.w
    end

    @testset "issue 1042" begin
        f = [1,2,3]
        @test f == @SVector [f[i] for i in 1:3]
    end

    @testset "issue 1118" begin
        a = SVector{1}(1)
        @test SVector{1, Tuple{SVector{1, Int}, SVector{1, Int}}}((a,a)) === SVector{1}((a,a))
        @test SVector{1, NTuple}((a,a))[1] === (a,a)
    end
end

@inline (::Type{FA})(x::Tuple) where {FA <: FieldArray} = construct_type(FA, x)(x...)

function construct_type(::Type{FA}, x) where {FA <: FieldArray}
    has_size(FA) || error("$FA has no static size!")
    length_match_size(FA, x)
    FA′ = adapt_eltype(FA, x)
    FA′ === FA && x isa Args && _missing_fa_constructor(FA, typeof(x.args))
    return FA′
end
@noinline function _missing_fa_constructor(@nospecialize(FA), @nospecialize(AT))
    Ts = join(("::$T" for T in fieldtypes(AT)), ", ")
    error("The constructor for $FA($Ts) is missing!")
end

@propagate_inbounds getindex(a::FieldArray, i::Int) = getfield(a, i)
@propagate_inbounds setindex!(a::FieldArray, x, i::Int) = (setfield!(a, i, x); a)

Base.cconvert(::Type{<:Ptr}, a::FieldArray) = Base.RefValue(a)
Base.unsafe_convert(::Type{Ptr{T}}, m::Base.RefValue{FA}) where {N,T,D,FA<:FieldArray{N,T,D}} =
    Ptr{T}(Base.unsafe_convert(Ptr{FA}, m))

# We can automatically preserve FieldArrays in array operations which do not
# change their eltype or Size. This should cover all non-parametric FieldArray,
# but for those which are parametric on the eltype the user will still need to
# overload similar_type themselves.
similar_type(::Type{A}, ::Type{T}, S::Size) where {N, T, A<:FieldArray{N, T}} =
    _fieldarray_similar_type(A, T, S, Size(A))

# Extra layer of dispatch to match NewSize and OldSize
_fieldarray_similar_type(A, T, NewSize::S, OldSize::S) where {S} = A
_fieldarray_similar_type(A, T, NewSize, OldSize) =
    default_similar_type(T, NewSize, length_val(NewSize))

# Convenience constructors for NamedTuple types 
Base.NamedTuple(array::FieldArray) = Base.NamedTuple{propertynames(array)}(array)

using StaticArrays, Test

@testset "Copy constructors" begin
    M = [1 2; 3 4]
    SizeM = SizedMatrix{2,2}(M)
    @test typeof(SizeM)(SizeM).data === M
end # testset

@testset "Constructors of zero size arrays" begin
    # Issue #520
    @testinf SVector{0}(Int8[]) === SVector{0,Int8}()
    @testinf SMatrix{0,0}(zeros(0,0)) === SMatrix{0,0,Float64}(())

    # Issue #651
    @testinf SVector{0,Float64}(Any[]) === SVector{0,Float64}()
    @testinf SVector{0,Float64}(Int8[]) === SVector{0,Float64}()

    # PR #808
    @test Scalar{Int}[SVector{1,Int}(3), SVector{1,Float64}(2.0)] == [Scalar{Int}(3), Scalar{Int}(2)]
    @test Scalar[SVector{1,Int}(3), SVector{1,Float64}(2.0)] == [Scalar{Int}(3), Scalar{Float64}(2.0)]
end

@testset "`real` and `float` of SArray/MArray" begin
    # Issue 935
    for SAT in (SArray, MArray)
        vInt = SAT(SA[1,2,3])           # S/MVector{3, Int}
        @test real(typeof(vInt)) === typeof(vInt)
        @test float(typeof(vInt)) === typeof(float.(vInt))

        vCInt = vInt + 1im*vInt         # S/MVector{3, Complex{Int}}
        @test real(typeof(vCInt)) === typeof(vInt)
        @test float(typeof(vCInt)) === typeof(float.(vCInt))
        
        vvInt = SAT(SA[vInt, vInt])    # S/MVector{2, S/MVector{3, Int}}
        @test real(typeof(vvInt)) === SAT{Tuple{2}, SAT{Tuple{3}, Int, 1, 3}, 1, 2}
        @test float(typeof(vvInt)) === SAT{Tuple{2}, SAT{Tuple{3}, Float64, 1, 3}, 1, 2}

        vvCInt = SAT(SA[vCInt, vCInt]) # S/MVector{2, S/MVector{3, Complex{Int}}}
        @test real(typeof(vvCInt)) === SAT{Tuple{2}, SAT{Tuple{3}, Int, 1, 3}, 1, 2}
        @test float(typeof(vvCInt)) === SAT{Tuple{2}, SAT{Tuple{3}, Complex{Float64}, 1, 3}, 1, 2}
    end
    mInt = SA[Int16(1) Int16(2) Int16(3); Int16(4) Int16(5) Int16(6)] # SMatrix{3,2,Int16}
    @test float(typeof(mInt)) === SMatrix{2, 3, float(Int16), 6}
end

@testset "convert with missing/wrong size" begin
    @test convert(SVector, MVector(1,2,3)) === SVector(1,2,3)
    @test convert(SMatrix{3}, MVector(1,2,3)) === SMatrix{3,1}(1,2,3)
    @test_throws Exception convert(SVector{1}, MVector(1,2,3)) 
end

struct BugStaticVector <: StaticVector{2,Int} end
@testset "Unknow StaticArray" begin
    # Make sure the new `construct_type` cause no regression.
    @test_throws DimensionMismatch BugStaticVector(1,2,3)
    f(x) = StaticArrays.construct_type(BugStaticVector, StaticArrays.Args(x))
    @test_inlined f((1,2,3,4))
end

using OffsetArrays
@testset "constructor/convert from OffsetArray" begin
    a = OffsetArray([-1 1;0 2], -1, -1)
    b = OffsetArray([-1,0,1,2], -1)
    c = OffsetArray(-1:2, -1)
    d = Base.IdentityUnitRange(-1:2)
    @test SVector{4}(a) === SVector{4}(b) === SVector{4}(c) === SVector{4}(d) == [-1,0,1,2]
    @test SMatrix{2,2}(a) === SMatrix{2,2}(b) === SMatrix{2,2}(c) === SMatrix{2,2}(d) == [-1 1;0 2]
end

@testset "[;;;;;]" begin
    @test ((@SVector [;])::SVector{0}).data === ()
    test_expand_error(:(@SVector [;;]))
    @test ((@MVector [;])::MVector{0}).data === ()
    test_expand_error(:(@MVector [;;]))

    @test ((@SMatrix [;;])::SMatrix{0,0}).data === ()
    test_expand_error(:(@SMatrix [;;;]))
    @test ((@MMatrix [;;])::MMatrix{0,0}).data === ()
    test_expand_error(:(@MMatrix [;;;]))
end

@testset "SizedArray" begin
    @testset "Inner Constructors" begin
        @test SizedArray{Tuple{2},Int,1,1,Vector{Int}}((3, 4)).data == [3, 4]
        @test SizedArray{Tuple{2},Int,1,1,Vector{Int}}([3, 4]).data == [3, 4]
        @test SizedArray{Tuple{2,2},Int,2,1,Vector{Int}}([3, 4, 5, 6]).data == [3, 4, 5, 6]
        @test SizedArray{Tuple{},Int,0,1,Vector{Int}}((2,)).data == [2]
        @test_throws DimensionMismatch SizedArray{Tuple{2,2,1},Int,3,2,Matrix{Int}}([1 2; 3 4]).data == [1 2; 3 4]

        # Bad input
        @test_throws Exception SArray{Tuple{1},Int,1}([2 3])

        # Bad parameters
        @test_throws Exception SizedArray{Tuple{1},Int,2}(undef)
        @test_throws Exception SArray{Tuple{3, 4},Int,1}(undef)

        # Parameter/input size mismatch
        @test_throws Exception SizedArray{Tuple{1},Int,2}([2; 3])
        @test_throws Exception SizedArray{Tuple{1},Int,2}((2, 3))
    end

    @testset "Outer Constructors" begin
        @test_throws DimensionMismatch SizedArray([3, 4])
        @test SizedArray{Tuple{2},Int,1}([3, 4]).data == [3, 4]
        @test SizedArray{Tuple{2},Int,1,1}([3, 4]).data == [3, 4]

        # From Array
        @test @inferred(SizedArray{Tuple{2},Float64,1,1}([1,2]))::SizedArray{Tuple{2},Float64,1,1} == [1.0, 2.0]
        @test @inferred(SizedArray{Tuple{2},Float64,1}([1,2]))::SizedArray{Tuple{2},Float64,1,1} == [1.0, 2.0]
        @test @inferred(SizedArray{Tuple{2},Float64}([1,2]))::SizedArray{Tuple{2},Float64,1,1} == [1.0, 2.0]
        @test @inferred(SizedArray{Tuple{2}}([1,2]))::SizedArray{Tuple{2},Int,1,1} == [1,2]
        @test @inferred(SizedArray{Tuple{2,2}}([1 2;3 4]))::SizedArray{Tuple{2,2},Int,2,2} == [1 2; 3 4]
        # From Array, reshaped
        @test @inferred(SizedArray{Tuple{2,2}}([1,2,3,4]))::SizedArray{Tuple{2,2},Int,2,1} == [1 3; 2 4]
        @test SizedArray{Tuple{4}}([1 2; 3 4]) == vec([1 2; 3 4])
        @test_throws DimensionMismatch SizedArray{Tuple{1,4}}([1 2; 3 4])
        # Uninitialized
        @test @inferred(SizedArray{Tuple{2,2},Int,2,2,Matrix{Int}}(undef)) isa SizedArray{Tuple{2,2},Int,2,2,Matrix{Int}}
        @test @inferred(SizedArray{Tuple{2,2},Int,2,2}(undef)) isa SizedArray{Tuple{2,2},Int,2,2,Matrix{Int}}
        @test @inferred(SizedArray{Tuple{2,2},Int,2,1}(undef)) isa SizedArray{Tuple{2,2},Int,2,1,Vector{Int}}
        @test @inferred(SizedArray{Tuple{2,2},Int,2}(undef)) isa SizedArray{Tuple{2,2},Int,2,2,Matrix{Int}}
        @test @inferred(SizedArray{Tuple{2,2},Int}(undef)) isa SizedArray{Tuple{2,2},Int,2,2,Matrix{Int}}
        @test size(SizedArray{Tuple{4,5},Int,2}(undef).data) == (4, 5)
        @test size(SizedArray{Tuple{4,5},Int}(undef).data) == (4, 5)

        # 0-element constructor
        @test (@inferred SizedArray(MMatrix{0,0,Float64}()))::SizedMatrix{0,0,Float64} == SizedMatrix{0,0,Float64}()

        # From Tuple
        @test @inferred(SizedArray{Tuple{2},Float64,1,1}((1,2)))::SizedArray{Tuple{2},Float64,1,1,Vector{Float64}} == [1.0, 2.0]
        @test @inferred(SizedArray{Tuple{2},Float64,1}((1,2)))::SizedArray{Tuple{2},Float64,1,1,Vector{Float64}} == [1.0, 2.0]
        @test @inferred(SizedArray{Tuple{2},Float64}((1,2)))::SizedArray{Tuple{2},Float64,1,1,Vector{Float64}} == [1.0, 2.0]
        @test @inferred(SizedArray{Tuple{2}}((1,2)))::SizedArray{Tuple{2},Int,1,1,Vector{Int}} == [1,2]
        @test @inferred(SizedArray{Tuple{2,2}}((1,2,3,4)))::SizedArray{Tuple{2,2},Int,2,2,Matrix{Int}} == [1 3; 2 4]
        @test @inferred(SizedArray{Tuple{2,2},Int,2,1}((1,2,3,4)))::SizedArray{Tuple{2,2},Int,2,1,Vector{Int}} == [1 3; 2 4]
        @test SizedArray{Tuple{2},Int,1}((3, 4)).data == [3, 4]

        # Dimension 0
        @test SizedArray{Tuple{},Int,0,1}((2,)).data == [2]
        @test SizedArray{Tuple{},Int,0}((2,)).data == fill(2)
        @test SizedArray{Tuple{},Int}((2,)).data == fill(2)
    end

    @testset "SizedVector and SizedMatrix" begin
        @test @inferred(SizedVector{2}([1,2]))::SizedArray{Tuple{2},Int,1,1,Vector{Int}} == [1,2]
        @test @inferred(SizedVector{2}((1,2)))::SizedArray{Tuple{2},Int,1,1,Vector{Int}} == [1,2]
        @test @inferred(SizedVector{0,Int}(()))::SizedArray{Tuple{0},Int,1,1,Vector{Int}} == []
        # Reshaping
        @test @inferred(SizedVector{2}([1 2]))::SizedArray{Tuple{2},Int,1,1,Vector{Int}} == [1,2]
        # Back to Vector
        @test Vector(SizedVector{2}((1,2))) == [1,2]
        @test convert(Vector, SizedVector{2}((1,2))) == [1,2]

        # 0-element constructor
        @test (@inferred SizedVector(MVector{0,Float64}()))::SizedVector{0,Float64} == SizedVector{0,Float64}()

        @test @inferred(SizedMatrix{2,2}([1 2; 3 4]))::SizedArray{Tuple{2,2},Int,2,2,Matrix{Int}} == [1 2; 3 4]
        # Reshaping
        @test @inferred(SizedMatrix{2,2}([1,2,3,4]))::SizedArray{Tuple{2,2},Int,2,1} == [1 3; 2 4]
        @test @inferred(SizedMatrix{2,2}((1,2,3,4)))::SizedArray{Tuple{2,2},Int,2,2} == [1 3; 2 4]
        @test @inferred(SizedMatrix{2,2,Int}(SVector(1,2,3,4)))::SizedMatrix{2,2,Int,2} == [1 3; 2 4]
        @test @inferred(SizedMatrix{2,2,Int,1}(SVector(1,2,3,4)))::SizedMatrix{2,2,Int,1} == [1 3; 2 4]
        @test @inferred(SizedMatrix{2,2,Int,1,SVector{4,Int}}(SVector(1,2,3,4)))::SizedMatrix{2,2,Int,1} == [1 3; 2 4]
        # Back to Matrix
        @test Matrix(SizedMatrix{2,2}([1 2;3 4])) == [1 2; 3 4]
        @test convert(Matrix, SizedMatrix{2,2}([1 2;3 4])) == [1 2; 3 4]

        # 0-element constructor
        @test (@inferred SizedMatrix(MMatrix{0,0,Float64}()))::SizedMatrix{0,0,Float64} == SizedMatrix{0,0,Float64}()
    end

    # setindex
    @testset "setindex" begin
        sa = SizedArray{Tuple{2}, Int, 1}([3, 4])
        sa[1] = 2
        @test sa.data == [2, 4]
        @test setindex!(sa, 2, 1) === sa

        sm = SizedArray{Tuple{4,3}}(rand(4, 3))
        sm[1] = 2
        @test sa.data[1] == 2
        sm[2, 3] = 4
        @test sm.data[2, 3] == 4
        @test setindex!(sm, 0.5, 1) === sm
        @test setindex!(sm, 0.5, 2, 3) === sm
    end

    # parent
    sa = SizedArray{Tuple{2}, Int, 1}([3, 4])
    @test parent(sa) === sa.data

    # pointer
    @testset "pointer" begin
        @test Base.cconvert(Ptr{Int}, sa) === Base.cconvert(Ptr{Int}, sa.data)
        @test pointer(sa) === pointer(sa.data)

        A = MMatrix{32,3,Float64}(undef);
        av1 = view(A, 1, :);
        av2 = view(A, :, 1);
        @test pointer(A) == pointer(av1) == pointer(av2)
        @test pointer(A, LinearIndices(A)[1,2]) == pointer(av1, 2)
        @test pointer(A, LinearIndices(A)[2,1]) == pointer(av2, 2)
        @test pointer(A, LinearIndices(A)[4,3]) == pointer(view(A, :, 3), 4) == pointer(view(A, 4, :), 3)
    end
    
    @testset "vec" begin
        sa2 = SizedArray{Tuple{2, 2}, Int}([1, 2, 3, 4])
        @test (@inferred vec(sa2)) isa SizedVector{4, Int}
        @test vec(sa2).data === vec(sa2.data)

        M = @MMatrix [1 2; 3 4]
        @test copy(vec(M)) isa SizedVector{4, Int}
    end

    @testset "aliasing" begin
        a1 = rand(4)
        a2 = copy(a1)
        sa1 = SizedVector{4}(a1)
        sa2 = SizedVector{4}(a2)
        @test Base.mightalias(a1, sa1)
        @test Base.mightalias(sa1, SizedVector{4}(a1))
        @test !Base.mightalias(a2, sa1)
        @test !Base.mightalias(sa1, SizedVector{4}(a2))
        @test Base.mightalias(sa1, view(sa1, 1:2))
        @test Base.mightalias(a1, view(sa1, 1:2))
        @test Base.mightalias(sa1, view(a1, 1:2))
    end

    @testset "back to Array" begin
        @test Array(SizedArray{Tuple{2}, Int, 1}([3, 4])) == [3, 4]
        @test Array{Int}(SizedArray{Tuple{2}, Int, 1}([3, 4])) == [3, 4]
        @test Array{Int, 1}(SizedArray{Tuple{2}, Int, 1}([3, 4])) == [3, 4]
        @test Vector(SizedArray{Tuple{4}, Int, 1}(collect(3:6))) == collect(3:6)
        @test convert(Vector, SizedArray{Tuple{4}, Int, 1}(collect(3:6))) == collect(3:6)
        @test Matrix(SMatrix{2,2}((1,2,3,4))) == [1 3; 2 4]
        @test convert(Matrix, SMatrix{2,2}((1,2,3,4))) == [1 3; 2 4]
        @test convert(Array, SizedArray{Tuple{2,2,2,2}, Int}(ones(2,2,2,2))) == ones(2,2,2,2)
        # Conversion after reshaping
        @test Array(SizedMatrix{2,2}([1,2,3,4])) == [1 3; 2 4]
        # Array(a::Array) makes a copy so this should work similarly
        a = [1 2; 3 4]
        @test Array(SizedMatrix{2,2}(a)) !== a
        @test @inferred(convert(Array, SizedMatrix{2,2}(a))) === a
        @test @inferred(convert(Array{Int}, SizedMatrix{2,2}(a))) === a
        @test @inferred(convert(Matrix{Int}, SizedMatrix{2,2}(a))) === a
        @test @inferred(convert(Matrix{Float64}, SizedMatrix{2,2}(a))) == a
    end

    @testset "promotion" begin
        @test @inferred(promote_type(SizedVector{1,Float64}, SizedVector{1,BigFloat})) == SizedVector{1,BigFloat}
        @test @inferred(promote_type(SizedVector{2,Int}, SizedVector{2,Float64})) === SizedVector{2,Float64}
        @test @inferred(promote_type(SizedMatrix{2,3,Float32,2}, SizedMatrix{2,3,Complex{Float64},2})) === SizedMatrix{2,3,Complex{Float64},2}
        @test @inferred(promote_type(SizedArray{Tuple{2,2},Float64,2,2,Matrix{Float64}}, SizedArray{Tuple{2,2},BigFloat,2,2,Matrix{BigFloat}})) == SizedArray{Tuple{2,2},BigFloat,2,2,Matrix{BigFloat}}
    end

    @testset "reshaping" begin
        y = rand(4,1,2)
        sy = SizedArray{Tuple{size(y)...}}(y)

        @test vec(sy) isa SizedArray{Tuple{8}, Float64}
        @test reshape(sy, Size(2,4)) isa SizedArray{Tuple{2, 4}, Float64}
    end

    @testset "sized views" begin
        x = rand(4,1,2)
        y = SizedMatrix{4,2}(view(x, :, 1, :))

        @test isa(y, SizedArray{Tuple{4,2},Float64,2,2,<:SubArray{Float64,2}})
        @test Array(y) isa Matrix{Float64}
        @test Array(y) == x[:, 1, :]
        @test convert(Array, y) isa Matrix{Float64}
        @test convert(Array, y) == x[:, 1, :]
        y[3, 2] = 18
        @test x[3, 1, 2] == 18

        x2 = rand(10)
        y2 = SizedMatrix{4,2}(view(x2, 1:8))
        @test isa(y2, SizedArray{Tuple{4,2},Float64,2,1,<:SubArray{Float64,1}})
        @test Array(y2) isa Matrix{Float64}
        @test Array(y2) == reshape(x2[1:8], 4, 2)
        @test convert(Array, y2) isa Matrix{Float64}
        @test convert(Array, y2) == reshape(x2[1:8], 4, 2)
    end

    @testset "views of sized arrays" begin
        x = SizedArray{Tuple{4,3,2}}(rand(4, 3, 2))
        x1 = view(x, :, 1, 2)
        @test isa(x1, SizedArray{Tuple{4},Float64,1,1,<:SubArray{Float64,1}})
        @test x1 == view(x.data, :, 1, 2)

        x2 = view(x, :, SA[1], 2)
        @test isa(x2, SizedArray{Tuple{4,1},Float64,2,2,<:SubArray{Float64,2}})
        @test x2 == view(x.data, :, SA[1], 2)

        x3 = view(x, SOneTo(3), 1, SA[2])
        @test isa(x3, SizedArray{Tuple{3,1},Float64,2,2,<:SubArray{Float64,2}})
        @test x3 == view(x.data, SOneTo(3), 1, SA[2])

        x4 = view(x, Base.Slice(SOneTo(4)), 1, SA[2])
        @test isa(x4, SizedArray{Tuple{4,1},Float64,2,2,<:SubArray{Float64,2}})
        @test x4 == view(x.data, Base.Slice(SOneTo(4)), 1, SA[2])

        x5 = view(x, :)
        @test isa(x5, SizedArray{Tuple{24},Float64,1,1,<:SubArray{Float64,1}})
        @test x5 == view(x.data, :)

        x6 = view(x, StaticArrays.SUnitRange(2, 3), :, 2)
        @test isa(x6, SizedArray{Tuple{2,3},Float64,2,2,<:SubArray{Float64,2}})
        @test x6 == view(x.data, StaticArrays.SUnitRange(2, 3), :, 2)

        x7 = view(x, :, SA[true, false, true], 1)
        @test x7 == view(x.data, :, SA[true, false, true], 1)
    end

    @testset "views of MArray" begin
        x = MArray{Tuple{4,3,2}}(rand(4, 3, 2))
        x1 = view(x, :, 1, 2)
        @test isa(x1, SizedArray{Tuple{4},Float64,1,1,<:SubArray{Float64,1}})
        @test x1 == view(Array(x), :, 1, 2)

        x2 = view(x, :, SA[1], 2)
        @test isa(x2, SizedArray{Tuple{4,1},Float64,2,2,<:SubArray{Float64,2}})
        @test x2 == view(Array(x), :, SA[1], 2)

        x3 = view(x, SOneTo(3), 1, SA[2])
        @test isa(x3, SizedArray{Tuple{3,1},Float64,2,2,<:SubArray{Float64,2}})
        @test x3 == view(Array(x), SOneTo(3), 1, SA[2])

        x4 = view(x, Base.Slice(SOneTo(4)), 1, SA[2])
        @test isa(x4, SizedArray{Tuple{4,1},Float64,2,2,<:SubArray{Float64,2}})
        @test x4 == view(Array(x), Base.Slice(SOneTo(4)), 1, SA[2])

        x5 = view(x, :)
        @test isa(x5, SizedArray{Tuple{24},Float64,1,1,<:SubArray{Float64,1}})
        @test x5 == view(Array(x5), :)
    end

    @testset "reverse" begin
        x = SizedArray{Tuple{4,3,2}}(rand(4, 3, 2))
        @test reverse(x) == reverse(reverse(reverse(collect(x), dims = 3), dims = 2), dims = 1)
    end
end

struct OVector <: AbstractVector{Int} end
Base.length(::OVector) = 10
Base.axes(::OVector) = (0:9,)
@test_throws ArgumentError SizedVector{10}(OVector())

@testset "some special case" begin
    @test_throws Exception SizedVector{1}(1, 2)
    @test (@inferred(SizedVector{1}((1, 2)))::SizedVector{1,NTuple{2,Int}}) == [(1, 2)]
    @test (@inferred(SizedVector{2}((1, 2)))::SizedVector{2,Int}) == [1, 2]
    @test (@inferred(SizedVector(1, 2))::SizedVector{2,Int}) == [1, 2]
    @test (@inferred(SizedVector((1, 2)))::SizedVector{2,Int}) == [1, 2]

    @test_throws Exception SizedMatrix{1,1}(1, 2)
    @test (@inferred(SizedMatrix{1,1}((1, 2)))::SizedMatrix{1,1,NTuple{2,Int}}) == fill((1, 2),1,1)
    @test (@inferred(SizedMatrix{1,2}((1, 2)))::SizedMatrix{1,2,Int}) == reshape(1:2, 1, 2)
    @test (@inferred(SizedMatrix{1}((1, 2)))::SizedMatrix{1,2,Int}) == reshape(1:2, 1, 2)
    @test (@inferred(SizedMatrix{1}(1, 2))::SizedMatrix{1,2,Int}) == reshape(1:2, 1, 2)
    @test (@inferred(SizedMatrix{2}((1, 2)))::SizedMatrix{2,1,Int}) == reshape(1:2, 2, 1)
    @test (@inferred(SizedMatrix{2}(1, 2))::SizedMatrix{2,1,Int}) == reshape(1:2, 2, 1)
end

@noinline function generator_too_short_error(inds::CartesianIndices, i::CartesianIndex)
    n = LinearIndices(inds)[i] - 1
    error("Generator produced too few elements: Expected exactly $(shape_string(inds)) elements, but got $(n)")
end
@noinline function generator_too_long_error(inds::CartesianIndices)
    error("Generator produced too many elements: Expected exactly $(shape_string(inds)) elements, but generator yields more")
end

shape_string(inds::CartesianIndices) = join(length.(inds.indices), '×')

@inline throw_if_nothing(x, inds, i) =
    (x === nothing && generator_too_short_error(inds, i); x)

@generated function sacollect(::Type{SA}, gen) where {SA <: StaticArray{S}} where {S <: Tuple}
    stmts = [:(@_inline_meta)]
    args = []
    iter = :(iterate(gen))
    inds = CartesianIndices(size_to_tuple(S))
    for i in inds
        el = Symbol(:el, i)
        push!(stmts, :(($el,st) = throw_if_nothing($iter, $inds, $i)))
        push!(args, el)
        iter = :(iterate(gen,st))
    end
    push!(stmts, :($iter === nothing || generator_too_long_error($inds)))
    push!(stmts, :(SA(($(args...),))))
    Expr(:block, stmts...)
end
"""
    sacollect(SA, gen)

Construct a statically-sized vector of type `SA`.from a generator
`gen`. `SA` needs to have a size parameter since the length of `vec`
is unknown to the compiler. `SA` can optionally specify the element
type as well.

Example:
```julia
sacollect(SVector{3, Int}, 2i+1 for i in 1:3)
sacollect(SMatrix{2, 3}, i+j for i in 1:2, j in 1:3)
sacollect(SArray{2, 3}, i+j for i in 1:2, j in 1:3)
```

This creates the same statically-sized vector as if the generator were
collected in an array, but is more efficient since no array is
allocated.

Equivalent:

```julia
SVector{3, Int}([2i+1 for i in 1:3])
```
"""
sacollect

@inline (::Type{SA})(gen::Base.Generator) where {SA <: StaticArray} =
    sacollect(SA, gen)

####################
## SArray methods ##
####################

@propagate_inbounds function getindex(v::SArray, i::Int)
    getfield(v,:data)[i]
end

@inline Base.Tuple(v::SArray) = getfield(v,:data)

Base.dataids(::SArray) = ()

# See #53
Base.cconvert(::Type{Ptr{T}}, a::SArray) where {T} = Base.RefValue(a)
Base.unsafe_convert(::Type{Ptr{T}}, a::Base.RefValue{SA}) where {S,T,D,L,SA<:SArray{S,T,D,L}} =
    Ptr{T}(Base.unsafe_convert(Ptr{SArray{S,T,D,L}}, a))

# Handle nested cat ast.
_cat_ndims(x) = 0
_cat_ndims(x::AbstractArray) = ndims(x)
_cat_size(x, _) = 1
_cat_size(x::AbstractArray, i) = size(x, i)
_cat_sizes(x, dims) = ntuple(i -> _cat_size(x, i), dims)

function cat_any(::Val{maxdim}, ::Val{catdim}, args::Vector{Any}) where {maxdim,catdim}
    szs = Dims{maxdim}[_cat_sizes(a, Val(maxdim)) for a in args]
    out = Array{Any}(undef, check_cat_size(szs, catdim))
    dims_before = ntuple(_ -> (:), Val(catdim-1))
    dims_after = ntuple(_ -> (:), Val(maxdim-catdim))
    cat_any!(out, dims_before, dims_after, args)
end

function cat_any!(out, dims_before, dims_after, args::Vector{Any})
    catdim = length(dims_before) + 1
    i = 0
    @views for arg in args
        len = _cat_size(arg, catdim)
        dest = out[dims_before..., i+1:i+len, dims_after...]
        if arg isa AbstractArray
            copyto!(dest, arg)
        else
            dest[] = arg
        end
        i += len
    end
    out
end

@noinline cat_mismatch(j,sz,nsz) = throw(DimensionMismatch("mismatch in dimension $j (expected $sz got $nsz)"))
function check_cat_size(szs::Vector{Dims{maxdim}}, catdim) where {maxdim}
    isempty(szs) && return ntuple(_ -> 0, Val(maxdim))
    sz = szs[1]
    catsz = sz[catdim]
    for i in 2:length(szs)
        for j in 1:maxdim
            nszⱼ = szs[i][j]
            if j == catdim
                catsz += nszⱼ
            elseif sz[j] != nszⱼ
                cat_mismatch(j, sz[j], nszⱼ)
            end
        end
    end
    return Base.setindex(sz, catsz, catdim)
end

parse_cat_ast(x) = x
function parse_cat_ast(ex::Expr)
    head, args = ex.head, ex.args
    head === :vect && return args
    i = 0
    if head === :typed_vcat || head === :typed_hcat || head === :typed_ncat
        i += 1 # skip Type arg
    end
    if head === :vcat || head === :typed_vcat
        catdim = 1
    elseif head === :hcat || head === :row || head === :typed_hcat
        catdim = 2
    elseif head === :ncat || head === :typed_ncat || head === :nrow
        catdim = args[i+=1]::Int
    else
        return ex
    end
    nargs = Any[parse_cat_ast(args[k]) for k in i+1:length(args)]
    maxdim = maximum(_cat_ndims, nargs; init = catdim)
    cat_any(Val(maxdim), Val(catdim), nargs)
end

#=
For example,
* `@SArray rand(2, 3, 4)`
* `@SArray rand(rng, 3, 4)`
will be expanded to the following.
* `_rand_with_Val(SArray, 2, 3, _int2val(2),   _int2val(3), Val((4,)))`
* `_rand_with_Val(SArray, 2, 3, _int2val(rng), _int2val(3), Val((4,)))`
The function `_int2val` is required to avoid the following case.
* `_rand_with_Val(SArray, 2, 3, Val(2),   Val(3), Val((4,)))`
* `_rand_with_Val(SArray, 2, 3, Val(rng), Val(3), Val((4,)))`
Mutable object such as `rng` cannot be type parameter, and `Val(rng)` throws an error.
=#
_int2val(x::Int) = Val(x)
_int2val(::Any) = nothing
# @SArray zeros(...)
_zeros_with_Val(::Type{SA}, ::Int,       ::Val{n1}, ::Val{ns}) where {SA, n1, ns} = zeros(SA{Tuple{n1, ns...}})
_zeros_with_Val(::Type{SA}, T::DataType, ::Val,     ::Val{ns}) where {SA, ns} = zeros(SA{Tuple{ns...}, T})
# @SArray ones(...)
_ones_with_Val(::Type{SA}, ::Int,       ::Val{n1}, ::Val{ns}) where {SA, n1, ns} = ones(SA{Tuple{n1, ns...}})
_ones_with_Val(::Type{SA}, T::DataType, ::Val,     ::Val{ns}) where {SA, ns} = ones(SA{Tuple{ns...}, T})
# @SArray rand(...)
@inline _rand_with_Val(::Type{SA}, ::Int,            ::Int,       ::Val{n1}, ::Val{n2}, ::Val{ns}) where {SA, n1, n2, ns} = rand(SA{Tuple{n1,n2,ns...}})
@inline _rand_with_Val(::Type{SA}, T::DataType,      ::Int,       ::Nothing, ::Val{n1}, ::Val{ns}) where {SA, n1, ns} = _rand(Random.GLOBAL_RNG, T, Size(n1, ns...), SA{Tuple{n1, ns...}, T})
@inline _rand_with_Val(::Type{SA}, sampler,          ::Int,       ::Nothing, ::Val{n1}, ::Val{ns}) where {SA, n1, ns} = _rand(Random.GLOBAL_RNG, sampler, Size(n1, ns...), SA{Tuple{n1, ns...}, Random.gentype(sampler)})
@inline _rand_with_Val(::Type{SA}, rng::AbstractRNG, ::Int,       ::Nothing, ::Val{n1}, ::Val{ns}) where {SA, n1, ns} = _rand(rng, Float64, Size(n1, ns...), SA{Tuple{n1, ns...}, Float64})
@inline _rand_with_Val(::Type{SA}, rng::AbstractRNG, T::DataType, ::Nothing, ::Nothing, ::Val{ns}) where {SA, ns} = _rand(rng, T, Size(ns...), SA{Tuple{ns...}, T})
@inline _rand_with_Val(::Type{SA}, rng::AbstractRNG, sampler,     ::Nothing, ::Nothing, ::Val{ns}) where {SA, ns} = _rand(rng, sampler, Size(ns...), SA{Tuple{ns...}, Random.gentype(sampler)})
# @SArray randn(...)
@inline _randn_with_Val(::Type{SA}, ::Int,            ::Int,       ::Val{n1}, ::Val{n2}, ::Val{ns}) where {SA, n1, n2, ns} = randn(SA{Tuple{n1,n2,ns...}})
@inline _randn_with_Val(::Type{SA}, T::DataType,      ::Int,       ::Nothing, ::Val{n1}, ::Val{ns}) where {SA, n1, ns} = _randn(Random.GLOBAL_RNG, Size(n1, ns...), SA{Tuple{n1, ns...}, T})
@inline _randn_with_Val(::Type{SA}, rng::AbstractRNG, ::Int,       ::Nothing, ::Val{n1}, ::Val{ns}) where {SA, n1, ns} = _randn(rng, Size(n1, ns...), SA{Tuple{n1, ns...}, Float64})
@inline _randn_with_Val(::Type{SA}, rng::AbstractRNG, T::DataType, ::Nothing, ::Nothing, ::Val{ns}) where {SA, ns} = _randn(rng, Size(ns...), SA{Tuple{ns...}, T})
# @SArray randexp(...)
@inline _randexp_with_Val(::Type{SA}, ::Int,            ::Int,       ::Val{n1}, ::Val{n2}, ::Val{ns}) where {SA, n1, n2, ns} = randexp(SA{Tuple{n1,n2,ns...}})
@inline _randexp_with_Val(::Type{SA}, T::DataType,      ::Int,       ::Nothing, ::Val{n1}, ::Val{ns}) where {SA, n1, ns} = _randexp(Random.GLOBAL_RNG, Size(n1, ns...), SA{Tuple{n1, ns...}, T})
@inline _randexp_with_Val(::Type{SA}, rng::AbstractRNG, ::Int,       ::Nothing, ::Val{n1}, ::Val{ns}) where {SA, n1, ns} = _randexp(rng, Size(n1, ns...), SA{Tuple{n1, ns...}, Float64})
@inline _randexp_with_Val(::Type{SA}, rng::AbstractRNG, T::DataType, ::Nothing, ::Nothing, ::Val{ns}) where {SA, ns} = _randexp(rng, Size(ns...), SA{Tuple{ns...}, T})

escall(args) = Iterators.map(esc, args)
function _isnonnegvec(args)
    length(args) == 0 && return false
    all(isa.(args, Integer)) && return all(args .≥ 0)
    return false
end
function static_array_gen(::Type{SA}, @nospecialize(ex), mod::Module) where {SA}
    if !isa(ex, Expr)
        error("Bad input for @$SA")
    end
    head = ex.head
    if head === :vect    # vector
        return :($SA{Tuple{$(length(ex.args))}}($tuple($(escall(ex.args)...))))
    elseif head === :ref # typed, vector
        return :($SA{Tuple{$(length(ex.args)-1)},$(esc(ex.args[1]))}($tuple($(escall(ex.args[2:end])...))))
    elseif head === :typed_vcat || head === :typed_hcat || head === :typed_ncat # typed, cat
        args = parse_cat_ast(ex)
        return :($SA{Tuple{$(size(args)...)},$(esc(ex.args[1]))}($tuple($(escall(args)...))))
    elseif head === :vcat || head === :hcat || head === :ncat # untyped, cat
        args = parse_cat_ast(ex)
        return :($SA{Tuple{$(size(args)...)}}($tuple($(escall(args)...))))
    elseif head === :comprehension
        if length(ex.args) != 1
            error("Expected generator in comprehension, e.g. [f(i,j) for i = 1:3, j = 1:3]")
        end
        ex = ex.args[1]
        if !isa(ex, Expr) || (ex::Expr).head != :generator
            error("Expected generator in comprehension, e.g. [f(i,j) for i = 1:3, j = 1:3]")
        end
        n_rng = length(ex.args) - 1
        rng_args = (ex.args[i+1].args[1] for i = 1:n_rng)
        rngs = Any[Core.eval(mod, ex.args[i+1].args[2]) for i = 1:n_rng]
        exprs = (:(f($(j...))) for j in Iterators.product(rngs...))
        return quote
            let
                f($(escall(rng_args)...)) = $(esc(ex.args[1]))
                $SA{Tuple{$(size(exprs)...)}}($tuple($(exprs...)))
            end
        end
    elseif head === :typed_comprehension
        if length(ex.args) != 2
            error("Expected generator in typed comprehension, e.g. Float64[f(i,j) for i = 1:3, j = 1:3]")
        end
        T = esc(ex.args[1])
        ex = ex.args[2]
        if !isa(ex, Expr) || (ex::Expr).head != :generator
            error("Expected generator in typed comprehension, e.g. Float64[f(i,j) for i = 1:3, j = 1:3]")
        end
        n_rng = length(ex.args) - 1
        rng_args = (ex.args[i+1].args[1] for i = 1:n_rng)
        rngs = Any[Core.eval(mod, ex.args[i+1].args[2]) for i = 1:n_rng]
        exprs = (:(f($(j...))) for j in Iterators.product(rngs...))
        return quote
            let
                f($(escall(rng_args)...)) = $(esc(ex.args[1]))
                $SA{Tuple{$(size(exprs)...)},$T}($tuple($(exprs...)))
            end
        end
    elseif head === :call
        f = ex.args[1]
        fargs = ex.args[2:end]
        if f === :zeros || f === :ones
            _f_with_Val = Symbol(:_, f, :_with_Val)
            if length(fargs) == 0
                # for calls like `zeros()`
                return :($f($SA{Tuple{},$Float64}))
            elseif _isnonnegvec(fargs)
                # for calls like `zeros(dims...)`
                return :($f($SA{Tuple{$(escall(fargs)...)}}))
            else
                # for calls like `zeros(type)`
                # for calls like `zeros(type, dims...)`
                return :($_f_with_Val($SA, $(esc(fargs[1])), Val($(esc(fargs[1]))), Val(tuple($(escall(fargs[2:end])...)))))
            end
        elseif f === :fill
            # for calls like `fill(value, dims...)`
            return :($f($(esc(fargs[1])), $SA{Tuple{$(escall(fargs[2:end])...)}}))
        elseif f === :rand || f === :randn || f === :randexp
            _f_with_Val = Symbol(:_, f, :_with_Val)
            if length(fargs) == 0
                # No support for `@SArray rand()`
                error("@$SA got bad expression: $(ex)")
            elseif _isnonnegvec(fargs)
                # for calls like `rand(dims...)`
                return :($f($SA{Tuple{$(escall(fargs)...)}}))
            elseif length(fargs) ≥ 2
                # for calls like `rand(dim1,    dim2,    dims...)`
                # for calls like `rand(type,    dim1,    dims...)`
                # for calls like `rand(sampler, dim1,    dims...)`
                # for calls like `rand(rng,     dim1,    dims...)`
                # for calls like `rand(rng,     type,    dims...)`
                # for calls like `rand(rng,     sampler, dims...)`
                # for calls like `randn(dim1, dim2, dims...)`
                # for calls like `randn(type, dim1, dims...)`
                # for calls like `randn(rng,  dim1, dims...)`
                # for calls like `randn(rng,  type, dims...)`
                # for calls like `randexp(dim1, dim2, dims...)`
                # for calls like `randexp(type, dim1, dims...)`
                # for calls like `randexp(rng,  dim1, dims...)`
                # for calls like `randexp(rng,  type, dims...)`
                return :($_f_with_Val($SA, $(esc(fargs[1])), $(esc(fargs[2])), _int2val($(esc(fargs[1]))), _int2val($(esc(fargs[2]))), Val(tuple($(escall(fargs[3:end])...)))))
            elseif length(fargs) == 1
                # for calls like `rand(dim)`
                return :($f($SA{Tuple{$(escall(fargs)...)}}))
            else
                error("@$SA got bad expression: $(ex)")
            end
        else
            error("@$SA only supports the zeros(), ones(), fill(), rand(), randn(), and randexp() functions.")
        end
    else
        error("Bad input for @$SA")
    end
end

"""
    @SArray [a b; c d]
    @SArray [[a, b];[c, d]]
    @SArray [i+j for i in 1:2, j in 1:2]
    @SArray ones(2, 2, 2)

A convenience macro to construct `SArray` with arbitrary dimension.
It supports:
1. (typed) array literals.
   !!! note
       Every argument inside the square brackets is treated as a scalar during expansion.
       Thus `@SArray[a; b]` always forms a `SVector{2}` and `@SArray [a b; c]` always throws
       an error.

2. comprehensions
   !!! note
       The range of a comprehension is evaluated at global scope by the macro, and must be
       made of combinations of literal values, functions, or global variables.

3. initialization functions
   !!! note
       Only support `zeros()`, `ones()`, `fill()`, `rand()`, `randn()`, and `randexp()`
"""
macro SArray(ex)
    static_array_gen(SArray, ex, __module__)
end

function promote_rule(::Type{<:SArray{S,T,N,L}}, ::Type{<:SArray{S,U,N,L}}) where {S,T,U,N,L}
    SArray{S,promote_type(T,U),N,L}
end

"""
    push(vec::StaticVector, item)

Return a new `StaticVector` with `item` inserted on the end of `vec`.

# Examples
```jldoctest
julia> push(@SVector[1, 2, 3], 4)
4-element SVector{4, Int64} with indices SOneTo(4):
 1
 2
 3
 4
```
"""
@inline push(vec::StaticVector, x) = _push(Size(vec), vec, x)
@generated function _push(::Size{s}, vec::StaticVector, x) where {s}
    newlen = s[1] + 1
    exprs = vcat([:(vec[$i]) for i = 1:s[1]], :x)
    return quote
        @_inline_meta
        @inbounds return similar_type(vec, Size($newlen))(tuple($(exprs...)))
    end
end

"""
    pushfirst(vec::StaticVector, item)

Return a new `StaticVector` with `item` inserted at the beginning of `vec`.

# Examples
```jldoctest
julia> pushfirst(@SVector[1, 2, 3, 4], 5)
5-element SVector{5, Int64} with indices SOneTo(5):
 5
 1
 2
 3
 4
```
"""
@inline pushfirst(vec::StaticVector, x) = _pushfirst(Size(vec), vec, x)
@generated function _pushfirst(::Size{s}, vec::StaticVector, x) where {s}
    newlen = s[1] + 1
    exprs = vcat(:x, [:(vec[$i]) for i = 1:s[1]])
    return quote
        @_inline_meta
        @inbounds return similar_type(vec, Size($newlen))(tuple($(exprs...)))
    end
end

"""
    insert(vec::StaticVector, index::Integer, item)

Return a new vector with `item` inserted into `vec` at the given `index`.

# Examples
```jldoctest
julia> insert(@SVector[6, 5, 4, 2, 1], 4, 3)
6-element SVector{6, Int64} with indices SOneTo(6):
 6
 5
 4
 3
 2
 1
```
"""
@propagate_inbounds insert(vec::StaticVector, index, x) = _insert(Size(vec), vec, index, x)
@generated function _insert(::Size{s}, vec::StaticVector, index, x) where {s}
    newlen = s[1] + 1
    exprs = [(i == 1 ? :(if $i < index; vec[$i] else x; end) :
              i == newlen ? :(ifelse($i == index, x, vec[$i-1])) :
              :(ifelse($i < index, vec[$i], ifelse($i == index, x, vec[$i-1])))) for i = 1:newlen]
    return quote
        @_propagate_inbounds_meta
        @boundscheck if (index < 1 || index > $newlen)
            throw(BoundsError(vec, index))
        end
        @inbounds return similar_type(vec, Size($newlen))(tuple($(exprs...)))
    end
end

"""
    pop(vec::StaticVector)

Return a new vector with the last item in `vec` removed.

# Examples
```jldoctest
julia> pop(@SVector[1,2,3])
2-element SVector{2, Int64} with indices SOneTo(2):
 1
 2
```
"""
@inline pop(vec::StaticVector) = _pop(Size(vec), vec)
@generated function _pop(::Size{s}, vec::StaticVector) where {s}
    newlen = s[1] - 1
    exprs = [:(vec[$i]) for i = 1:s[1]-1]
    return quote
        @_inline_meta
        @inbounds return similar_type(vec, Size($newlen))(tuple($(exprs...)))
    end
end

"""
    popfirst(vec::StaticVector)

Return a new vector with the first item in `vec` removed.

# Examples
```jldoctest
julia> popfirst(@SVector[1,2,3])
2-element SVector{2, Int64} with indices SOneTo(2):
 2
 3
```
"""
@inline popfirst(vec::StaticVector) = _popfirst(Size(vec), vec)
@generated function _popfirst(::Size{s}, vec::StaticVector) where {s}
    newlen = s[1] - 1
    exprs = [:(vec[$i]) for i = 2:s[1]]
    return quote
        @_inline_meta
        @inbounds return similar_type(vec, Size($newlen))(tuple($(exprs...)))
    end
end

"""
    deleteat(vec::StaticVector, index::Integer)

Return a new vector with the item at the given `index` removed.

# Examples
```jldoctest
julia> deleteat(@SVector[6, 5, 4, 3, 2, 1], 2)
5-element SVector{5, Int64} with indices SOneTo(5):
 6
 4
 3
 2
 1
```
"""
@propagate_inbounds deleteat(vec::StaticVector, index) = _deleteat(Size(vec), vec, index)
@generated function _deleteat(::Size{s}, vec::StaticVector, index) where {s}
    newlen = s[1] - 1
    exprs = [:(ifelse($i < index, vec[$i], vec[$i+1])) for i = 1:newlen]
    return quote
        @_propagate_inbounds_meta
        @boundscheck if (index < 1 || index > $(s[1]))
            throw(BoundsError(vec, index))
        end
        @inbounds return similar_type(vec, Size($newlen))(tuple($(exprs...)))
    end
end

# TODO consider prepend, append (can use vcat, but eltype might change), and
# maybe splice (a bit hard to get statically sized without a "static" range)


# Immutable version of setindex!(). Seems similar in nature to the above, but
# could also be justified to live in src/indexing.jl
import Base.setindex
"""
    setindex(vec::StaticArray, x, index::Int)

Return a new array with the item at `index` replaced by `x`.

# Examples
```jldoctest
julia> setindex(@SVector[1,2,3], 4, 2)
3-element SVector{3, Int64} with indices SOneTo(3):
 1
 4
 3

julia> setindex(@SMatrix[2 4; 6 8], 1, 2)
2×2 SMatrix{2, 2, Int64, 4} with indices SOneTo(2)×SOneTo(2):
 2  4
 1  8
```
"""
@propagate_inbounds setindex(a::StaticArray, x, index::Int) = _setindex(Length(a), a, convert(eltype(typeof(a)), x), index)
@generated function _setindex(::Length{L}, a::StaticArray{<:Tuple,T}, x::T, index::Int) where {L, T}
    exprs = [:(ifelse($i == index, x, a[$i])) for i = 1:L]
    return quote
        @_propagate_inbounds_meta
        @boundscheck if (index < 1 || index > $(L))
            throw(BoundsError(a, index))
        end
        @inbounds return typeof(a)(tuple($(exprs...)))
    end
end

# TODO proper multidimension boundscheck
@propagate_inbounds setindex(a::StaticArray, x, inds...) = setindex(a, x, LinearIndices(a)[inds...])

import Base.Order: Forward, Ordering, Perm, ord
import Base.Sort: Algorithm, lt, sort, sortperm


struct BitonicSortAlg <: Algorithm end

const BitonicSort = BitonicSortAlg()


# BitonicSort has non-optimal asymptotic behaviour, so we define a cutoff
# length. This also prevents compilation time to skyrocket for larger vectors.
const _bitonic_sort_limit = 20
defalg(a::StaticVector) =
    isimmutable(a) && length(a) <= _bitonic_sort_limit ? BitonicSort : QuickSort

@inline function sort(a::StaticVector;
              alg::Algorithm = defalg(a),
              lt = isless,
              by = identity,
              rev::Union{Bool,Nothing} = nothing,
              order::Ordering = Forward)
    length(a) <= 1 && return a
    ordr = ord(lt, by, rev, order)
    return _sort(a, alg, ordr)
end

@inline function sortperm(a::StaticVector;
               alg::Algorithm = defalg(a),
               lt = isless,
               by = identity,
               rev::Union{Bool,Nothing} = nothing,
               order::Ordering = Forward)
    p = Tuple(axes(a, 1))
    length(a) <= 1 && return SVector{length(a),Int}(p)

    ordr = Perm(ord(lt, by, rev, order), a)
    return SVector{length(a),Int}(_sort(p, alg, ordr))
end


@inline _sort(a::StaticVector, alg, order) =
    similar_type(a)(sort!(copyto!(similar(a), a); alg=alg, order=order))

@inline _sort(a::StaticVector, alg::BitonicSortAlg, order) =
    similar_type(a)(_sort(Tuple(a), alg, order))

_sort(a::NTuple, alg, order) = sort!(collect(a); alg=alg, order=order)

# Implementation loosely following
# https://www.inf.hs-flensburg.de/lang/algorithmen/sortieren/bitonic/oddn.htm
@generated function _sort(a::NTuple{N}, ::BitonicSortAlg, order) where N
    function swap_expr(i, j, rev)
        ai = Symbol('a', i)
        aj = Symbol('a', j)
        return :( ($ai, $aj) = @inbounds lt(order, $ai, $aj) ⊻ $rev ? ($ai, $aj) : ($aj, $ai) )
    end

    function merge_exprs(idx, rev)
        exprs = Expr[]
        length(idx) == 1 && return exprs

        ci = 2^(ceil(Int, log2(length(idx))) - 1)
        # TODO: generate simd code for these swaps
        for i in first(idx):last(idx)-ci
            push!(exprs, swap_expr(i, i+ci, rev))
        end
        append!(exprs, merge_exprs(idx[1:ci], rev))
        append!(exprs, merge_exprs(idx[ci+1:end], rev))
        return exprs
    end

    function sort_exprs(idx, rev=false)
        exprs = Expr[]
        length(idx) == 1 && return exprs

        append!(exprs, sort_exprs(idx[1:end÷2], !rev))
        append!(exprs, sort_exprs(idx[end÷2+1:end], rev))
        append!(exprs, merge_exprs(idx, rev))
        return exprs
    end

    idx = 1:N
    symlist = (Symbol('a', i) for i in idx)
    return quote
        @_inline_meta
        ($(symlist...),) = a
        ($(sort_exprs(idx)...);)
        return ($(symlist...),)
    end
end

using StaticArrays, Test, LinearAlgebra, Random

broadenrandn(::Type{BigFloat}) = BigFloat(randn(Float64))
broadenrandn(::Type{Int}) = rand(-9:9)
broadenrandn(::Type{Complex{T}}) where T = Complex{T}(broadenrandn(T), broadenrandn(T))
broadenrandn(::Type{T}) where T = randn(T)

Random.seed!(42)
@testset "QR decomposition" begin
    function test_qr(arr)

        T = eltype(arr)

        QR = @inferred qr(arr)
        @test QR isa StaticArrays.QR
        Q, R = QR # destructing via iteration
        @test Q isa StaticMatrix
        @test R isa StaticMatrix
        @test eltype(Q) == eltype(R) == typeof((one(T)*zero(T) + zero(T))/norm([one(T)]))

        Q_ref, R_ref = qr(Matrix(arr))
        @test abs.(Q) ≈ abs.(Matrix(Q_ref)) # QR is unique up to diag(Q) signs
        @test abs.(R) ≈ abs.(R_ref)
        @test Q*R ≈ arr
        @test Q'*Q ≈ one(Q'*Q)
        @test istriu(R)

        # pivot=true cases has no StaticArrays specific version yet
        # but fallbacks to LAPACK
        pivot = isdefined(LinearAlgebra, :PivotingStrategy) ? ColumnNorm() : Val(true)
        QRp = @inferred qr(arr, pivot)
        @test QRp isa StaticArrays.QR
        Q, R, p = QRp
        @test Q isa StaticMatrix
        @test R isa StaticMatrix
        @test p isa StaticVector

        Q_ref, R_ref, p_ref = qr(Matrix(arr), pivot)
        @test Q ≈ Matrix(Q_ref)
        @test R ≈ R_ref
        @test p == p_ref
    end

    for eltya in (Float32, Float64, BigFloat, Int),
            rel in (real, complex),
                sz in [(3,3), (3,4), (4,3)]
        arr = SMatrix{sz[1], sz[2], rel(eltya), sz[1]*sz[2]}( [broadenrandn(rel(eltya)) for i = 1:sz[1], j = 1:sz[2]] )
        test_qr(arr)
    end
    # some special cases
    for arr in (
                   (@MMatrix randn(3,2)),
                   (@MMatrix randn(2,3)),
                   (@SMatrix([0 1 2; 0 2 3; 0 3 4; 0 4 5])),
                   (@SMatrix zeros(Int,4,4)),
                   (@SMatrix([1//2 1//1])),
                   (@SMatrix randn(17,18)),    # fallback to LAPACK
                   (@SMatrix randn(18,17))
                )
        test_qr(arr)
    end

    if isdefined(LinearAlgebra, :PivotingStrategy)
        for N = (3, 18)
            A = (@SMatrix randn(N,N))
            @test qr(A, Val(false)) == qr(A, NoPivot())
            @test qr(A, Val(true)) == qr(A, ColumnNorm())
        end
    end
end

@testset "QR method ambiguity" begin
    # Issue #931; just test that methods do not throw an ambiguity error when called
    A = @SMatrix [1.0 2.0 3.0; 4.0 5.0 6.0]
    @test isa(qr(A),              StaticArrays.QR)
    @test isa(qr(A, Val(true)),   StaticArrays.QR)
    @test isa(qr(A, Val(false)),  StaticArrays.QR)
end

using StaticArrays, Test, LinearAlgebra

@testset "Matrix exponential" begin
    @test exp(SMatrix{0,0,Int}())::SMatrix === SMatrix{0,0,Float64}()
    @test exp(@SMatrix [2])::SMatrix ≈ SMatrix{1,1}(exp(2))
    @test exp(@SMatrix [5 2; -2 1])::SMatrix ≈ exp([5 2; -2 1])
    @test exp(@SMatrix [4 2; -2 1])::SMatrix ≈ exp([4 2; -2 1])
    @test exp(@SMatrix [4 2; 2 1])::SMatrix ≈ exp([4 2; 2 1])
    @test exp(@SMatrix [ -3+1im  -1+2im;-4-5im   5-2im])::SMatrix ≈ exp(Complex{Float64}[ -3+1im  -1+2im;-4-5im   5-2im])
    # test for case `(a[1,1] - a[2,2])^2 + 4*a[2,1]*a[1,2] == 0`
    @test exp(@SMatrix [2+2im  1-1im; -2-2im  6+2im])::SMatrix ≈ exp(Complex{Float64}[2+2im  1-1im; -2-2im  6+2im])
    # test for zeros matrix
    @test exp(@SMatrix zeros(Complex{Float64}, 2, 2))::SMatrix ≈ Complex{Float64}[1 0; 0 1]
    @test exp(@SMatrix [1 2 0; 2 1 0; 0 0 1]) ≈ exp([1 2 0; 2 1 0; 0 0 1])

    # https://github.com/JuliaArrays/StaticArrays.jl/issues/1295
    @test exp(@SMatrix [-800.0 800.0; 800.0 -800.0])::SMatrix ≈ [0.5 0.5; 0.5 0.5]
    @test exp(@SMatrix [-800.0 800.0; 800.0 -800.0]) ≈ exp([-800.0 800.0; 800.0 -800.0])

    for sz in (3,4), typ in (Float64, Complex{Float64})
        A = rand(typ, sz, sz)
        nA = norm(A, 1)
        for nB in (0.005, 0.1, 0.5, 3.0, 20.0)
            B = A*nB/nA
            SB = SMatrix{sz,sz,typ}(B)
            @test exp(B) ≈ exp(SB)
        end
    end
end

using StaticArrays, Test, LinearAlgebra

@testset "Eigenvalue decomposition" begin
    @testset "1×1" begin
        m = @SMatrix [2.0]
        (vals, vecs) = eigen(m)
        @test vals === SVector(2.0)
        @test eigvals(m) === vals
        @test vecs === SMatrix{1,1}(1.0)
        ef = eigen(m)
        @test ef.values === SVector(2.0)
        @test ef.vectors === SMatrix{1,1}(1.0)

        (vals, vecs) = eigen(Symmetric(m))
        @test vals === SVector(2.0)
        @test vecs === SMatrix{1,1}(1.0)
        ef = eigen(Symmetric(m))
        @test ef.values === SVector(2.0)
        @test ef.vectors === SMatrix{1,1}(1.0)
        # handle non-Hermitian case
        m = @SMatrix [2.0+im]
        @test eigvals(m) === SVector(2.0+im)
    end

    @testset "2×2" for i = 1:100
        m_a = randn(2,2)
        @test_throws ErrorException eigvals(SMatrix{2,2}(m_a))
        m_a = m_a*m_a'
        m = SMatrix{2,2}(m_a)

        (vals_a, vecs_a) = eigen(m_a)
        (vals, vecs) = eigen(m)
        @test vals::SVector ≈ vals_a
        @test eigvals(m) ≈ vals
        @test (vecs*diagm(Val(0) => vals)*vecs')::SMatrix ≈ m
        ef = eigen(m)
        @test ef.values::SVector ≈ vals_a
        @test (ef.vectors*diagm(Val(0) => vals)*ef.vectors')::SMatrix ≈ m

        (vals, vecs) = eigen(Symmetric(m))
        @test vals::SVector ≈ vals_a
        @test eigvals(m) ≈ vals
        @test (vecs*diagm(Val(0) => vals)*vecs')::SMatrix ≈ m
        ef = eigen(Symmetric(m))
        @test ef.values::SVector ≈ vals_a
        @test (ef.vectors*diagm(Val(0) => vals)*ef.vectors')::SMatrix ≈ m
        ef = eigen(Symmetric(m, :L))
        @test ef.values::SVector ≈ vals_a
        @test (ef.vectors*diagm(Val(0) => vals)*ef.vectors')::SMatrix ≈ m

        (vals, vecs) = eigen(Hermitian(m))
        @test vals::SVector ≈ vals_a
        @test eigvals(Hermitian(m)) ≈ vals
        @test eigvals(Hermitian(m, :L)) ≈ vals
        @test (vecs*diagm(Val(0) => vals)*vecs')::SMatrix ≈ m
        ef = eigen(Hermitian(m))
        @test ef.values::SVector ≈ vals_a
        @test (ef.vectors*diagm(Val(0) => vals)*ef.vectors')::SMatrix ≈ m
        ef = eigen(Hermitian(m, :L))
        @test ef.values::SVector ≈ vals_a
        @test (ef.vectors*diagm(Val(0) => vals)*ef.vectors')::SMatrix ≈ m

        m_d = randn(SVector{2}); m = diagm(Val(0) => m_d)
        (vals, vecs) = eigen(Hermitian(m))
        @test vals::SVector ≈ sort(m_d)
        (vals, vecs) = eigen(Hermitian(m, :L))
        @test vals::SVector ≈ sort(m_d)
        @test eigvals(m) ≈ sort(m_d)
        @test eigvals(Hermitian(m)) ≈ sort(m_d)

        m_c = complex(m) # issue 614 (diagonal complex Hermitian)
        (vals, vecs) = eigen(Hermitian(m_c))
        @test vals::SVector ≈ sort(m_d)
        (vals, vecs) = eigen(Hermitian(m_c, :L))
        @test vals::SVector ≈ sort(m_d)
        @test eigvals(m_c) ≈ sort(m_d)
        @test eigvals(Hermitian(m_c)) ≈ sort(m_d)

        # issue #523
        for (i, j) in ((1, 2), (2, 1)), uplo in (:U, :L)
            A = SMatrix{2,2,Float64}((i, 0, 0, j))
            E = eigen(Symmetric(A, uplo))
            @test eigvecs(E) * SDiagonal(eigvals(E)) * eigvecs(E)' ≈ A
        end

        # issue #956
        v1, v2 = let A = SMatrix{2,2}((1.0, 1e-100, 1e-100, 1.0))
            vecs = eigvecs(eigen(Hermitian(A)))
            vecs[:,1], vecs[:,2]
        end
        @test norm(v1) ≈ 1
        @test norm(v2) ≈ 1
        @test acos(v1 ⋅ v2)*2 ≈ π

        # Test that correct value is taken for upper or lower sym 
        for T in (Float64, Complex{Float64})
            af = SMatrix{2,2}(rand(T, 4))
            a = af + af' # Make hermitian
            au = Hermitian(SMatrix{2,2}((a[1,1], zero(T), a[1,2], a[2,2])), 'U')
            al = Hermitian(SMatrix{2,2}((a[1,1], a[2,1], zero(T), a[2,2])), 'L')
            @test eigvals(eigen(a)) ≈ eigvals(eigen(au)) ≈ eigvals(eigen(al))
            @test eigvals(eigen(a)) ≈ eigvals(eigen(au)) ≈ eigvals(eigen(al))
        end

        m1_a = randn(2,2)
        m1_a = m1_a*m1_a'
        m1 = SMatrix{2,2}(m1_a)
        m2_a = randn(2,2)
        m2_a = m2_a*m2_a'
        m2 = SMatrix{2,2}(m2_a)
        @test (@inferred SVector{2,ComplexF64} eigvals(m1, m2)) ≈ eigvals(m1_a, m2_a)
        @test (@inferred SVector{2,ComplexF64} eigvals(Symmetric(m1), Symmetric(m2))) ≈ eigvals(Symmetric(m1_a), Symmetric(m2_a))
    end

    @testset "2×2, difficult case" begin
        m1 = SA[1.6590891025248637 -2.7087777909606814e-7; -2.7087777909606814e-7 1.659089317183428]
        @test norm(m1 - Array(eigen(m1))) < 1e-15
    end

    @test_throws DimensionMismatch eigvals(SA[1 2 3; 4 5 6], SA[1 2 3; 4 5 5])
    @test_throws DimensionMismatch eigvals(SA[1 2; 4 5], SA[1 2 3; 4 5 5; 3 4 5])

    @testset "3×3" for i = 1:100
        m_a = randn(3,3)
        m_a = m_a*m_a'
        m = SMatrix{3,3}(m_a)

        (vals_a, vecs_a) = eigen(m)
        (vals, vecs) = eigen(m)
        @test vals::SVector ≈ vals_a
        @test eigvals(m) ≈ vals
        @test (vecs*diagm(Val(0) => vals)*vecs')::SMatrix ≈ m

        (vals, vecs) = eigen(Symmetric(m))
        @test vals::SVector ≈ vals_a
        @test eigvals(m) ≈ vals
        @test eigvals(Hermitian(m)) ≈ vals
        @test eigvals(Hermitian(m, :L)) ≈ vals
        @test (vecs*diagm(Val(0) => vals)*vecs')::SMatrix ≈ m

        (vals, vecs) = eigen(Symmetric(m, :L))
        @test vals::SVector ≈ vals_a

        m_d = randn(SVector{3}); m = diagm(Val(0) => m_d)
        (vals, vecs) = eigen(Hermitian(m))
        @test vals::SVector ≈ sort(m_d)
        (vals, vecs) = eigen(Hermitian(m, :L))
        @test vals::SVector ≈ sort(m_d)
        @test eigvals(m) ≈ sort(m_d)
        @test eigvals(Hermitian(m)) ≈ sort(m_d)

        m1_a = randn(3,3)
        m1_a = m1_a*m1_a'
        m1 = SMatrix{3,3}(m1_a)
        m2_a = randn(3,3)
        m2_a = m2_a*m2_a'
        m2 = SMatrix{3,3}(m2_a)
        @test (@inferred SVector{3,ComplexF64} eigvals(m1, m2)) ≈ eigvals(m1_a, m2_a)
    end

    @testset "3×3 complex" begin
        m = SMatrix{3,3}(ComplexF64[
            0.0 + 0.0im -0.0 - 1.3823165541274323im -0.0 - 0.29894503384118465im;
            0.0 + 1.3823165541274323im 0.0 + 0.0im -0.0 - 1.9507754416262268im;
            0.0 + 0.29894503384118465im 0.0 + 1.9507754416262268im 0.0 + 0.0im])
        vals = eigvals(m)
        @test isapprox(vals, eigvals(Matrix(m)))
    end

    @testset "3x3 degenerate cases" begin
        # Rank 1
        v = randn(SVector{3,Float64})
        m = v*v'
        vv = sum(abs2, v)
        vals, vecs = eigen(m)::Eigen{<:Any,<:Any,<:SMatrix,<:SVector}

        @test vecs'*vecs ≈ one(SMatrix{3,3,Float64})
        @test vals ≈ SVector(0.0, 0.0, vv)
        @test eigvals(m) ≈ vals

        # Rank 2
        v2 = randn(SVector{3,Float64})
        v2 -= dot(v,v2)*v/(vv)
        v2v2 = sum(abs2, v2)
        m += v2*v2'
        vals, vecs = eigen(m)::Eigen{<:Any,<:Any,<:SMatrix,<:SVector}

        @test vecs'*vecs ≈ one(SMatrix{3,3,Float64})
        if vv < v2v2
            @test vals ≈ SVector(0.0, vv, v2v2)
        else
            @test vals ≈ SVector(0.0, v2v2, vv)
        end
        @test eigvals(m) ≈ vals

        # Degeneracy (2 large)
        m = -99*(v*v')/vv + 100*one(SMatrix{3,3,Float64})
        vals, vecs = eigen(m)::Eigen{<:Any,<:Any,<:SMatrix,<:SVector}

        @test vecs'*vecs ≈ one(SMatrix{3,3,Float64})
        @test vals ≈ SVector(1.0, 100.0, 100.0)
        @test eigvals(m) ≈ vals

        # Degeneracy (2 small)
        m = (v*v')/vv + 1e-2*one(SMatrix{3,3,Float64})
        vals, vecs = eigen(m)::Eigen{<:Any,<:Any,<:SMatrix,<:SVector}

        @test vecs'*vecs ≈ one(SMatrix{3,3,Float64})
        @test vals ≈ SVector(1e-2, 1e-2, 1.01)
        @test eigvals(m) ≈ vals

        # Block diagonal
        m = @SMatrix [1.0 0.0 0.0;
                      0.0 1.0 1.0;
                      0.0 1.0 1.0]
        vals, vecs = eigen(m)::Eigen{<:Any,<:Any,<:SMatrix,<:SVector}

        @test vals ≈ [0.0, 1.0, 2.0]
        @test vecs*diagm(Val(0) => vals)*vecs' ≈ m
        @test eigvals(m) ≈ vals

        m = @SMatrix [1.0 0.0 1.0;
                      0.0 1.0 0.0;
                      1.0 0.0 1.0]
        vals, vecs = eigen(m)::Eigen{<:Any,<:Any,<:SMatrix,<:SVector}

        @test vals ≈ [0.0, 1.0, 2.0]
        @test vecs*diagm(Val(0) => vals)*vecs' ≈ m
        @test eigvals(m) ≈ vals

        m = @SMatrix [1.0 1.0 0.0;
                      1.0 1.0 0.0;
                      0.0 0.0 1.0]
        vals, vecs = eigen(m)::Eigen{<:Any,<:Any,<:SMatrix,<:SVector}

        @test vals ≈ [0.0, 1.0, 2.0]
        @test vecs*diagm(Val(0) => vals)*vecs' ≈ m
        @test eigvals(m) ≈ vals
    end

    @testset "4×4" for i = 1:100
        m_a = randn(4,4)
        m_a = m_a*m_a'
        m = SMatrix{4,4}(m_a)

        (vals_a, vecs_a) = eigen(m_a)
        (vals, vecs) = eigen(m)
        @test vals::SVector ≈ vals_a
        @test eigvals(m) ≈ vals
        @test (vecs*diagm(Val(0) => vals)*vecs')::SMatrix ≈ m

        (vals, vecs) = eigen(Symmetric(m))
        @test vals::SVector ≈ vals_a
        @test eigvals(m) ≈ vals
        @test eigvals(Hermitian(m)) ≈ vals
        @test eigvals(Hermitian(m, :L)) ≈ vals
        @test (vecs*diagm(Val(0) => vals)*vecs')::SMatrix ≈ m

        (vals, vecs) = eigen(Symmetric(m, :L))
        @test vals::SVector ≈ vals_a
        m_d = randn(SVector{4}); m = diagm(Val(0) => m_d)
        (vals, vecs) = eigen(Hermitian(m))
        @test vals::SVector ≈ sort(m_d)
        (vals, vecs) = eigen(Hermitian(m, :L))
        @test vals::SVector ≈ sort(m_d)
        @test eigvals(m) ≈ sort(m_d)
        @test eigvals(Hermitian(m)) ≈ sort(m_d)
    end

    @testset "complex" begin
        for n=1:5
            a = randn(n,n)+im*randn(n,n)
            a = a+a'
            A = Hermitian(SMatrix{n,n}(a))
            D,V = eigen(A)
            @test V'V ≈ Matrix(I, n, n)
            @test V*diagm(Val(0) => D)*V' ≈ A
            @test V'*A*V ≈ diagm(Val(0) => D)
        end
    end

    @testset "hermitian type stability" begin
        for n=1:4
            m = @SMatrix randn(n,n)
            m += m'

            @inferred eigen(Hermitian(m))
            @inferred eigen(Symmetric(m))

            # Test that general eigen() gives a small union of concrete types
            SEigen{T} = Eigen{T, T, SArray{Tuple{n,n},T,2,n*n}, SArray{Tuple{n},T,1,n}}
            @inferred Union{SEigen{ComplexF64},SEigen{Float64}} eigen(m)

            mc = @SMatrix randn(ComplexF64, n, n)
            @inferred eigen(Hermitian(mc + mc'))
        end
    end

    @testset "non-hermitian 2d" begin
        for n=1:5
            angle = 2π * rand()
            rot = @SMatrix [cos(angle) -sin(angle); sin(angle) cos(angle)]

            vals, vecs = eigen(rot)

            @test norm(vals[1]) ≈ 1.0
            @test norm(vals[2]) ≈ 1.0

            @test vecs[:,1] ≈ conj.(vecs[:,2])
        end
    end

    @testset "non-hermitian 3d" begin
        for n=1:5
            angle = 2π * rand()
            rot = @SMatrix [cos(angle) 0.0 -sin(angle); 0.0 1.0 0.0; sin(angle) 0.0 cos(angle)]

            vals, vecs = eigen(rot)

            @test norm(vals[1]) ≈ 1.0
            @test norm(vals[2]) ≈ 1.0

            @test vecs[:,1] ≈ conj.(vecs[:,2])
        end
    end

    @testset "non-float matrix" begin
        A = Symmetric(SMatrix{3,3}(1:9))
        λ, V = eigen(A)
        @test A * V ≈ V * Diagonal(λ)
    end
end

length(a::StaticArrayLike) = prod(Size(a))::Int
length(a::Type{SA}) where {SA <: StaticArrayLike} = prod(Size(SA))::Int

size(::Type{SA}) where {SA <: StaticArrayLike} = Tuple(Size(SA))
@inline function size(t::Type{<:StaticArrayLike}, d::Int)
    S = size(t)
    d > length(S) ? 1 : S[d]
end
@inline size(a::StaticArrayLike) = Tuple(Size(a))

Base.axes(s::StaticArrayLike) = _axes(Size(s))
@generated function _axes(::Size{sizes}) where {sizes}
    map(SOneTo, sizes)
end

Base.eachindex(::IndexLinear, a::StaticArray) = SOneTo(length(a))

# Base.strides is intentionally not defined for SArray, see PR #658 for discussion
Base.strides(a::MArray) = Base.size_to_strides(1, size(a)...)
Base.strides(a::SizedArray) = strides(a.data)

function Base.summary(io::IO, a, inds::Tuple{SOneTo, Vararg{SOneTo}})
    print(io, Base.dims2string(length.(inds)), " ")
    Base.showarg(io, a, true)
end

Base.IndexStyle(::Type{T}) where {T<:StaticArray} = IndexLinear()

# Default type search for similar_type
similar_type(::SA) where {SA<:StaticArrayLike} = similar_type(SA,eltype(SA))
similar_type(::Type{SA}) where {SA<:StaticArrayLike} = similar_type(SA,eltype(SA))

similar_type(::SA,::Type{T}) where {SA<:StaticArrayLike,T} = similar_type(SA,T,Size(SA))
similar_type(::Type{SA},::Type{T}) where {SA<:StaticArrayLike,T} = similar_type(SA,T,Size(SA))

similar_type(::A,s::Size{S}) where {A<:AbstractArray,S} = similar_type(A,eltype(A),s)
similar_type(::Type{A},s::Size{S}) where {A<:AbstractArray,S} = similar_type(A,eltype(A),s)

similar_type(::A,::Type{T},s::Size{S}) where {A<:AbstractArray,T,S} = similar_type(A,T,s)

# We should be able to deal with SOneTo axes
similar_type(s::SOneTo) = similar_type(typeof(s))
similar_type(::Type{SOneTo{n}}) where {n} = similar_type(SOneTo{n}, Int, Size(n))

similar_type(::A, shape::Tuple{SOneTo, Vararg{SOneTo}}) where {A<:AbstractArray} = similar_type(A, eltype(A), shape)
similar_type(::Type{A}, shape::Tuple{SOneTo, Vararg{SOneTo}}) where {A<:AbstractArray} = similar_type(A, eltype(A), shape)

similar_type(::A,::Type{T}, shape::Tuple{SOneTo, Vararg{SOneTo}}) where {A<:AbstractArray,T} = similar_type(A, T, Size(last.(shape)))
similar_type(::Type{A},::Type{T}, shape::Tuple{SOneTo, Vararg{SOneTo}}) where {A<:AbstractArray,T} = similar_type(A, T, Size(last.(shape)))


# unwrapping arrays (see issue #828)
const SimilarTypeArrayWrapper{T,AW} = Union{
    Transpose{T,AW},
    Adjoint{T,AW},
    Symmetric{T,AW},
    Hermitian{T,AW},
    UpperTriangular{T,AW},
    LowerTriangular{T,AW},
    UnitUpperTriangular{T,AW},
    UnitLowerTriangular{T,AW},
    Diagonal{T,AW}}

function similar_type(::Type{A}, ::Type{T}, shape::Size) where {T,AW<:AbstractArray,A<:SimilarTypeArrayWrapper{<:Any,AW}}
    return similar_type(AW, T, shape)
end

# Default types
# Generally, use SArray
similar_type(::Type{A},::Type{T},s::Size{S}) where {A<:AbstractArray,T,S} = default_similar_type(T,s,length_val(s))
default_similar_type(::Type{T}, s::Size{S}, ::Type{Val{D}}) where {T,S,D} = SArray{Tuple{S...},T,D,prod(s)}

similar_type(::Type{SA},::Type{T},s::Size{S}) where {SA<:Union{MVector,MMatrix,MArray},T,S} = mutable_similar_type(T,s,length_val(s))

mutable_similar_type(::Type{T}, s::Size{S}, ::Type{Val{D}}) where {T,S,D} = MArray{Tuple{S...},T,D,prod(s)}

similar_type(::Type{<:SizedArray},::Type{T},s::Size{S}) where {S,T} = sizedarray_similar_type(T,s,length_val(s))
# Should SizedArray also be used for normal Array?
#similar_type(::Type{<:Array},::Type{T},s::Size{S}) where {S,T} = sizedarray_similar_type(T,s,length_val(s))

sizedarray_similar_type(::Type{T},s::Size{S},::Type{Val{D}}) where {T,S,D} = SizedArray{Tuple{S...},T,D,length(s)}

# Utility for computing the eltype of an array instance, type, or type
# constructor.  For type constructors without a definite eltype, the default
# value is returned.
_eltype_or(a::AbstractArray, default) = eltype(a)
_eltype_or(::Type{<:AbstractArray{T}}, default) where {T} = T
_eltype_or(::Type{<:AbstractArray}, default) = default # eltype not available

"""
    _construct_similar(a, ::Size, elements::NTuple)

Construct a static array of similar type to `a` with the given `elements`.

When `a` is an instance or a concrete type the element type `eltype(a)` is
used. However, when `a` is a `UnionAll` type such as `SMatrix{2,2}`, the
promoted type of `elements` is used instead.
"""
@inline function _construct_similar(a, s::Size, elements::Tuple{ET,Vararg{ET,L}}) where {L,ET}
    similar_type(a, _eltype_or(a, ET), s)(elements)
end


# Field vectors are user controlled, and currently default to SVector, etc

"""
    similar(static_array)
    similar(static_array, T)
    similar(array, ::Size)
    similar(array, T, ::Size)

Constructs and returns a mutable but statically-sized array (i.e. a `StaticArray`). If the
input `array` is not a `StaticArray`, then the `Size` is required to determine the output
size (or else a dynamically sized array will be returned).
"""
similar(::SA) where {SA<:StaticArray} = similar(SA,eltype(SA))
similar(::Type{SA}) where {SA<:StaticArray} = similar(SA,eltype(SA))

similar(::SA,::Type{T}) where {SA<:StaticArray,T} = similar(SA,T,Size(SA))
similar(::Type{SA},::Type{T}) where {SA<:StaticArray,T} = similar(SA,T,Size(SA))

# Cases where a Size is given as the dimensions
similar(::A,s::Size{S}) where {A<:AbstractArray,S} = similar(A,eltype(A),s)
similar(::Type{A},s::Size{S}) where {A<:AbstractArray,S} = similar(A,eltype(A),s)

similar(::A,::Type{T},s::Size{S}) where {A<:AbstractArray,T,S} = similar(A,T,s)

# defaults to built-in mutable types for bits types
similar(::Type{A}, ::Type{T}, s::Size{S}) where {A<:AbstractArray,T,S} =
    isbitstype(T) ?
    mutable_similar_type(T, s, length_val(s))(undef) :
    sizedarray_similar_type(T, s, length_val(s))(undef)

# both SizedArray and Array return SizedArray
similar(::Type{SA},::Type{T},s::Size{S}) where {SA<:SizedArray,T,S} = sizedarray_similar_type(T,s,length_val(s))(undef)
similar(::Type{A},::Type{T},s::Size{S}) where {A<:Array,T,S} = sizedarray_similar_type(T,s,length_val(s))(undef)

# Support tuples of mixtures of `SOneTo`s alongside the normal `Integer` and `OneTo` options
# by simply converting them to either a tuple of Ints or a Size, re-dispatching to either one
# of the above methods (in the case of Size) or a base fallback (in the case of Ints).
const HeterogeneousBaseShape = Union{Integer, Base.OneTo}
const HeterogeneousShape = Union{HeterogeneousBaseShape, SOneTo}
const HeterogeneousShapeTuple = Tuple{Vararg{HeterogeneousShape}}

@static if isdefined(Base, :AbstractOneTo)
    similar(A::AbstractArray, ::Type{T}, shape::Tuple{SOneTo, Vararg{SOneTo}}) where {T} = similar(A, T, homogenize_shape(shape))
    similar(::Type{A}, shape::Tuple{SOneTo, Vararg{SOneTo}}) where {A<:AbstractArray} = similar(A, homogenize_shape(shape))
else
    similar(A::AbstractArray, ::Type{T}, shape::HeterogeneousShapeTuple) where {T} = similar(A, T, homogenize_shape(shape))
    similar(::Type{A}, shape::HeterogeneousShapeTuple) where {A<:AbstractArray} = similar(A, homogenize_shape(shape))
end
# Use an Array for StaticArrays if we don't have a statically-known size
similar(::Type{A}, shape::Tuple{Int, Vararg{Int}}) where {A<:StaticArray} = Array{eltype(A)}(undef, shape)

homogenize_shape(::Tuple{}) = ()
homogenize_shape(shape::Tuple{Vararg{SOneTo}}) = Size(map(last, shape))
homogenize_shape(shape::Tuple{Vararg{HeterogeneousShape}}) = map(last, shape)


@inline reshape(a::SArray, s::Size) = similar_type(a, s)(Tuple(a))
@inline reshape(a::AbstractArray, s::Size) = __reshape(a, ((typeof(s).parameters...)...,), s)
@inline reshape(a::SArray, s::Tuple{SOneTo,Vararg{SOneTo}}) = reshape(a, homogenize_shape(s))
@inline reshape(a::AbstractArray, s::Tuple{SOneTo,Vararg{SOneTo}}) = reshape(a, homogenize_shape(s))
@inline function reshape(a::StaticArray, s::Tuple{SOneTo,Vararg{SOneTo}})
    return __reshape(a, map(u -> last(u), s), homogenize_shape(s))
end
@inline function __reshape(a, shape, s::Size)
    return _maybewrap_reshape(Base._reshape(a, shape), Size(a), s)
end
@inline function __reshape(a::SizedArray, shape, s::Size)
    return _maybewrap_reshape(Base._reshape(a.data, shape), Size(a), s)
end
@inline function _maybewrap_reshape(a, ::Size{Sa}, ::Size{S}) where {Sa,S}
    return SizedArray{Tuple{S...}}(a)
end
@inline function _maybewrap_reshape(a::StaticArray, ::Size{S}, ::Size{S}) where {S}
    return a
end

reshape(a::Vector, ::Size{S}) where {S} = SizedArray{Tuple{S...}}(a)

Base.rdims(out::Val{N}, inds::Tuple{SOneTo, Vararg{SOneTo}}) where {N} = Base.rdims(ntuple(i -> SOneTo(1), Val(N)), inds)
Base.rdims(out::Tuple{Any}, inds::Tuple{SOneTo, Vararg{SOneTo}}) = (SOneTo(Base.rdims_trailing(inds...)),)

@inline vec(a::StaticArray) = reshape(a, Size(prod(Size(typeof(a)))))

@inline copy(a::StaticArray) = typeof(a)(Tuple(a))
@inline copy(a::SizedArray{S,T}) where {S,T} = SizedArray{S,T}(copy(a.data))

@inline reverse(v::StaticArray) = typeof(v)(_reverse(v))

@generated function _reverse(v::StaticArray{N}) where {N}
    L = tuple_prod(N)
    return Expr(:tuple, (:(v[$i]) for i = L:(-1):1)...)
end

@generated function Base.rot180(A::SMatrix{M,N}) where {M,N}
    exs = rot180([:(getindex(A,$i,$j)) for i in 1:M, j in 1:N])
    return :(SMatrix{M,N}($(exs...)))
end
for rot in [:rotl90, :rotr90]
    @eval @generated function Base.$rot(A::SMatrix{M,N}) where {M,N}
        exs = $rot([:(getindex(A,$i,$j)) for i in 1:M, j in 1:N])
        return :(SMatrix{N,M}($(exs...)))
    end
end

# TODO permutedims? So far just the cases without perm:

Base.permutedims(A::SVector{N}) where {N} = SMatrix{1,N}(A.data...)
Base.permutedims(A::MVector{N}) where {N} = MMatrix{1,N}(A.data...)
Base.permutedims(A::SizedVector{N}) where {N} = SizedMatrix{1,N}(permutedims(A.data))

@generated function Base.permutedims(A::SMatrix{M,N}) where {M,N}
    exs = permutedims([:(getindex(A,$i,$j)) for i in 1:M, j in 1:N])
    return :(SMatrix{N,M}($(exs...)))
end
@generated function Base.permutedims(A::MMatrix{M,N}) where {M,N}
    exs = permutedims([:(getindex(A,$i,$j)) for i in 1:M, j in 1:N])
    return :(MMatrix{N,M}($(exs...)))
end
Base.permutedims(A::SizedMatrix{M,N}) where {M,N} = SizedMatrix{N,M}(permutedims(A.data))

#--------------------------------------------------
# Concatenation
@inline vcat(a::StaticMatrixLike) = a
@inline vcat(a::StaticVecOrMatLike, b::StaticVecOrMatLike) = _vcat(Size(a), Size(b), a, b)
@inline vcat(a::StaticVecOrMatLike, b::StaticVecOrMatLike, c::StaticVecOrMatLike...) = vcat(vcat(a,b), vcat(c...))
# A couple of hacky overloads to avoid some vcat surprises.
# We can't really make this work a lot better in general without Base providing
# a dispatch mechanism for output container type.
@inline vcat(a::StaticVector) = a
@inline vcat(a::StaticVector, bs::Number...) = vcat(a, SVector(bs))
@inline vcat(a::Number, b::StaticVector) = vcat(similar_type(b, typeof(a), Size(1))((a,)), b)

@generated function _vcat(::Size{Sa}, ::Size{Sb}, a::StaticVecOrMatLike, b::StaticVecOrMatLike) where {Sa, Sb}
    if Size(Sa)[2] != Size(Sb)[2]
        return :(throw(DimensionMismatch("Tried to vcat arrays of size $Sa and $Sb")))
    end

    # TODO cleanup?
    if a <: StaticVector && b <: StaticVector
        Snew = (Sa[1] + Sb[1],)
        exprs = vcat([:(a[$i]) for i = 1:Sa[1]],
                     [:(b[$i]) for i = 1:Sb[1]])
    else
        Snew = (Sa[1] + Sb[1], Size(Sa)[2])
        exprs = [((i <= size(a,1)) ? ((a <: StaticVector) ? :(a[$i]) : :(a[$i,$j]))
                                   : ((b <: StaticVector) ? :(b[$(i-size(a,1))]) : :(b[$(i-size(a,1)),$j])))
                                   for i = 1:(Sa[1]+Sb[1]), j = 1:Size(Sa)[2]]
    end

    return quote
        @_inline_meta
        @inbounds return similar_type(a, promote_type(eltype(a), eltype(b)), Size($Snew))(tuple($(exprs...)))
    end
end

@inline hcat(a::StaticVector) = similar_type(a, Size(Size(a)[1],1))(a)
@inline hcat(a::StaticMatrixLike) = a
@inline hcat(a::StaticVecOrMatLike, b::StaticVecOrMatLike) = _hcat(Size(a), Size(b), a, b)
@inline hcat(a::StaticVecOrMatLike, b::StaticVecOrMatLike, c::StaticVecOrMatLike...) = hcat(hcat(a,b), hcat(c...))
@inline hcat(a::StaticMatrix{1}) = a # disambiguation
@inline hcat(a::StaticMatrix{1}, bs::Number...) = hcat(a, SMatrix{1,length(bs)}(bs))
@inline hcat(a::Number, b::StaticMatrix{1}) = hcat(similar_type(b, typeof(a), Size(1))((a,)), b)

@generated function _hcat(::Size{Sa}, ::Size{Sb}, a::StaticVecOrMatLike, b::StaticVecOrMatLike) where {Sa, Sb}
    if Sa[1] != Sb[1]
        return :(throw(DimensionMismatch("Tried to hcat arrays of size $Sa and $Sb")))
    end

    exprs = vcat([:(a[$i]) for i = 1:prod(Sa)],
                 [:(b[$i]) for i = 1:prod(Sb)])

    Snew = (Sa[1], Size(Sa)[2] + Size(Sb)[2])

    return quote
        @_inline_meta
        @inbounds return similar_type(a, promote_type(eltype(a), eltype(b)), Size($Snew))(tuple($(exprs...)))
    end
end

# FIXME: This always assumes one-based linear indexing and that subtypes of StaticArray
# don't overload iterate
@inline function Base.rest(a::StaticArray{S}, (_, i) = (nothing, 0)) where {S}
    newlen = tuple_prod(S) - i
    return similar_type(typeof(a), Size(newlen))(Base.rest(Tuple(a), i + 1))
end

# SArrays may avoid the SubArray wrapper and consequently an additional level of indirection
# The output may use the broadcasting machinery defined for StaticArrays (see issue #892)
# wrap elements in Scalar to be consistent with 0D views
_maybewrapscalar(::Tuple{}, r::T) where {T} = Scalar{T}(r)
_maybewrapscalar(_, r) = r
function Base.view(S::SArray, I::Union{Colon, Integer, SOneTo, StaticArray{<:Tuple, Int}, CartesianIndex}...)
    V = getindex(S, I...)
    _maybewrapscalar(Base.index_dimsum(I...), V)
end

# zeros, ones and fill may return SArrays if all the axes are statically sized
for (arrf, elf) in ((:zeros, :zero), (:ones, :one))
    _arrf = Symbol(:_, arrf)
    @eval begin
        function $arrf(::Type{T}, ax::Tuple{SOneTo,Vararg{SOneTo}}) where {T}
            sz = homogenize_shape(ax)
            similar_type(SArray, T, sz)(ntuple(_->$elf(T), prod(sz)))
        end
    end
end

function fill(v, ax::Tuple{SOneTo,Vararg{SOneTo}})
    sz = homogenize_shape(ax)
    similar_type(SArray, typeof(v), sz)(ntuple(_->v, prod(sz)))
end

fsa = true

using StaticArrays
@static if fsa
    using FixedSizeArrays
end

if !isdefined(:N)
    N = 4
end

M_f = div(10^9, N^3)
M_g = div(2*10^8, N^2)

# Size

A = rand(N,N)
As = SMatrix{N,N}(A)
Am = MMatrix{N,N}(A)
@static if fsa
    Af = Mat(ntuple(j -> ntuple(i->A[i,j], N), N)) # there is a bug in FixedSizeArrays Mat constructor (13 July 2016)
end


if !isdefined(:f_mut_marray) || !isdefined(:benchmark_suite) || benchmark_suite == false
    f(n::Integer, A) = @inbounds (C = A; for i = 1:n; C = C*A; end; return C)
    f_unrolled(n::Integer, A::Union{SMatrix{M,M},MMatrix{M,M}}) where {M} = @inbounds (C = A; for i = 1:n; C = StaticArrays.A_mul_B_unrolled(C,A); end; return C)
    f_unrolled_chunks(n::Integer, A::Union{SMatrix{M,M},MMatrix{M,M}}) where {M} = @inbounds (C = A; for i = 1:n; C = StaticArrays.A_mul_B_unrolled_chunks(C,A); end; return C)
    f_via_sarray(n::Integer, A::MMatrix{M,M}) where {M}= @inbounds (C = A; for i = 1:n; C = MMatrix{M,M}(SMatrix{M,M}(C)*SMatrix{M,M}(A)); end; return C)
    f_mut_array(n::Integer, A) = @inbounds (C = copy(A); tmp = similar(A); for i = 1:n;  A_mul_B!(tmp, C, A); map!(identity, C, tmp); end; return C)
    f_mut_marray(n::Integer, A) = @inbounds (C = similar(A); C[:] = A[:]; tmp = similar(A); for i = 1:n; StaticArrays.A_mul_B_unrolled!(tmp, C, A); C.data = tmp.data; end; return C)
    f_blas_marray(n::Integer, A) = @inbounds (C = similar(A); C[:] = A[:]; tmp = similar(A); for i = 1:n; StaticArrays.A_mul_B_blas!(tmp, C, A); C.data = tmp.data; end; return C)

    g(n::Integer, A) = @inbounds (C = A; for i = 1:n; C = C + A; end; return C)
    g_mut(n::Integer, A) = @inbounds (C = similar(A); C[:] = A[:]; for i = 1:n; @inbounds map!(+, C, C, A); end; return C)
    g_via_sarray(n::Integer, A::MMatrix{M,M}) where {M} = @inbounds (C = similar(A); C[:] = A[:]; for i = 1:n; C = MMatrix{M,M}(SMatrix{M,M}(C) + SMatrix{M,M}(A)); end; return C)

    # Notes: - A[:] = B[:] is allocating in Base, unlike `map!`
    #        - Also, the same goes for Base's implementation of broadcast!(f, A, B, C) (but map! is OK).
    #        - I really need to implement copy() in StaticArrays... (and maybe a special instance of setindex!(C, :))

    # Old, "broken" defs:
    #f(n::Integer, A, B) = @inbounds (C = A*B; for i = 1:n; C += A*B; end; return C)
    #f_mut(n::Integer, A, B) = @inbounds (C = A*B; tmp = similar(C); for i = 1:n; A_mul_B!(tmp, A, B); map!(+, C, C, tmp); end; return C)
    #g(n::Integer, A, B) = @inbounds (C = A + B; for i = 1:n; C = C + B; end; return C)
    #g_mut(n::Integer, A, B) = @inbounds (C = A + B; for i = 1:n; @inbounds broadcast!(+, C, C, B); end; return C)
end

# Don't count these compilations either
C = f(2, A)
C_mut = f_mut_array(2, A)
if N == 4;  @assert C_mut ≈ C; end

C = g(2, A)
C_mut = g_mut(2, A)

if N == 4; @assert C_mut ≈ C; end

println("=====================================")
println("    Benchmarks for $N×$N matrices")
println("=====================================")
print("StaticArrays compilation time (×3):")
@time eval(quote
    # Warmup and some checks
    C = f(2, A)
    Cs = f(2, As)
    Cs_unrolled = f_unrolled(2, As)
    Cs_chunks = f_unrolled_chunks(2, As)
    Cm = f(2, Am)
    Cm_unrolled = f_unrolled(2, Am)
    Cm_chunks = f_unrolled_chunks(2, Am)
    Cm_via_sarray = f_via_sarray(2, Am)
    Cm_mut = f_mut_marray(2, Am)
    Cm_blas = f_blas_marray(2, Am)

    Cs::SMatrix
    if N == 4; @assert Cs ≈ C; end
    Cs_unrolled::SMatrix
    if N == 4; @assert Cs_unrolled ≈ C; end
    Cs_chunks::SMatrix
    if N == 4; @assert Cs_chunks ≈ C; end
    Cm::MMatrix
    if N == 4; @assert Cm ≈ C; end
    Cm_unrolled::MMatrix
    if N == 4; @assert Cm_unrolled ≈ C; end
    Cm_chunks::MMatrix
    if N == 4; @assert Cm_chunks ≈ C; end
    Cm_via_sarray::MMatrix
    if N == 4; @assert Cm_via_sarray ≈ C; end
    Cm_mut::MMatrix
    if N == 4; @assert Cm_mut ≈ C; end
    Cm_blas::MMatrix
    if N == 4; @assert Cm_blas ≈ C; end

    C = g(2, A)
    Cs = g(2, As)
    Cm = g(2, Am)
    Cm_via_sarray = g_via_sarray(2, Am)
    Cm_mut = g_mut(2, Am)

    Cs::SMatrix
    if N == 4; @assert Cs == C; end
    Cm::MMatrix
    if N == 4; @assert Cm == C; end
    Cm_via_sarray::MMatrix
    if N == 4; @assert Cm_via_sarray == C; end
    Cm_mut::MMatrix
    if N == 4; @assert Cm_mut == C; end
end)
@static if fsa
    print("FixedSizeArrays compilation time:  ")
    @time eval(quote
        C = f(2, A)
        Cf = f(2, Af)
        Cf::Mat
        if N == 4; @assert Cf == C; end

        C = g(2, A)
        Cf = g(2, Af)
        Cf::Mat
        if N == 4; @assert Cf == C; end
    end)
end
println()

# Do the performance tests

println("Matrix multiplication")
println("---------------------")
begin
   print("Array               ->"); @time f(M_f, A)
   print("Array (mutating)    ->"); @time f_mut_array(M_f, A)
   print("SArray              ->"); @time f(M_f, As)
   print("SArray (unrolled)   ->"); @time f_unrolled(M_f, As)
   print("SArray (chunks)     ->"); @time f_unrolled_chunks(M_f, As)
   print("MArray              ->"); @time f(M_f, Am)
   print("MArray (unrolled)   ->"); @time f_unrolled(M_f, Am)
   print("MArray (chunks)     ->"); @time f_unrolled_chunks(M_f, Am)
   print("MArray (via SArray) ->"); @time f_via_sarray(M_f, Am)
   print("MArray (mutating)   ->"); @time f_mut_marray(M_f, Am)
   print("MArray (BLAS gemm!) ->"); @time f_blas_marray(M_f, Am)
   @static if fsa
       print("Mat                 ->"); @time f(M_f, Af)
   end
end
println()

println("Matrix addition")
println("---------------")
begin
   print("Array               ->"); @time g(M_g, A)
   print("Array (mutating)    ->"); @time g_mut(M_g, A) # broadcast! seems to be broken!
   print("SArray (unrolled)   ->"); @time g(M_g, As)
   print("MArray (unrolled)   ->"); @time g(M_g, Am)
   print("MArray (via SArray) ->"); @time g_via_sarray(M_g, Am)
   print("MArray (mutating)   ->"); @time g_mut(M_g, Am)
   @static if fsa
       print("Mat                 ->"); @time g(M_g, Af)
   end
end
println()

@static if VERSION < v"1.8.0-DEV.410"
    using Base: @_inline_meta
else
    const var"@_inline_meta" = Base.var"@inline"
end

# Julia 1.9 removed the `@pure` annotation in favor of Concrete-Eval
# This behaves unfavorable with `julia --check-bounds=no`
Base.@pure function typeintersect(@nospecialize(a),@nospecialize(b))
    Base.typeintersect(a,b)
end

# For convenience
TupleN{T,N} = NTuple{N,T}

# Cast any Tuple to an TupleN{T}
@inline convert_ntuple(::Type{T},d::T) where {T} = T # For zero-dimensional arrays
@inline convert_ntuple(::Type{T},d::NTuple{N,T}) where {N,T} = d

# Base gives up on tuples for promote_eltype... (TODO can we improve Base?)
_TupleOf{T} = Tuple{T,Vararg{T}}
promote_tuple_eltype(::Union{_TupleOf{T}, Type{<:_TupleOf{T}}}) where {T} = T
@generated function promote_tuple_eltype(::Union{T,Type{T}}) where T <: Tuple
    t = Union{}
    for i = 1:length(T.parameters)
        tmp = Base.unwrapva(T.parameters[i])
        t = :(promote_type($t, $tmp))
    end
    return quote
        @_inline_meta
        $t
    end
end

# Something doesn't match up type wise
function check_array_parameters(Size, T, N, L)
    (!isa(Size, DataType) || (Size.name !== Tuple.name)) && throw(ArgumentError("Static Array parameter Size must be a Tuple type, got $Size"))
    !isa(T, Type) && throw(ArgumentError("Static Array parameter T must be a type, got $T"))
    !isa(N.parameters[1], Int) && throw(ArgumentError("Static Array parameter N must be an integer, got $(N.parameters[1])"))
    !isa(L.parameters[1], Int) && throw(ArgumentError("Static Array parameter L must be an integer, got $(L.parameters[1])"))
    # shouldn't reach here. Anything else should have made it to the function below
    error("Internal error. Please file a bug")
end

# Trivial view used to drop static dimensions to override dispatch
struct TrivialView{A,T,N} <: AbstractArray{T,N}
    a::A
end

size(a::TrivialView) = size(a.a)
getindex(a::TrivialView, inds...) = getindex(a.a, inds...)
setindex!(a::TrivialView, inds...) = (setindex!(a.a, inds...); a)
Base.IndexStyle(::Type{<:TrivialView{A}}) where {A} = IndexStyle(A)

TrivialView(a::AbstractArray{T,N}) where {T,N} = TrivialView{typeof(a),T,N}(a)


# Remove the static dimensions from an array

# This docstring is commented out, because of a bug that happens when building the docs.
# See https://github.com/JuliaLang/julia/issues/23826
# """
#     drop_sdims(a)
#
# Return an `AbstractArray` with the same elements as `a`, but with static
# dimensions removed (ie, not a `StaticArray`).
#
# This is useful if you want to override dispatch to call the `Base` version of
# operations such as `kron` instead of the implementation in `StaticArrays`.
# Normally you shouldn't need to do this, but it can be more efficient for
# certain algorithms where the number of elements of the output is a lot larger
# than the input.
# """
@inline drop_sdims(a::StaticArrayLike) = TrivialView(a)
@inline drop_sdims(a) = a

Base.@propagate_inbounds function invperm(p::StaticVector)
    # in difference to base, this does not check if p is a permutation (every value unique)
     ip = similar(p)
     ip[p] = 1:length(p)
     similar_type(p)(ip)
end

# Static Arrays
*Statically sized arrays for Julia*

**StaticArrays** provides a framework for implementing statically sized arrays
in Julia, using the abstract type `StaticArray{Size,T,N} <: AbstractArray{T,N}`.
Subtypes of [`StaticArray`](@ref) will provide fast implementations of common array and
linear algebra operations. Note that here "statically sized" means that the
size can be determined from the *type*, and "static" does **not** necessarily
imply `immutable`.

The package also provides some concrete static array types: [`SVector`](@ref), [`SMatrix`](@ref)
and [`SArray`](@ref), which may be used as-is (or else embedded in your own type).
Mutable versions [`MVector`](@ref), [`MMatrix`](@ref) and [`MArray`](@ref) are also exported, as well
as [`SizedArray`](@ref) for annotating standard `Array`s with static size information.
Further, the abstract [`FieldVector`](@ref) can be used to make fast static vectors
out of any uniform Julia "struct".

## When Static Arrays may be useful

When a program uses many small ($\lesssim 100$ elements) fixed-sized arrays (whose size is known by the compiler, i.e. "statically," when the performance-critical code is compiled), then using Static Arrays can have several performance advantages:

1. Completely unrolling to loop-free code.  e.g. `v3 = v1 + v2` is just implemented as 3 scalar additions, with no loop overhead at all, if these are all `SVector{3, Float64}`.  The unrolled loops can also sometimes trigger SIMD optimizations.
2. Avoiding heap (or even stack) allocations of temporary arrays.  This is related to point (1) — working with static arrays as local variables is *as if* you had just written out all of the scalar operations by hand on all the components.
3. Being stored "inline" in other data structures.  e.g. a length-$N$ array `Vector{SVector{3, Float64}}`, such as `[v1, v2, v3]` from the `SVector`s in the previous example, is stored as $3N$ *consecutive* `Float64` values.  This is *much* more efficient to access than a `Vector{Vector{Float64}}`, which is essentially an array of pointers to `Vector{Float64}` arrays, and is often faster and more convenient than a $3 \times N$ `Matrix{Float64}` (e.g. because the length 3 is stored in the type you get the benefits of (1) and (2) when accessing vectors in the array, and no "slicing" or "views" are needed).  (There is also [HybridArrays.jl](https://github.com/JuliaArrays/HybridArrays.jl) for matrices with a static number of rows.)

## When Static Arrays may be less useful

You probably don't want to use Static Arrays if:

1. The size of the array is not static.  For example, if it is changing too rapidly at runtime to make it worthwhile to recompile (and/or dynamically dispatch) the code every time the size changes.  (Such as when you have a collection of vectors of many different lengths.)
2. The size of the array is large ($\gg 100$ elements) You (1) don't want to unroll vector operations of long lengths because the code size explodes; (2) they need to be heap-allocated because you can't store them in registers or perhaps even on the stack; and (3) you can already get many of the benefits of "inline" storage in arrays by storing them as the columns of a `Matrix`, whereas you wouldn't want to store a large array inline in an arbitrary `struct`.
3. Working with the array is not performance critical — static arrays are a little less convenient to work with than an ordinary `Array` (because the size of the former is a constant encoded in the type), and it may not be worth the inconvenience for cases where performance is not paramount.

# Quick Start

```julia
import Pkg
Pkg.add("StaticArrays")  # or Pkg.clone("https://github.com/JuliaArrays/StaticArrays.jl")
using StaticArrays
using LinearAlgebra

# Use the convenience constructor type `SA` to create vectors and matrices
SA[1, 2, 3]     isa SVector{3,Int}
SA_F64[1, 2, 3] isa SVector{3,Float64}
SA_F32[1, 2, 3] isa SVector{3,Float32}
SA[1 2; 3 4]     isa SMatrix{2,2,Int}
SA_F64[1 2; 3 4] isa SMatrix{2,2,Float64}

# Create an SVector using various forms, using constructors, functions or macros
v1 = SVector(1, 2, 3)
v1.data === (1, 2, 3) # SVector uses a tuple for internal storage
v2 = SVector{3,Float64}(1, 2, 3) # length 3, eltype Float64
v3 = @SVector [1, 2, 3]
v4 = @SVector [i^2 for i = 1:10] # arbitrary comprehensions (range is evaluated at global scope)
v5 = zeros(SVector{3}) # defaults to Float64
v6 = @SVector zeros(3)
v7 = SVector{3}([1, 2, 3]) # Array conversions must specify size

# Can get size() from instance or type
size(v1) == (3,)
size(typeof(v1)) == (3,)

# Similar constructor syntax for matrices
m1 = SMatrix{2,2}(1, 2, 3, 4) # flat, column-major storage, equal to m2:
m2 = @SMatrix [ 1  3 ;
                2  4 ]
m3 = SMatrix{3,3}(1I)
m4 = @SMatrix randn(4,4)
m5 = SMatrix{2,2}([1 3 ; 2 4]) # Array conversions must specify size

# Higher-dimensional support
a = @SArray randn(2, 2, 2, 2, 2, 2)

# Supports all the common operations of AbstractArray
v7 = v1 + v2
v8 = sin.(v3)
v3 == m3 * v3 # recall that m3 = SMatrix{3,3}(1I)
# map, reduce, broadcast, map!, broadcast!, etc...

# Indexing can also be done using static arrays of integers
v1[1] === 1
v1[SVector(3,2,1)] === @SVector [3, 2, 1]
v1[:] === v1
typeof(v1[[1,2,3]]) <: Vector # Can't determine size from the type of [1,2,3]

# For geometric and computer graphics applications in dimensions 1 to 4, the
# conventional dimension names x,y,z,w can be used to access elements of the
# vector:

u = SA[1,2,3,4]

u.x === u[1]
u.y === u[2]
u.z === u[3]
u.w === u[4]

# The x,y,z and w properties also work to set values in those dimensions:
m6 = MVector(1,2)
m6.x = 10
# The following is now true
m6[1] === 10

# Is (partially) hooked into BLAS, LAPACK, etc:
rand(MMatrix{20,20}) * rand(MMatrix{20,20}) # large matrices can use BLAS
eigen(m3) # eigen(), etc uses specialized algorithms up to 3×3, or else LAPACK

# Static arrays stay statically sized, even when used by Base functions, etc:
typeof(eigen(m3)) == Eigen{Float64,Float64,SArray{Tuple{3,3},Float64,2,9},SArray{Tuple{3},Float64,1,3}}

# similar() returns a mutable container, while similar_type() returns a constructor:
typeof(similar(m3)) == MArray{Tuple{3,3},Int64,2,9} # (final parameter is length = 9)
similar_type(m3) == SArray{Tuple{3,3},Int64,2,9}

# The Size trait is a compile-time constant representing the size
Size(m3) === Size(3,3)

# A standard Array can be wrapped into a SizedArray
m4 = SizedMatrix{3,3}(rand(3,3))
inv(m4) # Take advantage of specialized fast methods

# reshape() uses Size() or types to specify size:
reshape([1,2,3,4], Size(2,2)) == @SMatrix [ 1  3 ;
                                            2  4 ]
typeof(reshape([1,2,3,4], Size(2,2))) === SizedArray{Tuple{2, 2},Int64,2,1}

```

# API
## Guide


### `SVector`

The simplest static array is the type `SVector{N,T}`, which provides an
immutable vector of fixed length `N` and type `T`.

`SVector` defines a series of convenience constructors, so you can just type
e.g. `SVector(1,2,3)`. Alternatively there is an intelligent `@SVector` macro
where you can use native Julia array literals syntax, comprehensions, and the
`zeros()`, `ones()`, `fill()`, `rand()` and `randn()` functions, such as `@SVector [1,2,3]`,
`@SVector Float64[1,2,3]`, `@SVector [f(i) for i = 1:10]`, `@SVector zeros(3)`,
`@SVector randn(Float32, 4)`, etc (Note: the range of a comprehension is evaluated at global scope by the
macro, and must be made of combinations of literal values, functions, or global
variables, but is not limited to just simple ranges. Extending this to
(hopefully statically known by type-inference) local-scope variables is hoped
for the future. The `zeros()`, `ones()`, `fill()`, `rand()`, `randn()`, and `randexp()` functions do not have this
limitation.)

### `SMatrix`

Statically sized `N×M` matrices are provided by `SMatrix{N,M,T,L}`.

Here `L` is the `length` of the matrix, such that `N × M = L`. However,
convenience constructors are provided, so that `L`, `T` and even `M` are
unnecessary. At minimum, you can type `SMatrix{2}(1,2,3,4)` to create a 2×2
matrix (the total number of elements must divide evenly into `N`). A
convenience macro `@SMatrix [1 2; 3 4]` is provided (which also accepts
comprehensions and the `zeros()`, `ones()`, `fill()`, `rand()`, `randn()`, and `randexp()`
functions).

### `SArray`

A container with arbitrarily many dimensions is defined as
`struct SArray{Size,T,N,L} <: StaticArray{Size,T,N}`, where
`Size = Tuple{S1, S2, ...}` is a tuple of `Int`s. You can easily construct one with
the `@SArray` macro, supporting all the features of `@SVector` and `@SMatrix`
(but with arbitrary dimension).

The main reason `SVector` and `SMatrix` are defined is to make it easier to
define the types without the extra tuple characters (compare `SVector{3}` to
`SArray{Tuple{3}}`).

### `Scalar`

Sometimes you want to broadcast an operation, but not over one of your inputs.
A classic example is attempting to displace a collection of vectors by the
same vector. We can now do this with the `Scalar` type:

```julia
[[1,2,3], [4,5,6]] .+ Scalar([1,0,-1]) # [[2,2,2], [5,5,5]]
```

`Scalar` is simply an implementation of an immutable, 0-dimensional `StaticArray`.

### The `Size` trait

The size of a statically sized array is a static parameter associated with the
type of the array. The `Size` trait is provided as an abstract representation of
the dimensions of a static array. An array `sa::SA` of size `(dims...)` is
associated with `Size{(dims...)}()`. The following are equivalent
constructors:
```julia
Size{(dims...,)}()
Size(dims...)
Size(sa::StaticArray)
Size(SA) # SA <: StaticArray
```
This is extremely useful for (a) performing dispatch depending on the size of an
array, and (b) passing array dimensions that the compiler can reason about.

An example of size-based dispatch for the determinant of a matrix would be:
```julia
det(x::StaticMatrix) = _det(Size(x), x)
_det(::Size{(1,1)}, x::StaticMatrix) = x[1,1]
_det(::Size{(2,2)}, x::StaticMatrix) = x[1,1]*x[2,2] - x[1,2]*x[2,1]
# and other definitions as necessary
```

Examples of using `Size` as a compile-time constant include
```julia
reshape(svector, Size(2,2))  # Convert SVector{4} to SMatrix{2,2}
SizedMatrix{3,3}(rand(3,3))  # Construct a random 3×3 SizedArray (see below)
```

### Indexing

Statically sized indexing can be realized by indexing each dimension by a
scalar, a `StaticVector` or `:`. Indexing in this way will result a statically
sized array (even if the input was dynamically sized, in the case of
`StaticVector` indices) of the closest type (as defined by `similar_type`).

Conversely, indexing a statically sized array with a dynamically sized index
(such as a `Vector{Integer}` or `UnitRange{Integer}`) will result in a standard
(dynamically sized) `Array`.

### `similar_type()`

Since immutable arrays need to be constructed "all-at-once", we need a way of
obtaining an appropriate constructor if the element type or dimensions of the
output array differs from the input. To this end, `similar_type` is introduced,
behaving just like `similar`, except that it returns a type. Relevant methods
are:

```julia
similar_type(::Type{A}) where {A <: StaticArray} # defaults to A
similar_type(::Type{A}, ::Type{ElType}) where {A <: StaticArray, ElType} # Change element type
similar_type(::Type{A}, size::Size) where {A <: AbstractArray} # Change size
similar_type(::Type{A}, ::Type{ElType}, size::Size) where {A <: AbstractArray, ElType} # Change both
```

These setting will affect everything, from indexing, to matrix multiplication
and `broadcast`. Users wanting introduce a new array type should *only* overload
the last method in the above.

Use of `similar` will fall back to a mutable container, such as a `MVector`
(see below), and it requires use of the `Size` trait if you wish to set a new
static size (or else a dynamically sized `Array` will be generated when
specifying the size as plain integers).

### Collecting directly into static arrays

You can collect [iterators](https://docs.julialang.org/en/v1/manual/interfaces/#man-interface-iteration) into static arrays directly with [`StaticArrays.sacollect`](@ref). The size needs to be specified, but the element type is optional.

### Mutable arrays: `MVector`, `MMatrix` and `MArray`

These statically sized arrays are identical to the above, but are defined as
`mutable struct`s, instead of immutable `struct`s. Because they are mutable, they
allow `setindex!` to be defined (achieved through pointer manipulation, into a
tuple).

As a consequence of Julia's internal implementation, these mutable containers
live on the heap, not the stack. Their memory must be allocated and tracked by
the garbage collector. Nevertheless, there is opportunity for speed
improvements relative to `Base.Array` because (a) there may be one less
pointer indirection, (b) their (typically small) static size allows for
additional loop unrolling and inlining, and consequentially (c) their mutating
methods like `map!` are extremely fast. Benchmarking shows that operations such
as addition and matrix multiplication are faster for `MMatrix` than `Matrix`,
at least for sizes up to 14 × 14, though keep in mind that optimal speed will
be obtained by using mutating functions (like `map!` or `mul!`) where
possible, rather than reallocating new memory.

Mutable static arrays also happen to be very useful containers that can be
constructed on the heap (with the ability to use `setindex!`, etc), and later
copied as e.g. an immutable `SVector` to the stack for use, or into e.g. an
`Array{SVector}` for storage.

Convenience macros `@MVector`, `@MMatrix` and `@MArray` are provided.

### `SizedArray`: a decorate size wrapper for `Array`

Another convenient mutable type is the `SizedArray`, which is just a wrapper-type
about a standard Julia `Array` which declares its known size. For example, if
we knew that `a` was a 2×2 `Matrix`, then we can type `sa = SizedArray{Tuple{2,2}}(a)`
to construct a new object which knows the type (the size will be verified
automatically). For one and two dimensions, a more convenient syntax for
obtaining a `SizedArray` is by using the `SizedMatrix` and `SizedVector`
aliases, e.g. `sa = SizedMatrix{2,2}(a)`.

Then, methods on `sa` will use the specialized code provided by the *StaticArrays*
package, which in many cases will be much, much faster. For example, calling
`eigen(sa)` will be significantly faster than `eigen(a)` since it will perform a
specialized 2×2 matrix diagonalization rather than a general algorithm provided
by Julia and *LAPACK*.

In some cases it will make more sense to use a `SizedArray`, and in other cases
an `MArray` might be preferable.

### `FieldVector`

Sometimes it is useful to give your own struct types the properties of a vector.
*StaticArrays* can take care of this for you by allowing you to inherit from
`FieldVector{N, T}`. For example, consider:

```julia
struct Point3D <: FieldVector{3, Float64}
    x::Float64
    y::Float64
    z::Float64
end
```

With this type, users can easily access fields to `p = Point3D(x,y,z)` using
`p.x`, `p.y` or `p.z`, or alternatively via `p[1]`, `p[2]`, or `p[3]`. You may
even permute the coordinates with `p[SVector(3,2,1)]`). Furthermore, `Point3D`
is a complete `AbstractVector` implementation where you can add, subtract or
scale vectors, multiply them by matrices, etc.

*Note*: the three components of an ordinary `v::SVector{3}` can also be
accessed as `v.x`, `v.y`, and `v.z`, so there is no need for a `FieldVector`
to use this convention.

It is also worth noting that `FieldVector`s may be mutable or immutable, and
that `setindex!` is defined for use on mutable types. For immutable containers,
you may want to define a method for `similar_type` so that operations leave the
type constant (otherwise they may fall back to `SVector`). For mutable
containers, you may want to define a default constructor (no inputs) and an
appropriate method for `similar`,

### Implementing your own types

You can easily create your own `StaticArray` type, by defining linear
`getindex` (and optionally `setindex!` for mutable types --- see
`setindex!(::MArray, val, i)` in *MArray.jl* for an example of how to
achieve this through pointer manipulation). Your type should define a constructor
that takes a tuple of the data (and mutable containers may want to define a
default constructor).

Other useful functions to overload may be `similar_type` (and `similar` for
mutable containers).

### Conversions from `Array`

In order to convert from a dynamically sized `AbstractArray` to one of the
statically sized array types, you must specify the size explicitly.  For
example,

```julia
v = [1,2]

m = [1 2;
     3 4]

# ... a lot of intervening code

sv = SVector{2}(v)
sm = SMatrix{2,2}(m)
sa = SArray{Tuple{2,2}}(m)

sized_v = SizedVector{2}(v)
sized_m = SizedMatrix{2,2}(m)
```

We have avoided adding `SVector(v::AbstractVector)` as a valid constructor to
help users avoid the type instability (and potential performance disaster, if
used without care) of this innocuous looking expression.

### Arrays of static arrays

Storing a large number of static arrays is convenient as an array of static
arrays. For example, a collection of positions (3D coordinates --- `SVector{3,Float64}`)
could be represented as a `Vector{SVector{3,Float64}}`.

Another common way of storing the same data is as a 3×`N` `Matrix{Float64}`.
Rather conveniently, such types have *exactly* the same binary layout in memory,
and therefore we can use `reinterpret` to convert between the two formats
```@example copy
using StaticArrays # hide
function svectors(x::Matrix{T}, ::Val{N}) where {T,N}
    size(x,1) == N || error("sizes mismatch")
    isbitstype(T) || error("use for bitstypes only")
    reinterpret(SVector{N,T}, vec(x))
end
nothing # hide
```
Such a conversion does not copy the data, rather it refers to the *same* memory.
Arguably, a `Vector` of `SVector`s is often preferable to a `Matrix` because it
provides a better abstraction of the objects contained in the array and it
allows the fast *StaticArrays* methods to act on elements.

However, the resulting object is a Base.ReinterpretArray, not an Array, which
carries some runtime penalty on every single access. If you can afford the
memory for a copy and can live with the non-shared mutation semantics, then it
is better to pull a copy by e.g.
```@example copy
function svectorscopy(x::Matrix{T}, ::Val{N}) where {T,N}
    size(x,1) == N || error("sizes mismatch")
    isbitstype(T) || error("use for bitstypes only")
    copy(reinterpret(SVector{N,T}, vec(x)))
end
nothing # hide
```
For example:
```@repl copy
M = reshape(collect(1:6), (2,3))
svectors(M, Val{2}())
svectorscopy(M, Val{2}())
```

### Working with mutable and immutable arrays

Generally, it is performant to rebind an *immutable* array, such as
```julia
function average_position(positions::Vector{SVector{3,Float64}})
    x = zeros(SVector{3,Float64})
    for pos ∈ positions
        x = x + pos
    end
    return x / length(positions)
end
```
so long as the `Type` of the rebound variable (`x`, above) does not change.

On the other hand, the above code for mutable containers like `Array`, `MArray`
or `SizedArray` is *not* very efficient. Mutable containers must
be *allocated* and later *garbage collected*, and for small, fixed-size arrays
this can be a leading contribution to the cost. In the above code, a new array
will be instantiated and allocated on each iteration of the loop. In order to
avoid unnecessary allocations, it is best to allocate an array only once and
apply mutating functions to it:
```julia
function average_position(positions::Vector{SVector{3,Float64}})
    x = zeros(MVector{3,Float64})
    for pos ∈ positions
        x .+= pos
    end
    x ./= length(positions)
    return x
end
```

The functions `setindex`, `push`, `pop`, `pushfirst`, `popfirst`, `insert` and `deleteat`
are provided for performing certain specific operations on static arrays, in
analogy with the standard functions `setindex!`, `push!`, `pop!`, etc. (Note that
if the size of the static array changes, the type of the output will differ from
the input.)

When building static arrays iteratively, it is usually efficient to build up an `MArray` first and then convert. The allocation will be elided by recent Julia compilers, resulting in very efficient code:
```julia
function standard_basis_vector(T, ::Val{I}, ::Val{N}) where {I,N}
    v = zero(MVector{N,T})
    v[I] = one(T)
    SVector(v)
end
```

### SIMD optimizations

It seems Julia and LLVM are smart enough to use processor vectorization
extensions like SSE and AVX - however they are currently partially disabled by
default. Run Julia with `julia -O` or `julia -O3` to enable these optimizations,
and many of your (immutable) `StaticArray` methods *should* become significantly
faster!

## Docstrings

```@index
Pages   = ["api.md"]
```
```@autodocs
Modules = [StaticArrays, StaticArraysCore]
```
